// Decompiled by Jad v1.5.8g. Copyright 2001 Pavel Kouznetsov.
// Jad home page: http://www.kpdus.com/jad.html
// Decompiler options: packimports(3) 
// Source File Name:   AIWalker.java


public class AIWalker extends AIAttacker
{
    public class Idle extends AIAttacker.Idle
    {

        public void PlayStandAnim()
        {
            PlayAnim(WalkerAnims[AIWalker.A_WALKER_NORMAL], -1);
        }

        public void OnAnimEnd(int i)
        {
        }

        public void OnMakeDecisionEntering()
        {
        }

        public void OnEnter()
        {
            super.OnEnter();
            cMotion.iSpeed = 0;
            UpdateMotion();
        }

        public void OnMakeDecision()
        {
        }

        public void OnLeave()
        {
            super.OnLeave();
            SetAnimMorphTime(fNormalAnimMorphTime);
        }

        public Idle()
        {
        }
    }

    public class IdleSitting extends Idle
    {

        public void PlayStandAnim()
        {
            if(bIsSittingBull)
                PlayAnim(WalkerAnims[AIWalker.A_WALKER_STANDBY], -1);
            else
                super.PlayStandAnim();
        }

        public void GetUpDone()
        {
            SetEllipsoidFromWalkerState((byte)0);
            super.OnLeave();
        }

        public void OnAnimEnd(int i)
        {
        }

        public void OnMakeDecisionEntering()
        {
        }

        public void OnEnter()
        {
            super.OnEnter();
            fOldAnimMorphTime = GetAnimMorphTime();
            SetAnimMorphTime(0.0F);
            PlayStandAnim();
            CallMethodIn("OnEnterDelayed", 0.0F);
        }

        public void OnMakeDecision()
        {
        }

        void OnEnterDelayed()
        {
            SetAnimMorphTime(fOldAnimMorphTime);
            SetEllipsoidFromWalkerState((byte)1);
        }

        public void GetUp()
        {
            if(bIsSittingBull)
            {
                PlayAnim(WalkerAnims[AIWalker.A_WALKER_WAKEUP], 1);
                PlaySound(sWakeUpSound);
                CallMethodOnceIn("GetUpDone", GetAnimLength(WalkerAnims[AIWalker.A_WALKER_WAKEUP]));
                bIsSittingBull = false;
            }
        }

        public void OnLeave()
        {
            GetUp();
        }

        float fOldAnimMorphTime;

        public IdleSitting()
        {
            fOldAnimMorphTime = 0.0F;
            super.bNeedTimeToLeave = true;
        }
    }

    public class Patrol extends AIAttacker.Patrol
    {

        public void PlayStandAnim()
        {
            PlayAnim(WalkerAnims[AIWalker.A_WALKER_NORMAL], -1);
        }

        public void OnAnimEnd(int i)
        {
        }

        public Patrol()
        {
        }
    }

    public class PatrolAttack extends Attack
    {

        public void OnEnter()
        {
            bIsInPatrolAttackStateNow = true;
            super.OnEnter();
        }

        public void OnLeave()
        {
            bIsInPatrolAttackStateNow = false;
            super.OnLeave();
        }

        public PatrolAttack()
        {
        }
    }

    public class Attack extends AIAttacker.Attack
    {

        public void PlayStandAnim()
        {
            switch(nWalkerState)
            {
            case 0: // '\0'
                PlayAnim(WalkerAnims[AIWalker.A_WALKER_NORMAL], -1);
                break;

            case 3: // '\003'
                PlayAnim(WalkerAnims[AIWalker.A_WALKER_DOWN], -1);
                break;

            case 2: // '\002'
                PlayAnim(WalkerAnims[AIWalker.A_WALKER_UP], -1);
                break;
            }
        }

        public void OnAnimEnd(int i)
        {
        }

        void OnMakeDecisionEntering()
        {
            NewTask(109);
        }

        public void OnEnter()
        {
            super.OnEnter();
            SetWalkTrackedObject(null);
        }

        void OnMakeDecision()
        {
            float fDistance = GetDistanceToEnemy();
            float fCurTime = GetTime();
            if(cMotion.IsMoving())
            {
                if(fCurTime - fWalkStartTime > fWalkTime)
                {
                    NewTask(151);
                    NewTask(156);
                    NewTask(157);
                    fWalkEndTime = fCurTime;
                    fWalkTime = fWkrWalkTime + GameObject.RandomFloat(fRandomWkrWalkTime);
                } else
                {
                    NewTask(3);
                }
            } else
            if(nWalkerState == 0 && fCurTime - fWalkEndTime > fStandTime && fDistance > fWkrMinMarchDistance)
            {
                if(bIsInPatrolAttackStateNow && !bEndOfPathReached)
                {
                    AIPatrolerPathPoint cCurrentNode = (AIPatrolerPathPoint)aPath.GetPoint(nCurrentNode);
                    if(cCurrentNode.fStopTimeInterval != 0.0F)
                        NewTask(52);
                    if(cCurrentNode.iSpeed != cMotion.iSpeed)
                    {
                        cMotion.iSpeed = cCurrentNode.iSpeed;
                        NewTask(9);
                    }
                    NewTask(50);
                } else
                {
                    NewTask(150);
                }
                NewTask(155);
                NewTask(158);
                fWalkStartTime = fCurTime;
                fStandTime = fWkrStandTime + GameObject.RandomFloat(fRandomWkrStandTime);
            } else
            {
                if(!bIsFiringSecondary)
                    NewTask(157);
                if(bIsFiringPrimary)
                    NewTask(156);
                if(fCurTime - fLastStateChangeTime > fTimeInOneState)
                {
                    switch(nWalkerState)
                    {
                    case 2: // '\002'
                    case 3: // '\003'
                        NewTask(153);
                        break;

                    case 0: // '\0'
                        if(CanHappen(50))
                            NewTask(152);
                        else
                            NewTask(154);
                        break;

                    case 1: // '\001'
                    default:
                        GameObject.LogD("Incorrect walker state at this moment (" + nWalkerState + ")\n!");
                        NewTask(3);
                        break;
                    }
                    fLastStateChangeTime = fCurTime;
                    fTimeInOneState = fWkrTimeInOneState + GameObject.RandomFloat(fRandomWkrTimeInOneState);
                } else
                {
                    NewTask(3);
                }
            }
        }

        float fWalkStartTime;
        float fWalkEndTime;
        float fLastStateChangeTime;
        float fWalkTime;
        float fStandTime;
        float fTimeInOneState;

        public Attack()
        {
            fWalkStartTime = 0.0F;
            fWalkEndTime = 0.0F;
            fLastStateChangeTime = 0.0F;
            fWalkTime = 0.0F;
            fStandTime = 0.0F;
            fTimeInOneState = 0.0F;
        }
    }

    public class SearchDynamic extends AIAttacker.SearchDynamic
    {

        public void PlayStandAnim()
        {
            PlayAnim(WalkerAnims[AIWalker.A_WALKER_NORMAL], -1);
        }

        public void OnAnimEnd(int i)
        {
        }

        public SearchDynamic()
        {
        }
    }

    public class Die extends AIBase.AIBaseState
    {

        public void OnTakeDamage(float f, float f1, GameObject gameobject, Vector vector, Vector vector1, int i)
        {
        }

        public void PlayStandAnim()
        {
        }

        public void OnAnimEnd(int i)
        {
        }

        public void OnEnter()
        {
            super.OnEnter();
            DisableVitalActivities();
            if(sWkrDieBlowFX != null)
            {
                ExecuteFX(sWkrDieBlowFX, GetElementPos(nWalkerHeadID), Vector.Up);
                ExecuteParticleSystem(sWkrDieBlowFX, GetElementPos(nWalkerHeadID), Vector.Up);
            }
            if(sWkrDieBlowSound != null)
                PlaySound(sWkrDieBlowSound);
            if(cDriver != null)
                cDriver.DeactivateOnModuleAlways();
            PlayAnim(WalkerAnims[AIWalker.A_WALKER_NORMAL2STANDBY], 1);
            CallMethodOnceIn("DeathAnimEnd", GetAnimLength(WalkerAnims[AIWalker.A_WALKER_NORMAL2STANDBY]) + 0.5F);
        }

        void DeathAnimEnd()
        {
            bReallyDead = true;
            SetEllipsoidFromWalkerState((byte)4);
            ClearFlag(32);
        }

        public Die()
        {
        }
    }

    public class TestState extends AIBase.AIBaseState
    {

        public void OnReact()
        {
        }

        public void PlayStandAnim()
        {
            switch(nWalkerState)
            {
            case 0: // '\0'
                PlayAnim(WalkerAnims[AIWalker.A_WALKER_NORMAL], -1);
                break;

            case 3: // '\003'
                PlayAnim(WalkerAnims[AIWalker.A_WALKER_DOWN], -1);
                break;

            case 2: // '\002'
                PlayAnim(WalkerAnims[AIWalker.A_WALKER_UP], -1);
                break;
            }
        }

        public void OnAnimEnd(int i)
        {
        }

        public void OnEnter()
        {
            nReadinessToSearch = 0;
            cEnemy = ((ChromeModuleSingle)GetModule()).MainPlayer;
        }

        public void OnHearNoise(Actor actor, float f, int i)
        {
        }

        void OnInputKey(int i, boolean flag, char c)
        {
        }

        float fAngle1;
        float fAngle2;

        public TestState()
        {
            fAngle1 = 0.0F;
            fAngle2 = 0.0F;
        }
    }


    void InitializeAIWeapon()
    {
        super.InitializeAIWeapon();
        AttachChild(super.ActiveWeapon, "Walker Gun");
        super.ActiveWeapon.SetPosition(Vector.Zero);
        super.ActiveWeapon.SetDirLocal(new Vector(1.0F, 0.0F, 0.0F));
        super.ActiveWeapon.EnableRendering(false);
        super.ActiveWeapon.ClearFlag(40);
    }

    void SecondaryWeaponStopFire()
    {
        super.ActiveWeapon.StopFire();
    }

    boolean IsTargetDirCloseToSecondaryBarrelDir()
    {
        return IsTargetDirCloseToPrimaryBarrelDir();
    }

    public boolean IsActive(ControlObject Activator)
    {
        return false;
    }

    void Initialize()
    {
        super.Initialize();
        bIsInPatrolAttackStateNow = false;
        SetEllipsoidFromWalkerState((byte)0);
    }

    public void OnTakeDamage(float fDamage, float fPhSimDamage, GameObject Assassin, Vector vHitLocation, Vector vSpeed, int nMeshElementorBoneID, int nDamageType)
    {
        if(Assassin instanceof AIAttacker)
        {
            ((AIAttacker)Assassin).NotifyPlayerHit(this);
        } else
        {
            if(super.fHealth > 0.0F && (Assassin instanceof ChromeActor))
            {
                ChromeActor cActor = (ChromeActor)Assassin;
                if(cActor != super.cEnemy && GetTeamRelation(cActor) == -1)
                {
                    super.nAttackCause = 3;
                    super.nTargetPointIdx = 0;
                    SeekAndDestroy(cActor);
                }
            }
            boolean wasDead = super.bDead;
            Damage(fDamage, nDamageType);
            if(!super.bDead)
                TryToScream(1);
            else
            if(wasDead != super.bDead)
            {
                TryToScream(2);
                if(Assassin instanceof Pawn)
                    ((Pawn)Assassin).YouKilledMe(this);
            }
        }
    }

    void SetEllipsoidFromWalkerState(byte nWalkerState)
    {
        float fHeight = aWalkerHeight[nWalkerState];
        SetEllipsoid(150F, fHeight, fHeight * 0.5F);
    }

    void DefineAnimationSet()
    {
        SetAnimFreq("", 36F);
        SetAnimMorphTime(super.fNormalAnimMorphTime);
        SetTorsoAnimMorphTime(super.fNormalAnimMorphTime);
        WalkerAnims[A_WALKER_NORMAL] = GetAnimID(super.ROOT_BONE, "normal");
        WalkerAnims[A_WALKER_NORMAL2STANDBY] = GetAnimID(super.ROOT_BONE, "normal-standby");
        WalkerAnims[A_WALKER_STANDBY] = GetAnimID(super.ROOT_BONE, "Standby");
        WalkerAnims[A_WALKER_STANDBY2STANDBY_OPEN] = GetAnimID(sCabinElemName, "standby-standby_open");
        WalkerAnims[A_WALKER_STANDBY_OPEN] = GetAnimID(super.ROOT_BONE, "standby_open");
        WalkerAnims[A_WALKER_STANDBY_OPEN2STANDBY] = GetAnimID(sCabinElemName, "Standby_open-standby");
        WalkerAnims[A_WALKER_WAKEUP] = GetAnimID(super.ROOT_BONE, "Wakeup");
        WalkerAnims[A_WALKER_NORMAL2UP] = GetAnimID(super.ROOT_BONE, "normal-up");
        WalkerAnims[A_WALKER_UP] = GetAnimID(super.ROOT_BONE, "up");
        WalkerAnims[A_WALKER_UP2NORMAL] = GetAnimID(super.ROOT_BONE, "up-normal");
        WalkerAnims[A_WALKER_NORMAL2DOWN] = GetAnimID(super.ROOT_BONE, "normal-down");
        WalkerAnims[A_WALKER_DOWN] = GetAnimID(super.ROOT_BONE, "down");
        WalkerAnims[A_WALKER_DOWN2NORMAL] = GetAnimID(super.ROOT_BONE, "down-normal");
        WalkerAnims[A_WALKER_ROTATE_LEFT] = GetAnimID(super.ROOT_BONE, "rotate_left");
        WalkerAnims[A_WALKER_ROTATE_RIGHT] = GetAnimID(super.ROOT_BONE, "rotate_right");
        WalkerAnims[A_WALKER_WALK] = GetAnimID(super.ROOT_BONE, "walk");
        WalkerAnims[A_WALKER_WALK_BACK] = GetAnimID(super.ROOT_BONE, "walk_back");
        super.nUnstuckAnimID = WalkerAnims[A_WALKER_NORMAL];
        SetElementAnimType(nWalkerNeckID, (byte)3, false);
        SetElementAnimType(nWalkerHeadID, (byte)3, false);
        SetElementAnimType(nWalkerGunID, (byte)3, false);
        for(int i = 0; i <= A_WALKER_WALK_BACK; i++)
            if(WalkerAnims[i] == -1)
                GameObject.CrashLog("ERROR: WalkerAnims[i] == -1, i=" + i + "\n");

    }

    public Vector GetFireOrigin()
    {
        return GetElementPos(nBarelID);
    }

    void StartFiringSecondary()
    {
        if(!bIsFiringSecondary)
        {
            AddTracking();
            bIsFiringSecondary = true;
        }
    }

    void StopFiringSecondary()
    {
        if(bIsFiringSecondary)
        {
            RemoveTracking();
            bIsFiringSecondary = false;
        }
        SecondaryWeaponStopFire();
    }

    void OpenCabin()
    {
        PlayAnim(WalkerAnims[A_WALKER_STANDBY2STANDBY_OPEN], 1);
        PlaySound(sCabinOpenSound);
        bIsCabinOpen = true;
    }

    void TakeAction(int nAction)
    {
        super.bActionInProgress = true;
        switch(nAction)
        {
        case 150: 
            UpdateWalkTargetPos();
            CallMethodEvery(METHOD_UpdateWalkTargetPos, fWkrEnemyPosUpdateTime);
            TaskFinishedQuick();
            break;

        case 151: 
            DisableCallMethod(METHOD_UpdateWalkTargetPos);
            StopGoTo();
            super.bTwistCanTurn = true;
            TaskFinishedQuick();
            break;

        case 152: 
            nNewWalkerState = 2;
            bChangeWalkerState = true;
            super.bTwistCanTurn = false;
            PerformAnimTask(WalkerAnims[A_WALKER_NORMAL2UP], 1);
            PlaySound(sNormUpSound);
            break;

        case 153: 
            nNewWalkerState = 0;
            bChangeWalkerState = true;
            super.bTwistCanTurn = true;
            if(nWalkerState == 2)
            {
                PerformAnimTask(WalkerAnims[A_WALKER_UP2NORMAL], 1);
                PlaySound(sUpNormSound);
            } else
            {
                PerformAnimTask(WalkerAnims[A_WALKER_DOWN2NORMAL], 1);
                PlaySound(sDownNormSound);
            }
            break;

        case 154: 
            nNewWalkerState = 3;
            bChangeWalkerState = true;
            super.bTwistCanTurn = false;
            PerformAnimTask(WalkerAnims[A_WALKER_NORMAL2DOWN], 1);
            PlaySound(sNormDownSound);
            break;

        case 155: 
            StartFiringPrimary();
            TaskFinishedQuick();
            break;

        case 156: 
            StopFiringPrimary();
            TaskFinishedQuick();
            break;

        case 157: 
            StartFiringSecondary();
            TaskFinishedQuick();
            break;

        case 158: 
            StopFiringSecondary();
            TaskFinishedQuick();
            break;

        default:
            super.TakeAction(nAction);
            break;
        }
    }

    void MessageWeapon(int nState)
    {
        if((nState & 1) == 0);
        if((nState & 2) != 0)
            super.ActiveWeapon.nAmmo = 0x186a0;
        else
        if((nState & 0xc0) != 0)
            GameObject.LogD("Shooting to often!\n");
    }

    float GetPrimaryWeaponDelay()
    {
        return super.ActiveWeapon.fDelay;
    }

    public void OnVehicleCollision(float f, GameObject gameobject, Vector vector, Vector vector1)
    {
    }

    public void OnPostCreate()
    {
        CallMethodIn("InitializeDriver", 0.0F);
    }

    void InitHumanBody()
    {
    }

    Vector GetLookFromPoint()
    {
        Vector vPoint = GetPosition();
        vPoint.fY = GetElementPos(nWalkerEyeID).fY;
        return vPoint;
    }

    void PlayHeadRotateSound(float fTime)
    {
        if(nHeadLoopSoundID == 0)
            nHeadLoopSoundID = AttachSound(sHeadLoopSound);
        else
            PlaySound(nHeadLoopSoundID);
        CallMethodOnceIn("StopHeadRotateSound", fTime);
    }

    void PlayGunRotateSound(float fTime)
    {
        if(nGunRotateLoopSoundID == 0)
            nGunRotateLoopSoundID = AttachSound(sHeadLoopSound);
        else
            PlaySound(nGunRotateLoopSoundID);
        CallMethodOnceIn("StopGunRotateSound", fTime);
    }

    public void OnPostUpdate()
    {
        if(super.bDead)
            FromUpForwardPosElement(nWalkerHeadID, Vector.Up, Vector.Forward, new Vector(0.0F, 0.0F, -100000F));
        super.OnPostUpdate();
    }

    boolean IsTargetDirCloseToPrimaryBarrelDir()
    {
        boolean bRet = false;
        Vector vTargetDir = super.cEnemy.GetPointToLookAt(super.nTargetPointIdx);
        if(vTargetDir == null)
            vTargetDir = super.cEnemy.GetPointToLookAt(0);
        if(vTargetDir != null)
        {
            vTargetDir.Sub(GetFireOrigin());
            vTargetDir.fY = 0.0F;
            vTargetDir.Normalize();
            Vector vBarrelDir = GetElementForwardVector(nWalkerGunID);
            vBarrelDir.fY = 0.0F;
            vBarrelDir.Normalize();
            bRet = vTargetDir.Dot(vBarrelDir) > fMaxTargetToBarrelCos;
        }
        return bRet;
    }

    public void SetLegsAnimMorphTime(float f)
    {
    }

    void InitializeDriver()
    {
        if(cDriver != null)
        {
            nSeatID = GetElementID("WW_Fotel");
            cDriver.Freeze();
            int nDriveAnim = cDriver.GetAnimID("", "drive");
            int nDriveFrame = cDriver.GetFirstFrame(nDriveAnim);
            cDriver.SetFrame(nDriveAnim, nDriveFrame, 0);
            cDriver.SetFlag(6);
            AttachChild(cDriver, nSeatID);
            Vector vPos = GetElementPos(nSeatID);
            vPos.fY -= 30F;
            Vector vBack = GetElementForwardVector(nSeatID);
            vBack.Mul(10F);
            vPos.Sub(vBack);
            cDriver.FromUpForwardPos(GetElementUpVector(nSeatID), GetElementForwardVector(nSeatID), vPos);
            cDriver.fDamageThreshold = 1000000F;
            cDriver.ClearFlag(256);
            if(((Pawn) (cDriver)).ActiveWeapon != null)
                ((Pawn) (cDriver)).ActiveWeapon.EnableRendering(false);
        }
    }

    void InitHeadElementID()
    {
        String aElemName[] = {
            "Walker Neck", "Walker Head", "Walker Gun"
        };
        aHeadElementID = new int[aElemName.length];
        for(int i = 0; i < aElemName.length; i++)
            aHeadElementID[i] = GetElementID(aElemName[i]);

    }

    void InitTalkingHead()
    {
    }

    void AnimationTaskFinished()
    {
        if(bChangeWalkerState)
            nWalkerState = nNewWalkerState;
        super.AnimationTaskFinished();
    }

    void ExecuteFXBarrel(String sFXName)
    {
        ExecuteFX(this, nBarelID, sFXName, Vector.Zero);
    }

    void UpdateFiringSecondary()
    {
        float fCurTime = GetTime();
        if(bIsSecondaryFiringNow)
        {
            if(fCurTime - fLastSecFireStartTime > fSecondaryFireTime)
            {
                SecondaryWeaponStopFire();
                bIsSecondaryFiringNow = false;
                fLastSecFireEndTime = fCurTime;
                fSecondaryFireTime = fWkrSecondaryFireTime + GameObject.RandomFloat(fRandomWkrSecondaryFireTime);
            } else
            if(!bWkrSecondaryUsesGuidedMissiles)
            {
                boolean bDirOK = IsTargetDirCloseToSecondaryBarrelDir();
                if(bDirOK)
                {
                    if(fLastSecFireTempStopTime > 0.0F && fCurTime - fLastSecFireTempStopTime > GetSecondaryWeaponDelay())
                    {
                        SecondaryWeaponStartFire();
                        fLastSecFireTempStopTime = 0.0F;
                    }
                } else
                {
                    SecondaryWeaponStopFire();
                    fLastSecFireTempStopTime = fCurTime;
                }
            }
        } else
        if(fCurTime - fLastSecFireEndTime > fSecondaryFireDelay && (bWkrSecondaryUsesGuidedMissiles || IsTargetDirCloseToSecondaryBarrelDir()) && IsEnemyInWeaponRange())
        {
            SecondaryWeaponStartFire();
            bIsSecondaryFiringNow = true;
            fLastSecFireTempStopTime = 0.0F;
            fLastSecFireStartTime = fCurTime;
            fSecondaryFireDelay = fWkrSecondaryFireDelay + GameObject.RandomFloat(fRandomWkrSecondaryFireDelay);
        }
    }

    public void ActivateAI(boolean bActivate, int nFreezeCause)
    {
        super.ActivateAI(bActivate, nFreezeCause);
        if(super.ActiveWeapon != null)
            super.ActiveWeapon.EnableRendering(false);
    }

    void UpdateAllTrackings()
    {
        super.UpdateAllTrackings();
        if(bIsFiringPrimary)
            UpdateFiringPrimary();
        if(bIsFiringSecondary)
            UpdateFiringSecondary();
    }

    void CancelAction(int nAction)
    {
        if(super.bActionInProgress)
        {
            switch(nAction)
            {
            case 150: 
                StopGoTo();
                super.bTwistCanTurn = true;
                DisableCallMethod(METHOD_UpdateWalkTargetPos);
                break;

            case 152: 
            case 153: 
            case 154: 
                super.bTwistCanTurn = true;
                nWalkerState = 0;
                StopAnim("");
                DisableCallMethod(super.METHOD_AnimationTaskFinished);
                break;

            case 155: 
            case 156: 
                StopFiringPrimary();
                break;

            case 157: 
            case 158: 
                StopFiringSecondary();
                break;

            default:
                super.CancelAction(nAction);
                break;

            case 151: 
                break;
            }
            super.bActionInProgress = false;
        }
    }

    public Vector GetLookDirection()
    {
        return GetElementForwardVector(nWalkerEyeID);
    }

    float GetTwistVertMin(int nTwistType)
    {
        return super.fTwistVertMin;
    }

    void TwistBody(float fHorizAngle, float fVertAngle, int nTwistType)
    {
        switch(nTwistType)
        {
        case 0: // '\0'
            RotateElementWithAnim(nWalkerNeckID, AIBase.vAlongXAxis, 0.0F);
            RotateElementWithAnim(nWalkerHeadID, AIBase.vAlongXAxis, 0.0F);
            RotateElementWithAnim(nWalkerGunID, AIBase.vAlongXAxis, 0.0F);
            if(Math.abs(fLastAngleH) > fMinSoundStartAngle)
                PlayHeadRotateSound(GetAnimMorphTime());
            else
                StopHeadRotateSound();
            if(Math.abs(fLastAngleV) > fMinSoundStartAngle)
                PlayGunRotateSound(GetAnimMorphTime());
            else
                StopGunRotateSound();
            fLastAngleH = fLastAngleV = 0.0F;
            break;

        case 1: // '\001'
        case 2: // '\002'
        case 3: // '\003'
            RotateElementWithAnim(nWalkerHeadID, AIBase.vAlongYAxis, fHorizAngle);
            if(Math.abs(fHorizAngle) < 15F)
            {
                if(fVertAngle < fGunSafeAngleVert)
                {
                    RotateElementWithAnim(nWalkerNeckID, AIBase.vAlongXAxis, fVertAngle - fGunSafeAngleVert);
                    RotateElementWithAnim(nWalkerGunID, AIBase.vAlongXAxis, fGunSafeAngleVert);
                } else
                {
                    RotateElementWithAnim(nWalkerNeckID, AIBase.vAlongXAxis, 0.3F * fVertAngle);
                    RotateElementWithAnim(nWalkerGunID, AIBase.vAlongXAxis, 0.7F * fVertAngle);
                }
            } else
            if(fVertAngle > fLegSafeAngleVert)
            {
                RotateElementWithAnim(nWalkerNeckID, AIBase.vAlongXAxis, fLegSafeAngleVert);
                RotateElementWithAnim(nWalkerGunID, AIBase.vAlongXAxis, fVertAngle - fLegSafeAngleVert);
            } else
            if(fVertAngle < fGunSafeAngleVert)
            {
                RotateElementWithAnim(nWalkerNeckID, AIBase.vAlongXAxis, fVertAngle - fGunSafeAngleVert);
                RotateElementWithAnim(nWalkerGunID, AIBase.vAlongXAxis, fGunSafeAngleVert);
            } else
            {
                RotateElementWithAnim(nWalkerNeckID, AIBase.vAlongXAxis, 0.3F * fVertAngle);
                RotateElementWithAnim(nWalkerGunID, AIBase.vAlongXAxis, 0.7F * fVertAngle);
            }
            if(Math.abs(fLastAngleH - fHorizAngle) > fMinSoundStartAngle)
                PlayHeadRotateSound(GetAnimMorphTime());
            else
                StopHeadRotateSound();
            if(Math.abs(fLastAngleV - fVertAngle) > fMinSoundStartAngle)
                PlayGunRotateSound(GetAnimMorphTime());
            else
                StopGunRotateSound();
            fLastAngleV = fVertAngle;
            fLastAngleH = fHorizAngle;
            break;

        default:
            GameObject.LogD("Incorrent twist type value!\n");
            break;
        }
        super.nLastTwistType = nTwistType;
    }

    void StopHeadRotateSound()
    {
        StopSound(nHeadLoopSoundID);
    }

    void StopGunRotateSound()
    {
        StopSound(nGunRotateLoopSoundID);
    }

    void CloseCabin()
    {
        PlayAnim(WalkerAnims[A_WALKER_STANDBY_OPEN2STANDBY], 1);
        PlaySound(sCabinCloseSound);
        bIsCabinOpen = false;
    }

    AIWalker()
    {
        cDriver = null;
        WalkerAnims = new int[LAST_WALKER_ANIM + 1];
        nWalkerState = 0;
        nNewWalkerState = nWalkerState;
        nOldWalkerState = -1;
        bChangeWalkerState = false;
        bIsCabinOpen = false;
        sWalkerEye = "Barel";
        sCabinElemName = "Walker Pane";
        nSeatID = 0;
        nWalkerEyeID = 0;
        nWalkerLookAtID = 0;
        nBarelID = 0;
        nWalkerHeadID = 0;
        nWalkerNeckID = 0;
        nWalkerGunID = 0;
        aHeadElementID = null;
        sStepSound = "Data/Sounds/Walker/Walker_Walk_k";
        sCabinOpenSound = "Data/Sounds/Walker/Walker_OpenCabin_k";
        sCabinCloseSound = "Data/Sounds/Walker/Walker_CloseCabin_k";
        sStandbySound = "Data/Sounds/Walker/Walker_Standby_k";
        sWakeUpSound = "Data/Sounds/Walker/Walker_WakeUp_k";
        sNormUpSound = "Data/Sounds/Walker/Walker_NormUp_k";
        sUpNormSound = "Data/Sounds/Walker/Walker_UpNorm_k";
        sNormDownSound = "Data/Sounds/Walker/Walker_NormDown_k";
        sDownNormSound = "Data/Sounds/Walker/Walker_DownNorm_k";
        sHeadLoopSound = "Data/Sounds/Walker/Walker_HeadLoop_k";
        sGunRotateLoopSound = "Data/Sounds/Walker/Walker_GunRotateLoop_k";
        nHeadLoopSoundID = 0;
        nGunRotateLoopSoundID = 0;
        fWkrEnemyPosUpdateTime = 2.5F;
        fWkrWalkTime = 2.0F;
        fRandomWkrWalkTime = 5F;
        fWkrStandTime = 2.0F;
        fRandomWkrStandTime = 5F;
        fWkrTimeInOneState = 1.0F;
        fRandomWkrTimeInOneState = 3F;
        fWkrMinMarchDistance = 700F;
        fWkrPrimaryFireTime = 0.5F;
        fRandomWkrPrimaryFireTime = 3F;
        fWkrPrimaryFireDelay = 0.5F;
        fRandomWkrPrimaryFireDelay = 3F;
        bWkrPrimaryUsesGuidedMissiles = false;
        fWkrSecondaryFireTime = 0.5F;
        fRandomWkrSecondaryFireTime = 3F;
        fWkrSecondaryFireDelay = 0.5F;
        fRandomWkrSecondaryFireDelay = 3F;
        bWkrSecondaryUsesGuidedMissiles = false;
        fMaxTargetToBarrelCos = (float)Math.cos(0.26179938779914941D);
        sWkrDieBlowFX = "FXBlowWalker";
        sWkrDieBlowSound = "Data/Sounds/Explosion/WalkerDieExplosion.wav";
        METHOD_UpdateWalkTargetPos = 0;
        bIsFiringPrimary = false;
        bIsFiringSecondary = false;
        fLastPrimFireStartTime = 0.0F;
        fLastPrimFireEndTime = 0.0F;
        fLastPrimFireTempStopTime = 0.0F;
        fPrimaryFireTime = 0.0F;
        fPrimaryFireDelay = 0.0F;
        bIsPrimaryFiringNow = false;
        fLastSecFireStartTime = 0.0F;
        fLastSecFireEndTime = 0.0F;
        fLastSecFireTempStopTime = 0.0F;
        fSecondaryFireTime = 0.0F;
        fSecondaryFireDelay = 0.0F;
        bIsSecondaryFiringNow = false;
        fLegSafeAngleVert = -15F;
        fGunSafeAngleVert = -10F;
        fLastAngleH = 0.0F;
        fLastAngleV = 0.0F;
        fMinSoundStartAngle = 2.0F;
        bIsInPatrolAttackStateNow = false;
        super.bIsEmpVulnerable = true;
        super.ScreenshotIconPath = "data/textures/icons/icon_walker.png";
        super.ROOT_BONE = "Walker Plevis";
        super.TORSO_BONE = "Walker Neck";
        super.MeshName = "Data/Meshes/AI/Walker_k.3da";
        super.sAIWeapon = "WeaponWalker_k";
        super.fTwistHorizMin = -35F;
        super.fTwistHorizMax = 35F;
        super.fTwistVertMin = -40F;
        super.fTwistVertMax = 50F;
        super.fStartHealth = 3000F;
        super.aMotionVelocity = (new float[] {
            0, 330F, 330F, 330F, 330F, 330F
        });
        super.fDamageThreshold = 20F;
    }

    public Vector GetPointToLookAt(int nPoint)
    {
        switch(nPoint)
        {
        case 0: // '\0'
            return GetElementPos(nWalkerLookAtID);
        }
        return null;
    }

    void PrimaryWeaponStartFire()
    {
        super.ActiveWeapon.StartFire((byte)2);
    }

    void PrimaryWeaponStopFire()
    {
        super.ActiveWeapon.StopFire();
    }

    void InitWalker()
    {
        nWalkerEyeID = GetElementID(sWalkerEye);
        nWalkerLookAtID = GetElementID("WW_Fotel");
        nBarelID = GetElementID("Barel");
        nWalkerHeadID = GetElementID("Walker Head");
        nWalkerNeckID = GetElementID("Walker Neck");
        nWalkerGunID = GetElementID("Walker Gun");
        InitHeadElementID();
    }

    void StepDone()
    {
        PlaySound(sStepSound);
    }

    void PlaceGun()
    {
    }

    float GetTwistHorizMin(int nTwistType)
    {
        return super.fTwistHorizMin;
    }

    void UpdateWalkTargetPos()
    {
        Vector vTargetPos = super.cEnemy.GetPosition();
        if(vTargetPos != null && vTargetPos.Distance(GetPosition()) > fWkrMinMarchDistance)
        {
            super.bTwistCanTurn = false;
            GoTo(vTargetPos, (byte)4, null, 3);
        } else
        {
            super.bTwistCanTurn = true;
            StopGoTo();
        }
    }

    void UpdateFiringPrimary()
    {
        float fCurTime = GetTime();
        if(bIsPrimaryFiringNow)
        {
            if(fCurTime - fLastPrimFireStartTime > fPrimaryFireTime)
            {
                PrimaryWeaponStopFire();
                bIsPrimaryFiringNow = false;
                fLastPrimFireEndTime = fCurTime;
                fPrimaryFireTime = fWkrPrimaryFireTime + GameObject.RandomFloat(fRandomWkrPrimaryFireTime);
            } else
            if(!bWkrPrimaryUsesGuidedMissiles)
            {
                boolean bDirOK = IsTargetDirCloseToPrimaryBarrelDir();
                if(bDirOK)
                {
                    if(fLastPrimFireTempStopTime > 0.0F && fCurTime - fLastPrimFireTempStopTime > GetPrimaryWeaponDelay())
                    {
                        PrimaryWeaponStartFire();
                        fLastPrimFireTempStopTime = 0.0F;
                    }
                } else
                {
                    PrimaryWeaponStopFire();
                    fLastPrimFireTempStopTime = fCurTime;
                }
            }
        } else
        if(fCurTime - fLastPrimFireEndTime > fPrimaryFireDelay && (bWkrPrimaryUsesGuidedMissiles || IsTargetDirCloseToPrimaryBarrelDir()) && IsEnemyInWeaponRange())
        {
            PrimaryWeaponStartFire();
            bIsPrimaryFiringNow = true;
            fLastPrimFireTempStopTime = 0.0F;
            fLastPrimFireStartTime = fCurTime;
            fPrimaryFireDelay = fWkrPrimaryFireDelay + GameObject.RandomFloat(fRandomWkrPrimaryFireDelay);
        }
    }

    float GetTwistVertMax(int nTwistType)
    {
        return super.fTwistVertMax;
    }

    public void SeekAndDestroy(Pawn cEnemy)
    {
        if(cEnemy != null)
            Attack(cEnemy);
        else
            ChooseIdleState();
    }

    public void DisableVitalActivities()
    {
        super.DisableVitalActivities();
        DisableCallMethod(METHOD_UpdateWalkTargetPos);
        if(bIsFiringPrimary)
            StopFiringPrimary();
        if(bIsFiringSecondary)
            StopFiringSecondary();
    }

    void UpdateMotion()
    {
        if(super.bDead)
            return;
        if(super.cMotion.IsEqualMoving(super.cOldMotion) && nWalkerState == nOldWalkerState)
            return;
        if(super.cMotion.IsMoving())
        {
            int nAnimToPlay = -1;
            if(super.cMotion.IsMovingLinear())
                switch(super.cMotion.iMoveZ)
                {
                case -1: 
                    nAnimToPlay = WalkerAnims[A_WALKER_WALK_BACK];
                    // fall through

                case 0: // '\0'
                    GameObject.LogD("No strafe animation defined!\n");
                    break;

                case 1: // '\001'
                    nAnimToPlay = WalkerAnims[A_WALKER_WALK];
                    break;
                }
            else
            if(super.cMotion.iTurn != 0)
                if(super.cMotion.iTurn > 0)
                    nAnimToPlay = WalkerAnims[A_WALKER_ROTATE_LEFT];
                else
                    nAnimToPlay = WalkerAnims[A_WALKER_ROTATE_RIGHT];
            if(nAnimToPlay != -1 && (super.cOldMotion.iMoveZ != super.cMotion.iMoveZ || super.cOldMotion.iTurn != super.cMotion.iTurn))
            {
                PlayAnim(nAnimToPlay, -1);
                StepDone();
                CallMethodEvery(super.METHOD_StepDone, GetAnimLength(nAnimToPlay) / 2.0F);
            }
        } else
        {
            PlayStandAnim();
            if(super.cOldMotion.IsMoving())
                DisableCallMethod(super.METHOD_StepDone);
        }
        super.cOldMotion = new MotionState(super.cMotion);
        nOldWalkerState = nWalkerState;
    }

    public void OnCreate()
    {
        InitWalker();
        METHOD_UpdateWalkTargetPos = RegisterCallMethod("UpdateWalkTargetPos");
        super.OnCreate();
        SetFlag(8192);
        SetBlobMapSize(300F);
        UpdatePathMap(true, 7);
        super.bRunAwayFromDanger = false;
    }

    void StartFiringPrimary()
    {
        if(!bIsFiringPrimary)
        {
            AddTracking();
            bIsFiringPrimary = true;
        }
    }

    void StopFiringPrimary()
    {
        if(bIsFiringPrimary)
        {
            RemoveTracking();
            bIsFiringPrimary = false;
        }
        PrimaryWeaponStopFire();
    }

    float GetSecondaryWeaponDelay()
    {
        return super.ActiveWeapon.fDelay;
    }

    float GetTwistHorizMax(int nTwistType)
    {
        return super.fTwistHorizMax;
    }

    void SecondaryWeaponStartFire()
    {
        super.ActiveWeapon.StartFire((byte)2);
    }

    public void SetTorsoAnimMorphTime(float fMorphTime)
    {
        for(int i = 0; i < aHeadElementID.length; i++)
            SetAnimMorphTime(aHeadElementID[i], fMorphTime, false);

    }

    public NewAI cDriver;
    static byte A_WALKER_NORMAL = 0;
    static byte A_WALKER_NORMAL2STANDBY = 1;
    static byte A_WALKER_STANDBY = 2;
    static byte A_WALKER_STANDBY2STANDBY_OPEN = 3;
    static byte A_WALKER_STANDBY_OPEN = 4;
    static byte A_WALKER_STANDBY_OPEN2STANDBY = 5;
    static byte A_WALKER_WAKEUP = 6;
    static byte A_WALKER_NORMAL2UP = 7;
    static byte A_WALKER_UP = 8;
    static byte A_WALKER_UP2NORMAL = 9;
    static byte A_WALKER_NORMAL2DOWN = 10;
    static byte A_WALKER_DOWN = 11;
    static byte A_WALKER_DOWN2NORMAL = 12;
    static byte A_WALKER_ROTATE_LEFT = 13;
    static byte A_WALKER_ROTATE_RIGHT = 14;
    static byte A_WALKER_WALK = 15;
    static byte A_WALKER_WALK_BACK;
    static byte LAST_WALKER_ANIM;
    int WalkerAnims[];
    float aWalkerHeight[] = {
        460F, 220F, 490F, 410F, 220F
    };
    static final byte _WALKER_STATE_NORMAL = 0;
    static final byte _WALKER_STATE_STANDBY = 1;
    static final byte _WALKER_STATE_UP = 2;
    static final byte _WALKER_STATE_DOWN = 3;
    static final byte _WALKER_STATE_DEAD = 4;
    byte nWalkerState;
    byte nNewWalkerState;
    byte nOldWalkerState;
    boolean bChangeWalkerState;
    boolean bIsCabinOpen;
    static final int _ACTION_WALKER_START_WALK_ON_ENEMY = 150;
    static final int _ACTION_WALKER_STOP_WALK = 151;
    static final int _ACTION_WALKER_GET_UP = 152;
    static final int _ACTION_WALKER_GET_NORMAL = 153;
    static final int _ACTION_WALKER_GET_DOWN = 154;
    static final int _ACTION_WALKER_START_FIRING_PRIMARY = 155;
    static final int _ACTION_WALKER_STOP_FIRING_PRIMARY = 156;
    static final int _ACTION_WALKER_START_FIRING_SECONDARY = 157;
    static final int _ACTION_WALKER_STOP_FIRING_SECONDARY = 158;
    String sWalkerEye;
    String sCabinElemName;
    int nSeatID;
    int nWalkerEyeID;
    int nWalkerLookAtID;
    int nBarelID;
    int nWalkerHeadID;
    int nWalkerNeckID;
    int nWalkerGunID;
    int aHeadElementID[];
    String sStepSound;
    String sCabinOpenSound;
    String sCabinCloseSound;
    String sStandbySound;
    String sWakeUpSound;
    String sNormUpSound;
    String sUpNormSound;
    String sNormDownSound;
    String sDownNormSound;
    String sHeadLoopSound;
    String sGunRotateLoopSound;
    int nHeadLoopSoundID;
    int nGunRotateLoopSoundID;
    float fWkrEnemyPosUpdateTime;
    float fWkrWalkTime;
    float fRandomWkrWalkTime;
    float fWkrStandTime;
    float fRandomWkrStandTime;
    float fWkrTimeInOneState;
    float fRandomWkrTimeInOneState;
    public float fWkrMinMarchDistance;
    float fWkrPrimaryFireTime;
    float fRandomWkrPrimaryFireTime;
    float fWkrPrimaryFireDelay;
    float fRandomWkrPrimaryFireDelay;
    boolean bWkrPrimaryUsesGuidedMissiles;
    float fWkrSecondaryFireTime;
    float fRandomWkrSecondaryFireTime;
    float fWkrSecondaryFireDelay;
    float fRandomWkrSecondaryFireDelay;
    boolean bWkrSecondaryUsesGuidedMissiles;
    float fMaxTargetToBarrelCos;
    String sWkrDieBlowFX;
    String sWkrDieBlowSound;
    int METHOD_UpdateWalkTargetPos;
    boolean bIsFiringPrimary;
    boolean bIsFiringSecondary;
    float fLastPrimFireStartTime;
    float fLastPrimFireEndTime;
    float fLastPrimFireTempStopTime;
    float fPrimaryFireTime;
    float fPrimaryFireDelay;
    boolean bIsPrimaryFiringNow;
    float fLastSecFireStartTime;
    float fLastSecFireEndTime;
    float fLastSecFireTempStopTime;
    float fSecondaryFireTime;
    float fSecondaryFireDelay;
    boolean bIsSecondaryFiringNow;
    float fLegSafeAngleVert;
    float fGunSafeAngleVert;
    float fLastAngleH;
    float fLastAngleV;
    float fMinSoundStartAngle;
    boolean bIsInPatrolAttackStateNow;

    static 
    {
        A_WALKER_WALK_BACK = 16;
        LAST_WALKER_ANIM = A_WALKER_WALK_BACK;
    }
}
