// Decompiled by Jad v1.5.8g. Copyright 2001 Pavel Kouznetsov.
// Jad home page: http://www.kpdus.com/jad.html
// Decompiler options: packimports(3) 
// Source File Name:   AlarmsManager.java

import java.util.Vector;

public class AlarmsManager extends GameObject
{

    void EnableAlarm(boolean bEnable, int iAlarmGroupID, float fDuration)
    {
        AlarmGroup alarmGroup = GetAlarmGroupByID(iAlarmGroupID);
        if(alarmGroup != null)
            alarmGroup.EnableAlarm(bEnable, GetTime(), fDuration);
    }

    void EnableAlarm(boolean bEnable, float fDuration)
    {
        float fCurrTime = GetTime();
        for(int i = 0; i < m_AlarmGroups.size(); i++)
        {
            AlarmGroup alarmGroup = (AlarmGroup)m_AlarmGroups.elementAt(i);
            alarmGroup.EnableAlarm(bEnable, fCurrTime, fDuration);
        }

    }

    AlarmGroup GetAlarmGroupByID(int iAlarmGroupID)
    {
        for(int i = 0; i < m_AlarmGroups.size(); i++)
        {
            AlarmGroup alarmGroup = (AlarmGroup)m_AlarmGroups.elementAt(i);
            if(alarmGroup.m_iAlarmID == iAlarmGroupID)
                return alarmGroup;
        }

        return null;
    }

    public void SGUpdate()
    {
        FileChunk.Log("[AlarmsManager.SGUpdate]\n");
        super.SGUpdate();
    }

    boolean IsAlarmEnabled()
    {
        if(m_AlarmGroups.size() == 0)
            return false;
        boolean bEnabled = true;
        for(int i = 0; i < m_AlarmGroups.size(); i++)
        {
            AlarmGroup alarmGroup = (AlarmGroup)m_AlarmGroups.elementAt(i);
            bEnabled = bEnabled && alarmGroup.m_bAlarmEnabled;
        }

        return bEnabled;
    }

    boolean IsAlarmEnabled(int iAlarmID)
    {
        AlarmGroup group = GetAlarmGroupByID(iAlarmID);
        if(group == null)
            return false;
        else
            return group.IsAlarmEnabled();
    }

    public AlarmsManager()
    {
        m_AlarmGroups = new Vector();
        m_bAlarmMultiple = false;
        m_Module = null;
    }

    public void UpdateAlarmGroups()
    {
        float fCurrTime = GetTime();
        for(int i = 0; i < m_AlarmGroups.size(); i++)
            ((AlarmGroup)m_AlarmGroups.elementAt(i)).CheckForDisable(fCurrTime);

    }

    void SetModule(ChromeModuleSingle module)
    {
        m_Module = module;
        m_AlarmsManager = this;
    }

    static int GetNextAutoAlarmID()
    {
        return _AUTO_ALARM_ID++;
    }

    void InitAlarmGuards()
    {
    }

    void InitAlarmTerminals()
    {
        GameObject aTab[] = GameObject.GetObjectsFromClass("AlarmTerminal");
        if(aTab.length == 0)
            return;
        for(int i = 0; i < aTab.length; i++)
        {
            AlarmTerminal terminal = (AlarmTerminal)aTab[i];
            AlarmGroup alarmGroup = GetAlarmGroupByID(terminal.m_iAlarmID);
            if(alarmGroup == null)
            {
                alarmGroup = new AlarmGroup(terminal.m_iAlarmID);
                m_AlarmGroups.addElement(alarmGroup);
            }
            alarmGroup.AddAlarmTerminal(terminal);
        }

    }

    void InitLightSignals()
    {
        GameObject aTab[] = GameObject.GetObjectsFromClass("LightSignal");
        if(aTab.length == 0)
            return;
        for(int i = 0; i < aTab.length; i++)
        {
            LightSignal light = (LightSignal)aTab[i];
            light.Stop();
            AlarmGroup alarmGroup = GetAlarmGroupByID(light.m_iAlarmID);
            if(alarmGroup == null)
            {
                alarmGroup = new AlarmGroup(light.m_iAlarmID);
                m_AlarmGroups.addElement(alarmGroup);
            }
            alarmGroup.AddAlarmLight(light);
        }

    }

    public void LogAlarmsGroups()
    {
        for(int i = 0; i < m_AlarmGroups.size(); i++)
            ((AlarmGroup)m_AlarmGroups.get(i)).LogAlarmGroup();

    }

    Vector GetTerminalsByID(int iAlarmGroupID)
    {
        AlarmGroup group = GetAlarmGroupByID(iAlarmGroupID);
        if(group == null)
            return null;
        if(group.m_aAlarmTerminals.size() == 0)
            return null;
        else
            return group.m_aAlarmTerminals;
    }

    public void OnCreate()
    {
        super.bSG = false;
        ActivateOnModule();
        InitLightSignals();
        InitAlarmTerminals();
        CallMethodEvery("UpdateAlarmGroups", _MIN_TIME_BTW_UPDATES);
    }

    void StartAlarmSystem()
    {
        InitAlarmGuards();
    }

    public void SGSaveChunk(FileChunk cFCParent)
    {
        FileChunk.Log("[AlarmsManager.SGSaveChunk]\n");
        FileChunk cFC = GameObject.NewChunk(1531, cFCParent);
        super.SGSaveChunk(cFC);
        cFC.SaveObjectsVectorRef(m_AlarmGroups);
        cFC.delete();
    }

    public void SGLoadChunk(FileChunk cParentFC)
    {
        FileChunk.Log("[AlarmsManager.SGLoadChunk]\n");
        FileChunk cFC = GameObject.LoadChunk(cParentFC);
        if(cFC.GetID() == 1531)
        {
            super.SGLoadChunk(cFC);
            m_AlarmGroups = cFC.LoadObjectsVectorRef();
        }
        cFC.delete();
    }

    public void OnDestroy()
    {
        DisableCallMethod("UpdateAlarmGroups");
    }

    static AlarmsManager m_AlarmsManager = null;
    static int _DEFAULT_ALARM_ID = 0;
    static float _MAX_ALARM_DURATION = 60F;
    static String _ALARM_SOUND_NAME = "Data/Sounds/alarm.wav";
    static float _MIN_TIME_BTW_UPDATES = 2.0F;
    static int _AUTO_ALARM_ID = 0xf4240;
    Vector m_AlarmGroups;
    boolean m_bAlarmMultiple;
    ChromeModuleSingle m_Module;

}
