// Decompiled by Jad v1.5.8g. Copyright 2001 Pavel Kouznetsov.
// Jad home page: http://www.kpdus.com/jad.html
// Decompiler options: packimports(3) 
// Source File Name:   Chat.java

import java.io.IOException;

public class Chat extends GameObject
    implements IChat
{

    void TryToConnect()
    {
        SetConnectionState(1);
        ConnectDo();
    }

    public void ScheduleReconnect()
    {
        m_nNickPostfix++;
        m_sNick = NetPlayerProfile.GetCurrentNickName() + m_nNickPostfix;
        m_cClient = null;
        DisconnectDo();
        TryToConnect();
    }

    private synchronized void ConnectDo()
    {
        if(m_cClient != null)
        {
            m_cClient.Destroy();
            m_cClient = null;
            DisableCallMethod(METHOD_TryToDisconnect);
            m_bConnectEnabled = false;
            CallMethodIn(METHOD_EnableConnect, 1.0F);
            DisableCallMethod(METHOD_ConnectDo);
            CallMethodIn(METHOD_ConnectDo, 1.0F);
            return;
        }
        if(!m_bConnectEnabled)
        {
            CallMethodIn(METHOD_ConnectDo, 0.01F);
            return;
        } else
        {
            m_cClient = new ChatClient("chat.chromethegame.com", 12468, m_sNick, this);
            DisableCallMethod(METHOD_ConnectDo);
            m_bDisconnectEnabled = false;
            CallMethodIn(METHOD_EnableDisconnect, 1.0F);
            m_bLockConnecting = true;
            CallMethodIn(METHOD_UnlockConnecting, 1.0F);
            return;
        }
    }

    protected synchronized void OutputMsg(String sMsg, int nType)
    {
        Vector vColor = NetMsg._COLOR_DEFAULT;
        switch(nType)
        {
        case 0: // '\0'
            sMsg = NetGameTools.RemoveLastSign(sMsg);
            vColor = NetMsg._COL_INMSG_CHAT;
            break;

        case 1: // '\001'
            sMsg = "priv from " + NetGameTools.RemoveLastSign(sMsg);
            vColor = NetMsg._COLOR_YELLOW;
            break;

        case 2: // '\002'
        case 3: // '\003'
            sMsg = NetGameTools.RemoveLastSign(sMsg);
            vColor = NetMsg._COLOR_YELLOW;
            break;

        case 4: // '\004'
            vColor = NetMsg._COL_INMSG_SERVER;
            break;

        case 5: // '\005'
            vColor = NetMsg._COL_INMSG_SYSTEM;
            break;

        case 6: // '\006'
            vColor = NetMsg._COLOR_RED;
            break;
        }
        OutputMsg(sMsg, vColor);
    }

    private synchronized void OutputMsg(String sText, Vector vColor)
    {
        ChatMsgInfo cMsgInfo = new ChatMsgInfo(sText, vColor);
        synchronized(m_cMsgHistory)
        {
            m_cMsgHistory.Add(cMsgInfo);
        }
        synchronized(m_cMsgToOutput)
        {
            m_cMsgToOutput.Add(cMsgInfo);
        }
        m_bMessagesChanged = true;
    }

    synchronized void OutputMsg()
    {
        synchronized(m_cMsgToOutput)
        {
            if(m_cIChatWindow != null)
            {
                for(int i = 0; i < m_cMsgToOutput.GetSize(); i++)
                {
                    ChatMsgInfo cMsgInfo = m_cMsgToOutput.GetMsgInfoAt(i);
                    m_cIChatWindow.OutputMsg(cMsgInfo.GetText(), cMsgInfo.GetColor());
                }

            }
            m_cMsgToOutput.RemoveAll();
        }
    }

    private String GetConnectionStateString(int nConnectionState)
    {
        String sText = null;
        switch(nConnectionState)
        {
        case 0: // '\0'
            sText = "Disconnected";
            break;

        case 1: // '\001'
            sText = "Connecting to " + "chat.chromethegame.com" + " ...";
            break;

        case 2: // '\002'
            sText = "Connected to " + "chat.chromethegame.com" + " as " + m_sNick;
            break;
        }
        return sText;
    }

    void CheckClient()
    {
        if(m_bClientsChanged)
        {
            m_bClientsChanged = false;
            ClientsChanged();
        }
        if(m_bMessagesChanged)
        {
            m_bMessagesChanged = false;
            OutputMsg();
        }
        if(m_nNewConnectionState != -1)
        {
            SetConnectionState(m_nNewConnectionState);
            m_nNewConnectionState = -1;
        }
    }

    boolean IsConnected()
    {
        return m_nConnectionState == 2;
    }

    protected synchronized void ClientsChanged()
    {
        String aClients[] = null;
        if(m_cClient != null)
            aClients = m_cClient.GetClients();
        if(m_cIChatWindow != null)
            m_cIChatWindow.UpdateClients(aClients);
    }

    public Chat()
    {
        m_bClientsChanged = false;
        m_nNewConnectionState = -1;
        m_bMessagesChanged = false;
        m_sNick = "Nick";
        m_nConnectionState = 0;
        m_cMsgHistory = new ChatMsgHistory(50);
        m_cMsgToOutput = new ChatMsgInfoList();
        m_cIChatWindow = null;
        METHOD_OutputMsg = 0;
        METHOD_TryToConnect = 0;
        METHOD_ConnectDo = 0;
        METHOD_TryToDisconnect = 0;
        METHOD_DisconnectDo = 0;
        METHOD_EnableConnect = 0;
        METHOD_EnableDisconnect = 0;
        METHOD_UnlockConnecting = 0;
        m_bConnectEnabled = true;
        m_bDisconnectEnabled = true;
        m_bLockConnecting = false;
        m_nNickPostfix = 0;
    }

    public void Acquire(IChatWindow cIChatWindow)
    {
        if(m_cIChatWindow != null)
            m_cIChatWindow.Acquire(null);
        m_cIChatWindow = cIChatWindow;
        if(m_cIChatWindow != null)
            m_cIChatWindow.Acquire(this);
    }

    public void Disconnect(String sReason)
    {
        if(IsConnected())
            TryToDisconnect();
    }

    void EnableDisconnect()
    {
        m_bDisconnectEnabled = true;
    }

    public ChatState GetState()
    {
        String aClients[] = null;
        ChatMsgHistory cMsgHistory = null;
        if(IsConnected())
        {
            if(m_cClient != null)
                aClients = m_cClient.GetClients();
            synchronized(m_cMsgHistory)
            {
                cMsgHistory = new ChatMsgHistory(m_cMsgHistory);
            }
        }
        return new ChatState(aClients, cMsgHistory, IsConnected(), GetConnectionStateString(m_nConnectionState));
    }

    protected void SetConnectionState(int nState)
    {
        m_nConnectionState = nState;
        UpdateConnnetionState();
    }

    public void Unacquire()
    {
        Acquire(null);
    }

    public void Connect()
    {
        m_nNickPostfix = 0;
        if(!IsConnected() && !m_bLockConnecting)
        {
            OutputMsg("Connecting...", 5);
            m_sNick = NetPlayerProfile.GetCurrentNickName();
            CallMethodIn(METHOD_TryToConnect, 0.1F);
        }
    }

    String GetNick()
    {
        return m_sNick;
    }

    void EnableConnect()
    {
        m_bConnectEnabled = true;
    }

    private synchronized void TryToDisconnect()
    {
        SetConnectionState(3);
        DisconnectDo();
    }

    private void DisconnectDo()
    {
        if(m_cClient != null)
        {
            if(!m_bDisconnectEnabled)
            {
                CallMethodIn(METHOD_DisconnectDo, 0.01F);
                return;
            }
            m_cClient.Disconnect("");
            m_cClient = null;
        }
        DisableCallMethod(METHOD_DisconnectDo);
        m_bConnectEnabled = false;
        CallMethodIn(METHOD_EnableConnect, 1.0F);
    }

    public synchronized void InputMsg(String sText)
    {
        if(IsConnected())
        {
            OutputMsg("> " + sText, NetMsg._COL_INMSG_CHAT_MY);
            try
            {
                if(m_cClient != null)
                    m_cClient.SendChatMsg(sText + "\n");
            }
            catch(IOException b)
            {
                OutputMsg("Can't send message.", 6);
                m_cClient.ConnectionLost();
            }
        } else
        {
            OutputMsg("Can't send message. You are disconnected", 6);
        }
    }

    public void LocalInputMsg(String sText, Vector vColor)
    {
        OutputMsg(sText, vColor);
    }

    void OnCreate()
    {
        METHOD_OutputMsg = RegisterCallMethod("OutputMsg");
        METHOD_TryToConnect = RegisterCallMethod("TryToConnect");
        METHOD_ConnectDo = RegisterCallMethod("ConnectDo");
        METHOD_TryToDisconnect = RegisterCallMethod("TryToDisconnect");
        METHOD_DisconnectDo = RegisterCallMethod("DisconnectDo");
        METHOD_EnableConnect = RegisterCallMethod("EnableConnect");
        METHOD_EnableDisconnect = RegisterCallMethod("EnableDisconnect");
        METHOD_UnlockConnecting = RegisterCallMethod("UnlockConnecting");
        CallMethodEvery("CheckClient", 0.1F);
    }

    private void UpdateConnnetionState()
    {
        String sText = GetConnectionStateString(m_nConnectionState);
        if(m_cIChatWindow != null)
            m_cIChatWindow.SetConnectionStatus(m_nConnectionState == 2, sText);
    }

    void UnlockConnecting()
    {
        m_bLockConnecting = false;
    }

    void OnDestroy()
    {
    }

    boolean m_bClientsChanged;
    int m_nNewConnectionState;
    boolean m_bMessagesChanged;
    static final String sm_sHost = "chat.chromethegame.com";
    static final int sm_nPort = 12468;
    static final int sm_nMsgHistoryLength = 50;
    private String m_sNick;
    private ChatClient m_cClient;
    private int m_nConnectionState;
    ChatMsgHistory m_cMsgHistory;
    ChatMsgInfoList m_cMsgToOutput;
    IChatWindow m_cIChatWindow;
    int METHOD_OutputMsg;
    int METHOD_TryToConnect;
    int METHOD_ConnectDo;
    int METHOD_TryToDisconnect;
    int METHOD_DisconnectDo;
    int METHOD_EnableConnect;
    int METHOD_EnableDisconnect;
    int METHOD_UnlockConnecting;
    private boolean m_bConnectEnabled;
    private boolean m_bDisconnectEnabled;
    private boolean m_bLockConnecting;
    static final float _TOGGLE_CONNECTION_DELAY = 1F;
    private int m_nNickPostfix;
}
