// Decompiled by Jad v1.5.8g. Copyright 2001 Pavel Kouznetsov.
// Jad home page: http://www.kpdus.com/jad.html
// Decompiler options: packimports(3) 
// Source File Name:   ChatClient.java

import java.io.*;
import java.net.Socket;
import java.net.UnknownHostException;

public class ChatClient extends ChatClientBase
{

    protected void SendRequestDisconnect(String sReason)
        throws IOException
    {
        synchronized(super.m_cOutput)
        {
            super.m_cOutput.writeShort(7);
            super.m_cOutput.writeInt(m_nMyId);
            super.m_cOutput.writeUTF(sReason);
        }
    }

    private void RecvStoredMsgs()
        throws IOException
    {
        short nMsgCnt = 0;
        nMsgCnt = super.m_cInput.readShort();
        if(nMsgCnt > 0)
        {
            for(int i = 0; i < nMsgCnt; i++)
            {
                String sNick = "";
                String sMsg = "";
                sNick = super.m_cInput.readUTF();
                sMsg = super.m_cInput.readUTF();
                OutputMsg(sNick + "> " + sMsg, 3);
            }

        }
    }

    private void RecvAndIgnoreUserActivity()
        throws IOException
    {
        InputReadClient();
        super.m_cInput.readShort();
        int nUsers = 0;
        nUsers = super.m_cInput.readInt();
        for(int i = 0; i < nUsers; i++)
            super.m_cInput.readInt();

    }

    private void RecvNewUserConnected()
        throws IOException
    {
        String sNick = super.m_cInput.readUTF();
        OutputMsg("'" + sNick + "' connected", 5);
    }

    private void RecvAndIgnoreUserEnterChannel()
        throws IOException
    {
        super.m_cInput.readInt();
        super.m_cInput.readUTF();
        super.m_cInput.readBoolean();
        super.m_cInput.readUTF();
        super.m_cInput.readBoolean();
    }

    protected void Disconnect(String sReason)
    {
        OutputMsg("Disconnected.", 5);
        try
        {
            super.m_bRunning = false;
            if(super.m_cOutput != null)
                SendRequestDisconnect(sReason);
            CloseUp();
        }
        catch(IOException e) { }
    }

    protected void SendMyVersion()
        throws IOException
    {
        synchronized(super.m_cOutput)
        {
            super.m_cOutput.writeShort(1);
            super.m_cOutput.writeDouble(m_fVersion);
        }
    }

    private void RecvChatMsg()
        throws IOException
    {
        ChatClientInfo cSenderInfo = null;
        boolean bPrivate = false;
        String sMsg = "";
        cSenderInfo = InputReadClient();
        bPrivate = super.m_cInput.readBoolean();
        super.m_cInput.readShort();
        sMsg = super.m_cInput.readUTF();
        InputReadAndSkipRecipients();
        if(cSenderInfo != null)
            sMsg = cSenderInfo.GetNick() + "> " + sMsg;
        int nType = bPrivate ? 1 : 0;
        OutputMsg(sMsg, nType);
    }

    private void RecvAndIgnoreLine()
        throws IOException
    {
        InputReadClient();
        super.m_cInput.readShort();
        super.m_cInput.readShort();
        super.m_cInput.readShort();
        super.m_cInput.readShort();
        super.m_cInput.readShort();
        super.m_cInput.readShort();
        InputReadAndSkipRecipients();
    }

    private void RecvUserDisconnected()
        throws IOException
    {
        int nId = 0;
        String sReason = "";
        nId = super.m_cInput.readInt();
        sReason = super.m_cInput.readUTF();
        super.m_cInput.readFully(new byte[super.m_cInput.available()]);
        if(sReason.equals(""))
            sReason = "no reason";
        if(nId == m_nMyId || nId == 0)
        {
            if(sReason.startsWith("There is already a user called"))
            {
                Chat cChat = m_cChat;
                CloseUp();
                if(cChat != null)
                    cChat.ScheduleReconnect();
            } else
            {
                OutputMsg("You have been disconnected", 5);
                CloseUp();
            }
        } else
        {
            ChatClientInfo cClientInfo = FindClientInfoById(nId);
            if(cClientInfo != null)
            {
                String sNick = cClientInfo.GetNick();
                OutputMsg("'" + sNick + "' disconnected", 5);
                synchronized(m_cClients)
                {
                    m_cClients.Remove(cClientInfo);
                }
                if(m_cChat != null)
                    m_cChat.m_bClientsChanged = true;
            }
        }
    }

    private void RecvAndIgnoreError()
        throws IOException
    {
        ChatClientInfo cSenderInfo = null;
        short nError = 0;
        InputReadClient();
        super.m_cInput.readShort();
        InputReadAndSkipRecipients();
    }

    private void SetConnectionState(int nState)
    {
        if(m_cChat != null)
            m_cChat.m_nNewConnectionState = nState;
    }

    private void RecvAndIgnoreClearBoard()
        throws IOException
    {
        InputReadClient();
        InputReadAndSkipRecipients();
    }

    private byte[] InputReadAll()
        throws IOException
    {
        byte aAll[] = new byte[super.m_cInput.available()];
        super.m_cInput.readFully(aAll);
        return aAll;
    }

    private void RecvAndIgnoreChannelList()
        throws IOException
    {
        int nRoomsCnt = 0;
        nRoomsCnt = super.m_cInput.readShort();
        for(int i = 0; i < nRoomsCnt; i++)
        {
            super.m_cInput.readUTF();
            super.m_cInput.readUTF();
            super.m_cInput.readBoolean();
            super.m_cInput.readBoolean();
            int nUsers = super.m_cInput.readInt();
            for(int j = 0; j < nUsers; j++)
                super.m_cInput.readUTF();

        }

    }

    public String[] GetClients()
    {
        String aNicks[] = null;
        synchronized(m_cClients)
        {
            if(m_cClients.GetSize() > 0)
            {
                aNicks = new String[m_cClients.GetSize()];
                for(int i = 0; i < m_cClients.GetSize(); i++)
                {
                    ChatClientInfo cInfo = m_cClients.GetClientInfoAt(i);
                    if(cInfo != null)
                        aNicks[i] = cInfo.GetNick();
                }

            }
        }
        return aNicks;
    }

    private void RecvSpecialMsg()
        throws IOException
    {
        ChatClientInfo cSenderInfo = null;
        String sMsg = "";
        cSenderInfo = InputReadClient();
        super.m_cInput.readInt();
        sMsg = super.m_cInput.readUTF();
        if(cSenderInfo != null)
            sMsg = cSenderInfo.GetNick() + "> " + sMsg;
        OutputMsg(sMsg, 2);
    }

    protected synchronized void CloseUp()
    {
        SetConnectionState(0);
        super.m_bRunning = false;
        if(super.m_cInput != null)
            try
            {
                super.m_cInput.close();
            }
            catch(IOException e1) { }
        try
        {
            if(super.m_cOutput != null)
                synchronized(super.m_cOutput)
                {
                    SendToServer();
                    super.m_cOutput.close();
                }
            if(super.m_cSocket != null)
                super.m_cSocket.close();
        }
        catch(IOException e2) { }
        super.m_cInput = null;
        super.m_cOutput = null;
        super.m_cSocket = null;
        m_cClients.Clear();
        m_cChat = null;
        System.gc();
    }

    public void SendRequestStoredMsgs()
        throws IOException
    {
        synchronized(super.m_cOutput)
        {
            super.m_cOutput.writeShort(25);
            super.m_cOutput.writeInt(m_nMyId);
        }
    }

    private void RecvAndIgnoreBanUser()
        throws IOException
    {
        InputReadClient();
        super.m_cInput.readUTF();
        super.m_cInput.readInt();
    }

    private void RecvAndIgnorePageUser()
        throws IOException
    {
        InputReadClient();
        InputReadAndSkipRecipients();
    }

    protected void SendChatMsg(String sText)
        throws IOException
    {
        synchronized(super.m_cOutput)
        {
            super.m_cOutput.writeShort(15);
            super.m_cOutput.writeInt(m_nMyId);
            super.m_cOutput.writeBoolean(false);
            super.m_cOutput.writeShort(0);
            super.m_cOutput.writeUTF(sText);
            super.m_cOutput.writeInt(0);
        }
    }

    void OutputMsg(String sText, int nType)
    {
        if(m_cChat != null)
            m_cChat.OutputMsg(sText, nType);
    }

    public ChatClient(String sHost, int nPort, String sNick, Chat cChat)
    {
        super(sHost, nPort);
        m_nMyId = 0;
        m_sNick = null;
        m_fVersion = 2.1000000000000001D;
        m_cClients = new ChatClientInfoList();
        m_cChat = null;
        m_cChat = cChat;
        m_sNick = sNick;
        start();
    }

    private void RecvAndIgnoreDrawPicture()
        throws IOException
    {
        int nLen = 0;
        byte aData[] = null;
        InputReadClient();
        super.m_cInput.readShort();
        super.m_cInput.readShort();
        nLen = super.m_cInput.readInt();
        aData = new byte[nLen];
        for(int nRead = 0; nRead < nLen; nRead += super.m_cInput.read(aData, nRead, nLen - nRead));
        InputReadAndSkipRecipients();
    }

    private void RecvUserInfo()
        throws IOException
    {
        int nId = 0;
        String sNick = "";
        nId = super.m_cInput.readInt();
        sNick = super.m_cInput.readUTF();
        super.m_cInput.readUTF();
        super.m_cInput.readBoolean();
        super.m_cInput.readUTF();
        super.m_cInput.readUTF();
        if(sNick.equals(m_sNick))
        {
            m_nMyId = nId;
            SetConnectionState(2);
            OutputMsg("Connected as " + m_sNick, 5);
        }
        synchronized(m_cClients)
        {
            m_cClients.Add(new ChatClientInfo(nId, sNick));
        }
        if(m_cChat != null)
            m_cChat.m_bClientsChanged = true;
    }

    void Destroy()
    {
        m_cChat = null;
        CloseUp();
    }

    protected void RecvFromServer()
        throws IOException
    {
        short nCommand = 0;
        synchronized(super.m_cInput)
        {
            super.m_cInput.mark(1024);
            nCommand = super.m_cInput.readShort();
            if(!super.m_bRunning)
                return;
            switch(nCommand)
            {
            case 15: // '\017'
                RecvChatMsg();
                break;

            case 23: // '\027'
                RecvSpecialMsg();
                break;

            case 26: // '\032'
                RecvStoredMsgs();
                break;

            case 6: // '\006'
                RecvMsgFromServer();
                break;

            case 4: // '\004'
                RecvNewUserConnected();
                break;

            case 7: // '\007'
                RecvUserDisconnected();
                break;

            case 5: // '\005'
                RecvUserInfo();
                break;

            case 14: // '\016'
                RecvAndIgnoreUserActivity();
                break;

            case 8: // '\b'
                RecvAndIgnoreChannelList();
                break;

            case 9: // '\t'
                RecvAndIgnoreInviteChannel();
                break;

            case 10: // '\n'
                RecvAndIgnoreUserEnterChannel();
                break;

            case 11: // '\013'
                RecvAndIgnoreKickUser();
                break;

            case 12: // '\f'
                RecvAndIgnoreBanUser();
                break;

            case 13: // '\r'
                RecvAndIgnoreUnbanUser();
                break;

            case 16: // '\020'
                RecvAndIgnoreLine();
                break;

            case 17: // '\021'
                RecvAndIgnoreDrawRect();
                break;

            case 18: // '\022'
                RecvAndIgnoreDrawOval();
                break;

            case 19: // '\023'
                RecvAndIgnoreDrawText();
                break;

            case 20: // '\024'
                RecvAndIgnoreDrawPicture();
                break;

            case 21: // '\025'
                RecvAndIgnoreClearBoard();
                break;

            case 22: // '\026'
                RecvAndIgnorePageUser();
                break;

            case 27: // '\033'
                RecvAndIgnoreError();
                break;

            case 24: // '\030'
            case 25: // '\031'
            default:
                InputReadAll();
                break;

            case 2: // '\002'
            case 3: // '\003'
                break;
            }
        }
    }

    private void RecvMsgFromServer()
        throws IOException
    {
        OutputMsg(super.m_cInput.readUTF(), 4);
    }

    private void InputReadAndSkipRecipients()
        throws IOException
    {
        int nRecipientsCnt = super.m_cInput.readInt();
        for(int i = 0; i < nRecipientsCnt; i++)
            super.m_cInput.readInt();

    }

    protected void SendMyInfo()
        throws IOException
    {
        synchronized(super.m_cOutput)
        {
            super.m_cOutput.writeShort(5);
            super.m_cOutput.writeInt(0);
            super.m_cOutput.writeUTF(m_sNick);
            super.m_cOutput.writeUTF("");
            super.m_cOutput.writeBoolean(false);
            super.m_cOutput.writeUTF("");
            super.m_cOutput.writeUTF("en");
        }
    }

    private void RecvAndIgnoreDrawText()
        throws IOException
    {
        InputReadClient();
        super.m_cInput.readShort();
        super.m_cInput.readShort();
        super.m_cInput.readShort();
        super.m_cInput.readShort();
        super.m_cInput.readShort();
        super.m_cInput.readShort();
        super.m_cInput.readUTF();
        InputReadAndSkipRecipients();
    }

    private ChatClientInfo FindClientInfoById(int nId)
    {
        synchronized(m_cClients)
        {
            ChatClientInfo chatclientinfo = m_cClients.FindClientInfoById(nId);
            return chatclientinfo;
        }
    }

    private void RecvAndIgnoreDrawRect()
        throws IOException
    {
        InputReadClient();
        super.m_cInput.readShort();
        super.m_cInput.readShort();
        super.m_cInput.readShort();
        super.m_cInput.readShort();
        super.m_cInput.readShort();
        super.m_cInput.readShort();
        super.m_cInput.readBoolean();
        InputReadAndSkipRecipients();
    }

    protected void ConnectionLost()
    {
        if(super.m_bRunning)
        {
            OutputMsg("Connection to server lost", 5);
            CloseUp();
        }
    }

    private void RecvAndIgnoreKickUser()
        throws IOException
    {
        InputReadClient();
        super.m_cInput.readUTF();
        super.m_cInput.readInt();
    }

    private void RecvAndIgnoreUnbanUser()
        throws IOException
    {
        InputReadClient();
        super.m_cInput.readUTF();
        super.m_cInput.readInt();
    }

    public void run()
    {
        if(!super.m_bStarted)
        {
            super.m_bStarted = true;
            Start();
        }
        super.run();
    }

    private ChatClientInfo InputReadClient()
        throws IOException
    {
        int nId = 0;
        nId = super.m_cInput.readInt();
        return FindClientInfoById(nId);
    }

    private void RecvAndIgnoreInviteChannel()
        throws IOException
    {
        InputReadClient();
        super.m_cInput.readUTF();
        super.m_cInput.readInt();
    }

    private void RecvAndIgnoreDrawOval()
        throws IOException
    {
        InputReadClient();
        super.m_cInput.readShort();
        super.m_cInput.readShort();
        super.m_cInput.readShort();
        super.m_cInput.readShort();
        super.m_cInput.readShort();
        super.m_cInput.readShort();
        super.m_cInput.readBoolean();
        InputReadAndSkipRecipients();
    }

    protected void Start()
    {
        try
        {
            super.m_bRunning = true;
            super.Start();
            synchronized(super.m_cInput)
            {
                synchronized(super.m_cOutput)
                {
                    SendMyVersion();
                    if(super.m_cInput.readShort() == 1)
                        RecvServerVersion();
                    else
                        InputReadAll();
                }
            }
            SendMyInfo();
            SendRequestStoredMsgs();
        }
        catch(UnknownHostException e1)
        {
            OutputMsg("Can't connect. Unknown host " + super.m_sHost, 6);
            super.m_bRunning = false;
            return;
        }
        catch(IOException e2)
        {
            OutputMsg("Can't connect. Chat server not found on " + super.m_sHost, 6);
            super.m_bRunning = false;
            return;
        }
        catch(Exception e3)
        {
            OutputMsg("Can't connect.", 6);
            super.m_bRunning = false;
            return;
        }
    }

    private void RecvServerVersion()
        throws IOException
    {
        m_fVersion = super.m_cInput.readDouble();
    }

    private int m_nMyId;
    private String m_sNick;
    private double m_fVersion;
    private ChatClientInfoList m_cClients;
    private Chat m_cChat;
}
