// Decompiled by Jad v1.5.8g. Copyright 2001 Pavel Kouznetsov.
// Jad home page: http://www.kpdus.com/jad.html
// Decompiler options: packimports(3) 
// Source File Name:   ConnectionStatusManager.java


public class ConnectionStatusManager extends GameObject
{

    void CancelDisconnect()
    {
        DisableCallMethod(METHOD_Disconnect);
    }

    private void SetStatus(int nComponent, byte byStatus)
    {
        m_aComponents[nComponent] = byStatus;
    }

    private byte GetStatus(int nComponent)
    {
        return m_aComponents[nComponent];
    }

    void TimeCompensatorConnectionToServerLost()
    {
        Update(2, 2);
    }

    void ScheduleDisconnect()
    {
        CallMethodIn(METHOD_Disconnect, 10F);
    }

    private void Update(int nComponent, int nValue)
    {
        byte byStatus = CalcStatus(nComponent, nValue);
        if(byStatus != GetStatus(nComponent))
        {
            SetStatus(nComponent, byStatus);
            CheckIfMainStatusChanged();
        }
    }

    ConnectionStatusManager()
    {
        m_cGameInfo = null;
        m_byCurrentStatus = 0;
        m_bRunning = false;
        METHOD_LockPlayer = 0;
        METHOD_Disconnect = 0;
        m_bPlayerLocked = false;
        for(int i = 0; i < m_aComponents.length; i++)
            m_aComponents[i] = 0;

        m_byCurrentStatus = 0;
    }

    private void CheckIfMainStatusChanged()
    {
        if(UpdateCurrentStatus())
        {
            UpdateHud();
            if(m_cGameInfo.IsLocalPlayer())
                UpdateLockPlayer();
            UpdateDisconnect();
        }
    }

    void Stop()
    {
        for(int nComponent = 0; nComponent < m_aComponents.length; nComponent++)
            SetStatus(nComponent, (byte)0);

        CheckIfMainStatusChanged();
        m_bRunning = false;
    }

    void UpdatePacketLoss(int nPacketLoss)
    {
        Update(1, nPacketLoss);
    }

    void TimeCompensatorServerNotResponding()
    {
        Update(2, 1);
    }

    private byte CalcStatus(int nComponent, int nValue)
    {
        int aThresholds[] = sm_aComponenstDef[nComponent].GetStatusThresholds();
        byte nStatus;
        for(nStatus = 0; nStatus < aThresholds.length; nStatus++)
            if(nValue < aThresholds[nStatus])
                return nStatus;

        return nStatus;
    }

    private boolean UpdateCurrentStatus()
    {
        byte byStatus = 0;
        float fDisconnectDelayTime = -1F;
        for(int nComponent = 0; nComponent < m_aComponents.length; nComponent++)
            if(byStatus < m_aComponents[nComponent])
                byStatus = m_aComponents[nComponent];

        if(m_byCurrentStatus != byStatus)
        {
            m_byCurrentStatus = byStatus;
            return true;
        } else
        {
            return false;
        }
    }

    void Disconnect()
    {
        DisableCallMethod(METHOD_Disconnect);
        if(m_cGameInfo != null)
            m_cGameInfo.EventDisconnectByConnectionStatusManager();
        else
            CallMethodIn(METHOD_Disconnect, 0.1F);
    }

    private void UpdateHud()
    {
        if(m_cGameInfo.GetHUDNet() != null)
            m_cGameInfo.GetHUDNet().SetConnectionStatus(m_byCurrentStatus);
    }

    void UpdateLatency(int nLatency)
    {
        Update(0, nLatency);
    }

    void LockPlayer()
    {
        DisableCallMethod(METHOD_LockPlayer);
        if(m_cGameInfo.GetMyPlayerNet() != null)
            m_cGameInfo.GetMyPlayerNet().SetLockedByConnectionStatusManager(true);
        else
            CallMethodIn(METHOD_LockPlayer, 0.5F);
    }

    private void UpdateDisconnect()
    {
        if(m_byCurrentStatus >= 3)
            ScheduleDisconnect();
        else
            CancelDisconnect();
    }

    private void UpdateLockPlayer()
    {
        boolean bPlayerLocked = false;
        for(int nComponent = 0; nComponent < m_aComponents.length; nComponent++)
        {
            if(sm_aComponenstDef[nComponent].GetMinLockPlayerStatus() == -1 || sm_aComponenstDef[nComponent].GetMinLockPlayerStatus() > m_aComponents[nComponent])
                continue;
            bPlayerLocked = true;
            break;
        }

        if(m_bPlayerLocked != bPlayerLocked)
        {
            m_bPlayerLocked = bPlayerLocked;
            if(m_bPlayerLocked)
                LockPlayer();
            else
                UnLockPlayer();
        }
    }

    void UnLockPlayer()
    {
        DisableCallMethod(METHOD_LockPlayer);
        if(m_cGameInfo.GetMyPlayerNet() != null)
            m_cGameInfo.GetMyPlayerNet().SetLockedByConnectionStatusManager(false);
    }

    void TimeCompensatorOk()
    {
        Update(2, 0);
    }

    void OnCreate()
    {
        METHOD_LockPlayer = RegisterCallMethod("LockPlayer");
        METHOD_Disconnect = RegisterCallMethod("Disconnect");
    }

    void SetGameInfo(NetGameInfoBase cGameInfo)
    {
        m_cGameInfo = cGameInfo;
    }

    void Start()
    {
        m_bRunning = true;
    }

    void OnDestroy()
    {
        m_cGameInfo = null;
    }

    static final int _STATUS_OK = 0;
    static final int _STATUS_WARNING = 1;
    static final int _STATUS_ERROR = 2;
    static final int _STATUS_CRITICAL_ERROR = 3;
    static final int _NO_LOCK_PLAYER = -1;
    static final int _LOCK_PLAYER_AT_WARNING = 1;
    static final int _LOCK_PLAYER_AT_ERROR = 2;
    static final int _LATENCY = 0;
    static final int _PACKET_LOSS = 1;
    static final int _TIME_COMPENSATOR = 2;
    static final int _COMPONENTS_CNT = 3;
    static final int _COMPONENT_OK = 0;
    static final int _COMPONENT_WARNING = 1;
    static final int _COMPONENT_ERROR = 2;
    static final int _COMPONENT_CRITICAL_ERROR = 3;
    static final int _DISCONNECT_DELAY_TIME = 10;
    static final ConnectionStatusInfo sm_aComponenstDef[] = {
        new ConnectionStatusInfo(2, 400, 700, 1000, 10F), new ConnectionStatusInfo(2, 10, 20, 40, 10F), new ConnectionStatusInfo(2)
    };
    static final byte m_aComponents[] = new byte[3];
    NetGameInfoBase m_cGameInfo;
    byte m_byCurrentStatus;
    private boolean m_bRunning;
    int METHOD_LockPlayer;
    int METHOD_Disconnect;
    boolean m_bPlayerLocked;

}
