// Decompiled by Jad v1.5.8g. Copyright 2001 Pavel Kouznetsov.
// Jad home page: http://www.kpdus.com/jad.html
// Decompiler options: packimports(3) 
// Source File Name:   ConsoleCommand.java


public abstract class ConsoleCommand
{

    int GetErrorId()
    {
        return m_nErrorId;
    }

    boolean IsLocalPerform()
    {
        return m_bLocalPerform;
    }

    void SetLocalPerform(boolean bLocal)
    {
        m_bLocalPerform = bLocal;
    }

    String GetPlayerIdName()
    {
        if(IsInternetGame())
            return "PID";
        else
            return "HostId";
    }

    String GetName()
    {
        return m_sName;
    }

    String GetTextCommandName()
    {
        return GetName();
    }

    void InitPerform()
    {
        if(IsForAdminsOnly() && !ShouldExecuteOnlyOnServer())
        {
            NetLog.Error(" ConsoleCommand " + GetNetInfo() + " IsForAdminsOnly but not ShouldExecuteOnlyOnServer");
            SetErrorId(0x7fffffff);
        }
        m_cPlayerInfo = m_cGameInfo.GetPlayerInfoList().GetPlayerByHostId(GetHost());
    }

    void Perform()
    {
    }

    boolean AreResultsExpected()
    {
        return m_bResultsExpected || m_sResults != null;
    }

    boolean ErrorOccured()
    {
        return m_nErrorId != 0;
    }

    String GetTextCommandNotAccepted()
    {
        return NetGameTools.MixString(Text.Get("&ConsoleCommandNotAccepted&"), GetTextCommandName());
    }

    int GetPlayerId(NetPlayerInfo cPlayerInfo)
    {
        if(IsInternetGame())
            return cPlayerInfo.GetPID();
        else
            return cPlayerInfo.GetClientOwnerId();
    }

    String GetNetInfo()
    {
        return "" + m_sName + " id:" + m_nId;
    }

    void PackResults(GameObject cMessager)
    {
        cMessager.MessagePackInt(m_nHost);
        cMessager.MessagePackStringBool(m_sResults);
        boolean bResultsContainer = m_aResultsContainer != null;
        cMessager.MessagePackBoolean(bResultsContainer);
        if(bResultsContainer)
            m_aResultsContainer.ToMessage(cMessager);
    }

    void UnPackAddResults(GameObject gameobject)
    {
    }

    void ShowResults()
    {
        boolean bNullResults = false;
        if(m_sResults == null)
        {
            m_sResults = GetTextCommandAccepted();
            bNullResults = true;
        }
        WriteResults(m_sResults);
        if(bNullResults)
            m_sResults = null;
    }

    boolean ShouldExecuteOnlyOnServer()
    {
        return m_bShouldExecuteOnlyOnServer;
    }

    void UnPackResults(GameObject cMessager)
    {
        m_nHost = cMessager.MessageUnPackInt();
        m_sResults = cMessager.MessageUnPackStringBool(null);
        boolean bResultsContainer = cMessager.MessageUnPackBoolean();
        if(bResultsContainer)
        {
            m_aResultsContainer = new NetDataContainer();
            m_aResultsContainer.FromMessage(cMessager);
        }
    }

    void UnPack(GameObject cMessager)
    {
        m_nHost = cMessager.MessageGetSenderId();
    }

    protected void WriteResults(String sText)
    {
        if(sText != null)
            m_cGameInfo.WriteCommandResults(sText);
    }

    protected void WriteSpecialResults(String sText)
    {
        if(sText != null)
            m_cGameInfo.WriteSpecialCommandResults(sText);
    }

    void UnPackErrors(GameObject cMessager)
    {
        m_nErrorId = cMessager.MessageUnPackInt();
    }

    boolean AreResultsToAll()
    {
        return m_bResultsToAll;
    }

    int GetCurrentStatus()
    {
        return m_nCurrentStatus;
    }

    int GetRequiredAdminRights()
    {
        return m_nRequiredAdminRights;
    }

    int GetHost()
    {
        return m_nHost;
    }

    void Clean()
    {
        m_nCurrentStatus = 0;
        m_nHost = 0;
        m_bLocalPerform = false;
        m_sResults = null;
        m_aResultsContainer = null;
        m_nErrorId = 0;
        m_cPlayerInfo = null;
    }

    boolean IsEqual(String sName)
    {
        if(sName == null || m_sName == null)
            return false;
        return m_sName.compareToIgnoreCase(sName) == 0;
    }

    boolean IsEqual(int nId)
    {
        return m_nId == nId;
    }

    ConsoleCommand()
    {
        m_cGameInfo = null;
        m_cPlayerInfoList = null;
        m_sName = null;
        m_nId = -1;
        m_nRequiredAdminRights = -1;
        m_bResultsExpected = true;
        m_bResultsToAll = false;
        m_bShouldExecuteOnlyOnServer = true;
        m_nCurrentStatus = 0;
        m_nHost = 0;
        m_cPlayerInfo = null;
        m_bLocalPerform = false;
        m_nErrorId = 0;
        m_sResults = null;
        m_aResultsContainer = null;
        String sClassName = getClass().getName();
        m_sName = NetGameTools.GetTextWithoutPrefix(sClassName, "Command");
    }

    String GetTextCommandAccepted()
    {
        return NetGameTools.MixString(Text.Get("&ConsoleCommandAccepted&"), GetTextCommandName());
    }

    boolean IsError(int nErrorId)
    {
        return nErrorId != 0;
    }

    void PostPerform()
    {
    }

    void SetId(int nId)
    {
        m_nId = nId;
    }

    boolean IsInternetGame()
    {
        return m_cGameInfo != null && m_cGameInfo.IsInternetGame();
    }

    boolean IsForAdminsOnly()
    {
        return m_nRequiredAdminRights > -1;
    }

    int GetId()
    {
        return m_nId;
    }

    void Pack(GameObject gameobject)
    {
    }

    void SetErrorId(int nId)
    {
        m_nErrorId = nId;
    }

    void SetErrorId()
    {
        SetErrorId(0x7fffffff);
    }

    void PackErrors(GameObject cMessager)
    {
        cMessager.MessagePackInt(m_nErrorId);
    }

    void Init(ConsoleCommand cCommand)
    {
        m_nHost = cCommand.GetHost();
    }

    void ShowErrors()
    {
        String sError = GetTextCommandNotAccepted();
        switch(m_nErrorId)
        {
        case 1: // '\001'
            sError = sError + " " + Text.Get("&ConsoleCommandUnknown&");
            break;

        case 10: // '\n'
            sError = sError + " " + Text.Get("&ConsoleCommandYouAreNotAdmin&");
            break;

        case 11: // '\013'
            sError = sError + " " + Text.Get("&ConsoleCommandYouAreNotAuthorizedToExecuteThisCommand&");
            break;

        case 15: // '\017'
            sError = sError + " " + Text.Get("&ConsoleCommandWrongParameter&");
            break;

        case 16: // '\020'
            sError = sError + " " + Text.Get("&ConsoleCommandWrongParameterType&");
            break;

        case 17: // '\021'
            sError = sError + " " + Text.Get("&ConsoleCommandWrongParameterNumber&");
            break;

        case 20: // '\024'
            sError = sError + " " + Text.Get("&ConsoleCommandPlayerNotFound&");
            break;

        case 21: // '\025'
            sError = sError + " " + Text.Get("&ConsoleCommandPlayerIsDead&");
            break;

        case 22: // '\026'
            sError = sError + " " + Text.Get("&ConsoleCommandGameOver&");
            break;

        case 23: // '\027'
            sError = sError + " " + Text.Get("&ConsoleCommandNotTeamGameplayMode&");
            break;

        default:
            sError = null;
            NetLog.Warning("ConsoleError " + GetErrorId() + " not supported");
            break;

        case 2147483647: 
            break;
        }
        if(sError != null)
            WriteResults(sError);
    }

    void InitStreamParams(String s)
    {
    }

    static String GetResultsPrefix()
    {
        return "|>";
    }

    static String GetAdminPrefix()
    {
        return "!>";
    }

    void SetGameInfo(NetGameInfoHud cGameInfo)
    {
        m_cGameInfo = cGameInfo;
        m_cPlayerInfoList = m_cGameInfo == null ? null : m_cGameInfo.GetPlayerInfoList();
    }

    void SetName(String sName)
    {
        m_sName = sName;
    }

    static final String sm_sResultsPrefix = "|>";
    static final String sm_sAdminPrefix = "!>";
    protected NetGameInfoHud m_cGameInfo;
    protected NetPlayerInfoList m_cPlayerInfoList;
    private String m_sName;
    private int m_nId;
    int m_nRequiredAdminRights;
    boolean m_bResultsExpected;
    boolean m_bResultsToAll;
    boolean m_bShouldExecuteOnlyOnServer;
    private int m_nCurrentStatus;
    private int m_nHost;
    NetPlayerInfo m_cPlayerInfo;
    private boolean m_bLocalPerform;
    private int m_nErrorId;
    String m_sResults;
    NetDataContainer m_aResultsContainer;
}
