// Decompiled by Jad v1.5.8g. Copyright 2001 Pavel Kouznetsov.
// Jad home page: http://www.kpdus.com/jad.html
// Decompiler options: packimports(3) 
// Source File Name:   ConsoleCommandBaseMap.java

import java.io.File;

public class ConsoleCommandBaseMap extends ConsoleCommandParams
{

    void Clean()
    {
        super.Clean();
        m_sMapName = null;
        m_nGameType = -1;
        m_aNetMapInfo = null;
    }

    ConsoleCommandBaseMap()
    {
        m_sMapName = null;
        m_nGameType = -1;
        m_aNetMapInfo = null;
        super.m_nRequiredAdminRights = 0;
        super.m_nMinParams = 1;
        super.m_nMaxParams = 2;
        super.m_bResultsToAll = true;
    }

    String GetTextCommandName()
    {
        String sName = super.GetTextCommandName();
        if(GetParamsCnt() > 0)
        {
            sName = sName + " " + GetParam(0);
            if(GetParamsCnt() > 1)
                sName = sName + " " + GetParam(1);
        }
        return sName;
    }

    void InitPerform()
    {
        super.InitPerform();
        if(ErrorOccured())
            return;
        if(super.m_cGameInfo.IsGameOver())
        {
            SetErrorId(0x7fffffff);
            return;
        }
        m_sMapName = GetSParam(0);
        m_nGameType = -1;
        if(GetParamsCnt() > 1)
        {
            String sGameType = GetSParam(1);
            m_nGameType = ENetGameType.GetGameTypeIdByShortName(sGameType);
            if(m_nGameType != -1)
            {
                sGameType = ENetGameType.GetGameNameShort(m_nGameType);
                SetParam(1, sGameType);
            } else
            {
                SetErrorId(35);
            }
        }
        if(ErrorOccured())
            return;
        m_aNetMapInfo = FindNetMapInfo();
        if(m_aNetMapInfo == null)
        {
            SetErrorId(0x7fffffff);
            return;
        } else
        {
            return;
        }
    }

    void Perform()
    {
    }

    void PackResults(GameObject cMessager)
    {
        super.PackResults(cMessager);
        cMessager.MessagePackStringBoolTable(GetParams());
    }

    void UnPackResults(GameObject cMessager)
    {
        super.UnPackResults(cMessager);
        SetParams(cMessager.MessageUnPackStringBoolTable(""));
    }

    void ShowErrors()
    {
        String sError = GetTextCommandNotAccepted();
        switch(GetErrorId())
        {
        case 33: // '!'
            sError = sError + " " + Text.Get("&ConsoleCommandWrongMapName&");
            break;

        case 35: // '#'
            sError = sError + " " + Text.Get("&ConsoleCommandUnknownGameplayMode&");
            break;

        case 36: // '$'
            sError = sError + " " + Text.Get("&ConsoleCommandYouCantRunThisMapInGivenGameplayMode&");
            break;

        case 37: // '%'
            sError = sError + " " + Text.Get("&ConsoleCommandNoGameplayModeAvailableForGivenMap&");
            break;

        case 38: // '&'
            sError = sError + " " + Text.Get("&ConsoleCommandCannotRemoveThisMapFromTheMapList&");
            break;

        case 34: // '"'
        default:
            sError = null;
            super.ShowErrors();
            break;
        }
        if(sError != null)
            WriteResults(sError);
    }

    private NetMapInfo[] FindNetMapInfo()
    {
        NetMapInfo aMapInfo[] = null;
        File cMapDir = new File("Data/LevelsNet");
        if(!cMapDir.exists())
        {
            SetErrorId(33);
            return null;
        }
        String aList[] = cMapDir.list();
        for(int i = 0; i < aList.length; i++)
            if(m_sMapName.equalsIgnoreCase(aList[i]))
            {
                String sDirToCheck = "Data/LevelsNet" + "/" + aList[i];
                File cDirToCheck = new File(sDirToCheck);
                if(cDirToCheck.isDirectory())
                {
                    m_sMapName = aList[i];
                    SetParam(0, m_sMapName);
                }
            }

        String sDir = "Data/LevelsNet" + "/" + m_sMapName;
        String sMapFile = sDir + "/" + m_sMapName + ".map";
        File cFile = new File(sMapFile);
        if(!cFile.exists())
        {
            SetErrorId(33);
            return null;
        }
        if(m_nGameType != -1)
        {
            NetMapInfo cMapInfo = new NetMapInfo(sMapFile);
            if(cMapInfo.SetGameType(m_nGameType))
            {
                aMapInfo = new NetMapInfo[1];
                aMapInfo[0] = cMapInfo;
                return aMapInfo;
            } else
            {
                SetErrorId(36);
                return null;
            }
        }
        ObjectsList cList = new ObjectsList();
        for(int iGameType = 0; iGameType < 8; iGameType++)
        {
            NetMapInfo cMapInfo = new NetMapInfo(sMapFile);
            if(cMapInfo.SetGameType(iGameType))
                cList.Add(cMapInfo);
        }

        if(cList.GetSize() > 0)
        {
            aMapInfo = new NetMapInfo[cList.GetSize()];
            for(int i = 0; i < cList.GetSize(); i++)
                aMapInfo[i] = (NetMapInfo)cList.GetObjectAt(i);

            cList.Destroy();
            return aMapInfo;
        } else
        {
            SetErrorId(37);
            return null;
        }
    }

    String m_sMapName;
    int m_nGameType;
    NetMapInfo m_aNetMapInfo[];
    static final int _PARAM_MAP_NAME = 0;
    static final int _PARAM_GAME_TYPE = 1;
    static final String sm_sMapDir = "Data/LevelsNet";
}
