// Decompiled by Jad v1.5.8g. Copyright 2001 Pavel Kouznetsov.
// Jad home page: http://www.kpdus.com/jad.html
// Decompiler options: packimports(3) 
// Source File Name:   ConsoleCommandParams.java


public abstract class ConsoleCommandParams extends ConsoleCommand
{

    int GetParamsCnt()
    {
        if(m_aParams != null)
            return m_aParams.length;
        else
            return 0;
    }

    void Clean()
    {
        super.Clean();
        m_sStreamParams = null;
        m_aParams = null;
        m_aParamsToEnd = null;
        m_sWorkParams = null;
        m_bParamsParsed = false;
    }

    String GetParam(int nParam)
    {
        if(nParam < GetParamsCnt())
        {
            return m_aParams[nParam];
        } else
        {
            NetLog.Error("Can't get " + nParam + " param " + GetNetInfo());
            return null;
        }
    }

    String GetSParam(int nParam)
    {
        if(ErrorOccured())
        {
            return null;
        } else
        {
            String sValue = GetParam(nParam);
            NetLog.ConsoleCommand("GetSParam(" + nParam + ") " + sValue);
            return sValue;
        }
    }

    ConsoleCommandParams()
    {
        m_sStreamParams = null;
        m_aParams = null;
        m_aParamsToEnd = null;
        m_nMinParams = -1;
        m_nMaxParams = -1;
        m_bParamsParsed = false;
        m_sWorkParams = null;
    }

    void SetParamsToEnd(String aParams[])
    {
        m_aParamsToEnd = aParams;
    }

    int GetParamsToEndCnt()
    {
        if(m_aParamsToEnd != null)
            return m_aParamsToEnd.length;
        else
            return 0;
    }

    private String GetAndRemoveNextParam()
    {
        String sWord = NetGameTools.GetFirstWord(m_sWorkParams);
        m_sWorkParams = NetGameTools.RemoveWord(m_sWorkParams, sWord);
        return sWord;
    }

    void SetParams(String aParams[])
    {
        m_aParams = aParams;
    }

    void PackParams(GameObject cMessager)
    {
        cMessager.MessagePackStringBool(m_sStreamParams);
    }

    private String GetFromNextParamToEnd()
    {
        return m_sWorkParams;
    }

    private void ParseParams()
    {
        if(m_bParamsParsed)
            return;
        m_sWorkParams = GetStreamParams();
        ObjectsList cList = new ObjectsList();
        int nParamsCnt = 0;
        do
        {
            String sToEnd = GetFromNextParamToEnd();
            String sCurrent = GetAndRemoveNextParam();
            if(!NetGameTools.IsStringValid(sCurrent))
                break;
            cList.Add(sCurrent);
            cList.Add(sToEnd);
            nParamsCnt++;
        } while(m_nMaxParams <= 0 || nParamsCnt < m_nMaxParams);
        m_aParams = new String[cList.GetSize() / 2];
        m_aParamsToEnd = new String[cList.GetSize() / 2];
        for(int i = 0; i < m_aParams.length; i++)
        {
            m_aParams[i] = (String)cList.GetObjectAt(2 * i);
            m_aParamsToEnd[i] = (String)cList.GetObjectAt(2 * i + 1);
            if(NetLog.IsEnabled(14))
                NetLog.ConsoleCommand("Param " + i + " : " + m_aParams[i] + " " + m_aParamsToEnd[i]);
        }

        cList.Destroy();
        m_bParamsParsed = true;
    }

    void InitPerform()
    {
        super.InitPerform();
        if(ErrorOccured())
            return;
        ParseParams();
        if(m_nMinParams > 0 && GetParamsCnt() < m_nMinParams)
            SetErrorId(17);
    }

    String[] GetParamsToEnd()
    {
        return m_aParamsToEnd;
    }

    String GetParamsToEnd(int nParam)
    {
        if(nParam < GetParamsToEndCnt())
        {
            return m_aParamsToEnd[nParam];
        } else
        {
            NetLog.Error("Can't get " + nParam + " params to end " + GetNetInfo());
            return null;
        }
    }

    boolean CheckIParam(int nParam)
    {
        boolean bOk = true;
        String sValue = GetParam(nParam);
        try
        {
            Integer.parseInt(sValue);
        }
        catch(Exception e)
        {
            bOk = false;
        }
        return bOk;
    }

    String GetStreamParams()
    {
        return m_sStreamParams;
    }

    String[] GetParams()
    {
        return m_aParams;
    }

    void UnPackParams(GameObject cMessager)
    {
        m_sStreamParams = cMessager.MessageUnPackStringBool(null);
    }

    boolean CheckFParam(int nParam)
    {
        boolean bOk = true;
        String sValue = GetParam(nParam);
        try
        {
            Float.parseFloat(sValue);
        }
        catch(Exception e)
        {
            bOk = false;
        }
        return bOk;
    }

    String GetNetInfo()
    {
        return super.GetNetInfo() + " " + GetStreamParams();
    }

    void Pack(GameObject cMessager)
    {
        super.Pack(cMessager);
        PackParams(cMessager);
    }

    void UnPack(GameObject cMessager)
    {
        super.UnPack(cMessager);
        UnPackParams(cMessager);
    }

    void Init(ConsoleCommandParams cCommand)
    {
        super.Init(cCommand);
        m_sStreamParams = cCommand.GetStreamParams();
    }

    void SetParam(int nParam, String sParam)
    {
        if(nParam < GetParamsCnt())
            m_aParams[nParam] = sParam;
        else
            NetLog.Error("Can't set " + nParam + " param " + GetNetInfo());
    }

    void InitStreamParams(String sText)
    {
        String sNameWithPrefix = "/" + GetName();
        m_sStreamParams = NetGameTools.RemoveWord(sText, sNameWithPrefix);
    }

    int GetIParam(int nParam)
    {
        if(ErrorOccured())
            return 0;
        String sValue = GetParam(nParam);
        int nValue = 0;
        try
        {
            nValue = Integer.parseInt(sValue);
        }
        catch(Exception e)
        {
            SetErrorId(16);
        }
        NetLog.ConsoleCommand("GetIParam(" + nParam + ") '" + sValue + "' -> " + nValue);
        return nValue;
    }

    float GetFParam(int nParam)
    {
        if(ErrorOccured())
            return 0.0F;
        String sValue = GetParam(nParam);
        float fValue = 0.0F;
        try
        {
            fValue = Float.parseFloat(sValue);
        }
        catch(Exception e)
        {
            SetErrorId(16);
        }
        NetLog.ConsoleCommand("GetFParam(" + nParam + ") '" + sValue + "' -> " + fValue);
        return fValue;
    }

    boolean CheckSParam(int nParam)
    {
        return NetGameTools.IsStringValid(GetParam(nParam));
    }

    private String m_sStreamParams;
    private String m_aParams[];
    private String m_aParamsToEnd[];
    int m_nMinParams;
    int m_nMaxParams;
    private boolean m_bParamsParsed;
    private String m_sWorkParams;
}
