// Decompiled by Jad v1.5.8g. Copyright 2001 Pavel Kouznetsov.
// Jad home page: http://www.kpdus.com/jad.html
// Decompiler options: packimports(3) 
// Source File Name:   ConsoleCommandsManager.java


public class ConsoleCommandsManager extends GameObject
{

    void PerformCommand(ConsoleCommand cCommand)
    {
        if(cCommand == null)
            return;
        if(cCommand.IsForAdminsOnly())
        {
            int nHostId = cCommand.GetHost();
            int nRights = m_cGameInfo.GetAdminsManager().GetAdminRights(nHostId);
            if(nRights == -1)
            {
                cCommand.SetErrorId(10);
                return;
            }
            if(nRights < cCommand.GetRequiredAdminRights())
            {
                cCommand.SetErrorId(11);
                return;
            }
        }
        cCommand.InitPerform();
        if(cCommand.ErrorOccured())
        {
            return;
        } else
        {
            cCommand.Perform();
            return;
        }
    }

    public ConsoleCommandsManager()
    {
        m_cCommandsList = null;
        m_cGameInfo = null;
    }

    void ServerReceivedCommand(ConsoleCommand cReceivedCommand)
    {
        ConsoleCommand cCommand = null;
        if(cReceivedCommand.GetId() != _COMMAND_UNKNOWN)
        {
            cCommand = cReceivedCommand;
        } else
        {
            String sNameWithPrefix = "/" + cReceivedCommand.GetName();
            ConsoleCommand cServerCommand = CheckCommand(sNameWithPrefix, false);
            if(cServerCommand != null)
            {
                cCommand = cServerCommand;
                cCommand.Init(cReceivedCommand);
            } else
            {
                cCommand = cReceivedCommand;
            }
        }
        cCommand.SetLocalPerform(false);
        PerformCommand(cCommand);
        if(!cCommand.ErrorOccured())
        {
            if(cCommand.AreResultsExpected())
            {
                m_cGameInfo.MsgSendClientCommandResults(cCommand);
                if(cCommand.AreResultsToAll())
                    cCommand.ShowResults();
            }
            cCommand.PostPerform();
        } else
        {
            m_cGameInfo.MsgSendClientCommandErrors(cCommand);
        }
        cCommand.Clean();
    }

    void AddCommands()
    {
    }

    void ServerTypedCommand(ConsoleCommand cCommand)
    {
        cCommand.SetLocalPerform(true);
        PerformCommand(cCommand);
        if(cCommand.ErrorOccured())
        {
            cCommand.ShowErrors();
            return;
        }
        if(cCommand.AreResultsExpected())
        {
            if(cCommand.AreResultsToAll())
                m_cGameInfo.MsgSendClientCommandResults(cCommand);
            cCommand.ShowResults();
        }
        cCommand.PostPerform();
        cCommand.Clean();
    }

    void ClientTypedCommand(ConsoleCommand cCommand)
    {
        if(cCommand.ShouldExecuteOnlyOnServer())
        {
            NetLog.ConsoleCommand("" + GetNetInfo() + " is not local -> skip on client");
            return;
        }
        cCommand.SetLocalPerform(true);
        PerformCommand(cCommand);
        if(cCommand.ErrorOccured())
        {
            cCommand.ShowErrors();
            return;
        }
        if(cCommand.AreResultsExpected())
            cCommand.ShowResults();
        cCommand.PostPerform();
        cCommand.Clean();
    }

    ConsoleCommand FindCommand(int nCommandId)
    {
        ConsoleCommand cCommand = m_cCommandsList.GetCommandById(nCommandId);
        if(cCommand != null)
            cCommand.Clean();
        return cCommand;
    }

    static String ParseCommandName(String sTypedText)
    {
        return NetGameTools.GetTextWithoutPrefix(sTypedText, "/");
    }

    void OnCreate()
    {
        m_cCommandsList = new ConsoleCommandsList();
        _COMMAND_SERVER = m_cCommandsList.AddCommand(new ConsoleCommandServer());
        _COMMAND_UNKNOWN = m_cCommandsList.AddCommand(new ConsoleCommandUnknown());
        m_cCommandsList.AddCommand(new CommandMsgTeam());
        m_cCommandsList.AddCommand(new CommandMsgNick());
        m_cCommandsList.AddCommand(new CommandChangeTeam());
        m_cCommandsList.AddCommand(new CommandNick());
        m_cCommandsList.AddCommand(new CommandKillMe());
        m_cCommandsList.AddCommand(new CommandPlayerList());
        m_cCommandsList.AddCommand(new CommandAdminList());
        m_cCommandsList.AddCommand(new CommandTimeLeft());
        m_cCommandsList.AddCommand(new CommandAdminLogin());
        m_cCommandsList.AddCommand(new CommandAdminLogout());
        m_cCommandsList.AddCommand(new CommandAdminSay());
        m_cCommandsList.AddCommand(new CommandRun());
        m_cCommandsList.AddCommand(new CommandKick());
        m_cCommandsList.AddCommand(new CommandKill());
        m_cCommandsList.AddCommand(new CommandMap());
        m_cCommandsList.AddCommand(new CommandMapNext());
        m_cCommandsList.AddCommand(new CommandMapRemove());
        m_cCommandsList.AddCommand(new CommandMapSetParam());
        m_cCommandsList.AddCommand(new CommandMapSetDefaultParams());
        m_cCommandsList.AddCommand(new CommandMapSetCustomParams());
        m_cCommandsList.AddCommand(new CommandMapSaveParams());
        m_cCommandsList.AddCommand(new CommandServerShutdown());
        m_cCommandsList.AddCommand(new CommandForceNick());
        m_cCommandsList.AddCommand(new CommandForceTeam());
        m_cCommandsList.AddCommand(new CommandExit());
        m_cCommandsList.AddCommand(new CommandPlayersList());
    }

    ConsoleCommand CheckCommand(String sTypedText, boolean bForceCommand)
    {
        String sCommandName = ParseCommandName(sTypedText);
        if(sCommandName != null)
        {
            ConsoleCommand cCommand = m_cCommandsList.GetCommandByName(sCommandName);
            if(cCommand == null)
            {
                String sAlias = "";
                if(bForceCommand)
                    cCommand = FindCommand(_COMMAND_UNKNOWN);
                else
                    return null;
            }
            cCommand.Clean();
            cCommand.InitStreamParams(sTypedText);
            return cCommand;
        } else
        {
            return null;
        }
    }

    ConsoleCommand CheckCommand(String sTypedText)
    {
        return CheckCommand(sTypedText, true);
    }

    void SetGameInfo(NetGameInfoHud cGameInfo)
    {
        m_cGameInfo = m_cGameInfo = cGameInfo;
        m_cCommandsList.SetGameInfo(cGameInfo);
    }

    void OnDestroy()
    {
        m_cCommandsList.Destroy();
        m_cCommandsList = null;
    }

    ConsoleCommandsList m_cCommandsList;
    protected NetGameInfoHud m_cGameInfo;
    static int _COMMAND_SERVER = -1;
    static int _COMMAND_UNKNOWN = -1;
    static final String sm_sCommandPrefix = "/";

}
