// Decompiled by Jad v1.5.8g. Copyright 2001 Pavel Kouznetsov.
// Jad home page: http://www.kpdus.com/jad.html
// Decompiler options: packimports(3) 
// Source File Name:   DestroyableNet.java


public class DestroyableNet extends Destroyable
{

    public void OnDestroy()
    {
        super.OnDestroy();
        m_cParent = null;
    }

    static void CleanGlobalDestroyableStateCounter()
    {
        sm_cGlobalDestroyableStateCounter.Clean();
    }

    public void OnTakeDamage(float fDamage, float fPhSimDamage, GameObject Assassin, Vector vHitLocation, Vector vSpeed, int nMeshElementorBoneID, int nDamageType)
    {
        if(super.Role == 4)
        {
            m_cAssasinPlayer = ModuleNet.GetAssassinPlayerNetFromObject(Assassin);
            super.OnTakeDamage(fDamage, fPhSimDamage, Assassin, vHitLocation, vSpeed, nMeshElementorBoneID, nDamageType);
            CheckUnderAttack();
        }
    }

    void Blast()
    {
        if(super.Role == 4)
            super.Blast();
    }

    void DelayedBlow()
    {
        if(super.fBlastRange > 0.0F || super.fBlastDamage > 0.0F)
            Blast();
    }

    void UnderAttack()
    {
    }

    public void Demolish()
    {
        super.Demolish();
        m_nState = 1;
        if(super.Role == 4)
            MsgSendClientDestroyableChangeState();
    }

    void MsgSendClientDestroyableState()
    {
        NetLog.MsgOut("MSG_CLIENT_DESTROYABLE_STATE", this);
        MessageNew(20);
        MessagePackInt(GetNextGlobalDestroyableStateCounter());
        MessagePackState();
        MessageSend();
        NetLog.Destroyable("SendState " + GetStateName(m_nState), this);
    }

    void MsgSendClientDestroyableChangeState()
    {
        NetLog.MsgOut("MSG_CLIENT_DESTROYABLE_CHANGESTATE", this);
        MessageNew(21);
        MessagePackInt(GetNextGlobalDestroyableStateCounter());
        MessagePackState();
        MessageSend();
        NetLog.Destroyable("SendChangeState " + GetStateName(m_nState), this);
    }

    public void Die()
    {
        m_cParent = GetParent();
        super.Die();
        m_nState = 2;
        if(super.Role == 4)
            MsgSendClientDestroyableChangeState();
    }

    void MsgRecvClientDestroyableState()
    {
        int nStateCounter = MessageUnPackInt();
        int nState = MessageUnPackState();
        MessageEnd();
        NetLog.Destroyable("RecvState " + GetStateName(nState), this);
        if(VerifyDestroyableStateCounter(nStateCounter))
        {
            super.bLoadingSG = true;
            ChangeState(nState);
            super.bLoadingSG = false;
        }
    }

    void MsgRecvClientDestroyableChangeState()
    {
        int nStateCounter = MessageUnPackInt();
        int nState = MessageUnPackState();
        MessageEnd();
        NetLog.Destroyable("RecvChangeState " + GetStateName(nState), this);
        if(VerifyDestroyableStateCounter(nStateCounter))
            ChangeState(nState);
    }

    void MessagePackState()
    {
        MessagePackInt(m_nState);
    }

    public DestroyableNet()
    {
        m_fMaxHealth = 0.0F;
        m_sMeshName = null;
        m_nState = 0;
        m_cParent = null;
        m_fUnderAttackTime = -1F;
        m_cDestroyableStateCounter = new ChangeStateCounter(this);
        m_cAssasinPlayer = null;
    }

    String GetStateName(int i)
    {
        switch(i)
        {
        case 0: // '\0'
            return "SPAWNED";

        case 1: // '\001'
            return "DEMOLISHED";

        case 2: // '\002'
            return "DEAD";
        }
        return "unknown (" + i + ")";
    }

    static int GetNextGlobalDestroyableStateCounter()
    {
        return sm_cGlobalDestroyableStateCounter.GetNext();
    }

    int MessageUnPackState()
    {
        return MessageUnPackInt();
    }

    boolean VerifyDestroyableStateCounter(int nCounter)
    {
        return m_cDestroyableStateCounter.Verify(nCounter);
    }

    void ServerRespawn()
    {
        if(super.Role == 4)
        {
            Respawn();
            MsgSendClientDestroyableChangeState();
        }
    }

    void Respawn()
    {
        CallMethodIn("DeleteAttachedFXes", 0.0F);
        CallMethodIn("DeleteAllChildren", 0.0F);
        super.fHealth = m_fMaxHealth;
        super.bDead = false;
        super.MeshName = m_sMeshName;
        LoadMesh();
        SetMeshColor(new Vector(1.0F, 1.0F, 1.0F));
        if(m_cParent != null)
            m_cParent.AttachChildAndKeepWorldPos(this);
        m_fUnderAttackTime = GetTime() - sm_fMinAlertDeltaAttackTime;
        ActivateOnModule();
        m_nState = 0;
    }

    PlayerNet GetAssasinPlayer()
    {
        return m_cAssasinPlayer;
    }

    private void CheckUnderAttack()
    {
        float fTime = GetTime();
        float fDelta = fTime - m_fUnderAttackTime;
        if(fDelta >= sm_fMinAlertDeltaAttackTime)
            UnderAttack();
        m_fUnderAttackTime = fTime;
    }

    public void OnReplicateServer()
    {
        if(super.bNetInit)
            MsgSendClientDestroyableState();
    }

    public void OnMessage()
    {
        switch(MessageGetId())
        {
        case 20: // '\024'
            NetLog.MsgIn("MSG_CLIENT_DESTROYABLE_STATE", this);
            MsgRecvClientDestroyableState();
            break;

        case 21: // '\025'
            NetLog.MsgIn("MSG_CLIENT_DESTROYABLE_CHANGESTATE", this);
            MsgRecvClientDestroyableChangeState();
            break;

        default:
            NetLog.MsgIn("CANCEL " + MessageGetId(), this);
            MessageCancel();
            break;
        }
    }

    public void OnCreate()
    {
        super.OnCreate();
        m_fMaxHealth = super.fHealth;
        m_sMeshName = super.MeshName;
        SetFlag(2048);
        super.bGreatHit = true;
        super.bDeleteAfterDestroy = true;
    }

    void ChangeState(int nState)
    {
        if(m_nState == nState)
        {
            NetLog.Destroyable("ChangeState skipped, state " + GetStateName(m_nState), this);
            return;
        }
        NetLog.Destroyable("ChangeState " + GetStateName(m_nState) + " -> " + GetStateName(nState), this);
        switch(nState)
        {
        default:
            break;

        case 0: // '\0'
            Respawn();
            break;

        case 1: // '\001'
            if(m_nState == 2)
                Respawn();
            Demolish();
            break;

        case 2: // '\002'
            Die();
            break;
        }
    }

    boolean IsAlive()
    {
        return m_nState != 2;
    }

    float m_fMaxHealth;
    String m_sMeshName;
    static final int _STATE_SPAWNED = 0;
    static final int _STATE_DEMOLISHED = 1;
    static final int _STATE_DEAD = 2;
    int m_nState;
    ControlObject m_cParent;
    private float m_fUnderAttackTime;
    static float sm_fMinAlertDeltaAttackTime = 20F;
    private static ChangeStateCounter sm_cGlobalDestroyableStateCounter = new ChangeStateCounter();
    private ChangeStateCounter m_cDestroyableStateCounter;
    private PlayerNet m_cAssasinPlayer;
    final int MSG_CLIENT_DESTROYABLE_STATE = 20;
    final int MSG_CLIENT_DESTROYABLE_CHANGESTATE = 21;

}
