// Decompiled by Jad v1.5.8g. Copyright 2001 Pavel Kouznetsov.
// Jad home page: http://www.kpdus.com/jad.html
// Decompiler options: packimports(3) 
// Source File Name:   FlyingRobot.java


public class FlyingRobot extends Pawn
    implements ISecuritySystemComponent
{

    int MakeDecision()
    {
        cCurrentTarget = FindTarget();
        float fCurrTime = GetTime();
        if(bFiring)
        {
            if(fCurrTime - fLastFireTime > 0.2F)
            {
                fLastFireTime = fCurrTime;
                Fire();
            }
            if(fCurrTime - fLastStopFireTime > 1.0F)
            {
                bFiring = false;
                fLastStartFireTime = fCurrTime;
            }
        } else
        if(fCurrTime - fLastStartFireTime > 1.0F)
        {
            bFiring = true;
            fLastStopFireTime = fCurrTime;
        }
        boolean bIsRelevant = IsInFrustum();
        if(cCurrentTarget != null)
        {
            Vector vVect = GetPosition();
            vVect.Sub(cCurrentTarget.GetPosition());
            if(vVect.Len() < fRelevantRadius)
                bIsRelevant = true;
        }
        int nAction;
        if(!bIsRelevant)
            nAction = 2;
        else
        if(nLastAction == 2)
            nAction = 1;
        else
        if(GameObject.RandomInt(10) < 3)
            nAction = 2;
        else
            nAction = 1;
        vBasePosition = null;
        vTranslation = null;
        fActionStartTime = GetTime();
        fActionDuration = 0.6283185F;
        return nAction;
    }

    void RobotMove(float fTime)
    {
        int nVariant = -1;
        if(vTranslation == null)
        {
            vBasePosition = GetPosition();
            for(int nTrials = 6; nTrials > 0 && vTranslation == null; nTrials--)
            {
                nVariant = GameObject.RandomInt(3);
                fActionDuration = 1.0F + (float)nVariant * 0.3F;
                float fDurationScale = 0.8F;
                fActionDuration *= fDurationScale;
                Vector vEnemyDir = null;
                if(cCurrentTarget != null)
                {
                    vEnemyDir = cCurrentTarget.GetPosition();
                    vEnemyDir.Sub(GetPosition());
                    float fDistance = vEnemyDir.Len();
                    if(fDistance < 150F)
                    {
                        vEnemyDir = null;
                    } else
                    {
                        vEnemyDir.Normalize();
                        vEnemyDir.Mul(200F);
                    }
                }
                if(bFollowPlayersHeight)
                {
                    float fPlayerY = ((ChromeModuleSingle)GetModule()).MainPlayer.GetPointToLookAt(0).fY - 30F;
                    vTranslation = new Vector(GameObject.RandomFloat(100F) - 50F, ((GameObject.RandomFloat(20F) - 10F) + fPlayerY) - vBasePosition.fY, GameObject.RandomFloat(100F) - 50F);
                    if(vEnemyDir != null)
                    {
                        vEnemyDir.fY = 0.0F;
                        vTranslation.Add(vEnemyDir);
                    }
                } else
                {
                    vTranslation = new Vector(GameObject.RandomFloat(100F) - 50F, ((GameObject.RandomFloat(20F) - 10F) + vInitialPosition.fY) - vBasePosition.fY, GameObject.RandomFloat(100F) - 50F);
                    if(vTranslation.fY > 50F)
                        vTranslation.fY = 50F;
                    else
                    if(vTranslation.fY < -50F)
                        vTranslation.fY = -50F;
                    if(vEnemyDir != null)
                        vTranslation.Add(vEnemyDir);
                }
                vTranslation.Mul(fActionDuration / fDurationScale);
                if(vTranslation.Len() == 0.0F)
                {
                    vTranslation = null;
                } else
                {
                    Vector vStoredPos = GetPosition();
                    if(!MoveByEllipsoid(vTranslation))
                        vTranslation = null;
                    SetPositionWorld(vStoredPos);
                }
            }

            Vector vNewDir = null;
            if(cCurrentTarget != null)
            {
                vNewDir = new Vector(cCurrentTarget.GetPointToLookAt(0));
                vNewDir.Sub(GetPosition());
                if(vTranslation != null)
                    vNewDir.Sub(vTranslation);
            } else
            if(vTranslation != null)
                vNewDir = new Vector(vTranslation);
            else
                vNewDir = null;
            if(vNewDir != null)
            {
                vNewDir.fY = 0.0F;
                vNewDir.Normalize();
                SetMaxAngSpeed(90F);
                SetDestDir(vNewDir);
            }
        }
        if(vTranslation == null)
        {
            nCurrentAction = 0;
        } else
        {
            switch(nVariant)
            {
            case 0: // '\0'
                PlaySound("Data/Sounds/Ai/FlyingRobot1");
                break;

            case 1: // '\001'
                PlaySound("Data/Sounds/Ai/FlyingRobot1_3");
                break;

            case 2: // '\002'
                PlaySound("Data/Sounds/Ai/FlyingRobot1_6");
                break;
            }
            Vector vTrans = new Vector(vTranslation);
            float fFactor = fTime / fActionDuration;
            vTrans.Mul(GetFactor(fFactor));
            vTrans.Add(vBasePosition);
            SetPosition(vTrans);
        }
    }

    public void DeactivateRobot()
    {
        FreezeCallMethods();
        DeactivateOnModuleAlways();
    }

    public boolean IsActive(ControlObject Activator)
    {
        return false;
    }

    public void ActivateRobot()
    {
        ActivateOnModule();
        UnfreezeCallMethods();
    }

    Pawn FindTarget()
    {
        ControlObject aPawns[] = GetObjectsInRadiusFromClass(fFindTargetRange, "Pawn");
        Pawn cFoundTarget = null;
        int nPawns = aPawns.length;
        for(int i = 0; i < nPawns; i++)
        {
            Pawn cCurrent = (Pawn)aPawns[i];
            if(!((Actor) (cCurrent)).bDead && IsEnemy(cCurrent) && CheckTraceAbsolute(cCurrent, cCurrent.GetPointToLookAt(0), GetPosition()))
                cFoundTarget = cCurrent;
        }

        return cFoundTarget;
    }

    void Update()
    {
        if(super.bDead)
            return;
        float fLightTime = GetTime();
        if(fLightTime - fLastLightTime > 1.0F)
        {
            ShowLight();
            fLastLightTime = fLightTime;
        }
        if(nCurrentAction == 0)
            nCurrentAction = MakeDecision();
        float fTime = GetTime() - fActionStartTime;
        if(fTime > fActionDuration)
            fTime = fActionDuration;
        switch(nCurrentAction)
        {
        case 2: // '\002'
            RobotSwing(fTime);
            break;

        case 1: // '\001'
            RobotMove(fTime);
            break;
        }
        if(fTime >= fActionDuration)
        {
            nLastAction = nCurrentAction;
            nCurrentAction = 0;
        }
    }

    void ExecuteWeaponBeam(float fDistance, Vector vBeamPos, int nElementID)
    {
        super.ExecuteWeaponBeam(fDistance, vBeamPos, nElementID);
        super.fFXSizeX = 5F;
        ExecuteFX(this, nBarrelElementID, "WeaponLaser", Vector.Zero);
    }

    FlyingRobot()
    {
        cSecuritySystem = null;
        bEnabledOnStart = true;
        cCannon = null;
        bFollowPlayersHeight = false;
        cCurrentTarget = null;
        fRelevantRadius = 1000F;
        fShootingRange = 500F;
        fFindTargetRange = 1500F;
        sBlowFX = "FXFlyingRobot";
        sBlowSound = "Data/Sounds/Explosion/RocketExplosionFF";
        vBasePosition = null;
        vInitialPosition = null;
        vTranslation = null;
        nCurrentAction = 0;
        nLastAction = 0;
        fActionStartTime = 0.0F;
        fActionDuration = 0.0F;
        nLightElementID = -1;
        sLightFXName = "RobotSmallLight";
        fLastLightTime = 0.0F;
        nBarrelElementID = -1;
        bFiring = false;
        fLastFireTime = 0.0F;
        fLastStopFireTime = 0.0F;
        fLastStartFireTime = 0.0F;
        super.MeshName = "Data/Meshes/AI/robot_maly.3DA";
        super.nTeamID = 10000;
        super.bIsAITarget = true;
    }

    public void Die()
    {
        super.Die();
        DisableCallMethod("Update");
        CallMethodIn("BlowUp", GameObject.RandomFloat(0.5F));
    }

    void BlowUp()
    {
        if(sBlowFX != null)
        {
            ExecuteFX(sBlowFX, GetPosition(), Vector.Up);
            ExecuteParticleSystem(sBlowFX, GetPosition(), Vector.Up);
        }
        if(sBlowSound != null)
            PlaySound(sBlowSound);
        CallMethodIn("delete", 0.0F);
    }

    public void Enable()
    {
        ActivateRobot();
    }

    void RobotSwing(float fTime)
    {
        if(!IsInFrustum());
    }

    public void Disable()
    {
        DeactivateRobot();
    }

    void ShowLight()
    {
        if(nLightElementID == -1)
        {
            return;
        } else
        {
            Vector vPos = GetElementLocalPos(nLightElementID);
            ExecuteFX(this, nLightElementID, sLightFXName, vPos);
            return;
        }
    }

    public void FollowPlayersHeight()
    {
        bFollowPlayersHeight = true;
    }

    public void OnCreate()
    {
        super.OnCreate();
        SetFlag(2048);
        SetPhysicsActive(true);
        SetPhysicsType(6);
        SetMass(0.0F);
        SetSpeed(new Vector(0.0F, 1.0F, 0.0F));
        SetSpeedValue(0.0F);
        SetLighting(true);
        vInitialPosition = GetPosition();
        cCannon = (FlyingRobotCannon)CreateObjectNoInit("FlyingRobotCannon");
        cCannon.cOwner = this;
        cCannon.InitObject();
        CallMethodEveryMinMax("Update", 0.0005F, 1.0F);
        if(nLightElementID == -1)
            nLightElementID = GetElementID("light");
        if(nBarrelElementID == -1)
            nBarrelElementID = GetElementID("barrel");
        super.bActiveTrigger = false;
        super.bIsActiveTarget = true;
        if(cSecuritySystem != null)
            cSecuritySystem.RegisterComponent(this);
        else
        if(bEnabledOnStart)
            Enable();
        else
            Disable();
    }

    public void Bleed(float f, GameObject gameobject, Vector vector, Vector vector1, int i)
    {
    }

    public void Bleed(float f, GameObject gameobject, Vector vector, Vector vector1, int i, int j)
    {
    }

    void InitInventory()
    {
    }

    float GetFactor(float fFactor)
    {
        float fVal = (1.0F + (float)Math.sin(fFactor * 3.141593F - 1.570796F)) / 2.0F;
        return fVal * fVal;
    }

    void Fire()
    {
        if(cCurrentTarget != null)
        {
            Vector vStart = GetPosition();
            Vector vEnd = cCurrentTarget.GetPointToLookAt(0);
            Vector vDir = new Vector(vEnd);
            vDir.Sub(vStart);
            if(vDir.Len() < fShootingRange)
            {
                vDir.Normalize();
                cCannon.Fire(vStart, vDir);
            }
        }
    }

    void ProcessOnFrame()
    {
    }

    public SecuritySystem cSecuritySystem;
    public boolean bEnabledOnStart;
    FlyingRobotCannon cCannon;
    public boolean bFollowPlayersHeight;
    Pawn cCurrentTarget;
    public float fRelevantRadius;
    public float fShootingRange;
    public float fFindTargetRange;
    final int _ACTION_MOVE = 1;
    final int _ACTION_SWING = 2;
    final int _ACTION_NONE = 0;
    final float _PI = 3.141593F;
    String sBlowFX;
    String sBlowSound;
    Vector vBasePosition;
    Vector vInitialPosition;
    Vector vTranslation;
    int nCurrentAction;
    int nLastAction;
    float fActionStartTime;
    float fActionDuration;
    final float _TIME_BTW_LIGHTS = 1.0F;
    int nLightElementID;
    String sLightFXName;
    float fLastLightTime;
    int nBarrelElementID;
    boolean bFiring;
    float fLastFireTime;
    float fLastStopFireTime;
    float fLastStartFireTime;
}
