// Decompiled by Jad v1.5.8g. Copyright 2001 Pavel Kouznetsov.
// Jad home page: http://www.kpdus.com/jad.html
// Decompiler options: packimports(3) 
// Source File Name:   FlyingVehicle.java


public class FlyingVehicle extends ChromeActor
    implements ipar_MovieVehicle
{

    public void ActivateVehicle()
    {
        m_bVehicleActive = true;
        SetMeshVisibilityRange(fBlendStart, fVisibilityEnd);
        if(bGridIndependent)
            ActivateOnModuleGridIndependent();
        else
            ActivateOnModule();
        if(m_Physics != null)
            m_Physics.ActivatePhysics();
        if(m_bRestoreFlySoundAfterDeactivate)
        {
            m_bRestoreFlySoundAfterDeactivate = false;
            AttachFlySound();
        }
        EnableRendering(true);
    }

    public boolean IsActive(ControlObject Activator)
    {
        return false;
    }

    public void SGLoadChunk(FileChunk cParentFC)
    {
        FileChunk.Log("[FlyingVehicle.SGLoadChunk]\n");
        FileChunk cFC = GameObject.LoadChunk(cParentFC);
        if(cFC.GetID() == 1626)
        {
            super.SGLoadChunk(cFC);
            m_Physics = (FlyingVehiclePhysics)cFC.LoadObject(m_Physics, this);
            m_bRestoreFlySoundAfterDeactivate = cFC.LoadBool();
            m_bVehicleActive = cFC.LoadBool();
            m_bStarting = cFC.LoadBool();
            m_bLanding = cFC.LoadBool();
            m_iFlySoundSG = cFC.LoadInt();
        }
        cFC.delete();
    }

    public void OnTakeDamage(float fDamage, float fPhSimDamage, GameObject Assassin, Vector vHitLocation, Vector vSpeed, int nMeshElementorBoneID, int nDamageType)
    {
        if(Assassin instanceof ChromeActor)
            ((ChromeActor)Assassin).NotifyHit(this, nDamageType);
        if(super.bDead)
        {
            return;
        } else
        {
            Damage(fDamage, nDamageType);
            return;
        }
    }

    public void OnAudioReinitialize()
    {
        if(m_iFlySound != 0)
        {
            m_iFlySound = 0;
            AttachFlySound();
        }
    }

    public void PlayStartSound(float fTimeToIgnoreInSinglePlayer)
    {
        PlayStartSound();
    }

    public void PlayStartSound()
    {
        if(_START_SOUND_NAME != null)
            AttachOneShotSound(_START_SOUND_NAME, fMinSound, fMaxSound);
    }

    void DetachFlySound()
    {
        if(m_iFlySound != 0)
        {
            DetachSound(m_iFlySound);
            m_iFlySound = 0;
        }
    }

    void FryActors()
    {
        if(m_fActorFryingDistance > 0.0F)
        {
            GameObject aObjs[] = GetObjectsInRadiusOfFlagsFromClass(GetPosition(), m_fActorFryingDistance, 0x2000000, "ChromeActor");
            if(aObjs != null)
            {
                for(int i = 0; i < aObjs.length; i++)
                {
                    Actor cActor = (Actor)aObjs[i];
                    if(cActor.fHealth > 0.0F)
                    {
                        ControlObject parent = cActor;
                        boolean bFound = false;
                        do
                        {
                            parent = parent.GetParent();
                            if(parent != this)
                                continue;
                            bFound = true;
                            break;
                        } while(parent != null);
                        if(!bFound)
                            cActor.TakeDamage(m_fActorFryingDamage, m_fActorFryingDamage, this, null, null, -1, EnumDamageType._HEAT);
                    }
                }

            }
        }
    }

    FlyingVehicle()
    {
        fBlendStart = 30000F;
        fVisibilityEnd = 35000F;
        bGridIndependent = false;
        _START_SOUND_NAME = "Data/Sounds/Vehicles/shuttle start";
        _FLY_SOUND_NAME = "Data/Sounds/Vehicles/shuttle";
        fMinSound = 5000F;
        fMaxSound = 15000F;
        m_Physics = null;
        m_iFlySound = 0;
        m_bRestoreFlySoundAfterDeactivate = false;
        m_fActorFryingUpdateTime = 0.5F;
        m_fActorFryingDistance = 1200F;
        m_fActorFryingDamage = 500F;
        m_sPhysicsClassName = "FlyingVehiclePhysics";
        m_bVehicleActive = false;
        m_bStarting = false;
        m_bLanding = false;
        m_iFlySoundSG = 0;
        super.MeshName = "Data/Meshes/Vehicles/TransportowiecMaly.3DA";
        super.bIsAITarget = true;
    }

    public void Die()
    {
        if(super.bDead)
            return;
        DetachFlySound();
        DetachAllSounds();
        if(m_Physics != null)
            m_Physics.DeactivatePhysics();
        super.Die();
    }

    void PlayFXDustStart()
    {
    }

    void PlayFXDustLand()
    {
    }

    void ActivatePhysics()
    {
        if(m_Physics != null)
            m_Physics.ActivatePhysics();
    }

    public void SGUpdate()
    {
        FileChunk.Log("[FlyingVehicle.SGUpdate]\n");
        DetachFlySound();
        if(m_iFlySoundSG != 0)
            AttachFlySound();
        super.SGUpdate();
        if(m_Physics != null)
            m_Physics.SGUpdate();
    }

    void VehicleLanded(float fTime)
    {
        m_Physics.SetState("IdleState");
        DetachFlySound();
    }

    void OnDestinationPos()
    {
        m_Physics.SetState("IdleState");
    }

    void OnDestinationPos(int i)
    {
    }

    public void SetVehicleForMovie(boolean bEnable, boolean bPlayEngineStartStopSound)
    {
        if(bEnable)
        {
            DeactivatePhysics();
            if(bPlayEngineStartStopSound)
                PlayStartSound();
        }
    }

    public void OnCreate()
    {
        super.OnCreate();
        super.bSG = true;
        SetCollType(2);
        SetCollAction(16);
        SetCollHandler(0);
        SetTraceCollType(5);
        SetFlag(1);
        SetFlag(8);
        SetFlag(32);
        SetPhysicsType(0);
        SetPhysicsActive(false);
        m_Physics = (FlyingVehiclePhysics)CreateObject(m_sPhysicsClassName);
        m_Physics.InitPhysics(this);
        m_Physics.SetState("IdleState");
        SetBlobMapSize(1300F);
        DeactivateOnModuleAlways();
    }

    void VehicleStarted(float fTime)
    {
        m_Physics.SetState("IdleState");
        AttachFlySound();
    }

    void AttachFlySound()
    {
        if(m_iFlySound == 0 && _FLY_SOUND_NAME != null)
            m_iFlySound = AttachSound(_FLY_SOUND_NAME, fMinSound, fMaxSound);
    }

    void SetPreciseMoving(boolean bPrecise)
    {
        m_Physics.m_bPreciseMoving = bPrecise;
    }

    public void SGSaveChunk(FileChunk cFCParent)
    {
        FileChunk.Log("[FlyingVehicle.SGSaveChunk]\n");
        FileChunk cFC = GameObject.NewChunk(1626, cFCParent);
        super.SGSaveChunk(cFC);
        cFC.SaveObject(m_Physics);
        cFC.SaveBool(m_bRestoreFlySoundAfterDeactivate);
        cFC.SaveBool(m_bVehicleActive);
        cFC.SaveBool(m_bStarting);
        cFC.SaveBool(m_bLanding);
        cFC.SaveInt(m_iFlySound);
        cFC.delete();
    }

    void DeactivatePhysics()
    {
        if(m_Physics != null)
            m_Physics.DeactivatePhysics();
    }

    public void DeactivateVehicle()
    {
        m_bVehicleActive = false;
        if(m_Physics != null)
            m_Physics.DeactivatePhysics();
        if(m_iFlySound != 0)
        {
            DetachFlySound();
            m_bRestoreFlySoundAfterDeactivate = true;
        }
        DeactivateOnModuleAlways();
        EnableRendering(false);
    }

    public void OnDestroy()
    {
        if(m_Physics != null)
        {
            m_Physics.delete();
            m_Physics = null;
        }
        DetachFlySound();
    }

    public float fBlendStart;
    public float fVisibilityEnd;
    public boolean bGridIndependent;
    String _START_SOUND_NAME;
    String _FLY_SOUND_NAME;
    public float fMinSound;
    public float fMaxSound;
    FlyingVehiclePhysics m_Physics;
    int m_iFlySound;
    boolean m_bRestoreFlySoundAfterDeactivate;
    float m_fActorFryingUpdateTime;
    float m_fActorFryingDistance;
    float m_fActorFryingDamage;
    String m_sPhysicsClassName;
    boolean m_bVehicleActive;
    static String _VEHICLE_DUST_START = "DustStartFlyingVehicle";
    static String _VEHICLE_DUST_LAND = "DustLandFlyingVehicle";
    boolean m_bStarting;
    boolean m_bLanding;
    int m_iFlySoundSG;

}
