// Decompiled by Jad v1.5.8g. Copyright 2001 Pavel Kouznetsov.
// Jad home page: http://www.kpdus.com/jad.html
// Decompiler options: packimports(3) 
// Source File Name:   FlyingVehiclePhysics.java


public class FlyingVehiclePhysics extends GameObject
{
    public class GotoPointState extends State
    {

        public void SGSave(FileChunk cParentFC)
        {
            FileChunk.Log("[FlyingVehiclePhysics$GotoPointState] : SGSave\n");
            FileChunk cFC = GameObject.NewChunk(1647, cParentFC);
            super.SGSave(cFC);
            cFC.SaveBool(m_bStopping);
            cFC.delete();
        }

        public void SGUpdate()
        {
            FileChunk.Log("[FlyingVehiclePhysics$GotoPointState] : SGUpdate\n");
        }

        boolean CheckMoveDecision()
        {
            if(!m_bSlowDownToPoint)
            {
                float fDist = Physics_CalcDist();
                if(fDist < _MOVE_PRECISION)
                {
                    if(m_iCurrPoint == m_vDestPoints.length - 1)
                    {
                        m_Owner.OnDestinationPos();
                    } else
                    {
                        m_Owner.OnDestinationPos(m_iCurrPoint);
                        m_iCurrPoint++;
                        if(m_iCurrPoint == m_vDestPoints.length - 1)
                            m_bSlowDownToPoint = true;
                    }
                } else
                if(!Physics_EnoughTimeToTurn())
                    m_iAccelFlag = FlyingVehiclePhysics._DEACCEL;
                else
                    m_iAccelFlag = FlyingVehiclePhysics._ACCEL;
            } else
            if(!m_bStopping)
            {
                float fDist = Physics_CalcDist();
                if(fDist < _MOVE_PRECISION)
                {
                    m_bStopping = true;
                    m_iAccelFlag = FlyingVehiclePhysics._DEACCEL;
                } else
                if(!Physics_EnoughTimeToTurn())
                    m_iAccelFlag = FlyingVehiclePhysics._DEACCEL;
                else
                    m_iAccelFlag = FlyingVehiclePhysics._ACCEL;
            } else
            if(m_bPreciseMoving)
            {
                if(m_fCurrSpeed == 0.0F)
                {
                    SetState("PrecisionGotoState");
                    return true;
                }
            } else
            if(m_fCurrSpeed == 0.0F)
                if(m_bStopTurn)
                {
                    if(m_fCurrTurnSpeed == 0.0F)
                    {
                        m_Owner.OnDestinationPos();
                        return true;
                    }
                } else
                {
                    m_Owner.OnDestinationPos();
                    return true;
                }
            return false;
        }

        public void SGLoad(FileChunk cParentFC)
        {
            FileChunk.Log("[FlyingVehiclePhysics$GotoPointState] : SGLoad\n");
            FileChunk cFC = GameObject.LoadChunk(cParentFC);
            if(cFC.GetID() == 1647)
            {
                super.SGLoad(cFC);
                m_bStopping = cFC.LoadBool();
            }
            cFC.delete();
        }

        public void OnEnter()
        {
            m_iCurrPoint = 0;
            m_iAccelFlag = FlyingVehiclePhysics._ACCEL;
            m_bStopping = false;
        }

        public void OnFrame()
        {
            float fTime = GetTime();
            do
            {
                Physics_MakeUpTurnDecision(FlyingVehiclePhysics._DEG_PRECISION);
                Physics_MakeUpDownDecision(m_Owner.GetPosition(), m_vDestPoints[m_iCurrPoint].fY);
            } while(!CheckMoveDecision() && UpdatePhysics(fTime));
        }

        boolean m_bStopping;

        public GotoPointState()
        {
            m_bStopping = false;
        }
    }

    public class PrecisionGotoState extends GotoPointState
    {

        public void SGSave(FileChunk cParentFC)
        {
            FileChunk.Log("[FlyingVehiclePhysics$PrecisionGotoPointState] : SGSave\n");
            FileChunk cFC = GameObject.NewChunk(1647, cParentFC);
            super.SGSave(cFC);
            cFC.SaveVector(vStart);
            cFC.SaveVector(vEnd);
            cFC.SaveVector(vDir);
            cFC.SaveFloat(fStartTime);
            cFC.SaveFloat(fEndTime);
            cFC.SaveFloat(fDist);
            cFC.delete();
        }

        public void SGUpdate()
        {
            FileChunk.Log("[FlyingVehiclePhysics$PrecisionGotoPointState] : SGUpdate\n");
        }

        public void SGLoad(FileChunk cParentFC)
        {
            FileChunk.Log("[FlyingVehiclePhysics$PrecisionGotoPointState] : SGLoad\n");
            FileChunk cFC = GameObject.LoadChunk(cParentFC);
            if(cFC.GetID() == 1647)
            {
                super.SGLoad(cFC);
                vStart = cFC.LoadVector();
                vEnd = cFC.LoadVector();
                vDir = cFC.LoadVector();
                fStartTime = cFC.LoadFloat();
                fEndTime = cFC.LoadFloat();
                fDist = cFC.LoadFloat();
            }
            cFC.delete();
        }

        public void OnEnter()
        {
            fStartTime = GetTime();
            vStart = m_Owner.GetPosition();
            vEnd = new Vector(m_vDestPoints[m_iCurrPoint]);
            vDir = new Vector(vEnd);
            vDir.Sub(vStart);
            fDist = vDir.Len();
            vDir.Normalize();
            fEndTime = fStartTime + vStart.Distance(vEnd) / 200F;
            m_iTurnFlag = FlyingVehiclePhysics._NO_TURN;
        }

        public boolean UpdatePosition()
        {
            float fTime = GetTime();
            float fValue = Smoothstep(fStartTime, fEndTime, fTime);
            Vector vPos = new Vector(vDir);
            vPos.Mul(fDist * fValue);
            vPos.Add(vStart);
            m_Owner.SetPosition(vPos);
            if(fValue >= 1.0F)
            {
                Finish();
                return true;
            } else
            {
                return false;
            }
        }

        float Smoothstep(float a, float b, float x)
        {
            if(x < a)
                return 0.0F;
            if(x >= b)
            {
                return 1.0F;
            } else
            {
                x = (x - a) / (b - a);
                return x * x * (3F - 2.0F * x);
            }
        }

        void Finish()
        {
            m_Owner.OnDestinationPos();
        }

        public void OnFrame()
        {
            for(float fTime = GetTime(); !UpdatePosition() && UpdatePhysics(fTime););
        }

        Vector vStart;
        Vector vEnd;
        float fStartTime;
        float fEndTime;
        float fDist;
        Vector vDir;

        public PrecisionGotoState()
        {
            vStart = null;
            vEnd = null;
            vDir = null;
        }
    }

    public class IdleState extends State
    {

        public void OnEnter()
        {
            m_iAccelFlag = FlyingVehiclePhysics._NO_ACCEL;
            m_iTurnFlag = FlyingVehiclePhysics._NO_TURN;
            m_iUpDownFlag = FlyingVehiclePhysics._NO_ACCEL;
        }

        public IdleState()
        {
        }
    }

    public class StartState extends State
    {

        public void SGSave(FileChunk cParentFC)
        {
            FileChunk.Log("[FlyingVehiclePhysics$StartState] : SGSave\n");
            FileChunk cFC = GameObject.NewChunk(1647, cParentFC);
            super.SGSave(cFC);
            cFC.SaveFloat(fStartHeight);
            cFC.SaveBool(bSetLandingAngle);
            cFC.SaveVector(vLandDestPoint);
            cFC.SaveFloat(fLastFryUpdateTime);
            cFC.SaveBool(bLandFXSpawned);
            cFC.SaveFloat(_DIST_TO_SPAWN_LAND_DUST);
            cFC.delete();
        }

        public void SGUpdate()
        {
            FileChunk.Log("[FlyingVehiclePhysics$StartState] : SGUpdate\n");
        }

        boolean CheckStartDecision(Vector vPos, float fHeight)
        {
            Physics_MakeUpDownDecision(vPos, fHeight);
            if(m_fCurrUpDownSpeed == 0.0F && m_iUpDownFlag == FlyingVehiclePhysics._NO_ACCEL)
            {
                float fCurrDistance = Physics_CalcUpDownDist(vPos, fHeight);
                if(Math.abs(fCurrDistance) <= _UPDOWN_FLY_PRECISION)
                {
                    if(!m_bStarting)
                        m_Owner.VehicleLanded(GetTime());
                    else
                        m_Owner.VehicleStarted(GetTime());
                    m_vLandDestDir = null;
                    return true;
                }
            }
            return false;
        }

        public void SGLoad(FileChunk cParentFC)
        {
            FileChunk.Log("[FlyingVehiclePhysics$GotoPointState] : SGLoad\n");
            FileChunk cFC = GameObject.LoadChunk(cParentFC);
            if(cFC.GetID() == 1647)
            {
                super.SGLoad(cFC);
                fStartHeight = cFC.LoadFloat();
                bSetLandingAngle = cFC.LoadBool();
                vLandDestPoint = cFC.LoadVector();
                fLastFryUpdateTime = cFC.LoadFloat();
                bLandFXSpawned = cFC.LoadBool();
                _DIST_TO_SPAWN_LAND_DUST = cFC.LoadFloat();
            }
            cFC.delete();
        }

        void FryingActors()
        {
            float fTime = GetTime();
            if(m_Owner.m_fActorFryingUpdateTime > 0.0F && fTime - fLastFryUpdateTime > m_Owner.m_fActorFryingUpdateTime)
            {
                fLastFryUpdateTime = fTime;
                m_Owner.FryActors();
            }
        }

        public void OnEnter()
        {
            m_iAccelFlag = FlyingVehiclePhysics._NO_ACCEL;
            m_iTurnFlag = FlyingVehiclePhysics._NO_TURN;
            bLandFXSpawned = false;
            fStartHeight = m_vStartLandPos.fY;
            if(m_vLandDestDir != null)
            {
                bSetLandingAngle = true;
                m_vDestPoints = new Vector[1];
                m_iCurrPoint = 0;
                m_vDestPoints[m_iCurrPoint] = m_Owner.GetPosition();
                m_vDestPoints[m_iCurrPoint].Add(m_vLandDestDir);
            } else
            {
                bSetLandingAngle = false;
            }
            fLastFryUpdateTime = 0.0F;
        }

        public void OnFrame()
        {
            float fDistBefore = 0.0F;
            float fDistAfter = 0.0F;
            float fTime = GetTime();
            do
            {
                if(bSetLandingAngle)
                {
                    Physics_MakeUpTurnDecision(1.0F);
                    if(Math.abs(Physics_CalcAngle()) < 1.0F)
                    {
                        bSetLandingAngle = false;
                        m_iTurnFlag = FlyingVehiclePhysics._NO_TURN;
                    }
                }
                fDistAfter = Physics_CalcUpDownDist(m_vVehiclePos, fStartHeight);
                if(fDistBefore * fDistAfter < 0.0F)
                {
                    m_fCurrUpDownSpeed = 0.0F;
                    m_iUpDownFlag = FlyingVehiclePhysics._NO_ACCEL;
                    m_vVehiclePos.fY = fStartHeight;
                }
                if(CheckStartDecision(m_Owner.GetPosition(), fStartHeight))
                    break;
                fDistBefore = Physics_CalcUpDownDist(m_vVehiclePos, fStartHeight);
            } while(UpdatePhysics(fTime));
            if(!bLandFXSpawned && m_Owner.m_bLanding)
            {
                float fCurrDistance = Physics_CalcUpDownDist(m_Owner.GetPosition(), fStartHeight);
                if(Math.abs(fCurrDistance) < _DIST_TO_SPAWN_LAND_DUST)
                {
                    m_Owner.PlayFXDustLand();
                    bLandFXSpawned = true;
                }
            }
            FryingActors();
        }

        float fStartHeight;
        boolean bSetLandingAngle;
        Vector vLandDestPoint;
        float fLastFryUpdateTime;
        boolean bLandFXSpawned;
        float _DIST_TO_SPAWN_LAND_DUST;

        public StartState()
        {
            fStartHeight = 0.0F;
            bSetLandingAngle = false;
            vLandDestPoint = null;
            fLastFryUpdateTime = 0.0F;
            bLandFXSpawned = false;
            _DIST_TO_SPAWN_LAND_DUST = 200F;
        }
    }


    void Physics_MakeUpDownDecision(Vector vPos, float fHeight)
    {
        float fDistanceToStop = Physics_CalcHeightToStop(_ACCEL_UPDOWN);
        float fCurrDistance = Physics_CalcUpDownDist(vPos, fHeight);
        if(Math.abs(fCurrDistance) > _UPDOWN_FLY_PRECISION || fDistanceToStop > Math.abs(fCurrDistance))
        {
            if(fCurrDistance > 0.0F)
                if(m_fCurrUpDownSpeed > 0.0F)
                    m_iUpDownFlag = _DEACCEL;
                else
                if(fDistanceToStop > fCurrDistance)
                    m_iUpDownFlag = _ACCEL;
                else
                    m_iUpDownFlag = _DEACCEL;
            if(fCurrDistance < 0.0F)
                if(m_fCurrUpDownSpeed < 0.0F)
                    m_iUpDownFlag = _ACCEL;
                else
                if(fDistanceToStop > Math.abs(fCurrDistance))
                    m_iUpDownFlag = _NO_ACCEL;
                else
                    m_iUpDownFlag = _ACCEL;
        } else
        {
            m_iUpDownFlag = _NO_ACCEL;
        }
    }

    float Physics_CalcAngleToStop(float fAccelTurn)
    {
        float fTurnSpeed = Math.abs(m_fCurrTurnSpeed);
        float fTimeToStop = fTurnSpeed / fAccelTurn;
        return fTimeToStop * (fTurnSpeed - (fAccelTurn * fTimeToStop) / 2.0F);
    }

    float Physics_CalcDist()
    {
        Vector vDestDir = new Vector(m_vDestPoints[m_iCurrPoint]);
        vDestDir.Sub(m_Owner.GetPosition());
        vDestDir.fY = 0.0F;
        return vDestDir.Len();
    }

    void UpdateOneStep(float fStep)
    {
        Physics_UpdateTurnSpeed(fStep);
        Physics_UpdateSpeed(fStep);
        Physics_UpdateUpDownSpeed(fStep);
        Physics_UpdatePosAndOrientation(fStep);
    }

    float GetMaxForwardSpeed()
    {
        return _MAX_FW_SPEED;
    }

    float Physics_CalcDistToStop()
    {
        float fTimeToStop = m_fCurrSpeed / _ACCEL_BW;
        return fTimeToStop * (m_fCurrSpeed - (_ACCEL_BW * fTimeToStop) / 2.0F);
    }

    void Physics_MakeUpTurnDecision(float fAnglePrecision)
    {
        float fCurrAngle = Physics_CalcAngle();
        if(m_iTurnFlag != _NO_TURN)
        {
            float fAngleToStop = Physics_CalcAngleToStop(_ACCEL_TURN);
            if(fCurrAngle > 0.0F)
            {
                if(m_fCurrTurnSpeed < 0.0F)
                    m_iTurnFlag = _TURN_RIGHT;
                else
                if(fAngleToStop > fCurrAngle)
                    m_iTurnFlag = _NO_TURN;
            } else
            if(fCurrAngle < 0.0F)
                if(m_fCurrTurnSpeed > 0.0F)
                    m_iTurnFlag = _TURN_LEFT;
                else
                if(fAngleToStop > -fCurrAngle)
                    m_iTurnFlag = _NO_TURN;
        } else
        if(m_fCurrTurnSpeed == 0.0F)
            if(Math.abs(fCurrAngle) > fAnglePrecision)
            {
                if(fCurrAngle > 0.0F)
                    m_iTurnFlag = _TURN_RIGHT;
                else
                    m_iTurnFlag = _TURN_LEFT;
            } else
            {
                m_iUpDownFlag = _NO_TURN;
            }
    }

    float Physics_CalcUpDownDist(Vector vPos, float fHeight)
    {
        return vPos.fY - fHeight;
    }

    void SetMaxUpDownSpeed(float fNewSpeed)
    {
        _MAX_UPDOWN_SPEED = fNewSpeed;
    }

    int GetPathPointsNum()
    {
        if(m_vDestPoints == null)
            return 0;
        else
            return m_vDestPoints.length;
    }

    void Physics_UpdateSpeed(float fDT)
    {
        if(m_iAccelFlag == _ACCEL)
        {
            if(m_fCurrSpeed < _CURR_MAX_FW_SPEED)
            {
                m_fCurrSpeed += fDT * _ACCEL_FW;
                if(m_fCurrSpeed > _CURR_MAX_FW_SPEED)
                    m_fCurrSpeed = _CURR_MAX_FW_SPEED;
            } else
            if(m_fCurrSpeed > _CURR_MAX_FW_SPEED)
            {
                m_fCurrSpeed -= fDT * _ACCEL_BW;
                if(m_fCurrSpeed < _CURR_MAX_FW_SPEED)
                    m_fCurrSpeed = _CURR_MAX_FW_SPEED;
            }
        } else
        if(m_iAccelFlag == _DEACCEL && m_fCurrSpeed > 0.0F)
        {
            m_fCurrSpeed -= fDT * _ACCEL_BW;
            if(m_fCurrSpeed < 0.0F)
                m_fCurrSpeed = 0.0F;
        }
    }

    boolean UpdatePhysics(float fCurrentT)
    {
        float fDT = fCurrentT - m_fLastT;
        if(fDT == 0.0F)
            return false;
        m_vVehicleForward = m_Owner.GetForwardVector();
        m_vVehiclePos = m_Owner.GetPosition();
        if(fDT >= _MIN_PHYSICS_UPDATE_GRAIN)
        {
            UpdateOneStep(_MIN_PHYSICS_UPDATE_GRAIN);
            m_fLastT += _MIN_PHYSICS_UPDATE_GRAIN;
            fDT -= _MIN_PHYSICS_UPDATE_GRAIN;
        } else
        {
            UpdateOneStep(fDT);
            m_fLastT += fDT;
            fDT = 0.0F;
        }
        float fUpDown = m_fCurrSpeed / _MAX_FW_SPEED / 3F;
        if(fUpDown > 1.0F)
            fUpDown = 1.0F;
        fUpDown *= _MAX_VERT_ANGLE;
        float fLeftRight = m_fCurrTurnSpeed / _MAX_TURN_SPEED;
        fLeftRight *= _MAX_HORIZ_ANGLE;
        Vector vUp = new Vector(Vector.Up);
        Vector vRightAxis = m_vVehicleForward.Cross(Vector.Up);
        vRightAxis.Normalize();
        vUp = RotateVector(Vector.Up, -fUpDown, vRightAxis);
        m_vVehicleForward = RotateVector(m_vVehicleForward, -fUpDown, vRightAxis);
        vUp = RotateVector(vUp, fLeftRight, m_vVehicleForward);
        m_Owner.FromUpForwardPos(vUp, m_vVehicleForward, m_vVehiclePos);
        Vector vSpeed = m_Owner.GetForwardVector();
        vSpeed.Mul(m_fCurrSpeed);
        vSpeed.fY = m_fCurrUpDownSpeed;
        m_Owner.SetSpeed(vSpeed);
        return fDT > 0.0F;
    }

    public void SGSaveChunk(FileChunk cFCParent)
    {
        FileChunk.Log("[FlyingVehiclePhysics.SGSaveChunk]\n");
        FileChunk cFC = GameObject.NewChunk(1629, cFCParent);
        super.SGSaveChunk(cFC);
        cFC.SaveFloat(m_fCurrSpeed);
        cFC.SaveInt(m_iAccelFlag);
        cFC.SaveInt(m_iTurnFlag);
        cFC.SaveFloat(m_fCurrTurnSpeed);
        cFC.SaveInt(m_iUpDownFlag);
        cFC.SaveFloat(m_fCurrUpDownSpeed);
        cFC.SaveBool(m_vDestPoints != null);
        if(m_vDestPoints != null)
        {
            cFC.SaveInt(m_vDestPoints.length);
            for(int i = 0; i < m_vDestPoints.length; i++)
                cFC.SaveVector(m_vDestPoints[i]);

        }
        cFC.SaveInt(m_iCurrPoint);
        cFC.SaveBool(m_bStopTurn);
        cFC.SaveFloat(m_fLastT);
        cFC.SaveVector(m_vLandDestDir);
        cFC.SaveVector(m_vVehicleForward);
        cFC.SaveVector(m_vVehiclePos);
        cFC.SaveBool(m_bPreciseMoving);
        cFC.SaveVector(m_vStartLandPos);
        cFC.SaveBool(m_bSlowDownToPoint);
        cFC.SaveBool(m_bStarting);
        cFC.SaveObjectRef(m_Owner);
        cFC.SaveBool(bActivatePhysics);
        cFC.delete();
    }

    void StartFly()
    {
        m_Owner.PlayFXDustStart();
        SetState("StartState");
    }

    void StartFly(Vector vDestPos)
    {
        m_vStartLandPos = vDestPos;
        m_bStarting = true;
        m_Owner.PlayFXDustStart();
        SetState("StartState");
    }

    public void SGLoadChunk(FileChunk cParentFC)
    {
        FileChunk.Log("[FlyingVehiclePhysics.SGLoadChunk]\n");
        FileChunk cFC = GameObject.LoadChunk(cParentFC);
        if(cFC.GetID() == 1629)
        {
            super.SGLoadChunk(cFC);
            m_fCurrSpeed = cFC.LoadFloat();
            m_iAccelFlag = cFC.LoadInt();
            m_iTurnFlag = cFC.LoadInt();
            m_fCurrTurnSpeed = cFC.LoadFloat();
            m_iUpDownFlag = cFC.LoadInt();
            m_fCurrUpDownSpeed = cFC.LoadFloat();
            if(cFC.LoadBool())
            {
                int nSize = cFC.LoadInt();
                if(m_vDestPoints == null || nSize != m_vDestPoints.length)
                    m_vDestPoints = new Vector[nSize];
                for(int i = 0; i < m_vDestPoints.length; i++)
                    m_vDestPoints[i] = cFC.LoadVector();

            } else
            {
                m_vDestPoints = null;
            }
            m_iCurrPoint = cFC.LoadInt();
            m_bStopTurn = cFC.LoadBool();
            m_fLastT = cFC.LoadFloat();
            m_vLandDestDir = cFC.LoadVector();
            m_vVehicleForward = cFC.LoadVector();
            m_vVehiclePos = cFC.LoadVector();
            m_bPreciseMoving = cFC.LoadBool();
            m_vStartLandPos = cFC.LoadVector();
            m_bSlowDownToPoint = cFC.LoadBool();
            m_bStarting = cFC.LoadBool();
            m_Owner = (FlyingVehicle)cFC.LoadObjectRef();
            bActivateSG = cFC.LoadBool();
        }
        cFC.delete();
    }

    void SetAccelUpDown(float fAccel)
    {
        _ACCEL_UPDOWN = fAccel;
    }

    float Physics_CalcAngle()
    {
        Vector vForward = m_Owner.GetForwardVector();
        vForward.fY = 0.0F;
        vForward.Normalize();
        Vector vDestDir = new Vector(m_vDestPoints[m_iCurrPoint]);
        vDestDir.Sub(m_Owner.GetPosition());
        vDestDir.fY = 0.0F;
        vDestDir.Normalize();
        float fReturn = vDestDir.Dot(vForward);
        if(fReturn < -1F)
            fReturn = -1F;
        if(fReturn > 1.0F)
            fReturn = 1.0F;
        fReturn = (float)Math.acos(fReturn);
        if(vDestDir.Cross(vForward).fY < 0.0F)
            fReturn *= -1F;
        fReturn *= _RAD_TO_DEG;
        return fReturn;
    }

    void Physics_UpdatePosAndOrientation(float fDT)
    {
        Vector vForward = new Vector(m_vVehicleForward);
        vForward.fY = 0.0F;
        vForward.Normalize();
        Vector vPos = new Vector(m_vVehiclePos);
        vForward = m_Owner.RotateVector(vForward, -m_fCurrTurnSpeed * fDT, Vector.Up);
        if(m_fCurrSpeed != 0.0F)
        {
            Vector vMove = new Vector(vForward);
            vMove.Mul(m_fCurrSpeed * fDT);
            vPos.Add(vMove);
        }
        vPos.fY += m_fCurrUpDownSpeed * fDT;
        m_vVehicleForward.Set(vForward);
        m_vVehiclePos.Set(vPos);
    }

    int Physics_CalcTurnDirection()
    {
        Vector vForward = m_Owner.GetForwardVector();
        vForward.fY = 0.0F;
        vForward.Normalize();
        Vector vDestDir = new Vector(m_vDestPoints[m_iCurrPoint]);
        vDestDir.Sub(m_Owner.GetPosition());
        vDestDir.fY = 0.0F;
        vDestDir.Normalize();
        if(vDestDir.Cross(vForward).fY > 0.0F)
            return _TURN_RIGHT;
        else
            return _TURN_LEFT;
    }

    public void SGUpdate()
    {
        super.SGUpdate();
        if((!bActivatePhysics) & bActivateSG)
            ActivatePhysics();
        else
        if(bActivatePhysics & (!bActivateSG))
            DeactivatePhysics();
    }

    void SetCurrMaxForwardSpeed(float fNewSpeed)
    {
        _CURR_MAX_FW_SPEED = fNewSpeed;
        if(_CURR_MAX_FW_SPEED > _MAX_FW_SPEED)
        {
            _CURR_MAX_FW_SPEED = _MAX_FW_SPEED;
            GameObject.CrashLog("_CURR_MAX_FW_SPEED > _MAX_FW_SPEED !!!\n");
        }
    }

    void StartLand(Vector vDestPos, Vector vDestDir)
    {
        m_vStartLandPos = vDestPos;
        m_vLandDestDir = vDestDir;
        m_bStarting = false;
        SetState("StartState");
    }

    void Physics_UpdateTurnSpeed(float fDT)
    {
        if(m_iTurnFlag == _TURN_LEFT)
        {
            m_fCurrTurnSpeed -= fDT * _ACCEL_TURN;
            if(m_fCurrTurnSpeed < -_MAX_TURN_SPEED)
                m_fCurrTurnSpeed = -_MAX_TURN_SPEED;
        } else
        if(m_iTurnFlag == _TURN_RIGHT)
        {
            m_fCurrTurnSpeed += fDT * _ACCEL_TURN;
            if(m_fCurrTurnSpeed > _MAX_TURN_SPEED)
                m_fCurrTurnSpeed = _MAX_TURN_SPEED;
        } else
        {
            if(m_fCurrTurnSpeed > 0.0F)
            {
                m_fCurrTurnSpeed -= fDT * _ACCEL_TURN;
                if(m_fCurrTurnSpeed < 0.0F)
                    m_fCurrTurnSpeed = 0.0F;
            }
            if(m_fCurrTurnSpeed < 0.0F)
            {
                m_fCurrTurnSpeed += fDT * _ACCEL_TURN;
                if(m_fCurrTurnSpeed > 0.0F)
                    m_fCurrTurnSpeed = 0.0F;
            }
        }
    }

    void ActivatePhysics()
    {
        bActivatePhysics = true;
        ActivateOnModule();
        m_fLastT = GetTime();
    }

    public FlyingVehiclePhysics()
    {
        _UPDOWN_FLY_PRECISION = 10F;
        _ACCEL_UPDOWN = 1000F;
        _MAX_UPDOWN_SPEED = 2000F;
        _MOVE_PRECISION = 1000F;
        _MAX_FW_SPEED = 4000F;
        _CURR_MAX_FW_SPEED = 2000F;
        _ACCEL_FW = 1000F;
        _ACCEL_BW = 1200F;
        _MAX_TURN_SPEED = 120F;
        _ACCEL_TURN = 40F;
        _MAX_VERT_ANGLE = 45F;
        _MAX_HORIZ_ANGLE = 30F;
        _AIM_AT_ENEMY_ANGLE_PRECISION = 30F;
        m_fCurrSpeed = 0.0F;
        m_iAccelFlag = _NO_ACCEL;
        m_iTurnFlag = _NO_TURN;
        m_fCurrTurnSpeed = 0.0F;
        m_iUpDownFlag = _NO_ACCEL;
        m_fCurrUpDownSpeed = 0.0F;
        m_Owner = null;
        m_vDestPoints = null;
        m_iCurrPoint = 0;
        m_bStopTurn = true;
        m_fLastT = 0.0F;
        m_vLandDestDir = null;
        m_vVehicleForward = null;
        m_vVehiclePos = null;
        m_bPreciseMoving = false;
        m_vStartLandPos = null;
        m_bSlowDownToPoint = true;
        m_bStarting = false;
        bActivatePhysics = false;
        bActivateSG = false;
    }

    float Physics_CalcHeightToStop(float fAccel)
    {
        float fUpDownSpeed = Math.abs(m_fCurrUpDownSpeed);
        float fTimeToStop = fUpDownSpeed / fAccel;
        return fTimeToStop * (fUpDownSpeed - (fAccel * fTimeToStop) / 2.0F);
    }

    void Reset()
    {
        m_iAccelFlag = _NO_ACCEL;
        m_iTurnFlag = _NO_TURN;
        m_iUpDownFlag = _NO_ACCEL;
        m_fCurrSpeed = 0.0F;
        m_fCurrTurnSpeed = 0.0F;
        m_fCurrUpDownSpeed = 0.0F;
        m_iCurrPoint = 0;
    }

    void InitPhysics(FlyingVehicle owner)
    {
        m_Owner = owner;
    }

    void PatrolPoints(Vector vPoints[])
    {
        if(m_Owner == null)
            return;
        if(vPoints == null)
        {
            return;
        } else
        {
            m_bSlowDownToPoint = vPoints.length <= 1;
            m_bStopTurn = true;
            m_vDestPoints = vPoints;
            SetState("GotoPointState");
            return;
        }
    }

    void SetMovePrecision(float fMovePrecision)
    {
        _MOVE_PRECISION = fMovePrecision;
    }

    void MoveTo(Vector vDestPoint, boolean bStopTurn)
    {
        MoveTo(vDestPoint, bStopTurn, true);
    }

    void MoveTo(Vector vDestPoint, boolean bStopTurn, boolean bSlowDownToPoint)
    {
        if(m_Owner == null)
        {
            return;
        } else
        {
            m_bSlowDownToPoint = bSlowDownToPoint;
            m_bStopTurn = bStopTurn;
            m_vDestPoints = new Vector[1];
            m_vDestPoints[0] = new Vector(vDestPoint);
            SetState("GotoPointState");
            return;
        }
    }

    void MoveTo(Vector vDestPoint)
    {
        MoveTo(vDestPoint, false);
    }

    void SetMaxForwardSpeed(float fNewSpeed)
    {
        _MAX_FW_SPEED = fNewSpeed;
    }

    void Physics_UpdateUpDownSpeed(float fDT)
    {
        if(m_iUpDownFlag < 0)
        {
            m_fCurrUpDownSpeed -= fDT * _ACCEL_UPDOWN;
            if(m_fCurrUpDownSpeed < -_MAX_UPDOWN_SPEED)
                m_fCurrUpDownSpeed = -_MAX_UPDOWN_SPEED;
        } else
        if(m_iUpDownFlag > 0)
        {
            m_fCurrUpDownSpeed += fDT * _ACCEL_UPDOWN;
            if(m_fCurrUpDownSpeed > _MAX_UPDOWN_SPEED)
                m_fCurrUpDownSpeed = _MAX_UPDOWN_SPEED;
        } else
        if(m_iUpDownFlag == 0)
        {
            if(m_fCurrUpDownSpeed > 0.0F)
            {
                m_fCurrUpDownSpeed -= fDT * _ACCEL_UPDOWN;
                if(m_fCurrUpDownSpeed < 0.0F)
                    m_fCurrUpDownSpeed = 0.0F;
            }
            if(m_fCurrUpDownSpeed < 0.0F)
            {
                m_fCurrUpDownSpeed += fDT * _ACCEL_UPDOWN;
                if(m_fCurrUpDownSpeed > 0.0F)
                    m_fCurrUpDownSpeed = 0.0F;
            }
        }
    }

    void DeactivatePhysics()
    {
        bActivatePhysics = false;
        CallMethodIn("DeactivateOnModule", 0.0F);
    }

    boolean Physics_EnoughTimeToTurn()
    {
        boolean bReturn = true;
        float fAngle = Physics_CalcAngle();
        float fDist = Physics_CalcDist();
        if(Math.abs(m_fCurrTurnSpeed) < 1.0F)
            return true;
        if(m_fCurrSpeed < 100F)
            return true;
        float fTurnTime = Physics_CalcAngle() / m_fCurrTurnSpeed;
        if(fTurnTime < 0.0F)
            return true;
        return fTurnTime <= fDist / m_fCurrSpeed;
    }

    public void OnFrame()
    {
        for(float fTime = GetTime(); UpdatePhysics(fTime););
    }

    static float _MIN_PHYSICS_UPDATE_GRAIN = 0.05F;
    float _UPDOWN_FLY_PRECISION;
    float _ACCEL_UPDOWN;
    float _MAX_UPDOWN_SPEED;
    float _MOVE_PRECISION;
    float _MAX_FW_SPEED;
    float _CURR_MAX_FW_SPEED;
    float _ACCEL_FW;
    float _ACCEL_BW;
    static float _DEG_PRECISION = 1.0F;
    float _MAX_TURN_SPEED;
    float _ACCEL_TURN;
    float _MAX_VERT_ANGLE;
    float _MAX_HORIZ_ANGLE;
    float _AIM_AT_ENEMY_ANGLE_PRECISION;
    static float _RAD_TO_DEG = 57.29578F;
    static float _NO_VALUE = -1F;
    static int _TURN_LEFT = -1;
    static int _NO_TURN = 0;
    static int _TURN_RIGHT = 1;
    static int _DEACCEL = -1;
    static int _NO_ACCEL = 0;
    static int _ACCEL = 1;
    float m_fCurrSpeed;
    int m_iAccelFlag;
    int m_iTurnFlag;
    float m_fCurrTurnSpeed;
    int m_iUpDownFlag;
    float m_fCurrUpDownSpeed;
    FlyingVehicle m_Owner;
    Vector m_vDestPoints[];
    int m_iCurrPoint;
    boolean m_bStopTurn;
    float m_fLastT;
    Vector m_vLandDestDir;
    Vector m_vVehicleForward;
    Vector m_vVehiclePos;
    boolean m_bPreciseMoving;
    Vector m_vStartLandPos;
    public boolean m_bSlowDownToPoint;
    boolean m_bStarting;
    boolean bActivatePhysics;
    boolean bActivateSG;

}
