// Decompiled by Jad v1.5.8g. Copyright 2001 Pavel Kouznetsov.
// Jad home page: http://www.kpdus.com/jad.html
// Decompiler options: packimports(3) 
// Source File Name:   ForceFieldFence.java


public class ForceFieldFence extends MeshObject
    implements iact_EnableDisable
{

    public void OnAudioReinitialize()
    {
        if(nAmbientLoop != 0)
        {
            nAmbientLoop = 0;
            AttachAmbient();
        }
    }

    public boolean IsEnabled()
    {
        return bIsEnabled;
    }

    public void SGUpdate()
    {
        FileChunk.Log("[ForceFieldFence.SGUpdate]\n");
        super.SGUpdate();
        DetachAmbient();
        if(bCurrEnabledSG)
            CallMethodIn("Enable", 0.0F);
        else
            CallMethodIn("Disable", 0.0F);
    }

    public ForceFieldFence()
    {
        bIsEnabled = true;
        fPlayerDamage = 300F;
        fPlayerJumpUp = 1300F;
        fPlayerJumpHoriz = 400F;
        sFXTouched = "FXBlowFence";
        sTouchedSound = "Data/Sounds/RedBarriersShock.wav";
        sAmbientSound = "Data/Sounds/RedBarriersLoop.wav";
        nAmbientLoop = 0;
        bCurrEnabled = false;
        bCurrEnabledSG = false;
    }

    public void OnCollisionFullInfo(ControlObject Col, Vector vPoint, Vector vNormal)
    {
        if(Col instanceof Actor)
        {
            Actor cActor = (Actor)Col;
            Vector vFXPoint = new Vector(vPoint);
            if(cActor.fHealth > 0.0F)
            {
                if(cActor instanceof Vehicle)
                {
                    Vehicle vehicle = (Vehicle)cActor;
                    vehicle.TakeDamage(fPlayerDamage, EnumDamageType._BULLET);
                } else
                if(cActor instanceof Player)
                {
                    Player cPlayer = (Player)cActor;
                    cPlayer.TakeDamage(fPlayerDamage, fPlayerDamage, this, new Vector(Vector.Up), vNormal, -1, EnumDamageType._ELECTRIC);
                    cPlayer.SetFallSpeed(new Vector(0.0F, 0.0F, 0.0F));
                    cPlayer.SetLocalSpeed(new Vector(), false);
                    Vector vJump = new Vector(vNormal);
                    vJump.fY = fPlayerJumpUp;
                    vJump.fX *= fPlayerJumpHoriz;
                    vJump.fZ *= fPlayerJumpHoriz;
                    cPlayer.Jump(vJump);
                    vFXPoint.fY += 50F;
                } else
                if(cActor instanceof InvObject)
                {
                    if(GetTime() - ((InvObject)cActor).fLastForceFieldCollision > 1.0F)
                    {
                        cActor.TakeDamage(cActor.fHealth * 10F, cActor.fHealth * 10F, this, new Vector(Vector.Up), vNormal, -1, EnumDamageType._ELECTRIC);
                        ((InvObject)cActor).fLastForceFieldCollision = GetTime();
                    } else
                    {
                        return;
                    }
                } else
                {
                    cActor.TakeDamage(cActor.fHealth * 10F, cActor.fHealth * 10F, this, new Vector(Vector.Up), vNormal, -1, EnumDamageType._ELECTRIC);
                }
                ExecuteFX(sFXTouched, vFXPoint, Vector.Up);
                ExecuteParticleSystem(sFXTouched, vFXPoint, Vector.Up);
                PlaySound(sTouchedSound);
            }
        } else
        {
            GameObject.CrashLog("WARNING: ForceFieldFence - collision with NON-Actor object\n");
        }
    }

    public void Enable()
    {
        DisableCallMethod("Enable");
        DisableCallMethod("Disable");
        EnableForceField(true);
    }

    void AttachAmbient()
    {
        if(nAmbientLoop == 0)
            nAmbientLoop = AttachSound(sAmbientSound, 800F, 1200F);
    }

    public void Disable()
    {
        DisableCallMethod("Enable");
        DisableCallMethod("Disable");
        EnableForceField(false);
    }

    public void EnableForceField(boolean bEnable)
    {
        bCurrEnabled = bEnable;
        EnableRendering(bEnable);
        if(bEnable)
        {
            SetFlag(1);
            ActivateOnModule();
            AttachAmbient();
        } else
        {
            ClearFlag(1);
            DetachAmbient();
            DeactivateOnModuleAlways();
        }
    }

    void OnCreate()
    {
        super.OnCreate();
        super.bSG = true;
        SetFlags(36);
        SetPhysicsActive(false);
        SetCollType(2);
        SetCollHandler(768);
        if(bIsEnabled)
            CallMethodIn("Enable", 0.0F);
    }

    void DetachAmbient()
    {
        if(nAmbientLoop != 0)
            DetachSound(nAmbientLoop);
        nAmbientLoop = 0;
    }

    public void SGSaveChunk(FileChunk cFCParent)
    {
        FileChunk.Log("[ForceFieldFence.SGSaveChunk]\n");
        FileChunk cFC = GameObject.NewChunk(1622, cFCParent);
        super.SGSaveChunk(cFC);
        cFC.SaveBool(bCurrEnabled);
        cFC.delete();
    }

    public void SGLoadChunk(FileChunk cParentFC)
    {
        FileChunk.Log("[ForceFieldFence.SGLoadChunk]\n");
        FileChunk cFC = GameObject.LoadChunk(cParentFC);
        if(cFC.GetID() == 1622)
        {
            super.SGLoadChunk(cFC);
            bCurrEnabledSG = cFC.LoadBool();
        }
        cFC.delete();
    }

    void OnDestroy()
    {
        DetachAmbient();
    }

    public boolean bIsEnabled;
    public float fPlayerDamage;
    public float fPlayerJumpUp;
    public float fPlayerJumpHoriz;
    public String sFXTouched;
    public String sTouchedSound;
    public String sAmbientSound;
    int nAmbientLoop;
    boolean bCurrEnabled;
    boolean bCurrEnabledSG;
}
