// Decompiled by Jad v1.5.8g. Copyright 2001 Pavel Kouznetsov.
// Jad home page: http://www.kpdus.com/jad.html
// Decompiler options: packimports(3) 
// Source File Name:   Gate.java


public class Gate extends TriggerObject
    implements iact_OpenClose, iact_LockUnlock, iact_LockOpened
{

    public void ToggleOpenClose()
    {
        if(bOpened)
            Close();
        else
            Open();
    }

    void AfterClose()
    {
        GameObject.InvokeActionChain(aOnClose);
    }

    String GetTip()
    {
        if(bOpened)
            return "[&GateClose&]";
        else
            return "[&GateOpen&]";
    }

    void AfterOpen()
    {
        GameObject.InvokeActionChain(aOnOpen);
    }

    public void LockOpened()
    {
        bLocked = false;
        Open();
        Lock();
    }

    Gate()
    {
        bCanAIOpenIt = true;
        bFenceGateType = false;
        fMinSound = 2000F;
        fMaxSound = 5000F;
        sOpenSound = "Data/Sounds/DoorE_Open";
        sCloseSound = "Data/Sounds/DoorE_Close";
        sLockSystemAccept = "Data/Sounds/doors/LockSystemAccept";
        sLockSystemReject = "Data/Sounds/doors/LockSystemReject";
        aIndicatorsFound = null;
        bMultipleUse = true;
        bOpened = false;
        bLocked = false;
        aOnOpen = null;
        aOnClose = null;
        nOpenStartFrame = 0;
        nOpenEndFrame = 0;
        nCloseStartFrame = 0;
        nCloseEndFrame = 0;
        nAnimOpenID = -1;
        nAnimCloseID = -1;
        super.ActiveElement = "zamek_elektroniczny";
    }

    public void SGUpdate()
    {
        FileChunk.Log("[Gate.SGUpdate]\n");
        super.SGUpdate();
        UpdateIndicators();
    }

    boolean IsIndicator(MeshObject cObj)
    {
        for(int i = 0; i < m_sIndicatorElems.length; i++)
            if(cObj.GetElementID(m_sIndicatorElems[i]) != -1)
                return true;

        return false;
    }

    public void Unlock()
    {
        bLocked = false;
        UpdateIndicators();
    }

    public void ToggleLockUnlock()
    {
        if(bLocked)
            Unlock();
        else
            Lock();
    }

    public boolean IsLocked()
    {
        return bLocked;
    }

    void UpdateIndicators()
    {
        if(aIndicatorsFound == null)
            return;
        for(int i = 0; i < aIndicatorsFound.length; i++)
            if(IsLocked() && !IsOpened())
                aIndicatorsFound[i].SetSkin("Locked");
            else
                aIndicatorsFound[i].SetSkin("Unlocked");

    }

    public void Close()
    {
        if(bLocked)
            return;
        if(!bMultipleUse)
            super.bActiveTrigger = false;
        bOpened = false;
        PlayAnim(nAnimCloseID, 1);
        CallMethodIn("AfterClose", GetAnimLength(nAnimCloseID));
        PlaySound(sCloseSound, fMinSound, fMaxSound);
    }

    public void Lock()
    {
        bLocked = true;
        UpdateIndicators();
    }

    public void Open()
    {
        if(bLocked)
            return;
        if(!bMultipleUse)
            super.bActiveTrigger = false;
        bOpened = true;
        PlayAnim(nAnimOpenID, 1);
        CallMethodIn("AfterOpen", GetAnimLength(nAnimOpenID));
        PlaySound(sOpenSound, fMinSound, fMaxSound);
    }

    public boolean IsOpened()
    {
        return bOpened;
    }

    void OnCreate()
    {
        super.bSG = true;
        super.OnCreate();
        int nLastFrame = (int)GetNumFrames();
        if(nOpenStartFrame == nOpenEndFrame && nOpenStartFrame == 0)
        {
            nOpenStartFrame = 0;
            nOpenEndFrame = nLastFrame / 2;
            GameObject.CrashLog("[Gate.OnCreate] nOpenStartFrame=" + nOpenStartFrame + " nOpenEndFrame=" + nOpenEndFrame + "\n");
        }
        if(nCloseStartFrame == nCloseEndFrame && nCloseStartFrame == 0)
        {
            nCloseStartFrame = nLastFrame / 2;
            nCloseEndFrame = nLastFrame;
            GameObject.CrashLog("[Gate.OnCreate] nCloseStartFrame=" + nCloseStartFrame + " nCloseEndFrame=" + nCloseEndFrame + "\n");
        }
        InitAnimSeq("open", nOpenStartFrame, nOpenEndFrame);
        InitAnimSeq("close", nCloseStartFrame, nCloseEndFrame);
        nAnimOpenID = GetAnimID(0, "open");
        nAnimCloseID = GetAnimID(0, "close");
        SetAnimMorphTime(0.0F);
        SetFlag(8);
        ClearFlag(6);
        if(bFenceGateType)
            ClearFlag(8);
        if(bOpened)
            SetFrame(nOpenEndFrame, 0);
        GetNearestDoorsIndicators();
        UpdateIndicators();
    }

    void Execute(Actor executor)
    {
        if(bLocked)
            return;
        super.Execute(executor);
        if(!bOpened)
        {
            float fTime = GetWaveDuration(sLockSystemAccept);
            PlaySound(sLockSystemAccept, GetElementPos(GetElementID(super.ActiveElement)), fMinSound, fMaxSound);
            CallMethodIn("Open", fTime);
        } else
        {
            float fTime = GetWaveDuration(sLockSystemAccept);
            PlaySound(sLockSystemAccept, GetElementPos(GetElementID(super.ActiveElement)), fMinSound, fMaxSound);
            CallMethodIn("Close", fTime);
        }
    }

    void GetNearestDoorsIndicators()
    {
        Vector vPos = GetPosition();
        GameObject aLampkas[] = GetObjectsInRadiusFromClass(vPos, 750F, "TriggerObject");
        float fMinDist = 1E+011F;
        float fMinDist2 = 1E+011F;
        int nMinLampka = -1;
        int nMinLampka2 = -1;
        for(int i = 0; i < aLampkas.length; i++)
            if(IsIndicator((MeshObject)aLampkas[i]))
            {
                float fDist = vPos.Distance2(((ControlObject)aLampkas[i]).GetPosition());
                if(fDist < fMinDist)
                {
                    fMinDist = fDist;
                    nMinLampka = i;
                } else
                if(fDist < fMinDist2)
                {
                    fMinDist2 = fDist;
                    nMinLampka2 = i;
                }
            }

        if(nMinLampka != -1 && nMinLampka2 != -1)
        {
            aIndicatorsFound = new TriggerObject[2];
            aIndicatorsFound[0] = (TriggerObject)aLampkas[nMinLampka];
            aIndicatorsFound[1] = (TriggerObject)aLampkas[nMinLampka2];
        } else
        if(nMinLampka != -1)
        {
            aIndicatorsFound = new TriggerObject[1];
            aIndicatorsFound[0] = (TriggerObject)aLampkas[nMinLampka];
        } else
        if(nMinLampka2 != -1)
        {
            aIndicatorsFound = new TriggerObject[1];
            aIndicatorsFound[0] = (TriggerObject)aLampkas[nMinLampka2];
        }
    }

    public void SGSaveChunk(FileChunk cFCParent)
    {
        FileChunk.Log("[Gate.SGSaveChunk]\n");
        FileChunk cFC = GameObject.NewChunk(1163, cFCParent);
        super.SGSaveChunk(cFC);
        cFC.SaveBool(IsPlaying(nAnimOpenID));
        cFC.SaveBool(IsPlaying(nAnimCloseID));
        cFC.SaveBool(bLocked);
        cFC.SaveBool(bOpened);
        cFC.delete();
    }

    public void SGLoadChunk(FileChunk cParentFC)
    {
        FileChunk.Log("[Gate.SGLoadChunk]\n");
        FileChunk cFC = GameObject.LoadChunk(cParentFC);
        if(cFC.GetID() == 1163)
        {
            super.SGLoadChunk(cFC);
            boolean bPlayingAnim = false;
            if(cFC.LoadBool())
                bPlayingAnim = true;
            if(cFC.LoadBool())
                bPlayingAnim = true;
            bLocked = cFC.LoadBool();
            bOpened = cFC.LoadBool();
            if(!bPlayingAnim)
                if(bOpened)
                    SetFrame(GetLastFrame(nAnimOpenID), -1);
                else
                    SetFrame(GetLastFrame(nAnimCloseID), -1);
        }
        cFC.delete();
    }

    public void OnDestroy()
    {
    }

    public boolean bCanAIOpenIt;
    public boolean bFenceGateType;
    public float fMinSound;
    public float fMaxSound;
    public String sOpenSound;
    public String sCloseSound;
    public String sLockSystemAccept;
    public String sLockSystemReject;
    TriggerObject aIndicatorsFound[];
    String m_sIndicatorElems[] = {
        "TerminalA", "Terminal"
    };
    public boolean bMultipleUse;
    public boolean bOpened;
    public boolean bLocked;
    public Action aOnOpen[];
    public Action aOnClose[];
    int nOpenStartFrame;
    int nOpenEndFrame;
    int nCloseStartFrame;
    int nCloseEndFrame;
    int nAnimOpenID;
    int nAnimCloseID;
}
