// Decompiled by Jad v1.5.8g. Copyright 2001 Pavel Kouznetsov.
// Jad home page: http://www.kpdus.com/jad.html
// Decompiler options: packimports(3) 
// Source File Name:   Grenade.java


public class Grenade extends Bullet
{
    public class Flying extends Bullet.Flying
    {

        void FlyingNoiseUpdate()
        {
            if(!bExploded)
            {
                MakeNoise(fFlyingNoiseRange, 5);
                CallMethodIn(METHOD_FlyingNoiseUpdate, fFlyingNoiseUpdateTime);
            }
        }

        void SpeedUpdate()
        {
        }

        public void SGUpdate()
        {
            FileChunk.Log("[Grenade$Flying] : SGUpdate\n");
            super.SGUpdate();
            ActivateOnModule();
        }

        public void OnCollisionFullInfo(ControlObject Col, Vector v1, Vector v2)
        {
            if(Col instanceof ForceFieldFence)
            {
                Explode();
                return;
            } else
            {
                super.OnCollisionFullInfo(Col, v1, v2);
                PlayHitSound(Col, v1, v2);
                RotateInit(m_fRotateMaxSpeed, GetTime());
                SpeedReductionOnHit(Col, v1, v2);
                return;
            }
        }

        public void OnEnter()
        {
            super.OnEnter();
            FlyingNoiseUpdate();
        }

        void OnFrame()
        {
            Rotate();
        }

        public Flying()
        {
        }
    }


    void Start(float fForce, Vector vDir, float fTime)
    {
        Start(fForce, GetPosition(), vDir, fTime);
    }

    void CheckWater()
    {
        GetPosition(l_vPos);
        float fGroundHeight = TerrainHeight(l_vPos.fX, l_vPos.fZ);
        boolean bInWater = l_vPos.fY > fGroundHeight && l_vPos.fY < fGroundHeight;
        if(m_bInWater != bInWater)
        {
            m_bInWater = bInWater;
            if(m_bInWater)
                PlayHitSound(9);
        }
    }

    void BulletStarted()
    {
        if(super.cWeaponOwner instanceof WeaponGrenade)
            ((WeaponGrenade)super.cWeaponOwner).GrenadeStarted();
    }

    Grenade()
    {
        m_fMass = 55F;
        fExplodeTime = 3F;
        fReduceSpeed = 100F;
        m_fRotateMaxSpeed = 500F;
        m_vRotate = null;
        m_fRotateLastTime = 0.0F;
        fFlyingNoiseRange = 1000F;
        fFlyingNoiseUpdateTime = 0.5F;
        fThrowForce = 0.0F;
        METHOD_FlyingNoiseUpdate = 0;
        METHOD_Explode = 0;
        m_fLastSpeedReductionTime = 0.0F;
        m_fMinSpeedReductionInterval = 0.2F;
        fHitSoundMinDist = 300F;
        fHitSoundMaxDist = 1200F;
        m_bInWater = false;
        super.sName = "Grenades";
        super.MeshName = "Data/Meshes/Equipment/granat_zaczepny_fly.3DA";
        super.fHealth = 1.0F;
        super.fDamage = 10F;
        super.fDirectHitDamage = 0.0F;
        super.fPhysicsSimDamage = super.fDamage;
        super.fBlastDamage = 1000F;
        super.fPhysicsSimBlastDamage = super.fBlastDamage;
        super.fBlastRadius = 1000F;
        super.fStartSpeed = 100F;
        super.sSoundExplodeName = "Data/Sounds/Weapon/GrenadeExplosion";
        super.sFXHitName = "FXBlowGrenade";
        super.m_fDamageDelay = _DAMAGE_DELAY;
        super.fLightScaleFlight = 1.0F;
    }

    public void SGUpdate()
    {
        super.SGUpdate();
        FileChunk.Log("[Grenade.SGUpdate]\n");
        RotateInit(m_fRotateMaxSpeed);
    }

    public void Acquire(Module mod, Pawn owner)
    {
        super.Acquire(mod, owner);
        METHOD_FlyingNoiseUpdate = RegisterCallMethod("FlyingNoiseUpdate");
        METHOD_Explode = RegisterCallMethod("Explode");
    }

    void PlayHitSound(ControlObject cHitObject, Vector vPoint, Vector vNormal)
    {
        l_vStart.Set(vPoint);
        l_vEnd.Set(vPoint);
        vNormal.Mul(100F);
        l_vStart.Sub(vNormal);
        l_vEnd.Add(vNormal);
        int nMaterial = -1;
        Collision stCollObject = TraceObjectsExclude(l_vStart, l_vEnd, this);
        if(stCollObject != null)
            nMaterial = stCollObject.nMaterial;
        else
            nMaterial = 0;
        if(nMaterial > -1)
            PlayHitSound(nMaterial);
    }

    void PlayHitSound(int nMaterial)
    {
        int nMotionStepType = 0;
        if(nMaterial == 9)
            nMotionStepType = 0;
        if(nMotionStepType != -1)
        {
            ChromeModule module = (ChromeModule)GetModule();
            String sStepSound = module.GetGrenadeSound(nMaterial, nMotionStepType);
            if(sStepSound != null)
                AttachOneShotSound(sStepSound, fHitSoundMinDist, fHitSoundMaxDist);
        }
    }

    public void OnCreate()
    {
        super.OnCreate();
        METHOD_FlyingNoiseUpdate = RegisterCallMethod("FlyingNoiseUpdate");
        METHOD_Explode = RegisterCallMethod("Explode");
        SetMass(WeaponGrenade.sm_bThrowOnPressKey ? 50F : 80F);
        SetPhysicsType(4);
        SetPhysicsActive(false);
        SetCollAction(32);
        ClearFlag(8192);
        super.fExplosionNoiseRange = 5000F;
        float fExtSize = 20F;
        Vector vMin = GetPosition();
        Vector vMax = new Vector(vMin);
        vMin.fX -= fExtSize;
        vMin.fY -= fExtSize;
        vMin.fZ -= fExtSize;
        vMax.fX += fExtSize;
        vMax.fY += fExtSize;
        vMax.fZ += fExtSize;
        SetExtents(vMin, vMax);
        SetEllipsoidNoExtents(7.5F, 15F, 0.0F);
        super.fDamgeShiftPos = 30F;
    }

    void RotateInit(float fRotateSpeed)
    {
        RotateInit(fRotateSpeed, GetTime());
    }

    void RotateInit(float fRotateSpeed, float fTime)
    {
        m_vRotate = new Vector(-fRotateSpeed, -fRotateSpeed, -fRotateSpeed);
        m_vRotate.fX += 2.0F * GameObject.RandomFloat(fRotateSpeed);
        m_vRotate.fY += 2.0F * GameObject.RandomFloat(fRotateSpeed);
        m_vRotate.fZ += 2.0F * GameObject.RandomFloat(fRotateSpeed);
        m_fRotateLastTime = fTime;
    }

    void Rotate()
    {
        if(GetSpeedValue() > 50F)
        {
            float fTime = GetTime();
            float fDeltaTime = fTime - m_fRotateLastTime;
            m_fRotateLastTime = fTime;
            RotateLocal(new Vector(1.0F, 0.0F, 0.0F), m_vRotate.fX * fDeltaTime);
            RotateLocal(new Vector(0.0F, 1.0F, 0.0F), m_vRotate.fY * fDeltaTime);
            RotateLocal(new Vector(0.0F, 0.0F, 1.0F), m_vRotate.fZ * fDeltaTime);
        }
    }

    void SpeedReductionOnHit(ControlObject cObj, Vector vPos, Vector vNorm)
    {
        float fCurrentSpeed = GetSpeedValue() * 0.4F;
        if(fCurrentSpeed < 10F)
            SetSpeedValue(0.0F);
        else
        if(GetTime() - m_fLastSpeedReductionTime >= m_fMinSpeedReductionInterval)
        {
            m_fLastSpeedReductionTime = GetTime();
            SetSpeedValue(fCurrentSpeed);
        }
    }

    public void SGSaveChunk(FileChunk cFCParent)
    {
        FileChunk.Log("[Grenade.SGSaveChunk]\n");
        FileChunk cFC = GameObject.NewChunk(1654, cFCParent);
        super.SGSaveChunk(cFC);
        cFC.SaveFloat(m_fLastSpeedReductionTime);
        cFC.delete();
    }

    public void SGLoadChunk(FileChunk cParentFC)
    {
        FileChunk.Log("[Grenade.SGLoadChunk]\n");
        FileChunk cFC = GameObject.LoadChunk(cParentFC);
        if(cFC.GetID() == 1654)
        {
            super.SGLoadChunk(cFC);
            m_fLastSpeedReductionTime = cFC.LoadFloat();
        }
        cFC.delete();
    }

    void Start(float fForce, Vector vPos, Vector vDir, float fTime)
    {
        SetStarted();
        SetMass(m_fMass);
        super.bSG = true;
        SetOwner();
        if(super.Owner != null)
            ChangeConflictSide(super.Owner.GetConflictSide());
        fThrowForce = fForce;
        if(super.m_bSetPositionWorld)
            SetPositionWorld(vPos);
        else
            SetPosition(vPos);
        SetDir(vDir);
        Vector vSpeed = new Vector(vDir);
        vSpeed.Mul(super.fStartSpeed * fThrowForce);
        SetSpeed(vSpeed);
        RotateInit(m_fRotateMaxSpeed, fTime);
        ActivateOnModule();
        SetPhysicsActive(fTime);
        DisableCallMethod(METHOD_Explode);
        CallMethodIn(METHOD_Explode, (fExplodeTime + fTime) - GetTime());
        SetCorrectPosOnRender(true);
        SetState("Flying");
    }

    void Start(float fForce, Vector vDir)
    {
        Start(fForce, vDir, GetTime());
    }

    static float _DAMAGE_DELAY = -1F;
    public float m_fMass;
    public float fExplodeTime;
    public float fReduceSpeed;
    float m_fRotateMaxSpeed;
    Vector m_vRotate;
    float m_fRotateLastTime;
    float fFlyingNoiseRange;
    float fFlyingNoiseUpdateTime;
    public float fThrowForce;
    int METHOD_FlyingNoiseUpdate;
    int METHOD_Explode;
    float m_fLastSpeedReductionTime;
    float m_fMinSpeedReductionInterval;
    static Vector l_vStart = new Vector();
    static Vector l_vEnd = new Vector();
    float fHitSoundMinDist;
    float fHitSoundMaxDist;
    static Vector l_vPos = new Vector();
    boolean m_bInWater;

}
