// Decompiled by Jad v1.5.8g. Copyright 2001 Pavel Kouznetsov.
// Jad home page: http://www.kpdus.com/jad.html
// Decompiler options: packimports(3) 
// Source File Name:   GroundVehicle.java


public class GroundVehicle extends ChromeActor
{

    public GroundVehicle()
    {
        _MAX_SPEED = 2000F;
        _MIN_SPEED = -500F;
        _ACCEL = 500F;
        _DEACCEL = 1000F;
        _ACCEL_SUPRESS = 200F;
        _MAX_TURN_SPEED = 70F;
        _TURN_ACCEL = 70F;
        _TURN_ACCEL_SUPRESS = 200F;
        _HALF_WHEEL_SIZE = 0.0F;
        _MAX_WHEEL_POS = 70F;
        _MIN_WHEEL_POS = -20F;
        _SPRING_MOVE_SPD = 500F;
        _NORMAL_ALIGN_SPEED = 60F;
        m_fCurrSpeed = 0.0F;
        m_fCurrTurnSpeed = 0.0F;
        m_vCurrSpeedDir = null;
        m_Controller = null;
        m_aHelpers = null;
        m_aWheels = null;
        m_aTurnWheels = null;
        m_aSpringsLen = null;
        m_aNewSpringsLen = null;
        m_vVehicleNormal = null;
        m_vNewVehicleNormal = null;
        m_vSuspensionDir = null;
        m_vStart = null;
        m_vEnd = null;
        m_Coll = null;
    }

    public void SetupTemp()
    {
        m_vStart = new Vector();
        m_vEnd = new Vector();
        m_Coll = new CollReturn();
        m_vSuspensionDir = new Vector();
        m_vVehicleNormal = new Vector(0.0F, 1.0F, 0.0F);
        m_vNewVehicleNormal = new Vector(0.0F, 1.0F, 0.0F);
    }

    void UpdateNormal(float fDeltaT)
    {
        float fDot = m_vVehicleNormal.Dot(m_vNewVehicleNormal);
        if(fDot > 0.99999F)
            return;
        Vector m_NormalsCross = m_vVehicleNormal.Cross(m_vNewVehicleNormal);
        m_NormalsCross.Normalize();
        float fAngleBtwNormals = (float)Math.acos(fDot);
        float fAngleToTurn = _NORMAL_ALIGN_SPEED * fDeltaT;
        if(fAngleToTurn > fAngleBtwNormals)
            fAngleToTurn = fAngleBtwNormals;
        m_vVehicleNormal = RotateVector(m_vVehicleNormal, fAngleToTurn, m_NormalsCross);
        FromUpForwardPos(m_vVehicleNormal, GetForwardVector(), GetPosition());
    }

    public void SetupHelpers()
    {
        m_aHelpers = new int[4];
        m_aHelpers[0] = GetElementID("kolobase_PP");
        m_aHelpers[1] = GetElementID("kolobase_LP");
        m_aHelpers[2] = GetElementID("kolobase_LT");
        m_aHelpers[3] = GetElementID("kolobase_PT");
    }

    public void SetupWheels()
    {
        m_aWheels = new int[4];
        m_aWheels[0] = GetElementID("kolo_PP");
        m_aWheels[1] = GetElementID("kolo_LP");
        m_aWheels[2] = GetElementID("kolo_LT");
        m_aWheels[3] = GetElementID("kolo_PT");
        if(m_aWheels[0] != -1)
            _HALF_WHEEL_SIZE = GetElementPos(m_aWheels[0]).fY - GetPosition().fY;
        m_aSpringsLen = new float[4];
        m_aNewSpringsLen = new float[4];
    }

    void UpdateNormalSpringsWheels(float fDeltaT)
    {
        CalculateNormalSprings();
        UpdateNormal(fDeltaT);
    }

    void CalculateNormalSprings()
    {
        if(m_aHelpers == null)
            return;
        m_vSuspensionDir.Set(m_vVehicleNormal);
        m_vSuspensionDir.Negate();
        m_vSuspensionDir.Mul((2.0F * _HALF_WHEEL_SIZE + _MAX_WHEEL_POS) - _MIN_WHEEL_POS);
        CollReturn collReturn = null;
        m_vNewVehicleNormal.Set(Vector.Zero);
        for(int i = 0; i < m_aHelpers.length; i++)
        {
            m_vStart.Set(m_vVehicleNormal);
            m_vStart.Mul(-_MIN_WHEEL_POS + _HALF_WHEEL_SIZE);
            m_vStart.Add(GetElementPos(m_aHelpers[i]));
            m_vEnd.Set(m_vStart);
            m_vEnd.Add(m_vSuspensionDir);
            collReturn = TestTrack(m_vStart, m_vEnd);
            if(collReturn != null)
            {
                m_vNewVehicleNormal.Add(collReturn.m_vNormal);
                if(collReturn.m_fDistance < 2.0F * _HALF_WHEEL_SIZE)
                    m_aNewSpringsLen[i] = _MIN_WHEEL_POS;
                else
                    m_aNewSpringsLen[i] = (collReturn.m_fDistance - 2.0F * _HALF_WHEEL_SIZE) + _MIN_WHEEL_POS;
            } else
            {
                m_aNewSpringsLen[i] = _MAX_WHEEL_POS;
            }
        }

        if(m_vNewVehicleNormal.Len2() > 0.01F)
            m_vNewVehicleNormal.Normalize();
        else
            m_vNewVehicleNormal.Set(Vector.Up);
    }

    void UpdateSprings(float fDeltaT)
    {
        for(int i = 0; i < m_aWheels.length; i++)
            if(m_aSpringsLen[i] < m_aNewSpringsLen[i])
            {
                m_aSpringsLen[i] += _SPRING_MOVE_SPD * fDeltaT;
                if(m_aSpringsLen[i] > m_aNewSpringsLen[i])
                    m_aSpringsLen[i] = m_aNewSpringsLen[i];
            } else
            {
                m_aSpringsLen[i] -= _SPRING_MOVE_SPD * fDeltaT;
                if(m_aSpringsLen[i] < m_aNewSpringsLen[i])
                    m_aSpringsLen[i] = m_aNewSpringsLen[i];
            }

    }

    CollReturn TestTrack(Vector vStart, Vector vEnd)
    {
        boolean bCollided = false;
        Collision coll = TraceTerrain(vStart, vEnd);
        if(coll != null)
        {
            bCollided = true;
            m_Coll.m_vNormal.Set(coll.vNormal);
            m_Coll.m_vEnd.Set(vEnd);
            m_Coll.m_fDistance = coll.fDistance;
            m_Coll.m_vNormal.Set(coll.vNormal);
        }
        coll = TraceObjectsExclude(vStart, vEnd, this);
        if(coll != null)
        {
            m_Coll.m_vNormal.Set(coll.vNormal);
            m_Coll.m_vEnd.Set(vEnd);
            m_Coll.m_fDistance = coll.fDistance;
            m_Coll.m_vNormal.Set(coll.vNormal);
        }
        if(!bCollided)
            return null;
        else
            return m_Coll;
    }

    public void OnCreate()
    {
        super.OnCreate();
        SetPhysicsType(6);
        SetCollType(1);
        SetPhysicsActive(true);
        SetSpeed(new Vector(0.0F, 0.0F, 1.0F));
        SetSpeedValue(0.0F);
        SetMaxClimbAngle(90F);
        SetEllipsoidNoExtents(100F, 300F, 150F);
        SetMass(40F);
        SetCollAction(16);
        SetupHelpers();
        SetupWheels();
        m_Controller = (VehicleController)CreateObject("VehicleController");
        m_Controller.SetVehicle(this);
        m_Controller.ActivateOnModule();
        SetupTemp();
    }

    float _MAX_SPEED;
    float _MIN_SPEED;
    float _ACCEL;
    float _DEACCEL;
    float _ACCEL_SUPRESS;
    float _MAX_TURN_SPEED;
    float _TURN_ACCEL;
    float _TURN_ACCEL_SUPRESS;
    float _HALF_WHEEL_SIZE;
    float _MAX_WHEEL_POS;
    float _MIN_WHEEL_POS;
    float _SPRING_MOVE_SPD;
    float _NORMAL_ALIGN_SPEED;
    float m_fCurrSpeed;
    float m_fCurrTurnSpeed;
    Vector m_vCurrSpeedDir;
    VehicleController m_Controller;
    int m_aHelpers[];
    int m_aWheels[];
    int m_aTurnWheels[];
    float m_aSpringsLen[];
    float m_aNewSpringsLen[];
    Vector m_vVehicleNormal;
    Vector m_vNewVehicleNormal;
    Vector m_vSuspensionDir;
    Vector m_vStart;
    Vector m_vEnd;
    CollReturn m_Coll;
}
