// Decompiled by Jad v1.5.8g. Copyright 2001 Pavel Kouznetsov.
// Jad home page: http://www.kpdus.com/jad.html
// Decompiler options: packimports(3) 
// Source File Name:   HUDMapNet.java

import java.util.Vector;

public class HUDMapNet extends HUDMap
{

    public void ComputeSpriteRotation(NetHudMapSprite cSprite, Vector vForward, Vector vRight)
    {
        double kat = 0.0D;
        float cos_alfa = vForward.Dot(super.vNBase);
        float cos_beta = vRight.Dot(super.vNBase);
        double kat_alfa = Tools.acos(cos_alfa);
        double kat_degree = (kat_alfa * 180D) / 3.1415926535897931D;
        if(cos_beta >= 0.0F)
            kat = kat_degree;
        else
            kat = 180D + (180D - kat_degree);
        cSprite.SetRotation((float)kat);
    }

    void OnUpdateGameSettings()
    {
        StartComputeObjectsPos();
    }

    void HideRemainingPlayers(int nVisiblePlayers)
    {
        m_nVisiblePlayers = nVisiblePlayers;
        for(int i = nVisiblePlayers; i < m_aPlayers.length; i++)
        {
            HudNetMapSpritePlayer cPlayer = m_aPlayers[i];
            if(cPlayer != null)
            {
                cPlayer.SetMode(-1);
                cPlayer.Hide();
            }
        }

    }

    public HUDMapNet()
    {
        m_cGameInfo = null;
        m_aPlayers = null;
        m_aVehicles = null;
        METHOD_ComputePlayersPos = 0;
        METHOD_ComputeVehiclesPos = 0;
        METHOD_ComputePlayerPos = 0;
        METHOD_TryToSetNetGameInfo = 0;
        METHOD_PlayerPosBlink = 0;
        METHOD_StartComputeObjectsPos = 0;
        m_nVisiblePlayers = 0;
    }

    void StartComputeObjectsPos()
    {
        DisableCallMethod(METHOD_ComputePlayersPos);
        DisableCallMethod(METHOD_ComputeVehiclesPos);
        CallMethodEvery(METHOD_ComputePlayersPos, 0.05F);
        if(m_aVehicles.length > 0)
            CallMethodEvery(METHOD_ComputeVehiclesPos, 0.045F);
    }

    void ComputePlayersPos()
    {
        ComputePlayerPos();
        ComputePlayersPosIndividual();
    }

    void ComputeVehiclesPos()
    {
        int nVehicleSpriteIndex = 0;
        NetGameInfo cGameInfo = (super.cModule instanceof ModuleNet) ? ((ModuleNet)super.cModule).GetGameInfo() : null;
        NetGameSettings cGameSettings = (cGameInfo instanceof NetGameInfo) ? cGameInfo.GetGameSettings() : null;
        if(cGameSettings == null || !cGameSettings.IsValid() || !cGameSettings.GetVehiclesVisibleOnHudMap())
        {
            HideRemainingVehicles(nVehicleSpriteIndex);
            if(cGameSettings != null && cGameSettings.IsValid())
            {
                DisableCallMethod(METHOD_ComputeVehiclesPos);
                CallMethodEvery(METHOD_ComputeVehiclesPos, 0.045F);
            }
            return;
        }
        Vector vVehicles = ((ModuleNet)GetModule()).GetVehicles();
        for(int i = 0; i < vVehicles.size() && nVehicleSpriteIndex < m_aVehicles.length; i++)
        {
            Vehicle cVehicle = (Vehicle)vVehicles.elementAt(i);
            if(cVehicle != null && cVehicle.DoesCanDrive())
            {
                HudNetMapSpriteVehicle cVehicleSprite = m_aVehicles[nVehicleSpriteIndex];
                cVehicleSprite.SetMode(6);
                ComputeSpritePos(cVehicleSprite, cVehicle.GetPositionVectorVolatile());
                ComputeSpriteRotation(cVehicleSprite, cVehicle.GetForwardVectorVolatile(), cVehicle.GetRightVectorVolatile());
                if(CanShowVehicle(cVehicle, cGameSettings))
                    cVehicleSprite.Show();
                else
                    cVehicleSprite.Hide();
                nVehicleSpriteIndex++;
            }
        }

        HideRemainingVehicles(nVehicleSpriteIndex);
    }

    boolean CanShowVehicle(Vehicle cVehicle, NetGameSettings cGameSettings)
    {
        return CanShowVehicleIndividual(cVehicle, cGameSettings);
    }

    void CallMethodsAfterActivate()
    {
    }

    void DisableCallMethodsAfterDeactivate()
    {
    }

    void SetCompassRef(HUDCompass cCompass)
    {
        super.SetCompassRef(cCompass);
        if(!super.m_bDisableInNetGame)
        {
            for(int i = 0; i < m_aPlayers.length; i++)
                m_aPlayers[i].m_cCompassElement = ((HUDCompassNet)super.cHUDCompasRef).AddWaypointNet(new Vector(), true, m_aPlayers[i]);

            for(int i = 0; i < m_aVehicles.length; i++)
                m_aVehicles[i].m_cCompassElement = ((HUDCompassNet)super.cHUDCompasRef).AddWaypointNet(new Vector(), true, m_aVehicles[i]);

        }
    }

    void ComputePlayersPosIndividual()
    {
        int nPlayerSpriteIndex = 0;
        NetGameInfo cGameInfo = (super.cModule instanceof ModuleNet) ? ((ModuleNet)super.cModule).GetGameInfo() : null;
        NetGameSettings cGameSettings = (cGameInfo instanceof NetGameInfo) ? cGameInfo.GetGameSettings() : null;
        if(cGameSettings == null || !cGameSettings.IsValid() || !cGameSettings.GetEnemiesVisibleOnHudMap())
        {
            HideRemainingPlayers(nPlayerSpriteIndex);
            if(cGameSettings != null && cGameSettings.IsValid())
            {
                DisableCallMethod(METHOD_ComputePlayersPos);
                CallMethodEvery(METHOD_ComputePlayerPos, 0.05F);
            }
            return;
        }
        NetPlayerInfoList cPlayersList = cGameInfo.GetPlayerInfoList();
        if(cPlayersList == null)
        {
            HideRemainingPlayers(nPlayerSpriteIndex);
            return;
        }
        for(int i = 0; i < cPlayersList.GetSize() && nPlayerSpriteIndex < m_aPlayers.length; i++)
        {
            NetPlayerInfo cPlayerInfo = cPlayersList.GetPlayerByIndex(i);
            if(cPlayerInfo != null && !((GameObject) (cPlayerInfo)).bNetIsOwner)
            {
                PlayerNet cPlayer = cPlayerInfo.GetPlayer();
                if(cPlayer != null && cPlayer.IsSpawned())
                {
                    HudNetMapSpritePlayer cPlayerSprite = m_aPlayers[nPlayerSpriteIndex];
                    cPlayerSprite.SetMode(2);
                    ComputeSpritePos(cPlayerSprite, cPlayer.GetPositionVectorVolatile());
                    ComputeSpriteRotation(cPlayerSprite, cPlayer.GetForwardVector(), cPlayer.GetRightVector());
                    if(super.m_bPlayerPosVisible)
                        cPlayerSprite.Show();
                    else
                        cPlayerSprite.Hide();
                    nPlayerSpriteIndex++;
                }
            }
        }

        HideRemainingPlayers(nPlayerSpriteIndex);
    }

    public void PlayerPosBlink()
    {
        super.PlayerPosBlink();
        for(int i = 0; i < m_nVisiblePlayers; i++)
        {
            HudNetMapSpritePlayer cPlayerSpr = m_aPlayers[i];
            if(cPlayerSpr != null)
                if(super.m_bPlayerPosVisible)
                    cPlayerSpr.Show();
                else
                    cPlayerSpr.Hide();
        }

    }

    void DrawDoUnderCursor()
    {
        super.DrawDoUnderCursor();
        for(int i = 0; i < m_aPlayers.length; i++)
        {
            HudNetMapSpritePlayer cPlayer = m_aPlayers[i];
            if(cPlayer != null)
                if(cPlayer.CanBeVisible())
                {
                    cPlayer.MoveTop();
                    cPlayer.Show();
                } else
                {
                    cPlayer.Hide();
                }
        }

    }

    void ComputeSpritePos(NetHudMapSprite cSprite, Vector vPos)
    {
        if(cSprite == null || vPos == null)
        {
            return;
        } else
        {
            int nSprSizeX = cSprite.GetCurrentSizeX();
            int nSprSizeY = cSprite.GetCurrentSizeY();
            cSprite.SetWorldPos(vPos);
            float fX = (float)super.nMapWidth - vPos.fX * super.nXcmIsPixls;
            float fZ = (float)super.nMapHeight - vPos.fZ * super.nZcmIsPixls;
            cSprite.SetRelativePos(new Vector(fX - (float)nSprSizeX / 2.0F, fZ - (float)nSprSizeY / 2.0F, 0.0F));
            return;
        }
    }

    void SetNetGameInfo(NetGameInfo cGameInfo)
    {
        m_cGameInfo = cGameInfo;
    }

    void HideRemainingVehicles(int nVisibleVehicles)
    {
        for(int i = nVisibleVehicles; i < m_aVehicles.length; i++)
        {
            HudNetMapSpriteVehicle cVehicle = m_aVehicles[i];
            if(cVehicle != null)
                cVehicle.Hide();
        }

    }

    public void OnCreate()
    {
        METHOD_ComputePlayersPos = RegisterCallMethod("ComputePlayersPos");
        METHOD_ComputeVehiclesPos = RegisterCallMethod("ComputeVehiclesPos");
        METHOD_ComputePlayerPos = RegisterCallMethod("ComputePlayerPos");
        METHOD_TryToSetNetGameInfo = RegisterCallMethod("TryToSetNetGameInfo");
        METHOD_PlayerPosBlink = RegisterCallMethod("PlayerPosBlink");
        METHOD_StartComputeObjectsPos = RegisterCallMethod("StartComputeObjectsPos");
        super.OnCreate();
        if(super.m_bDisableInNetGame)
            return;
        m_aPlayers = new HudNetMapSpritePlayer[GetPlayersCnt()];
        for(int i = 0; i < m_aPlayers.length; i++)
        {
            HudNetMapSpritePlayer cPlayer = (HudNetMapSpritePlayer)CreateObject("HudNetMapSpritePlayer");
            super.m_cMap.AddChild(cPlayer);
            m_aPlayers[i] = cPlayer;
        }

        m_aVehicles = new HudNetMapSpriteVehicle[GetVehiclesCnt()];
        for(int i = 0; i < m_aVehicles.length; i++)
        {
            HudNetMapSpriteVehicle cVehicle = (HudNetMapSpriteVehicle)CreateObject("HudNetMapSpriteVehicle");
            super.m_cMap.AddChild(cVehicle);
            m_aVehicles[i] = cVehicle;
        }

        TryToSetNetGameInfo();
        CallMethodEvery(METHOD_PlayerPosBlink, super.m_fBlinkTime);
        CallMethodIn(METHOD_StartComputeObjectsPos, 0.0F);
    }

    boolean CanShowVehicleIndividual(Vehicle cVehicle, NetGameSettings cGameSettings)
    {
        Pawn tOccupants[] = cVehicle.GetAllOccupants();
        boolean bEnemiesVisible = cGameSettings.GetEnemiesVisibleOnHudMap();
        if(tOccupants != null && tOccupants.length > 0)
        {
            for(int i = 0; i < tOccupants.length; i++)
                if(tOccupants[i] == super.cPlayer)
                    return true;

            return bEnemiesVisible;
        } else
        {
            return true;
        }
    }

    void TryToSetNetGameInfo()
    {
        NetGameInfo cGameInfo = (super.cModule instanceof ModuleNet) ? ((ModuleNet)super.cModule).GetGameInfo() : null;
        if(cGameInfo != null)
            SetNetGameInfo(cGameInfo);
        else
            CallMethodIn(METHOD_TryToSetNetGameInfo, 0.2F);
    }

    public void OnDestroy()
    {
        if(super.m_bDisableInNetGame)
            return;
        if(m_aPlayers != null)
        {
            for(int i = 0; i < m_aPlayers.length; i++)
                if(m_aPlayers[i] != null)
                {
                    RemoveSprite(m_aPlayers[i]);
                    m_aPlayers[i].delete();
                    m_aPlayers[i] = null;
                }

            m_aPlayers = null;
        }
        super.OnDestroy();
    }

    NetGameInfo m_cGameInfo;
    HudNetMapSpritePlayer m_aPlayers[];
    HudNetMapSpriteVehicle m_aVehicles[];
    int METHOD_ComputePlayersPos;
    int METHOD_ComputeVehiclesPos;
    int METHOD_ComputePlayerPos;
    int METHOD_TryToSetNetGameInfo;
    int METHOD_PlayerPosBlink;
    int METHOD_StartComputeObjectsPos;
    int m_nVisiblePlayers;
}
