// Decompiled by Jad v1.5.8g. Copyright 2001 Pavel Kouznetsov.
// Jad home page: http://www.kpdus.com/jad.html
// Decompiler options: packimports(3) 
// Source File Name:   Jeep.java


public class Jeep extends VehicleAttacker
{
    public class CrashedState extends Vehicle.CrashedState
    {

        public void DisableAllActivities()
        {
            EnableRendering(false);
            DeactivateOnModuleAlways();
            DisableCallMethods();
            StopFXSmokeUpdate();
            if(m_Wreck != null && m_bWreckVisible)
                StartFXSmokeUpdate();
            CallMethodIn("DeleteAttachedFXes", 10F);
        }

        public CrashedState()
        {
        }
    }


    boolean CanShowWreck()
    {
        if(super.m_Physics != null)
        {
            Vector vStart = GetPosition();
            Vector vEnd = new Vector(vStart);
            vEnd.fY -= _MAX_HEIGHT_TO_SHOW_WRECK;
            super.m_Physics.TestTrack(vStart, vEnd);
            vEnd.Set(super.m_Physics.m_collInfo.vEnd);
            vEnd.Sub(vStart);
            return vEnd.Len() < 0.99F * _MAX_HEIGHT_TO_SHOW_WRECK;
        } else
        {
            return true;
        }
    }

    void PassengerIsDead()
    {
    }

    void VehicleCrashed()
    {
        super.VehicleCrashed();
        if(CanShowWreck())
            ShowWreck();
        if(super.m_iStampSize > 0 && !IsUpdatingPathMap())
            UpdatePathMap(true, super.m_iStampSize, true);
    }

    Jeep()
    {
        _MAX_HEIGHT_TO_SHOW_WRECK = 50F;
        m_bLocalPlayerPassenger = false;
        super.ScreenshotIconPath = "data/textures/icons/icon_jeep.png";
        super.m_sSoundStartName = "Data/Sounds/Vehicles/JeepEngineStart";
        super.m_sSoundLoopName = "Data/Sounds/Vehicles/JeepEngineLoop";
        super.m_sSoundStopName = "Data/Sounds/Vehicles/JeepEngineStop";
        LoadSoundParams("Data/Sounds/Vehicles/Jeep.scr");
        super.m_fSoundLoopMin = 2500F;
        super.m_fSoundLoopMax = 7500F;
        super.m_sSoundAccelName = "Data/Sounds/Vehicles/VehicleAccelBrakeGravel";
        super.m_sSoundBrakeName = "Data/Sounds/Vehicles/VehicleAccelBrakeGravel";
        super.m_sSoundSlideName = "Data/Sounds/Vehicles/VehicleSlideGravel";
        super.m_fSoundVehicleStartDuration = 1.134875F;
        super.fBlobMapSize = 220F;
        super.sBlobMaterial = "blobs_jeep.mat";
        super.MeshName = "Data/Meshes/Vehicles/Jeep.3da";
        super.fHealth = super.fMaxHealth = 2000F;
        super.fDamageThreshold = 40F;
        super.fFireDamage = 100F;
        super.fRateOfFire = 600F;
        super.m_fOverCannonHeightShoot = 70F;
        super.m_fFromCannonBackShoot = 120F;
        super.m_aSpeeds = (new float[] {
            0, 210F, 630F, 1050F, 1575F, 2100F
        });
        super.m_fCannonMaxVAngle = 20F;
        super.m_iStampSize = 11;
        super.m_sWreckMeshName = "Data/Meshes/Vehicles/JeepWreck2.3da";
        super.m_vPositionModifier = new Vector(0.0F, 100F, 0.0F);
    }

    public Vector GetPointToLookAt(int nPoint)
    {
        Vector vReturn = GetPosition();
        vReturn.fY += 150F;
        return vReturn;
    }

    public void SGUpdate()
    {
        FileChunk.Log("[Jeep.SGSaveChunk]\n");
        super.SGUpdate();
        if(super.m_bWreckVisible)
            ShowWreck();
    }

    public void PawnGotOut(SeatInfo info, Pawn pawn)
    {
        super.PawnGotOut(info, pawn);
        if(info.GetRole() == 1)
            m_bLocalPlayerPassenger = false;
    }

    void DriverIsDead()
    {
    }

    void CreatePhysics()
    {
        super.m_Physics = new PhysicsJeep(this);
        super.m_Physics.Init();
        super.m_Physics.sWheelSmokeFX = "SmokeJeep";
        super.m_Physics.bWheelSmokeFX = true;
        super.m_Physics.bWheelSmokeRearOnly = false;
        super.m_Physics.fWheelSmokeShiftY = 15F;
        super.m_Physics.m_Params._TIME_BTW_SMOKES = 0.1F;
    }

    public void PawnGotIn(SeatInfo info, Pawn pawn)
    {
        super.PawnGotIn(info, pawn);
        if(info.GetRole() == 1)
        {
            Pawn cPassenger = GetFirstOccupant(1);
            m_bLocalPlayerPassenger = cPassenger != null && ((GameObject) (cPassenger)).bNetIsOwner;
        }
    }

    void OnCreate()
    {
        super.OnCreate();
        DeleteAllSeatsInfos();
        SeatInfo seat = new SeatInfo(this, "Driver", 0, EGetInOutAnimType._LEFT_SIDE);
        seat.m_fBeginPosRadius = 300F;
        AddSeatInfo(seat);
        seat = new SeatInfo(this, "Passenger", 1, EGetInOutAnimType._RIGHT_SIDE);
        seat.m_fBeginPosRadius = 300F;
        AddSeatInfo(seat);
        if(super.m_Physics != null)
        {
            super.m_Physics.m_Params._TIME_BETWEEN_SLIDE_SOUNDS = 0.15F;
            super.m_Physics.m_Params._TIME_BETWEEN_ACCEL_SOUNDS = 0.1F;
            super.m_Physics.m_Params._SLIDE_COEF = 1800F;
            super.m_Physics.m_Params._SLIDE_SUPRESS = 1000F;
            super.m_Physics.m_Params._ACCELERATION_COEF = 1800F;
            super.m_Physics.m_Params._BRAKE_COEF = 3000F;
            super.m_Physics.m_Params._TREE_HIT_SUPR = 0.2F;
            super.m_Physics.m_Params._TURNING_SPEED = 2000F;
            super.m_Physics.m_Params._MAX_TURN_ANGLE = 90F;
            super.m_Physics.m_Params._WHEEL_MOVE_SPEED_COEF = 1.0F;
            super.m_Physics.m_Params._HORIZ_DEV_ACCEL = 50F;
            super.m_Physics.sWheelSmokeFX = "SmokeJeep";
        }
        String tab[] = {
            "wahacz_LP", "wahacz_LT", "wahacz_PP", "wahacz_PT"
        };
        for(int i = 0; i < tab.length; i++)
        {
            int iElement = GetElementID(tab[i]);
            if(iElement > -1)
                SetElementAnimType(iElement, (byte)0, true);
        }

        SetFlag(256);
        SetBlobMaterial(super.sBlobMaterial);
        SetBlobMapSize(super.fBlobMapSize);
        ClearFlag(4096);
        SetTraceCollType(5);
        SetCollType(2);
        ClearFlag(4);
        SetFlag(264);
        SetFlag(0x10000);
        super.m_fAIControlledCannonVMinAngle = -45F;
        super.sBlowUpFX = "FXJeepBlow";
        SetEllipsoidNoExtents(260F, 250F, 125F);
        if(super.cCannon != null)
            super.cCannon.SetShotSoundRange(500F, 1500F);
        CreateWreck();
    }

    public void SGSaveChunk(FileChunk cFCParent)
    {
        FileChunk.Log("[Jeep.SGSaveChunk]\n");
        FileChunk cFC = GameObject.NewChunk(1150, cFCParent);
        super.SGSaveChunk(cFC);
        cFC.SaveBool(super.m_Wreck != null);
        if(super.m_Wreck != null)
            cFC.SaveObject(super.m_Wreck);
        cFC.SaveBool(super.m_bWreckVisible);
        cFC.delete();
    }

    public void SGLoadChunk(FileChunk cParentFC)
    {
        FileChunk.Log("[Jeep.SGLoadChunk]\n");
        FileChunk cFC = GameObject.LoadChunk(cParentFC);
        if(cFC.GetID() == 1150)
        {
            super.SGLoadChunk(cFC);
            if(cFC.LoadBool())
                super.m_Wreck = (VehicleWreck)cFC.LoadObject(super.m_Wreck, this);
            super.m_bWreckVisible = cFC.LoadBool();
        }
        cFC.delete();
    }

    float _MAX_HEIGHT_TO_SHOW_WRECK;
    boolean m_bLocalPlayerPassenger;
}
