// Decompiled by Jad v1.5.8g. Copyright 2001 Pavel Kouznetsov.
// Jad home page: http://www.kpdus.com/jad.html
// Decompiler options: packimports(3) 
// Source File Name:   NetGameSettings.java


public class NetGameSettings extends NetGameSettingsBase
{

    void CopyDataToContainer()
    {
        super.m_cContainer.PackString(GetLevelName());
        super.m_cContainer.PackInt(GetGameTimeLimitInMinutes());
        if(m_bScorePoints)
            super.m_cContainer.PackInt(GetPointsLimit());
        else
            super.m_cContainer.PackInt(GetFragsLimit());
        super.m_cContainer.PackInt(GetRespawnCntLimit());
        super.m_cContainer.PackFloat(GetMinRespawnTime());
        super.m_cContainer.PackBoolean(GetAvailableVehicles());
        super.m_cContainer.PackInt(GetVehicleRespawnCntLimit());
        super.m_cContainer.PackFloat(GetVehicleMinRespawnTime());
        super.m_cContainer.PackFloat(GetVehicleAutoReturnTime());
        super.m_cContainer.PackBoolean(GetEnemiesVisibleOnHudMap());
        super.m_cContainer.PackBoolean(GetVehiclesVisibleOnHudMap());
        super.m_cContainer.PackBoolean(GetAvailableInventoryRoom());
        super.m_cContainer.PackBoolean(GetIdentifyEnemyPlayers());
    }

    void SetGameTimeLimitInMinutes(int nMinutes)
    {
        m_fGameTimeLimit = (float)nMinutes * 60F;
    }

    boolean ScorePoints()
    {
        return m_bScorePoints;
    }

    void SetAvailableInventoryRoom(boolean bAvailable)
    {
        m_bAvailableInventoryRoom = bAvailable;
    }

    void SetMinRespawnTimeInSeconds(float fSeconds)
    {
        m_fMinRespawnTime = fSeconds;
    }

    float GetGameTimeLimit()
    {
        return m_fGameTimeLimit;
    }

    int GetRespawnCntLimit()
    {
        return m_nRespawnCntLimit;
    }

    int GetVehicleRespawnCntLimit()
    {
        return m_nVehicleRespawnCntLimit;
    }

    void SetVehicleMinRespawnTimeInSeconds(float fSeconds)
    {
        m_fVehicleMinRespawnTime = fSeconds;
    }

    void SetFragsLimit(int nFrags)
    {
        m_nFragsLimit = nFrags;
    }

    void SetPointsLimit(int nPoints)
    {
        m_nPointsLimit = nPoints;
    }

    void SaveSettings()
    {
        super.m_cScriptWriter.Write("GameTime(" + GetGameTimeLimitInMinutes() + ")");
        if(m_bScorePoints)
            super.m_cScriptWriter.Write("MaxPoints(" + m_nPointsLimit + ")");
        else
            super.m_cScriptWriter.Write("MaxFrags(" + GetFragsLimit() + ")");
        super.m_cScriptWriter.Write("RespawnCntLimit(" + m_nRespawnCntLimit + ")");
        super.m_cScriptWriter.Write("MinRespawnTime(" + m_fMinRespawnTime + ")");
        super.m_cScriptWriter.Write("VehicleRespawnCntLimit(" + m_nVehicleRespawnCntLimit + ")");
        super.m_cScriptWriter.Write("VehicleRespawnTime(" + m_fVehicleMinRespawnTime + ")");
        super.m_cScriptWriter.Write("VehicleAutoReturnTime(" + m_fVehicleAutoReturnTime + ")");
        super.m_cScriptWriter.Write("EnemiesVisibleOnHudMap(" + Bool2String(m_bEnemiesVisibleOnHudMap) + ")");
        super.m_cScriptWriter.Write("VehiclesVisibleOnHudMap(" + Bool2String(m_bVehiclesVisibleOnHudMap) + ")");
        super.m_cScriptWriter.Write("AvailableInventoryRoom(" + Bool2String(m_bAvailableInventoryRoom) + ")");
        super.m_cScriptWriter.Write("IdentifyEnemyPlayers(" + Bool2String(m_bIdentifyEnemyPlayers) + ")");
    }

    float GetMinRespawnTime()
    {
        return m_fMinRespawnTime;
    }

    float GetVehicleMinRespawnTime()
    {
        return m_fVehicleMinRespawnTime;
    }

    boolean GetAvailableInventoryRoom()
    {
        return m_bAvailableInventoryRoom;
    }

    void SetEnemiesVisibleOnHudMap(boolean bVisible)
    {
        m_bEnemiesVisibleOnHudMap = bVisible;
    }

    void SetVehiclesVisibleOnHudMap(boolean bVisible)
    {
        m_bVehiclesVisibleOnHudMap = bVisible;
    }

    void SetAvailableVehicles(boolean bAvailable)
    {
        m_bAvailableVehicles = bAvailable;
    }

    float GetVehicleAutoReturnTime()
    {
        return m_fVehicleAutoReturnTime;
    }

    int GetMinNumberActivePlayersInGame()
    {
        return m_nMinNumberActivePlayersInGame;
    }

    boolean ApplyModifier(ModifierNetGameSettings cModifier)
    {
        boolean bOk = true;
        switch(cModifier.GetId())
        {
        case 0: // '\0'
            SetGameTimeLimitInMinutes(cModifier.GetIntParam());
            break;

        case 2: // '\002'
            SetPointsLimit(cModifier.GetIntParam());
            break;

        case 3: // '\003'
            SetRespawnCntLimit(cModifier.GetIntParam());
            break;

        case 5: // '\005'
            SetMinRespawnTimeInSeconds(cModifier.GetFloatParam());
            break;

        case 8: // '\b'
            SetVehicleRespawnCntLimit(cModifier.GetIntParam());
            break;

        case 9: // '\t'
            SetVehicleMinRespawnTimeInSeconds(cModifier.GetFloatParam());
            break;

        case 10: // '\n'
            SetVehicleAutoReturnTime(cModifier.GetFloatParam());
            break;

        case 30: // '\036'
            SetEnemiesVisibleOnHudMap(cModifier.GetBooleanParam());
            break;

        case 32: // ' '
            SetVehiclesVisibleOnHudMap(cModifier.GetBooleanParam());
            break;

        case 35: // '#'
            SetAvailableInventoryRoom(cModifier.GetBooleanParam());
            break;

        case 7: // '\007'
            SetAvailableVehicles(cModifier.GetBooleanParam());
            break;

        case 6: // '\006'
            SetIdentifyEnemyPlayers(cModifier.GetBooleanParam());
            break;

        default:
            bOk = false;
            GameObject.LogD(" Modyfikator " + cModifier.GetId() + " nie zostal obsluzony\n");
            break;
        }
        return bOk;
    }

    void CopyDataFromContainer()
    {
        SetLevelName(super.m_cContainer.UnPackString());
        SetGameTimeLimitInMinutes(super.m_cContainer.UnPackInt());
        if(m_bScorePoints)
            SetPointsLimit(super.m_cContainer.UnPackInt());
        else
            SetFragsLimit(super.m_cContainer.UnPackInt());
        SetRespawnCntLimit(super.m_cContainer.UnPackInt());
        SetMinRespawnTimeInSeconds(super.m_cContainer.UnPackFloat());
        SetAvailableVehicles(super.m_cContainer.UnPackBoolean());
        SetVehicleRespawnCntLimit(super.m_cContainer.UnPackInt());
        SetVehicleMinRespawnTimeInSeconds(super.m_cContainer.UnPackFloat());
        SetVehicleAutoReturnTime(super.m_cContainer.UnPackFloat());
        SetEnemiesVisibleOnHudMap(super.m_cContainer.UnPackBoolean());
        SetVehiclesVisibleOnHudMap(super.m_cContainer.UnPackBoolean());
        SetAvailableInventoryRoom(super.m_cContainer.UnPackBoolean());
        SetIdentifyEnemyPlayers(super.m_cContainer.UnPackBoolean());
    }

    boolean GetAvailableVehicles()
    {
        return m_bAvailableVehicles;
    }

    void ASEQuery_OnWantRules(ModuleNetBaseQuery cLevel)
    {
        int nValue = GetGameTimeLimitInMinutes();
        String sRule = (this instanceof NetGameSettingsRound) ? "Round Time Limit" : "Time Limit";
        cLevel.ASEQuery_AddRule(sRule, nValue <= 0 ? "unlimited" : Integer.toString(nValue));
        nValue = m_bScorePoints ? GetPointsLimit() : GetFragsLimit();
        cLevel.ASEQuery_AddRule(m_bScorePoints ? "Points Limit" : "Frags Limit", nValue <= 0 ? "unlimited" : Integer.toString(nValue) + " min.");
        nValue = GetRespawnCntLimit();
        cLevel.ASEQuery_AddRule("Respawns Limit", nValue <= 0 ? "unlimited" : Integer.toString(nValue));
        nValue = (int)GetMinRespawnTime();
        cLevel.ASEQuery_AddRule("Respawn Delay", nValue <= 0 ? "no" : Integer.toString(nValue) + " sec.");
        cLevel.ASEQuery_AddRule("Enemies Visible On Map", NetGameTools.Bool2YesNo(GetEnemiesVisibleOnHudMap()));
        cLevel.ASEQuery_AddRule("Available Inventory Room", NetGameTools.Bool2YesNo(GetAvailableInventoryRoom()));
        cLevel.ASEQuery_AddRule("Identify Enemy Players", NetGameTools.Bool2YesNo(GetIdentifyEnemyPlayers()));
        cLevel.ASEQuery_AddRule("Available Vehicles", NetGameTools.Bool2YesNo(GetAvailableVehicles()));
        if(GetAvailableVehicles())
        {
            nValue = GetVehicleRespawnCntLimit();
            cLevel.ASEQuery_AddRule("Vehicle Respaws Limit", nValue <= 0 ? "unlimited" : Integer.toString(nValue));
            nValue = (int)GetVehicleMinRespawnTime();
            cLevel.ASEQuery_AddRule("Vehicle Respawn Delay", nValue <= 0 ? "no" : Integer.toString(nValue) + " sec.");
            nValue = (int)GetVehicleAutoReturnTime();
            cLevel.ASEQuery_AddRule("Vehicle Auto Return Time", nValue <= 0 ? "off" : Integer.toString(nValue) + " sec.");
            cLevel.ASEQuery_AddRule("Vehicles Visible On Map", NetGameTools.Bool2YesNo(GetVehiclesVisibleOnHudMap()));
        }
    }

    void SetRespawnCntLimit(int nCnt)
    {
        m_nRespawnCntLimit = nCnt;
    }

    void SetVehicleRespawnCntLimit(int nCnt)
    {
        m_nVehicleRespawnCntLimit = nCnt;
    }

    boolean GetIdentifyEnemyPlayers()
    {
        return m_bIdentifyEnemyPlayers;
    }

    NetGameSettings()
    {
        _TIME_LIMIT_IN_MINUTES = 20;
        _FRAGS_LIMIT = -1;
        _POINTS_LIMIT = -1;
        _RESPAWN_CNT_LIMIT = -1;
        _MIN_RESPAWN_TIME_IN_SECONDS = -1F;
        _VEHICLE_RESPAWN_CNT_LIMIT = -1;
        _VEHICLE_MIN_RESPAWN_TIME_IN_SECONDS = 30F;
        _VEHICLE_AUTO_RETURN_TIME_IN_SECONDS = 90F;
        _AVAILABLE_VEHICLES = false;
        _ENEMIES_VISIBLE_ON_HUD_MAP = false;
        _VEHICLES_VISIBLE_ON_HUD_MAP = true;
        _AVAILABLE_INVENTORY_ROOM = true;
        _IDENTIFY_ENEMY_PLAYERS = false;
        _MIN_ACTIVE_PLAYERS_IN_GAME = 2;
        m_fGameTimeLimit = -1F;
        m_nFragsLimit = -1;
        m_nPointsLimit = -1;
        m_nRespawnCntLimit = -1;
        m_fMinRespawnTime = -1F;
        m_nVehicleRespawnCntLimit = -1;
        m_fVehicleMinRespawnTime = 120F;
        m_fVehicleAutoReturnTime = -1F;
        m_bEnemiesVisibleOnHudMap = false;
        m_bVehiclesVisibleOnHudMap = true;
        m_bAvailableInventoryRoom = false;
        m_bIdentifyEnemyPlayers = false;
        m_nMinNumberActivePlayersInGame = 2;
        m_bAvailableVehicles = false;
        m_bScorePoints = true;
    }

    int GetFragsLimit()
    {
        return m_nFragsLimit;
    }

    int GetPointsLimit()
    {
        return m_nPointsLimit;
    }

    int GetGameTimeLimitInMinutes()
    {
        return (int)(m_fGameTimeLimit / 60F);
    }

    void SetVehicleAutoReturnTime(float fSeconds)
    {
        m_fVehicleAutoReturnTime = fSeconds;
    }

    void SetMinNumberActivePlayersInGame(int nMin)
    {
        m_nMinNumberActivePlayersInGame = nMin;
    }

    boolean GetEnemiesVisibleOnHudMap()
    {
        return m_bEnemiesVisibleOnHudMap;
    }

    boolean GetVehiclesVisibleOnHudMap()
    {
        return m_bVehiclesVisibleOnHudMap;
    }

    void SetIdentifyEnemyPlayers(boolean bIdentify)
    {
        m_bIdentifyEnemyPlayers = bIdentify;
    }

    void Init()
    {
        SetGameTimeLimitInMinutes(_TIME_LIMIT_IN_MINUTES);
        SetFragsLimit(_FRAGS_LIMIT);
        SetPointsLimit(_POINTS_LIMIT);
        SetMinRespawnTimeInSeconds(_MIN_RESPAWN_TIME_IN_SECONDS);
        SetRespawnCntLimit(_RESPAWN_CNT_LIMIT);
        SetVehicleRespawnCntLimit(_VEHICLE_RESPAWN_CNT_LIMIT);
        SetVehicleMinRespawnTimeInSeconds(_VEHICLE_MIN_RESPAWN_TIME_IN_SECONDS);
        SetVehicleAutoReturnTime(_VEHICLE_AUTO_RETURN_TIME_IN_SECONDS);
        SetMinNumberActivePlayersInGame(_MIN_ACTIVE_PLAYERS_IN_GAME);
        SetEnemiesVisibleOnHudMap(_ENEMIES_VISIBLE_ON_HUD_MAP);
        SetVehiclesVisibleOnHudMap(_VEHICLES_VISIBLE_ON_HUD_MAP);
        SetAvailableInventoryRoom(_AVAILABLE_INVENTORY_ROOM);
        SetAvailableVehicles(_AVAILABLE_VEHICLES);
        SetIdentifyEnemyPlayers(_IDENTIFY_ENEMY_PLAYERS);
    }

    int _TIME_LIMIT_IN_MINUTES;
    int _FRAGS_LIMIT;
    int _POINTS_LIMIT;
    int _RESPAWN_CNT_LIMIT;
    float _MIN_RESPAWN_TIME_IN_SECONDS;
    int _VEHICLE_RESPAWN_CNT_LIMIT;
    float _VEHICLE_MIN_RESPAWN_TIME_IN_SECONDS;
    float _VEHICLE_AUTO_RETURN_TIME_IN_SECONDS;
    boolean _AVAILABLE_VEHICLES;
    boolean _ENEMIES_VISIBLE_ON_HUD_MAP;
    boolean _VEHICLES_VISIBLE_ON_HUD_MAP;
    boolean _AVAILABLE_INVENTORY_ROOM;
    boolean _IDENTIFY_ENEMY_PLAYERS;
    int _MIN_ACTIVE_PLAYERS_IN_GAME;
    private float m_fGameTimeLimit;
    private int m_nFragsLimit;
    private int m_nPointsLimit;
    private int m_nRespawnCntLimit;
    private float m_fMinRespawnTime;
    private int m_nVehicleRespawnCntLimit;
    private float m_fVehicleMinRespawnTime;
    private float m_fVehicleAutoReturnTime;
    private boolean m_bEnemiesVisibleOnHudMap;
    private boolean m_bVehiclesVisibleOnHudMap;
    private boolean m_bAvailableInventoryRoom;
    private boolean m_bIdentifyEnemyPlayers;
    private int m_nMinNumberActivePlayersInGame;
    private boolean m_bAvailableVehicles;
    boolean m_bScorePoints;
}
