// Decompiled by Jad v1.5.8g. Copyright 2001 Pavel Kouznetsov.
// Jad home page: http://www.kpdus.com/jad.html
// Decompiler options: packimports(3) 
// Source File Name:   NetGameSettingsBase.java

import java.io.File;
import java.util.Vector;

public class NetGameSettingsBase extends NetObjectContainer
{

    void ApplyScriptModifiers(Vector aScriptModifiers)
    {
        if(aScriptModifiers == null)
            return;
        for(int i = 0; i < aScriptModifiers.size(); i++)
            if(aScriptModifiers.elementAt(i) instanceof ModifierNetGameSettings)
            {
                ModifierNetGameSettings cMod = (ModifierNetGameSettings)aScriptModifiers.elementAt(i);
                ApplyModifier(cMod);
            }

    }

    private boolean GameSettingNameIs(String sName)
    {
        switch(m_nParseMode)
        {
        case 1: // '\001'
            if(m_cSubKey == null)
                return false;
            else
                return m_cSubKey.Equals(sName);

        case 2: // '\002'
            String sParam = m_cCommand.GetSParam(0);
            if(!NetGameTools.IsStringValid(sParam))
                return false;
            boolean bFound = sParam.equalsIgnoreCase(sName);
            if(bFound)
                m_cCommand.FoundSettingName(sName);
            return bFound;
        }
        return false;
    }

    void SetDefaultSettings()
    {
        GameObject.LogD(" " + this + "\n");
        Init();
        ApplyScriptModifiers(m_aDefaultScriptModifiers);
    }

    void SetLevelName(String sName)
    {
        m_sLevelName = sName;
    }

    void SaveSettings(String sFileName)
    {
        m_cScriptWriter.Open(sFileName);
        m_cScriptWriter.Write("!include(\"../../LevelsNet/LevelNet.def\")");
        m_cScriptWriter.NewLine();
        m_cScriptWriter.Write("GameSettings()");
        m_cScriptWriter.Write("{");
        m_cScriptWriter.IncIndent();
        SaveSettings();
        m_cScriptWriter.DecIndent();
        m_cScriptWriter.Write("}");
        m_cScriptWriter.Close();
    }

    void SaveSettings()
    {
    }

    int GetGameType()
    {
        return m_nGameType;
    }

    private Vector ParseScriptFile(String sFileName)
    {
        Vector aScriptModifiers = new Vector();
        ParseKeyword cRoot = GameObject.ParseFile(sFileName);
        if(cRoot != null)
        {
            for(ParseKeyword cKey = cRoot; cKey != null; cKey = cKey.GetNext())
                if(cKey.Equals("GameSettings"))
                    ParseGameSettingsCommand(cKey.GetChild(), aScriptModifiers);

            cRoot.delete();
        } else
        {
            GameObject.CrashLog("No file " + sFileName + "!\n");
        }
        return aScriptModifiers;
    }

    boolean ApplyModifier(ModifierNetGameSettings cModifier)
    {
        return false;
    }

    boolean VerifyCounter(int nCounter)
    {
        return m_cCounter.Verify(nCounter);
    }

    private String GetSParam(int nParam)
    {
        switch(m_nParseMode)
        {
        case 1: // '\001'
            return m_cSubKey.GetSParam(nParam);

        case 2: // '\002'
            return m_cCommand.GetSParam(nParam + 1);
        }
        return null;
    }

    String Bool2String(boolean bVal)
    {
        if(bVal)
            return "\"yes\"";
        else
            return "\"no\"";
    }

    public NetGameSettingsBase()
    {
        m_nGameType = 0;
        m_sLevelName = "";
        m_sDefaultScriptFileName = null;
        m_sCustomScriptFileName = null;
        m_aDefaultScriptModifiers = null;
        m_aCustomScriptModifiers = null;
        m_nParseMode = 0;
        m_cSubKey = null;
        m_cCommand = null;
        m_cScriptWriter = new ScriptWriter();
        m_cCounter = new ChangeStateCounter(getClass().getName());
    }

    private void ParseGameSettingsCommand(ParseKeyword cSubKey, Vector aScriptModifiers)
    {
        m_nParseMode = 1;
        for(; cSubKey != null; cSubKey = cSubKey.GetNext())
        {
            m_cSubKey = cSubKey;
            ModifierNetGameSettings cMod = ParseGameSettingsCommand();
            if(cMod != null)
                aScriptModifiers.addElement(cMod);
        }

        m_cSubKey = null;
    }

    boolean ParseGameSettingsCommand(CommandMapSetParam cCommand)
    {
        m_nParseMode = 2;
        m_cCommand = cCommand;
        ModifierNetGameSettings cMod = ParseGameSettingsCommand();
        boolean bVerified = cCommand.VerifyModifier(cMod);
        m_cCommand = null;
        if(bVerified)
            return ApplyModifier(cMod);
        else
            return false;
    }

    private ModifierNetGameSettings ParseGameSettingsCommand()
    {
        ModifierNetGameSettings cMod = null;
        if(GameSettingNameIs("GameTime"))
            cMod = new ModifierNetGameSettings(0, GetIParam(0));
        else
        if(GameSettingNameIs("MaxPoints"))
            cMod = new ModifierNetGameSettings(2, GetIParam(0));
        else
        if(GameSettingNameIs("MaxFrags"))
            cMod = new ModifierNetGameSettings(1, GetIParam(0));
        else
        if(GameSettingNameIs("RespawnCntLimit"))
            cMod = new ModifierNetGameSettings(3, GetIParam(0));
        else
        if(GameSettingNameIs("MinRespawnTime"))
            cMod = new ModifierNetGameSettings(5, GetFParam(0));
        else
        if(GameSettingNameIs("VehicleRespawnCntLimit"))
            cMod = new ModifierNetGameSettings(8, GetIParam(0));
        else
        if(GameSettingNameIs("VehicleRespawnTime"))
            cMod = new ModifierNetGameSettings(9, GetFParam(0));
        else
        if(GameSettingNameIs("VehicleAutoReturnTime"))
            cMod = new ModifierNetGameSettings(10, GetFParam(0));
        else
        if(GameSettingNameIs("TeamBalance"))
            cMod = new ModifierNetGameSettings(20, GetSParam(0));
        else
        if(GameSettingNameIs("FriendlyFire"))
            cMod = new ModifierNetGameSettings(21, GetSParam(0));
        else
        if(GameSettingNameIs("FriendlyFireMul"))
            cMod = new ModifierNetGameSettings(22, GetFParam(0));
        else
        if(GameSettingNameIs("MinTeamsToStartGame"))
            cMod = new ModifierNetGameSettings(23, GetIParam(0));
        else
        if(GameSettingNameIs("ChangeSideOnNextRound"))
            cMod = new ModifierNetGameSettings(24, GetSParam(0));
        else
        if(GameSettingNameIs("RevengeMatch"))
            cMod = new ModifierNetGameSettings(25, GetSParam(0));
        else
        if(GameSettingNameIs("IdentifyEnemyPlayers"))
            cMod = new ModifierNetGameSettings(6, GetSParam(0));
        else
        if(GameSettingNameIs("EnemiesVisibleOnHudMap"))
            cMod = new ModifierNetGameSettings(30, GetSParam(0));
        else
        if(GameSettingNameIs("FriendsVisibleOnHudMap"))
            cMod = new ModifierNetGameSettings(31, GetSParam(0));
        else
        if(GameSettingNameIs("VehiclesVisibleOnHudMap"))
            cMod = new ModifierNetGameSettings(32, GetSParam(0));
        else
        if(GameSettingNameIs("FlagsVisibleOnHudMap"))
            cMod = new ModifierNetGameSettings(40, GetSParam(0));
        else
        if(GameSettingNameIs("FlagAutoReturnTime"))
            cMod = new ModifierNetGameSettings(41, GetFParam(0));
        else
        if(GameSettingNameIs("FlagsVisibleOnHudMap"))
            cMod = new ModifierNetGameSettings(41, GetSParam(0));
        else
        if(GameSettingNameIs("BasesVisibleOnHudMap"))
            cMod = new ModifierNetGameSettings(47, GetSParam(0));
        else
        if(GameSettingNameIs("ScoreUpdateTime"))
            cMod = new ModifierNetGameSettings(45, GetIParam(0));
        else
        if(GameSettingNameIs("AllowDominateByDeadPlayer"))
            cMod = new ModifierNetGameSettings(46, GetSParam(0));
        else
        if(GameSettingNameIs("AvailableInventoryRoom"))
            cMod = new ModifierNetGameSettings(35, GetSParam(0));
        else
        if(GameSettingNameIs("AvailableVehicles"))
            cMod = new ModifierNetGameSettings(7, GetSParam(0));
        return cMod;
    }

    void SetGameType(int nType)
    {
        m_nGameType = nType;
    }

    static void CleanGlobalCounter()
    {
        sm_cGlobalCounter.Clean();
    }

    int GetCounter()
    {
        return m_cCounter.Get();
    }

    String GetLevelName()
    {
        return m_sLevelName;
    }

    private void LoadDefaultModifiers()
    {
        if(m_sDefaultScriptFileName == null)
        {
            GameObject.LogD(" ERROR " + this + "\n");
            return;
        } else
        {
            m_aDefaultScriptModifiers = ParseScriptFile(m_sDefaultScriptFileName);
            return;
        }
    }

    void SetCustomSettings()
    {
        GameObject.LogD(" " + this + "\n");
        LoadCustomModifiers();
        Init();
        ApplyScriptModifiers(m_aDefaultScriptModifiers);
        ApplyScriptModifiers(m_aCustomScriptModifiers);
    }

    void SaveCustomSettings()
    {
        if(m_sCustomScriptFileName == null)
        {
            GameObject.LogD(" ERROR " + this + "\n");
            return;
        } else
        {
            SaveSettings(m_sCustomScriptFileName);
            return;
        }
    }

    static int GetNextGlobalCounter()
    {
        return sm_cGlobalCounter.GetNext();
    }

    private boolean LoadCustomModifiers()
    {
        if(m_sCustomScriptFileName == null)
        {
            GameObject.LogD(" ERROR " + this + "\n");
            return false;
        }
        File cFile = new File(m_sCustomScriptFileName);
        boolean bFileExists = cFile.exists();
        if(bFileExists)
            m_aCustomScriptModifiers = ParseScriptFile(m_sCustomScriptFileName);
        else
            m_aCustomScriptModifiers = ParseScriptFile(m_sDefaultScriptFileName);
        return bFileExists;
    }

    void Init(LevelContent cLevelContent)
    {
        if(cLevelContent != null)
            Init(cLevelContent.GetMapPath(), cLevelContent.GetLevelName());
    }

    void Init(String sPathName, String sLevelName)
    {
        m_sLevelName = sLevelName;
        m_sDefaultScriptFileName = sPathName + "/" + ENetGameType.GetScriptFileName(m_nGameType);
        m_sCustomScriptFileName = NetPlayerProfile.GetCurrentGameSettingsFile(sLevelName, m_nGameType);
        LoadDefaultModifiers();
        boolean bFileExists = LoadCustomModifiers();
        Init();
        ApplyScriptModifiers(m_aDefaultScriptModifiers);
        ApplyScriptModifiers(m_aCustomScriptModifiers);
        if(!bFileExists)
            SaveCustomSettings();
        SetValid(true);
    }

    void Init()
    {
    }

    private int GetIParam(int nParam)
    {
        switch(m_nParseMode)
        {
        case 1: // '\001'
            return m_cSubKey.GetIParam(nParam);

        case 2: // '\002'
            return m_cCommand.GetIParam(nParam + 1);
        }
        return 0;
    }

    private float GetFParam(int nParam)
    {
        switch(m_nParseMode)
        {
        case 1: // '\001'
            return m_cSubKey.GetFParam(nParam);

        case 2: // '\002'
            return m_cCommand.GetFParam(nParam + 1);
        }
        return 0.0F;
    }

    NetGameRule GetGameRule()
    {
        GameObject.LogD(" nie nadpisano metody!\n");
        return null;
    }

    String GetTextGameRule()
    {
        NetGameRule cGameRule = GetGameRule();
        if(cGameRule != null)
            return cGameRule.GetGameRuleString();
        else
            return "";
    }

    private int m_nGameType;
    private String m_sLevelName;
    private String m_sDefaultScriptFileName;
    private String m_sCustomScriptFileName;
    private Vector m_aDefaultScriptModifiers;
    private Vector m_aCustomScriptModifiers;
    static final int _PARSE_MODE_NONE = 0;
    static final int _PARSE_MODE_FILE = 1;
    static final int _PARSE_MODE_STRING = 2;
    int m_nParseMode;
    ParseKeyword m_cSubKey;
    CommandMapSetParam m_cCommand;
    ScriptWriter m_cScriptWriter;
    private static ChangeStateCounter sm_cGlobalCounter = new ChangeStateCounter();
    private ChangeStateCounter m_cCounter;

}
