// Decompiled by Jad v1.5.8g. Copyright 2001 Pavel Kouznetsov.
// Jad home page: http://www.kpdus.com/jad.html
// Decompiler options: packimports(3) 
// Source File Name:   NetObjectPositionController.java


public class NetObjectPositionController extends GameObject
{

    void SetSwingPeriod(float fPeriod)
    {
        m_fSwingPeriod = fPeriod;
    }

    void SetControlledObject(ControlObject cObj)
    {
        m_cControlledObj = cObj;
    }

    void SetRotateChangeDirTimeByPeriod()
    {
        SetRotateChangeDirTime(m_fRotatePeriod * 0.5F, m_fRotatePeriod * 1.5F);
    }

    NetObjectPositionController()
    {
        m_cControlledObj = null;
        m_nMovingMode = 0;
        m_fRotatePeriod = 20F;
        m_fRotateChangeDirTimeMin = 10F;
        m_fRotateChangeDirTimeMax = 30F;
        m_bRotateChangeDirTimeByPeriod = true;
        m_fSwingPeriod = 1.5F;
        m_fSwingAmplitude = 2.5F;
        METHOD_RotateChangeDir = 0;
        m_nRotateDir = 1;
        m_fLastSwing = 0.0F;
        m_fLastTime = 0.0F;
        if(m_bRotateChangeDirTimeByPeriod)
            SetRotateChangeDirTimeByPeriod();
    }

    void StartRotateAndSwing()
    {
        StartMoving(3);
    }

    void StartMoving(int nMode)
    {
        m_nMovingMode |= nMode;
        m_nMovingMode = nMode;
        m_fLastTime = GetTime();
        if((m_nMovingMode & 1) != 0)
            RotateChangeDir();
        CheckActivateOnModule();
    }

    void StopMoving()
    {
        m_nMovingMode = 0;
        DisableCallMethod(METHOD_RotateChangeDir);
        CheckActivateOnModule();
    }

    void SetRotateChangeDirTime(float fTime)
    {
        SetRotateChangeDirTime(fTime, fTime);
    }

    void SetRotatePeriod(float fPeriod)
    {
        m_fRotatePeriod = fPeriod;
        if(m_bRotateChangeDirTimeByPeriod)
            SetRotateChangeDirTimeByPeriod();
    }

    void SetRotateChangeDirTime(float fMin, float fMax)
    {
        m_fRotateChangeDirTimeMin = fMin;
        m_fRotateChangeDirTimeMax = fMax;
    }

    void StartRotateAndSwingSlow()
    {
        m_fSwingPeriod = 1.5F;
        m_fSwingAmplitude = 2.5F;
        StartRotateAndSwing();
    }

    void StartRotateAndSwingFast()
    {
        m_fSwingPeriod = 1.2F;
        m_fSwingAmplitude = 20F;
        StartRotateAndSwing();
    }

    void SetSwingAmplitude(float fAmplitude)
    {
        m_fSwingAmplitude = fAmplitude;
    }

    void RotateChangeDir()
    {
        DisableCallMethod(METHOD_RotateChangeDir);
        m_nRotateDir *= -1;
        if((m_nMovingMode & 1) != 0)
        {
            float fTime = m_fRotateChangeDirTimeMin + GameObject.RandomFloat(m_fRotateChangeDirTimeMax - m_fRotateChangeDirTimeMin);
            CallMethodIn(METHOD_RotateChangeDir, fTime);
        }
    }

    void OnCreate()
    {
        METHOD_RotateChangeDir = RegisterCallMethod("RotateChangeDir");
    }

    void Moving()
    {
        float fTime = GetTime();
        if((m_nMovingMode & 1) != 0)
        {
            Vector vDir = m_cControlledObj.GetForwardVector();
            float fDeltaTime = fTime - m_fLastTime;
            float fRotate = (360F * (float)m_nRotateDir * fDeltaTime) / m_fRotatePeriod;
            vDir = RotateVector(vDir, fRotate, Vector.Up);
            m_cControlledObj.SetDir(vDir);
        }
        if((m_nMovingMode & 2) != 0)
        {
            Vector vPos = m_cControlledObj.GetPosition();
            float fFrac = (fTime / m_fSwingPeriod) * 3.141593F;
            float fSwing = m_fSwingAmplitude * Math.abs((float)Math.sin(fFrac));
            vPos.fY += fSwing - m_fLastSwing;
            m_fLastSwing = fSwing;
            m_cControlledObj.SetPositionWorld(vPos);
        }
        m_fLastTime = fTime;
    }

    void CheckActivateOnModule()
    {
        if(m_nMovingMode != 0)
            ActivateOnModule();
        else
            DeactivateOnModuleAlways();
    }

    void OnFrame()
    {
        if(m_cControlledObj != null && m_nMovingMode != 0)
            Moving();
    }

    private ControlObject m_cControlledObj;
    private int m_nMovingMode;
    static final int _MOVING_MODE_NONE = 0;
    static final int _MOVING_MODE_ROTATE = 1;
    static final int _MOVING_MODE_SWING = 2;
    private float m_fRotatePeriod;
    private float m_fRotateChangeDirTimeMin;
    private float m_fRotateChangeDirTimeMax;
    private boolean m_bRotateChangeDirTimeByPeriod;
    static final float _SWING_PERIOD_SLOW = 1.5F;
    static final float _SWING_PERIOD_FAST = 1.2F;
    private float m_fSwingPeriod;
    static final float _SWING_AMPLITUDE_SLOW = 2.5F;
    static final float _SWING_AMPLITUDE_FAST = 20F;
    private float m_fSwingAmplitude;
    int METHOD_RotateChangeDir;
    private int m_nRotateDir;
    private float m_fLastSwing;
    private float m_fLastTime;
}
