// Decompiled by Jad v1.5.8g. Copyright 2001 Pavel Kouznetsov.
// Jad home page: http://www.kpdus.com/jad.html
// Decompiler options: packimports(3) 
// Source File Name:   NetPlayerModelInfo.java

import java.io.File;

public class NetPlayerModelInfo
{

    private boolean IsBald()
    {
        SkinPartialList cSkinList = m_aSkins[2];
        SkinPartial cSkin = cSkinList.GetCurrent();
        return cSkin != null && cSkin.IsBald();
    }

    private boolean HasIrokez()
    {
        SkinPartialList cSkinList = m_aSkins[5];
        SkinPartial cSkin = cSkinList.GetCurrent();
        return cSkin != null && cSkin.HasIrokez();
    }

    private void SetChangeAvailability()
    {
        for(int i = 0; i < m_aSkins.length; i++)
        {
            boolean bAvailable = true;
            switch(i)
            {
            case 4: // '\004'
                bAvailable = !HasHelmet();
                break;

            case 5: // '\005'
                bAvailable = !HasHelmet() && IsBald();
                break;
            }
            m_aSkins[i].SetChangeAvailable(bAvailable);
        }

    }

    static int GetSkinsPartialCnt()
    {
        return 6;
    }

    private void ChangePartialSkin(int nElement, boolean bNext)
    {
        if(nElement >= 0 && nElement < m_aSkins.length)
        {
            SkinPartialList cSkinList = m_aSkins[nElement];
            if(cSkinList != null && cSkinList.IsChangeAvailable())
            {
                int nSecure = cSkinList.GetSize() + 1;
                SkinPartial cOldSkin = cSkinList.GetCurrent();
                do
                    if(bNext)
                        cSkinList.SetNext();
                    else
                        cSkinList.SetPrevious();
                while(!VerifyChange(nElement) && nSecure-- > 0);
                if(nSecure <= 0)
                    GameObject.LogD("Change " + nElement + " " + bNext + " not verified \nOldSkin:" + cOldSkin.GetInfo() + "\n");
                RefreshCurrentSkins();
                SetChangeAvailability();
            }
        }
    }

    private boolean HasHelmet()
    {
        SkinPartialList cSkinList = m_aSkins[3];
        SkinPartial cSkin = cSkinList.GetCurrent();
        return cSkin != null && cSkin.HasHelmet();
    }

    NetPlayerModelInfo(String sMeshPathName)
    {
        m_sMeshPathName = null;
        m_aSkins = null;
        sParseDef = "!Skin(s)\r\n!Replace(s, s)\r\n!Hide(s)\r\n!NoHelmet()\r\n!Bald()\r\n!NoEyeGlass()\r\n!NoIrokez()\r\n";
        m_sMeshPathName = sMeshPathName;
        m_aSkins = new SkinPartialList[GetSkinsPartialCnt()];
        for(int i = 0; i < m_aSkins.length; i++)
            m_aSkins[i] = new SkinPartialList();

        String sSkinFile = m_sMeshPathName.substring(0, m_sMeshPathName.length() - 3) + "skn";
        ParseScriptFile(sSkinFile);
        RefreshCurrentSkins();
        SetChangeAvailability();
    }

    NetPlayerModelInfo(String sMeshPathName, int aPartialSkinsIndex[])
    {
        this(sMeshPathName);
        if(aPartialSkinsIndex != null)
        {
            for(int i = 0; i < aPartialSkinsIndex.length; i++)
                ForcePartialSkin(i, aPartialSkinsIndex[i]);

        }
    }

    NetPlayerModelInfo(NetPlayerProfile cProfile)
    {
        this(cProfile.GetMeshPathName(), cProfile.GetSkinsIndex());
    }

    void SetNextPartialSkin(int nElement)
    {
        ChangePartialSkin(nElement, true);
    }

    void SetPreviousPartialSkin(int nElement)
    {
        ChangePartialSkin(nElement, false);
    }

    private void ForcePartialSkin(int nElement, int nIndex)
    {
        if(nElement >= 0 && nElement < m_aSkins.length)
        {
            SkinPartialList cSkinList = m_aSkins[nElement];
            if(cSkinList != null)
            {
                cSkinList.SetCurrentByIndex(nIndex);
                RefreshCurrentSkins();
                SetChangeAvailability();
            }
        }
    }

    void ApplyPartialSkins(MeshObject cObject)
    {
        cObject.SetSkin("Default");
        for(int i = 0; i < m_aSkins.length; i++)
            if(m_aSkins[i].GetCurrentSkinName() != null)
                cObject.SetSkinLeavePrevious(m_aSkins[i].GetCurrentSkinName());

    }

    private boolean VerifyChange(int nElement)
    {
        boolean bVerified = true;
        switch(nElement)
        {
        case 4: // '\004'
            bVerified = HasHelmet() ? !HasEyeGlass() : true;
            break;

        case 5: // '\005'
            bVerified = HasHelmet() ? !HasIrokez() : true;
            break;

        default:
            bVerified = true;
            break;
        }
        return bVerified;
    }

    boolean[] GetChangeAvailability()
    {
        boolean aChangeAvailability[] = new boolean[m_aSkins.length];
        for(int i = 0; i < aChangeAvailability.length; i++)
            aChangeAvailability[i] = m_aSkins[i].IsChangeAvailable();

        return aChangeAvailability;
    }

    void SetPartialSkin(int nElement, int nIndex)
    {
        ChangePartialSkin(nElement, true);
    }

    private boolean HasEyeGlass()
    {
        SkinPartialList cSkinList = m_aSkins[4];
        SkinPartial cSkin = cSkinList.GetCurrent();
        return cSkin != null && cSkin.HasEyeGlass();
    }

    private void ParseScriptFile(String sFile)
    {
        File cFile = new File(sFile);
        if(!cFile.exists())
        {
            GameObject.LogD("File " + sFile + " not exist !\n");
            return;
        }
        ParseKeyword cRoot = GameObject.ParseFile(sFile);
        if(cRoot == null)
        {
            GameObject.LogD("Error while read/parse " + sFile + " file !\n");
            return;
        }
        for(ParseKeyword cKey = cRoot; cKey != null; cKey = cKey.GetNext())
            if(cKey.Equals("Skin"))
            {
                String sName = cKey.GetSParam(0);
                if(sName != null && sName.startsWith("@"))
                    NewSkinPartial(sName, cKey.GetChild());
            }

        cRoot.delete();
    }

    String GetMeshPathName()
    {
        return m_sMeshPathName;
    }

    boolean[] GetCurrentActivity()
    {
        boolean aActivity[] = new boolean[m_aSkins.length];
        for(int i = 0; i < aActivity.length; i++)
        {
            boolean bActive = true;
            switch(i)
            {
            case 3: // '\003'
                bActive = HasHelmet();
                break;

            case 4: // '\004'
                bActive = HasEyeGlass();
                break;

            case 5: // '\005'
                bActive = HasIrokez();
                break;

            default:
                bActive = true;
                break;
            }
            aActivity[i] = bActive;
        }

        return aActivity;
    }

    int[] GetCurrentPartialSkins()
    {
        int aSkins[] = new int[m_aSkins.length];
        for(int i = 0; i < m_aSkins.length; i++)
            aSkins[i] = m_aSkins[i].GetCurrentIndex();

        return aSkins;
    }

    void RefreshCurrentSkins()
    {
        for(int i = 0; i < m_aSkins.length; i++)
            switch(i)
            {
            default:
                break;

            case 4: // '\004'
                if(HasHelmet())
                    m_aSkins[i].SetCurrentByFlag((byte)4);
                break;

            case 5: // '\005'
                if(HasHelmet() || !IsBald())
                    m_aSkins[i].SetCurrentByFlag((byte)8);
                break;
            }

    }

    private void NewSkinPartial(String sName, ParseKeyword cKey)
    {
        int nElement = SkinPartial.GetElementIdBySkinName(sName);
        SkinPartial cSkin = new SkinPartial(sName);
        if(nElement >= 0 && nElement < m_aSkins.length)
            m_aSkins[nElement].Add(cSkin);
        else
            return;
        for(; cKey != null; cKey = cKey.GetNext())
        {
            if(nElement == 3 && cKey.Equals("NoHelmet"))
                cSkin.SetNoHelmet();
            if(nElement == 2 && cKey.Equals("Bald"))
                cSkin.SetBald();
            if(nElement == 4 && cKey.Equals("NoEyeGlass"))
                cSkin.SetNoEyeGlass();
            if(nElement == 5 && cKey.Equals("NoIrokez"))
                cSkin.SetNoIrokez();
        }

        GameObject.LogD("Dodano " + cSkin.GetInfo() + "\n");
    }

    private String m_sMeshPathName;
    SkinPartialList m_aSkins[];
    String sParseDef;
}
