// Decompiled by Jad v1.5.8g. Copyright 2001 Pavel Kouznetsov.
// Jad home page: http://www.kpdus.com/jad.html
// Decompiler options: packimports(3) 
// Source File Name:   NetPlayerProfile.java

import java.io.*;
import java.util.Vector;

public class NetPlayerProfile
{

    void SetMeshName(String sName)
    {
        m_sMeshName = sName;
    }

    static String GetCurrentFavoritesServersFileName()
    {
        NetPlayerProfile cProfile = GetCurrent();
        return GetFavoritesServersFileName(cProfile.GetProfileName());
    }

    static String GetCurrentServersFileName()
    {
        NetPlayerProfile cProfile = GetCurrent();
        return GetServersFileName(cProfile.GetProfileName());
    }

    String GetProfileName()
    {
        return m_sProfileName;
    }

    static String GetFavoritesMapsFileName(String sProfileName)
    {
        return "Data/Profiles/" + sProfileName + "/" + "FavoritesMaps.scr";
    }

    static boolean DeleteProfile(String sProfileName)
    {
        if(!FindProfile(sProfileName) || IsCurrentDefaultProfile())
            return false;
        if(IsCurrentDefaultProfile())
        {
            return false;
        } else
        {
            String sDir = "Data/Profiles/" + sProfileName;
            return NetGameTools.DeleteDir(sDir, 10);
        }
    }

    static StringsList FindProfiles()
    {
        StringsList aList = new StringsList();
        File cProfileDir = new File("Data/Profiles/");
        if(!cProfileDir.exists())
        {
            cProfileDir.mkdir();
            NetLog.Warning(" Directory " + "Data/Profiles/" + " not found and will be created.");
            return aList;
        }
        String aFileNames[] = cProfileDir.list();
        for(int i = 0; i < aFileNames.length; i++)
        {
            String sProfileName = aFileNames[i];
            if(FindProfile(sProfileName))
                aList.Add(sProfileName);
        }

        return aList;
    }

    static Vector FindNetModels()
    {
        Vector aList = new Vector();
        ParseKeyword cRoot = GameObject.ParseFile("Data/ModelsNet.scr");
        if(cRoot != null)
        {
            for(ParseKeyword cKey = cRoot; cKey != null; cKey = cKey.GetNext())
                if(cKey.Equals("Mesh"))
                {
                    String sFileName = cKey.GetSParam(0);
                    GameObject.Log(" " + sFileName + " ");
                    File cFile = new File("Data/Meshes/Ai/" + sFileName);
                    if(cFile.exists() && sFileName.length() >= ".3da".length())
                    {
                        String sExt = sFileName.substring(sFileName.length() - ".3da".length());
                        if(sExt.equalsIgnoreCase(".3da"))
                        {
                            int nDot = sFileName.lastIndexOf(".");
                            String sSkinFile = sFileName.substring(0, nDot) + ".skn";
                            cFile = new File("Data/Meshes/Ai/" + sSkinFile);
                            if(cFile.exists())
                            {
                                aList.addElement(sFileName);
                                GameObject.Log("Add mesh " + "Data/Meshes/Ai/" + "" + sFileName + " \n");
                            }
                        }
                    }
                }

            cRoot.delete();
        } else
        {
            GameObject.LogD("Read or parse error in file " + "Data/ModelsNet.scr" + " !\n");
        }
        return aList;
    }

    void Load()
    {
        Load(FindCurrentProfileName());
    }

    void Load(String sProfileName)
    {
        String sFile = "Data/Profiles/" + sProfileName + "/" + "Profile.scr";
        ParseKeyword cRoot = GameObject.ParseFile(sFile);
        if(cRoot != null)
        {
            for(ParseKeyword cKey = cRoot; cKey != null; cKey = cKey.GetNext())
            {
                if(cKey.Equals("Nick"))
                    m_sPlayerName = cKey.GetSParam(0);
                if(cKey.Equals("Model"))
                    m_sMeshName = cKey.GetSParam(0);
                if(cKey.Equals("Skin"))
                {
                    int nElement = cKey.GetIParam(0);
                    int nIndex = cKey.GetIParam(1);
                    if(nElement >= 0 && nElement < m_aSkins.length)
                        m_aSkins[nElement] = nIndex;
                }
            }

            cRoot.delete();
            SetProfileName(sProfileName);
        } else
        {
            GameObject.LogR("Read or parse error in file " + sFile + " !\n");
        }
    }

    String GetPlayerName()
    {
        return m_sPlayerName;
    }

    String GetMeshName()
    {
        return m_sMeshName;
    }

    static String GetCurrentControlsFileName()
    {
        NetPlayerProfile cProfile = GetCurrent();
        return GetControlsFileName(cProfile.GetProfileName());
    }

    static String GetCurrentFiltersFileName()
    {
        NetPlayerProfile cProfile = GetCurrent();
        return GetFiltersFileName(cProfile.GetProfileName());
    }

    static String GetFavoritesServersFileName(String sProfileName)
    {
        return "Data/Profiles/" + sProfileName + "/" + "FavoritesServers.scr";
    }

    static String GetServersFileName(String sProfileName)
    {
        return "Data/Profiles/" + sProfileName + "/" + "Servers.scr";
    }

    static String FindCurrentProfileName()
    {
        String sProfileName = null;
        File cFile = new File("Data/Profiles/" + "CurrentProfile.scr");
        if(cFile.exists())
        {
            String sReadProfileName = null;
            try
            {
                BufferedReader cBuff = new BufferedReader(new FileReader("Data/Profiles/" + "CurrentProfile.scr"));
                sReadProfileName = cBuff.readLine();
                cBuff.close();
            }
            catch(IOException e)
            {
                GameObject.LogD("ERROR " + e.getMessage());
            }
            if(FindProfile(sReadProfileName))
                sProfileName = sReadProfileName;
        }
        if(sProfileName == null)
            sProfileName = "DefaultProfile";
        return sProfileName;
    }

    static void LoadCurrentControlsAndApply()
    {
        String sName = GetCurrentControlsFileName();
        File cFile = new File(sName);
        if(!cFile.exists())
        {
            cFile = new File(ControlLoadSave.sm_sUserControlsFile);
            if(cFile.exists())
                ControlLoadSave.LoadKeySettings(ControlLoadSave.sm_sUserControlsFile);
            else
                ControlLoadSave.LoadDefaultKeySettings();
            ControlLoadSave.SaveControls(sName);
        }
        ControlLoadSave.LoadSettingsAndApply(sName);
    }

    static String GetServerSettingsFile(String sProfileName)
    {
        return "Data/Profiles/" + sProfileName + "/" + "ServerSettings.scr";
    }

    static String GetCurrentGameSettingsFile(String sLevelName, int nGameType)
    {
        NetPlayerProfile cProfile = GetCurrent();
        return GetGameSettingsFile(cProfile.GetProfileName(), sLevelName, nGameType);
    }

    void SetProfileName(String sName)
    {
        m_sProfileName = sName;
    }

    String GetMeshPathName()
    {
        return "Data/Meshes/Ai/" + m_sMeshName;
    }

    static String GetCurrentProfileName()
    {
        NetPlayerProfile cProfile = GetCurrent();
        return cProfile.GetProfileName();
    }

    static String GetCurrentNickName()
    {
        NetPlayerProfile cProfile = GetCurrent();
        return cProfile.GetPlayerName();
    }

    static String GetCurrentFavoritesMapsFileName()
    {
        NetPlayerProfile cProfile = GetCurrent();
        return GetFavoritesMapsFileName(cProfile.GetProfileName());
    }

    static boolean IsDefaultProfileName(String sProfileName)
    {
        return sProfileName != null && sProfileName.equals("DefaultProfile");
    }

    static boolean TryToSetCurrentProfileName(String sName)
    {
        boolean bFound = FindProfile(sName);
        if(bFound)
            SetCurrentProfileName(sName);
        return bFound;
    }

    void Save()
    {
        File cDir = new File("Data/Profiles/");
        if(!cDir.exists())
            cDir.mkdir();
        String sProfileDir = "Data/Profiles/" + m_sProfileName;
        cDir = new File(sProfileDir);
        if(!cDir.exists())
            cDir.mkdir();
        GameObject.LogD("Save profile file for Player: " + m_sPlayerName + "\n");
        m_cScriptWriter.Open(sProfileDir + "/" + "Profile.scr");
        m_cScriptWriter.Write("!Nick(s)");
        m_cScriptWriter.Write("!Model(s)");
        m_cScriptWriter.Write("!Skin(i,i)");
        m_cScriptWriter.NewLine();
        m_cScriptWriter.Write("Nick(\"" + m_sPlayerName + "\")");
        m_cScriptWriter.Write("Model(\"" + m_sMeshName + "\")");
        for(int i = 0; i < m_aSkins.length; i++)
            m_cScriptWriter.Write("Skin(" + i + "," + m_aSkins[i] + ")");

        m_cScriptWriter.Close();
        m_cScriptWriter.Open("Data/Profiles/" + "CurrentProfile.scr");
        m_cScriptWriter.Write(m_sProfileName);
        m_cScriptWriter.Close();
    }

    static String GetGameSettingsFile(String sProfileName, String sLevelName, int nGameType)
    {
        return "Data/Profiles/" + sProfileName + "/" + "GameSettings" + "_" + sLevelName + "_" + ENetGameType.GetCustomScriptFileName(nGameType);
    }

    static boolean DeleteCurrentProfile()
    {
        NetPlayerProfile cProfile = GetCurrent();
        return DeleteProfile(cProfile.GetProfileName());
    }

    boolean IsAutoPlayer()
    {
        return m_bAutoPlayer;
    }

    void SetAutoPlayer(boolean bVal)
    {
        m_bAutoPlayer = bVal;
    }

    void SetModel(NetPlayerModelInfo cModelInfo)
    {
        if(cModelInfo == null)
        {
            return;
        } else
        {
            String sMeshName = cModelInfo.GetMeshPathName();
            int nSlashIndex = sMeshName.lastIndexOf('/');
            m_sMeshName = sMeshName.substring(nSlashIndex + 1);
            m_aSkins = cModelInfo.GetCurrentPartialSkins();
            return;
        }
    }

    void New(String sProfileName)
    {
        Load("DefaultProfile");
        SetProfileName(sProfileName);
    }

    NetPlayerProfile()
    {
        m_sProfileName = "";
        m_sPlayerName = "";
        m_sMeshName = "";
        m_aSkins = new int[NetPlayerModelInfo.GetSkinsPartialCnt()];
        m_bBot = false;
        m_bAutoPlayer = false;
        m_cScriptWriter = new ScriptWriter();
    }

    NetPlayerProfile(String sProfileName)
    {
        m_sProfileName = "";
        m_sPlayerName = "";
        m_sMeshName = "";
        m_aSkins = new int[NetPlayerModelInfo.GetSkinsPartialCnt()];
        m_bBot = false;
        m_bAutoPlayer = false;
        m_cScriptWriter = new ScriptWriter();
        New(sProfileName);
    }

    static NetPlayerProfile GetCurrent()
    {
        NetPlayerProfile cProfile = new NetPlayerProfile();
        cProfile.Load();
        return cProfile;
    }

    static String GetCurrentServerSettingsFile()
    {
        NetPlayerProfile cProfile = GetCurrent();
        return GetServerSettingsFile(cProfile.GetProfileName());
    }

    static boolean IsCurrentDefaultProfile()
    {
        NetPlayerProfile cProfile = GetCurrent();
        return IsDefaultProfileName(cProfile.GetProfileName());
    }

    static boolean FindProfile(String sProfileName)
    {
        boolean bFound = false;
        String sProfile = "Data/Profiles/" + sProfileName + "/" + "Profile.scr";
        ParseKeyword cRoot = GameObject.ParseFile(sProfile);
        if(cRoot == null)
        {
            GameObject.LogD(" Read or parse error in file " + sProfile + " !\n");
        } else
        {
            for(ParseKeyword cKey = cRoot; cKey != null; cKey = cKey.GetNext())
            {
                if(!cKey.Equals("Nick"))
                    continue;
                bFound = true;
                break;
            }

            cRoot.delete();
        }
        return bFound;
    }

    boolean IsBot()
    {
        return m_bBot;
    }

    void SetBot(boolean bVal)
    {
        m_bBot = bVal;
    }

    private static void SetCurrentProfileName(String sName)
    {
        NetPlayerProfile cProfile = new NetPlayerProfile();
        cProfile.Load(sName);
        cProfile.m_cScriptWriter.Open("Data/Profiles/" + "CurrentProfile.scr");
        cProfile.m_cScriptWriter.Write(sName);
        cProfile.m_cScriptWriter.Close();
    }

    static String GetControlsFileName(String sProfileName)
    {
        return "Data/Profiles/" + sProfileName + "/" + "UserControls.scr";
    }

    static String GetFiltersFileName(String sProfileName)
    {
        return "Data/Profiles/" + sProfileName + "/" + "UserFilters.scr";
    }

    static int VerifyProfileName(String sProfileName)
    {
        if(FindProfile(sProfileName))
            return 1;
        File cDir = new File("Data/Profiles/");
        if(!cDir.exists())
            return 3;
        String sProfileDir = "Data/Profiles/" + sProfileName;
        cDir = new File(sProfileDir);
        if(!cDir.exists())
            cDir.mkdir();
        if(!cDir.isDirectory() || !cDir.exists())
        {
            return 2;
        } else
        {
            cDir.delete();
            return 0;
        }
    }

    int[] GetSkinsIndex()
    {
        return m_aSkins;
    }

    void SetSkins(int aSkins[])
    {
        m_aSkins = aSkins;
    }

    static void ForceProfileWithNick(String sNick)
    {
        if(!NetGameTools.IsStringValid(sNick))
            sNick = "PlayerName";
        StringsList aProfiles = FindProfiles();
        NetPlayerProfile cProfile = new NetPlayerProfile();
        for(int i = 0; i < aProfiles.GetSize(); i++)
        {
            cProfile.Load(aProfiles.GetStringAt(i));
            if(sNick.equalsIgnoreCase(cProfile.GetPlayerName()))
            {
                cProfile.Save();
                return;
            }
        }

        cProfile.Load("DefaultProfile");
        cProfile.SetPlayerName(sNick);
        cProfile.Save();
    }

    void SetPlayerName(String sName)
    {
        m_sPlayerName = sName;
    }

    private static final String sm_sProfileDir = "Data/Profiles/";
    private static final String sm_sCurrentProfileFile = "CurrentProfile.scr";
    private static final String sm_sDefaultProfile = "DefaultProfile";
    private static final String sm_sProfileFile = "Profile.scr";
    private static final String sm_sControlsFile = "UserControls.scr";
    private static final String sm_sFiltersFile = "UserFilters.scr";
    private static final String sm_sServersFile = "Servers.scr";
    private static final String sm_sFavoritesServersFile = "FavoritesServers.scr";
    private static final String sm_sFavoritesMapsFile = "FavoritesMaps.scr";
    private static final String sm_sServerSettingsFile = "ServerSettings.scr";
    private static final String sm_sGameSettingsPrefixFile = "GameSettings";
    static final String sm_sModelsScript = "Data/ModelsNet.scr";
    static final String sm_sModelDir = "Data/Meshes/Ai/";
    static final String sm_sPostfixMeshFile = ".3da";
    static final String sm_sPostfixSkinFile = ".skn";
    static final String sm_sDefaultNick = "PlayerName";
    private String m_sProfileName;
    private String m_sPlayerName;
    private String m_sMeshName;
    private int m_aSkins[];
    private boolean m_bBot;
    private boolean m_bAutoPlayer;
    ScriptWriter m_cScriptWriter;
    static final int _MAX_LEVEL_DIRECTORY = 10;
    static final int _NEW_PROFILE_NAME_OK = 0;
    static final int _NEW_PROFILE_NAME_EXIST = 1;
    static final int _NEW_PROFILE_NAME_WRONG = 2;
    static final int _NO_PROFILE_DIR = 3;
    String aT[] = {
        "*", "?"
    };
}
