// Decompiled by Jad v1.5.8g. Copyright 2001 Pavel Kouznetsov.
// Jad home page: http://www.kpdus.com/jad.html
// Decompiler options: packimports(3) 
// Source File Name:   NetServerInfoList.java

import java.io.File;

public class NetServerInfoList extends ObjectsList
{

    boolean IsValid()
    {
        return m_bServersValid;
    }

    public NetServerInfoList()
    {
        m_bServersValid = false;
        m_iRefreshTime = 0L;
        m_cScriptWriter = new ScriptWriter();
    }

    void Add(NetServerInfo cServerInfo)
    {
        if(IsOnList(cServerInfo.sServerAddr, cServerInfo.GetGamePort()) || !cServerInfo.IsCorrect())
        {
            return;
        } else
        {
            super.Add(cServerInfo);
            return;
        }
    }

    void Load()
    {
        Clear();
        String sFile = GetFileName();
        File cFile = new File(sFile);
        if(cFile.exists())
        {
            ParseKeyword cRoot = GameObject.ParseFile(sFile);
            if(cRoot != null)
            {
                for(ParseKeyword cKey = cRoot; cKey != null; cKey = cKey.GetNext())
                {
                    if(cKey.Equals("RefreshTime"))
                    {
                        String sRefreshTime = cKey.GetSParam(0);
                        m_iRefreshTime = Long.parseLong(sRefreshTime);
                        CheckServersValid();
                    }
                    if(cKey.Equals("NetServerInfo"))
                    {
                        NetServerInfo cServerInfo = m_bServersValid ? new NetServerInfo(cKey.GetSParam(0), cKey.GetSParam(2), cKey.GetIParam(1), cKey.GetSParam(3), cKey.GetIParam(4), cKey.GetIParam(5), cKey.GetIParam(6), cKey.GetIParam(7), cKey.GetIParam(8), cKey.GetIParam(9) != 0, 0, cKey.GetIParam(10), true) : new NetServerInfo(cKey.GetSParam(0), cKey.GetSParam(2), cKey.GetIParam(1));
                        cServerInfo.bInternetServer = true;
                        Add(cServerInfo);
                    }
                }

                cRoot.delete();
            } else
            {
                NetLog.Test("Error while read/parse " + sFile + " file !\n");
            }
        } else
        {
            Save();
        }
    }

    private static String GetFileName()
    {
        return NetPlayerProfile.GetCurrentServersFileName();
    }

    private boolean IsOnList(String sIP, int nGamePort)
    {
        for(int i = 0; i < GetSize(); i++)
        {
            NetServerInfo cServerInfo = (NetServerInfo)GetObjectAt(i);
            if(cServerInfo.AddressEquals(sIP, nGamePort))
                return true;
        }

        return false;
    }

    void SetRefreshTimeNow()
    {
        m_iRefreshTime = System.currentTimeMillis();
    }

    void Clear()
    {
        super.Clear();
        SetRefreshTimeNow();
    }

    void CheckServersValid()
    {
        long nTimeDelta = System.currentTimeMillis() - m_iRefreshTime;
        int nHours = 0;
        int nMinutes = 0;
        int nSeconds = 15;
        int nMinTime = 60 * (60 * (1000 * nSeconds) + nMinutes) + nHours;
        m_bServersValid = nTimeDelta < (long)nMinTime;
    }

    void Save()
    {
        m_cScriptWriter.Open(GetFileName());
        m_cScriptWriter.Write("!RefreshTime(s)");
        m_cScriptWriter.Write("!NetServerInfo(s,i,s,s,i,i,i,i,i,i,i)");
        m_cScriptWriter.NewLine();
        String sRefreshTime = Long.toString(m_iRefreshTime);
        m_cScriptWriter.Write("RefreshTime(\"" + sRefreshTime + "\")");
        for(int i = 0; i < GetSize(); i++)
        {
            NetServerInfo cServer = (NetServerInfo)GetObjectAt(i);
            String sServer = "NetServerInfo(\"" + cServer.sServerAddr + "\"," + cServer.GetGamePort() + "," + "\"" + cServer.sServerName + "\"," + "\"" + cServer.sCurrentLevelName + "\"," + cServer.nNumberPlayerInGame + "," + cServer.nMaxPlayersInGame + "," + cServer.nGameType + "," + cServer.nPing + "," + cServer.nGameVersion + "," + (cServer.bPassword ? 1 : 0) + "," + cServer.nMapCRC + ")";
            m_cScriptWriter.Write(sServer);
        }

        m_cScriptWriter.NewLine();
        m_cScriptWriter.Close();
    }

    private boolean m_bServersValid;
    private long m_iRefreshTime;
    ScriptWriter m_cScriptWriter;
}
