// Decompiled by Jad v1.5.8g. Copyright 2001 Pavel Kouznetsov.
// Jad home page: http://www.kpdus.com/jad.html
// Decompiler options: packimports(3) 
// Source File Name:   NetServerInitInfo.java

import java.io.File;

public class NetServerInitInfo extends NetServerInitInfoBase
{

    void SetServerAddr(String sAddr)
    {
        m_sServerAddr = sAddr;
    }

    NetServerInitInfo()
    {
        m_sScriptFileName = null;
        m_sServerAddr = "localhost";
        m_nGamePort = 27015;
        m_sPassword = null;
        m_bInternetGame = false;
        m_cScriptWriter = new ScriptWriter();
        InitScriptFileName();
    }

    NetServerInitInfo(NetServerInitInfo cInfo)
    {
        super(cInfo);
        m_sScriptFileName = null;
        m_sServerAddr = "localhost";
        m_nGamePort = 27015;
        m_sPassword = null;
        m_bInternetGame = false;
        m_cScriptWriter = new ScriptWriter();
        InitScriptFileName();
    }

    void SaveSettings()
    {
        m_cScriptWriter.Open(m_sScriptFileName);
        m_cScriptWriter.Write("!ServerName(s)");
        m_cScriptWriter.Write("!MaxPlayer(i)");
        m_cScriptWriter.Write("!LoopLevels()");
        m_cScriptWriter.Write("!Dedicated()");
        m_cScriptWriter.Write("!Password(s)");
        m_cScriptWriter.Write("!InternetGame()");
        m_cScriptWriter.Write("!GamePort(i)");
        m_cScriptWriter.NewLine();
        m_cScriptWriter.Write("ServerName(\"" + GetServerName() + "\")");
        m_cScriptWriter.Write("MaxPlayer(" + String.valueOf(GetMaxPlayers()) + ")");
        if(GetLoopLevels())
            m_cScriptWriter.Write("LoopLevels()");
        if(GetDedicated())
            m_cScriptWriter.Write("Dedicated()");
        if(IsPassword())
            m_cScriptWriter.Write("Password(\"" + GetPassword() + "\")");
        if(IsInternetGame())
        {
            m_cScriptWriter.Write("InternetGame()");
            m_cScriptWriter.Write("GamePort(" + GetGamePort() + ")");
        }
        m_cScriptWriter.Close();
    }

    void SetGamePort(int nPort)
    {
        m_nGamePort = nPort;
    }

    void InitScriptFileName()
    {
        m_sScriptFileName = NetPlayerProfile.GetCurrentServerSettingsFile();
    }

    void SetInternetGame(boolean bVal)
    {
        m_bInternetGame = bVal;
    }

    boolean IsInternetGame()
    {
        return m_bInternetGame;
    }

    String GetServerAddr()
    {
        return m_sServerAddr;
    }

    int GetGamePort()
    {
        return m_nGamePort;
    }

    void SetPassword(String sPassword)
    {
        m_sPassword = sPassword;
        SetPassword(m_sPassword != null);
    }

    boolean IsPassword()
    {
        return m_sPassword != null;
    }

    void ParseDefaultScriptFile()
    {
        ParseScriptFile("Data/ServerSettingsDefault.scr");
    }

    void ParseScriptFile()
    {
        if(!ParseScriptFile(m_sScriptFileName))
        {
            ParseScriptFile("Data/ServerSettingsDefault.scr");
            SaveSettings();
        }
    }

    boolean ParseScriptFile(String sFile)
    {
        boolean bReturn = true;
        File cFile = new File(sFile);
        if(!cFile.exists())
        {
            GameObject.LogD("File " + sFile + " not exist !\n");
            bReturn = false;
        } else
        {
            m_nGamePort = 27015;
            int nReadGamePort = m_nGamePort;
            ParseKeyword cRoot = GameObject.ParseFile(sFile);
            if(cRoot != null)
            {
                for(ParseKeyword cKey = cRoot; cKey != null; cKey = cKey.GetNext())
                {
                    if(cKey.Equals("ServerName"))
                        SetServerName(new String(cKey.GetSParam(0)));
                    if(cKey.Equals("MaxPlayer"))
                        SetMaxPlayers(cKey.GetIParam(0));
                    if(cKey.Equals("LoopLevels"))
                        SetLoopLevels(true);
                    if(cKey.Equals("Dedicated"))
                        SetDedicated(true);
                    if(cKey.Equals("Password"))
                        SetPassword(new String(cKey.GetSParam(0)));
                    if(cKey.Equals("InternetGame"))
                        SetInternetGame(true);
                    if(cKey.Equals("GamePort"))
                        nReadGamePort = cKey.GetIParam(0);
                }

                if(IsInternetGame())
                    SetGamePort(nReadGamePort);
                if(Game.cSingleton != null && GameObject.IsDedicatedServer())
                    SetDedicated(true);
                cRoot.delete();
            } else
            {
                GameObject.LogD("Error while read/parse " + sFile + " file !\n");
                bReturn = false;
            }
        }
        return bReturn;
    }

    static boolean VerifyPorts(int nGamePort)
    {
        return nGamePort >= 2000 && nGamePort <= 65000;
    }

    String GetPassword()
    {
        return m_sPassword;
    }

    static final String sm_sDefaultScriptFileName = "Data/ServerSettingsDefault.scr";
    static final int sm_nDefaultGamePort = 27015;
    static final int sm_nGamePortMin = 2000;
    static final int sm_nGamePortMax = 65000;
    static final int sm_nRemoteAccessShift = 8;
    private String m_sScriptFileName;
    private String m_sServerAddr;
    private int m_nGamePort;
    private String m_sPassword;
    private boolean m_bInternetGame;
    ScriptWriter m_cScriptWriter;
}
