// Decompiled by Jad v1.5.8g. Copyright 2001 Pavel Kouznetsov.
// Jad home page: http://www.kpdus.com/jad.html
// Decompiler options: packimports(3) 
// Source File Name:   PhysicsVehicle.java


public class PhysicsVehicle
    implements ISaveGame
{

    void TakeWaterDamage(float fTime)
    {
        if(m_bPhysicsCalcOnly)
            return;
        float fDamageCoeff = m_Params._DAMAGE_COEFF_WATER_COLLISION * fTime;
        float fDamage = ((Actor) (m_Vehicle)).fMaxHealth * fDamageCoeff;
        m_Vehicle.TakeDamage(fDamage, EnumDamageType._BULLET);
        if(m_Vehicle.m_bModuleNet)
        {
            float fOccupantsDamageMul = m_Vehicle.m_fSingleOccupantsDamageMul - m_Vehicle.m_fNetOccupantsDamageMul;
            if(fOccupantsDamageMul > 0.0F)
                m_Vehicle.OccupantsDamage(fDamage * fOccupantsDamageMul, null);
        }
    }

    void UpdateSounds()
    {
        if(m_bPhysicsCalcOnly)
        {
            return;
        } else
        {
            m_Vehicle.UpdateSounds();
            return;
        }
    }

    void NetSimulate(float fDeltaTime, boolean bServer)
    {
        m_bNetSimulate = true;
        m_fFrameTime = fDeltaTime;
        m_fNowTime += m_fFrameTime;
        boolean bSlide = (m_fCurrDirAngle > m_fMinDirAngleSlide || m_fCurrDirAngle < -m_fMinDirAngleSlide) && (m_fCurrSpeed < m_Params._MIN_SPEED / 2.0F || m_fCurrSpeed > m_Params.GetMaxSpeed() / 2.0F);
        boolean bAccel = false;
        boolean bBrake = false;
        Vector vProduct = CalculateNewNormal();
        if(vProduct.Len2() != 0.0F)
        {
            vProduct.Mul(m_Params._GROUND_ALIGN_INERTIA * m_fFrameTime);
            m_vVehicleNormal.Mul(m_Params._NORMAL_INTERPOLATION_COEFF);
            vProduct.Add(m_vVehicleNormal);
            vProduct.Normalize();
            m_vVehicleNormal.Set(vProduct);
            m_vVehicleTNormal.Set(m_vVehicleNormal);
        }
        boolean bFX = false;
        if(bSlide)
        {
            TurnSlideSmokeFX();
            bFX = true;
            PlaySoundSlide();
        }
        if(bAccel)
        {
            AccelerateSmokeFX();
            bFX = true;
            PlaySoundAccel();
        }
        if(bBrake)
        {
            BrakeSmokeFX();
            bFX = true;
            PlaySoundBrake();
        }
        if(!bFX && bWheelSmokeFX && Math.abs(m_fCurrSpeed) > 10F)
            WheelSmokeFX();
        UpdateSounds();
        UpdateSpringsAndWheels();
        InitParamsFromVehicle();
        m_bNetSimulate = false;
    }

    void SavePhysicsState()
    {
        m_bPhysicsCalcOnly = true;
        if(m_PhysicsState == null)
            m_PhysicsState = new VehiclePhysicsState();
        m_PhysicsState.SavePhysicsState(this);
    }

    void AdditionalSimulate(byte iAcc, float fTurn, float fDeltaTime, Vector vEndPos, Vector vEndDir, Vector vEndRight, Vector vEndUp)
    {
        SavePhysicsState();
        Simulate(iAcc, fTurn, fDeltaTime);
        m_Vehicle.GetPosition(vEndPos);
        if(vEndDir != null)
            m_Vehicle.GetForwardVector(vEndDir);
        if(vEndRight != null)
            m_Vehicle.GetRightVector(vEndRight);
        if(vEndUp != null)
            m_Vehicle.GetUpVector(vEndUp);
        RestorePhysicsState();
    }

    void RotateTurnWheels()
    {
        RotateTurnWheels(m_fCurrDirAngle);
    }

    void RotateTurnWheels(float fAngle)
    {
        for(int i = 0; i < 2; i++)
            if(m_Wheels[i] != -1)
                m_Vehicle.RotateElement(m_Wheels[i], m_vRotateTurn, -fAngle / 2.0F);

    }

    void DecreaseTurnSlide()
    {
        float fNewValue = m_vTurningSlide.Len() - m_Params._SLIDE_SUPRESS * m_fFrameTime;
        if(fNewValue < 0.0F)
            fNewValue = 0.0F;
        m_vTurningSlide.Normalize();
        m_vTurningSlide.Mul(fNewValue);
    }

    void PlaySoundSlide()
    {
        if(m_bPhysicsCalcOnly)
            return;
        if(m_fNowTime - m_fLastSlideSound > m_Params._TIME_BETWEEN_SLIDE_SOUNDS)
        {
            m_Vehicle.SlideSound();
            m_fLastSlideSound = m_fNowTime;
        }
    }

    final void SetVehicleParams(VehicleParams Params)
    {
        m_Params = Params;
    }

    void UpdateMovementParams(byte iAccel, float fTurn)
    {
        if(iAccel > 0)
        {
            m_fAccelerate = iAccel;
            m_fBrake = 0.0F;
        } else
        if(iAccel < 0)
        {
            m_fAccelerate = 0.0F;
            m_fBrake = -(float)iAccel;
        } else
        {
            m_fAccelerate = 0.0F;
            m_fBrake = 0.0F;
        }
        if(fTurn > 0.0F)
        {
            m_fTurnRight = fTurn;
            m_fTurnLeft = 0.0F;
        } else
        if(fTurn < 0.0F)
        {
            m_fTurnRight = 0.0F;
            m_fTurnLeft = -fTurn;
        } else
        {
            m_fTurnRight = 0.0F;
            m_fTurnLeft = 0.0F;
        }
        boolean bSpeedChange = false;
        if(m_fAccelerate > 0.0F)
        {
            if(m_fCurrSpeed < m_Params._MIN_SPEED / 2.0F)
                PlaySoundBrake();
            bSpeedChange = true;
            if(m_fFlyingTime < m_Params._REAL_FLY_TIME_CONTROL && m_bEnableBack)
            {
                if(m_fCurrSpeed < 0.0F)
                {
                    m_fCurrSpeed += m_Params._BRAKE_COEF * m_fFrameTime;
                    if(m_fCurrSpeed > 0.0F)
                    {
                        m_fCurrSpeed = 0.0F;
                        EnableBackLater();
                    }
                } else
                {
                    if(m_fCurrSpeed < m_fAccelerate * m_Params._CURR_MAX_SPEED)
                    {
                        float fTemp = m_fAccelerate * m_Params._CURR_MAX_SPEED;
                        m_fCurrSpeed += m_Params._ACCELERATION_COEF * m_fFrameTime;
                        if(m_fCurrSpeed > fTemp)
                            m_fCurrSpeed = fTemp;
                    } else
                    if(m_fCurrSpeed > m_fAccelerate * m_Params._CURR_MAX_SPEED)
                    {
                        m_fCurrSpeed -= m_Params._ACCELERATION_COEF * m_fFrameTime;
                        if(m_fCurrSpeed < m_fAccelerate * m_Params._CURR_MAX_SPEED)
                            m_fCurrSpeed = m_fAccelerate * m_Params._CURR_MAX_SPEED;
                    }
                    m_Vehicle.fFuel -= m_Vehicle.fFuelConsumption * m_fFrameTime;
                }
            } else
            if(m_fCurrSpeed < 0.0F)
            {
                m_fCurrSpeed += m_Params._FLY_SLOW_COEF * m_fFrameTime;
                if(m_fCurrSpeed > 0.0F)
                    m_fCurrSpeed = 0.0F;
            } else
            {
                m_fCurrSpeed -= m_Params._FLY_SLOW_COEF * m_fFrameTime;
                if(m_fCurrSpeed < 0.0F)
                    m_fCurrSpeed = 0.0F;
            }
        }
        if(m_fBrake > 0.0F && m_fFlyingTime < m_Params._REAL_FLY_TIME_CONTROL && m_bEnableBack)
        {
            bSpeedChange = true;
            if(!m_Vehicle.m_bIsPatrolling && m_fCurrSpeed > m_Params.GetMaxSpeed() / 2.0F)
                PlaySoundBrake();
            if(m_fCurrSpeed > 0.0F)
            {
                m_fCurrSpeed -= m_Params._BRAKE_COEF * m_fFrameTime;
                if(m_fCurrSpeed < 0.0F)
                {
                    m_fCurrSpeed = 0.0F;
                    EnableBackLater();
                }
            } else
            {
                if(m_fCurrSpeed > m_fBrake * m_Params._MIN_SPEED)
                {
                    float fTemp = m_fBrake * m_Params._MIN_SPEED;
                    m_fCurrSpeed -= m_Params._ACCELERATION_COEF * m_fFrameTime;
                    if(m_fCurrSpeed < fTemp)
                        m_fCurrSpeed = fTemp;
                }
                m_Vehicle.fFuel -= m_Vehicle.fFuelConsumption * m_fFrameTime;
            }
        }
        if(!bSpeedChange)
            if(m_fCurrSpeed < 0.0F)
            {
                m_fCurrSpeed += m_Params._SLOW_COEF * m_fFrameTime;
                if(m_fCurrSpeed > 0.0F)
                    m_fCurrSpeed = 0.0F;
            } else
            {
                m_fCurrSpeed -= m_Params._SLOW_COEF * m_fFrameTime;
                if(m_fCurrSpeed < 0.0F)
                    m_fCurrSpeed = 0.0F;
            }
        if(m_Vehicle.m_bIsPatrolling)
        {
            m_fTurnInPathMove = m_Params._TURNING_SPEED * m_fFrameTime;
            if(m_fTurnLeft > 0.0F)
            {
                if(m_fTurnInPathMove > m_fTurnLeft * m_Params._MAX_TURN_ANGLE)
                    m_fTurnInPathMove = m_fTurnLeft * m_Params._MAX_TURN_ANGLE;
                m_fTurnInPathMove *= -1F;
                m_fCurrDirAngle = m_fTurnInPathMove / m_fFrameTime;
                if(m_fCurrDirAngle < -m_Params._MAX_TURN_ANGLE)
                    m_fCurrDirAngle = -m_Params._MAX_TURN_ANGLE;
            }
            if(m_fTurnRight > 0.0F)
            {
                if(m_fTurnInPathMove > m_fTurnRight * m_Params._MAX_TURN_ANGLE)
                    m_fTurnInPathMove = m_fTurnRight * m_Params._MAX_TURN_ANGLE;
                m_fCurrDirAngle = m_fTurnInPathMove / m_fFrameTime;
                if(m_fCurrDirAngle > m_Params._MAX_TURN_ANGLE)
                    m_fCurrDirAngle = m_Params._MAX_TURN_ANGLE;
            }
        } else
        {
            if(m_fTurnLeft > 0.0F)
            {
                float fTemp = m_fTurnLeft * m_Params._MAX_TURN_ANGLE;
                m_fCurrDirAngle -= m_Params._TURNING_SPEED * m_fFrameTime;
                if(m_fCurrDirAngle < -fTemp)
                    m_fCurrDirAngle = -fTemp;
            }
            if(m_fTurnRight > 0.0F)
            {
                float fTemp = m_fTurnRight * m_Params._MAX_TURN_ANGLE;
                m_fCurrDirAngle += m_Params._TURNING_SPEED * m_fFrameTime;
                if(m_fCurrDirAngle > fTemp)
                    m_fCurrDirAngle = fTemp;
            }
        }
    }

    void AlignSprings()
    {
        for(int i = 0; i < m_nWheelCnt; i++)
        {
            if(m_Springs[i] < m_SpringsNew[i])
            {
                m_Springs[i] += m_Params._SPRING_TIME_MOVE_COEF * m_fFrameTime;
                if(m_Springs[i] > m_SpringsNew[i])
                    m_Springs[i] = m_SpringsNew[i];
            } else
            {
                m_Springs[i] = m_SpringsNew[i];
            }
            if(m_Springs[i] < m_Params._SPRING_MIN)
                m_Springs[i] = m_Params._SPRING_MIN;
            if(m_Springs[i] > m_Params._SPRING_MAX)
                m_Springs[i] = m_Params._SPRING_MAX;
        }

    }

    void ZeroParams()
    {
        m_fFlyingTime = 0.0F;
        m_fLandingTime = 0.0F;
        m_bEnableBack = true;
        m_vSlideVector.Set(Vector.Zero);
        m_fCurrDirAngle = 0.0F;
        m_bIsFlyingOnFrame = false;
        m_fWheelRotationSpeed = 0.0F;
        m_bLanding = false;
        m_vTurningSlide.Set(Vector.Zero);
        m_vCollisionVector.Set(Vector.Zero);
        m_bGotCollision = false;
    }

    void TakeDamageFromFall()
    {
        if(!m_bPhysicsCalcOnly && m_fCurrGravity <= -3000F && m_fLastYPos - m_vVehiclePosition.fY > m_Params._FALL_DAMAGE_HEIGHT_MIN)
        {
            float fDamage = m_fLastYPos - m_vVehiclePosition.fY - m_Params._FALL_DAMAGE_HEIGHT_MIN;
            fDamage *= (m_Params._FALL_DAMAGE * m_Params._FALL_DAMAGE) / 10000F;
            if(m_Vehicle.m_bLocalPlayerDriver && ((GameObject) (m_Vehicle)).Role < 4)
                m_Vehicle.MsgSendServerVehicleCollision(fDamage);
            else
            if(m_Vehicle.m_bLocalPlayerDriver && ((GameObject) (m_Vehicle)).Role == 4)
                m_Vehicle.TakeDamage(fDamage, EnumDamageType._BULLET);
            m_fLastYPos = m_vVehiclePosition.fY;
        }
    }

    boolean CanMoveToPosition(Vector vPos)
    {
        return m_Vehicle.GetTerrainType(vPos.fX + _TERRAIN_TEST_LEN, vPos.fZ) != 0 && m_Vehicle.GetTerrainType(vPos.fX - _TERRAIN_TEST_LEN, vPos.fZ) != 0 && m_Vehicle.GetTerrainType(vPos.fX, vPos.fZ + _TERRAIN_TEST_LEN) != 0 && m_Vehicle.GetTerrainType(vPos.fX, vPos.fZ - _TERRAIN_TEST_LEN) != 0;
    }

    void TestTrackNoCheckTerrainHeight(Vector vStart, Vector vEnd)
    {
        if(vStart.fX == vEnd.fX && vStart.fZ == vEnd.fZ)
        {
            Vector vNormal = new Vector();
            float fTerrainHeight = m_Vehicle.TerrainHeightNormal(vStart.fX, vStart.fZ, vNormal);
            if(vStart.fY >= fTerrainHeight && vEnd.fY <= fTerrainHeight)
            {
                m_collInfo.coll = new Collision();
                m_collInfo.coll.vNormal = vNormal;
                m_collInfo.coll.fDistance = vStart.fY - fTerrainHeight;
                m_collInfo.coll.Obstacle = null;
                m_collInfo.coll.ObstacleElement = -1;
                m_collInfo.coll.nMaterial = 0;
                m_collInfo.coll.nMaterialFlags = 0;
                m_collInfo.vEnd = new Vector(vEnd);
                m_collInfo.vEnd.fY = fTerrainHeight;
            } else
            {
                m_collInfo.coll = null;
                m_collInfo.vEnd = new Vector(vEnd);
            }
        } else
        {
            m_collInfo.coll = m_Vehicle.TraceTerrain(vStart, vEnd);
            m_collInfo.vEnd = new Vector(vEnd);
        }
        Collision colObj = m_Vehicle.TraceObjectsExclude(vStart, vEnd, m_Vehicle);
        if(colObj != null)
        {
            m_collInfo.coll = colObj;
            m_collInfo.vEnd.Set(vEnd);
        }
    }

    public void HandleDetectedCollision(Vector vMoveDir, boolean bCouldMoveAfterColl)
    {
        if(m_fRealSpeed < m_Params._MIN_SPEED_TO_COLLIDE)
        {
            m_fCurrSpeed /= 2.0F;
            return;
        }
        if(!bCouldMoveAfterColl && m_fNowTime - m_fLastCollisionSound > m_Params._TIME_BETWEEN_HIT_SOUNDS)
            PlaySoundHit();
        Vector vNormal = new Vector(vMoveDir);
        vNormal.Mul(-1F);
        vNormal.Normalize();
        GameObject.LogLine("PseudoKolizja z obiektem  vNormal " + vNormal);
        float fMoveSpeed = m_fRealSpeed;
        if(fMoveSpeed <= 0.01F && fMoveSpeed >= -0.01F)
            fMoveSpeed = 1.0F;
        vNormal.Mul(m_Params._TREE_HIT_SUPR * fMoveSpeed);
        m_vCollisionVector.Add(vNormal);
        if(m_vCollisionVector.Len() > m_Params._COLL_COEF_MAX_SPEED)
        {
            m_vCollisionVector.Normalize();
            m_vCollisionVector.Mul(m_Params._COLL_COEF_MAX_SPEED);
            GameObject.LogLine("wektor za dlugi, obcinamy do m_vCollisionVector " + m_vCollisionVector);
        }
        m_fCurrSpeed = 0.0F;
        if(!bCouldMoveAfterColl)
            TakeCollisionDamage(fMoveSpeed);
    }

    public void HandleCollision(ControlObject obj, Vector vPoint, Vector vNormal, Vector vMove)
    {
        if(obj instanceof Bullet)
        {
            obj.ClearFlag(32);
            m_bRecalculateMove = true;
            return;
        }
        if(m_Vehicle.m_bModuleNet && (obj instanceof Pawn))
        {
            m_bNetPawnCollision = true;
            return;
        }
        m_bCheckCollision = false;
        vNormal.Mul(-1F);
        if(vNormal.Dot(Vector.Up) > 0.5F)
            return;
        float fMoveSpeed = m_fRealSpeed;
        if(fMoveSpeed < m_Params._MIN_SPEED_TO_COLLIDE)
        {
            m_fCurrSpeed /= 2.0F;
            return;
        }
        if(fMoveSpeed <= 0.1F && fMoveSpeed >= -0.1F)
            fMoveSpeed = 1.0F;
        if(obj != null && (obj instanceof Pawn))
        {
            HandlePawnCollision((Pawn)obj, vNormal, vMove, fMoveSpeed, vPoint);
            return;
        }
        if(m_fNowTime - m_fLastCollisionSound > m_Params._TIME_BETWEEN_HIT_SOUNDS && !(obj instanceof Barrier))
            PlaySoundHit();
        if(vMove.Len2() > 0.0F)
        {
            m_vMoveDir.Set(vMove);
            Vector vMoveDirNorm = new Vector(m_vMoveDir);
            vMoveDirNorm.Normalize();
            float fAngle = 180F - (float)Math.acos(vNormal.Dot(vMoveDirNorm)) * 57.29F;
            Vector vBounceDir = m_Vehicle.RotateVector(vNormal, fAngle, Vector.Up);
            vBounceDir.Mul(m_Params._TREE_HIT_SUPR * fMoveSpeed);
            m_vCollisionVector.Add(vBounceDir);
            if(m_vCollisionVector.Len() > m_Params._COLL_COEF_MAX_SPEED)
            {
                m_vCollisionVector.Normalize();
                m_vCollisionVector.Mul(m_Params._COLL_COEF_MAX_SPEED);
                GameObject.LogLine("wektor za dlugi, obcinamy do m_vCollisionVector " + m_vCollisionVector);
            }
        }
        if(!m_bPhysicsCalcOnly)
            TakeCollisionDamage(fMoveSpeed);
        m_fCurrSpeed = 0.0F;
    }

    void BrakeSmokeFX()
    {
        if(m_bPhysicsCalcOnly)
            return;
        if(m_fNowTime - m_fLastBrakeFXTime > m_Params._TIME_BTW_SMOKES)
            m_fLastBrakeFXTime = m_fNowTime;
        else
            return;
        if(sWheelSmokeFX != null)
        {
            for(int i = 0; i < m_nWheelCnt; i++)
                m_Vehicle.ExecuteFX(sWheelSmokeFX, GetWheelFXPos(i), m_vVehicleNormal);

        }
    }

    float GetMaxSpeed()
    {
        return m_Params.GetMaxSpeed();
    }

    float GetSpeedToTurnCoeff(float fSpeed)
    {
        float fSpeedCoef = fSpeed;
        if(fSpeedCoef >= 0.0F)
            fSpeedCoef /= m_Params.GetMaxSpeed();
        else
            fSpeedCoef /= -m_Params.GetMaxSpeed();
        if(fSpeedCoef < 0.0F)
            fSpeedCoef = 0.0F;
        if(fSpeedCoef > 1.0F)
            fSpeedCoef = 1.0F;
        fSpeedCoef *= 1.5F;
        float fTemp = -fSpeedCoef;
        fSpeedCoef -= 2.0F;
        fSpeedCoef *= fTemp;
        return fSpeedCoef;
    }

    Vector CalculateNewNormal()
    {
        Vector vDown = new Vector(0.0F, -1F, 0.0F);
        Vector vSuspensionDir = new Vector(m_vVehicleNormal);
        vSuspensionDir.Mul(m_Params._SUSPENSION_HEIGHT);
        for(int i = 0; i < m_nWheelBaseCnt; i++)
        {
            if(m_WheelsBase[i] != -1)
                vWheelTmp[i].Set(m_Vehicle.GetElementPos(m_WheelsBase[i]));
            else
                vWheelTmp[i].Set(m_Vehicle.GetPosition());
            vWheelTmp[i].Add(vSuspensionDir);
        }

        vSuspensionDir.Negate();
        vSuspensionDir.Mul(2.0F);
        Vector vEnd = null;
        for(int i = 0; i < m_nWheelBaseCnt; i++)
        {
            vEnd = new Vector(vSuspensionDir);
            vEnd.Add(vWheelTmp[i]);
            TestTrack(vWheelTmp[i], vEnd);
            if(m_collInfo.coll != null)
                vWheelTmp[i].Set(m_collInfo.coll.vNormal);
            else
                vWheelTmp[i].Set(Vector.Zero);
        }

        Vector vProduct = new Vector(vWheelTmp[m_nWheelBaseCnt - 1]);
        for(int i = 0; i < m_nWheelBaseCnt - 1; i++)
            vProduct.Add(vWheelTmp[i]);

        vProduct.Normalize();
        if(vProduct.Len2() == 0.0F)
        {
            Vector vTemp = new Vector(m_vVehiclePosition);
            vTemp.fY += m_Params._SUSPENSION_HEIGHT;
            vEnd = new Vector(vTemp);
            vEnd.fY -= 2.0F * m_Params._SUSPENSION_HEIGHT;
            TestTrack(vTemp, vEnd);
            if(m_collInfo.coll != null)
                vProduct.Set(m_collInfo.coll.vNormal);
            else
                vProduct.Set(Vector.Up);
        }
        return vProduct;
    }

    public void SGSaveChunk(FileChunk cFCParent)
    {
        FileChunk.Log("[PhysicsVehicle.SGSaveChunk]\n");
        FileChunk cFC = GameObject.NewChunk(1153, cFCParent);
        cFC.SaveFloat(m_fFrameTime);
        cFC.SaveFloat(m_fNowTime);
        cFC.SaveFloat(_HALF_WHEEL_SIZE);
        cFC.SaveObjectRef(m_Params);
        cFC.SaveFloat(m_fFlyingTime);
        cFC.SaveFloat(m_fLandingTime);
        cFC.SaveBool(m_bEnableBack);
        cFC.SaveVector(m_vSlideVector);
        cFC.SaveFloat(m_fAccelerate);
        cFC.SaveFloat(m_fBrake);
        cFC.SaveFloat(m_fTurnLeft);
        cFC.SaveFloat(m_fTurnRight);
        cFC.SaveFloat(m_fCurrSpeed);
        cFC.SaveFloat(m_fCurrGravity);
        cFC.SaveFloat(m_fCurrDirAngle);
        cFC.SaveBool(m_bIsFlyingOnFrame);
        cFC.SaveFloat(m_fWheelRotationSpeed);
        cFC.SaveBool(m_bFlying);
        cFC.SaveBool(m_bLanding);
        cFC.SaveVector(m_vTurningSlide);
        cFC.SaveFloat(m_fCurrVehicleHAngle);
        cFC.SaveFloat(m_fCurrVehicleVAngle);
        cFC.SaveVector(m_vVehicleNormal);
        cFC.SaveVector(m_vVehicleForward);
        cFC.SaveVector(m_vVehicleRight);
        cFC.SaveVector(m_vVehicleTForward);
        cFC.SaveVector(m_vVehicleTNormal);
        cFC.SaveVector(m_vVehiclePosition);
        cFC.SaveVector(m_vCollisionVector);
        cFC.SaveVector(m_vMoveDir);
        cFC.SaveBool(m_bGotCollision);
        cFC.SaveFloat(m_fLastAccelFXTimeStart);
        cFC.SaveFloat(m_fLastAccelFXTime);
        cFC.SaveFloat(m_fLastBrakeFXTime);
        cFC.SaveFloat(m_fLastSlideFXTime);
        cFC.SaveFloat(m_fLastWheelFXTime);
        cFC.SaveObjectRef(m_Vehicle);
        cFC.SaveFloat(m_fHitTurnAngle);
        cFC.SaveFloat(m_fBrakePressTime);
        cFC.SaveFloat(m_fLastCollisionSound);
        cFC.SaveFloat(m_fLastSlideSound);
        cFC.SaveFloat(m_fLastAccelSound);
        cFC.SaveFloat(m_fMoveSpeed);
        cFC.SaveVector(m_collInfo.vEnd);
        cFC.SaveObjectRef(m_collInfo.coll);
        cFC.SaveBool(m_bCheckCollision);
        cFC.SaveFloat(m_fTurnInPathMove);
        cFC.SaveVector(m_vShiftUp);
        cFC.SaveVector(m_vShiftForward);
        cFC.SaveVector(m_vRotateTurn);
        cFC.SaveVector(m_vRotateRevolution);
        cFC.SaveBool(m_bMotorLikeAlign);
        cFC.SaveBool(bWheelSmokeRearOnly);
        cFC.SaveFloat(m_fMovieWheelsAngleMult);
        cFC.SaveFloat(m_fLastYPos);
        cFC.delete();
    }

    void AddSlideFromTurning()
    {
        Vector vTemp = new Vector(m_vVehicleRight);
        vTemp.fY = 0.0F;
        vTemp.Normalize();
        float fSpeedCoef = m_fCurrSpeed;
        if(m_fCurrSpeed >= 0.0F)
            fSpeedCoef /= m_Params.GetMaxSpeed();
        else
            fSpeedCoef /= -m_Params.GetMaxSpeed();
        vTemp.Mul(((m_fFrameTime * m_Params._SLIDE_COEF * m_fCurrDirAngle) / m_Params._MAX_TURN_ANGLE) * fSpeedCoef);
        m_vTurningSlide.Add(vTemp);
    }

    public void SGLoadChunk(FileChunk cParentFC)
    {
        FileChunk.Log("[PhysicsVehicle.SGLoadChunk]\n");
        FileChunk cFC = GameObject.LoadChunk(cParentFC);
        if(cFC.GetID() == 1153)
        {
            m_fFrameTime = cFC.LoadFloat();
            m_fNowTime = cFC.LoadFloat();
            _HALF_WHEEL_SIZE = cFC.LoadFloat();
            m_Params = (VehicleParams)cFC.LoadObjectRef();
            m_fFlyingTime = cFC.LoadFloat();
            m_fLandingTime = cFC.LoadFloat();
            m_bEnableBack = cFC.LoadBool();
            m_vSlideVector = cFC.LoadVector();
            m_fAccelerate = cFC.LoadFloat();
            m_fBrake = cFC.LoadFloat();
            m_fTurnLeft = cFC.LoadFloat();
            m_fTurnRight = cFC.LoadFloat();
            m_fCurrSpeed = cFC.LoadFloat();
            m_fCurrGravity = cFC.LoadFloat();
            m_fCurrDirAngle = cFC.LoadFloat();
            m_bIsFlyingOnFrame = cFC.LoadBool();
            m_fWheelRotationSpeed = cFC.LoadFloat();
            m_bFlying = cFC.LoadBool();
            m_bLanding = cFC.LoadBool();
            m_vTurningSlide = cFC.LoadVector();
            m_fCurrVehicleHAngle = cFC.LoadFloat();
            m_fCurrVehicleVAngle = cFC.LoadFloat();
            m_vVehicleNormal = cFC.LoadVector();
            m_vVehicleForward = cFC.LoadVector();
            m_vVehicleRight = cFC.LoadVector();
            m_vVehicleTForward = cFC.LoadVector();
            m_vVehicleTNormal = cFC.LoadVector();
            m_vVehiclePosition = cFC.LoadVector();
            m_vCollisionVector = cFC.LoadVector();
            m_vMoveDir = cFC.LoadVector();
            m_bGotCollision = cFC.LoadBool();
            m_fLastAccelFXTimeStart = cFC.LoadFloat();
            m_fLastAccelFXTime = cFC.LoadFloat();
            m_fLastBrakeFXTime = cFC.LoadFloat();
            m_fLastSlideFXTime = cFC.LoadFloat();
            m_fLastWheelFXTime = cFC.LoadFloat();
            m_Vehicle = (Vehicle)cFC.LoadObjectRef();
            m_fHitTurnAngle = cFC.LoadFloat();
            m_fBrakePressTime = cFC.LoadFloat();
            m_fLastCollisionSound = cFC.LoadFloat();
            m_fLastSlideSound = cFC.LoadFloat();
            m_fLastAccelSound = cFC.LoadFloat();
            m_fMoveSpeed = cFC.LoadFloat();
            m_collInfo.vEnd = cFC.LoadVector();
            m_collInfo.coll = (Collision)cFC.LoadObjectRef();
            m_bCheckCollision = cFC.LoadBool();
            m_fTurnInPathMove = cFC.LoadFloat();
            m_vShiftUp = cFC.LoadVector();
            m_vShiftForward = cFC.LoadVector();
            m_vRotateTurn = cFC.LoadVector();
            m_vRotateRevolution = cFC.LoadVector();
            m_bMotorLikeAlign = cFC.LoadBool();
            bWheelSmokeRearOnly = cFC.LoadBool();
            m_fMovieWheelsAngleMult = cFC.LoadFloat();
            m_fLastYPos = cFC.LoadFloat();
        }
        cFC.delete();
    }

    void MoveVehicle()
    {
        float fWaterLevel = m_Vehicle.GetModule().GetWaterLevel();
        m_vMoveDir.Set(m_vVehicleForward);
        m_vMoveDir.Mul(m_fFrameTime * m_fCurrSpeed);
        Vector vTemp = new Vector(m_vSlideVector);
        vTemp.Mul(m_fFrameTime);
        m_vMoveDir.Add(vTemp);
        vTemp.Set(m_vTurningSlide);
        vTemp.Mul(m_fFrameTime);
        m_vMoveDir.Add(vTemp);
        vTemp.Set(m_vCollisionVector);
        vTemp.Mul(m_fFrameTime);
        m_vMoveDir.Add(vTemp);
        Vector vStart = new Vector(m_vVehicleNormal);
        if(Math.abs(m_fCurrSpeed) > 3F)
            vStart.Set(m_vVehicleNormal);
        else
            vStart.Set(Vector.Up);
        vStart.Mul(m_Params._SUSPENSION_HEIGHT);
        vStart.Add(m_vVehiclePosition);
        Vector vEnd = new Vector(vStart);
        vEnd.Add(m_vMoveDir);
        m_fMoveSpeed = m_vMoveDir.Len() / m_fFrameTime;
        if(m_bFlyOverWater && vEnd.fY < fWaterLevel)
            vEnd.fY = fWaterLevel;
        TestTrack(vStart, vEnd);
        vEnd.Set(m_collInfo.vEnd);
        if(m_collInfo.coll != null)
        {
            if(Vector.Up.Dot(m_collInfo.coll.vNormal) < m_Params._MAX_SLOPE_ANGLE)
                SetBounceVector(m_collInfo.coll.vNormal);
            else
                vEnd.fY += 0.01F;
            vEnd.fY += _HEIGHT_OVER_GROUND;
            m_fCurrGravity = 0.0F;
            TakeDamageFromFall();
            if(!m_bPhysicsCalcOnly)
                m_fLastYPos = m_vVehiclePosition.fY;
        } else
        {
            Vector vCurrGravity = new Vector();
            if(Math.abs(m_fCurrSpeed) > 3F)
                vCurrGravity.Set(m_vVehicleNormal);
            else
                vCurrGravity.Set(Vector.Up);
            m_fCurrGravity += m_Params._GRAVITY_ACCEL * m_fFrameTime;
            vCurrGravity.Mul(m_fFrameTime * m_fCurrGravity);
            vStart.Set(vEnd);
            Vector vVehicleDown = new Vector();
            if(Math.abs(m_fCurrSpeed) > 3F)
                vVehicleDown.Set(m_vVehicleNormal);
            else
                vVehicleDown.Set(Vector.Up);
            vVehicleDown.Negate();
            vVehicleDown.Mul(m_Params._SUSPENSION_HEIGHT + _HEIGHT_OVER_GROUND);
            vEnd.Add(vVehicleDown);
            vEnd.Add(vCurrGravity);
            boolean bIsOverWater = false;
            if(m_bFlyOverWater && vEnd.fY < fWaterLevel)
            {
                vEnd.fY = fWaterLevel;
                bIsOverWater = true;
            }
            TestTrack(vStart, vEnd);
            vEnd.Set(m_collInfo.vEnd);
            if(m_collInfo.coll != null)
            {
                if(Vector.Up.Dot(m_collInfo.coll.vNormal) < m_Params._MAX_SLOPE_ANGLE)
                    SetBounceVector(m_collInfo.coll.vNormal);
                vEnd.fY += 0.01F + _HEIGHT_OVER_GROUND;
                TakeDamageFromFall();
                m_fCurrGravity = 0.0F;
                if(!m_bPhysicsCalcOnly)
                    m_fLastYPos = m_vVehiclePosition.fY;
            } else
            {
                if(bIsOverWater)
                    m_fCurrGravity = 0.0F;
                else
                    m_bIsFlyingOnFrame = true;
                vEnd.fY += _HEIGHT_OVER_GROUND;
            }
        }
        m_vMoveDir.Set(vEnd);
        m_vMoveDir.Sub(m_vVehiclePosition);
        if(vEnd.fY + m_Params._WATER_LEVEL_MARGIN < fWaterLevel)
        {
            m_vMoveDir.Mul(0.4F);
            TakeWaterDamage(m_fFrameTime);
        }
        float fMoveLen = m_vMoveDir.Len();
        m_fMoveSpeed = fMoveLen / m_fFrameTime;
        m_bCheckCollision = true;
        if(m_vMoveDir.Len2() > 0.0F)
        {
            vMoveDir.Set(m_vMoveDir);
            boolean bCouldMoveAfterColl = m_Vehicle.MoveByEllipsoid(m_vMoveDir);
            Vector vPos = new Vector(m_vVehiclePosition);
            vPos.Add(m_vMoveDir);
            if(!CanMoveToPosition(vPos))
            {
                m_vMoveDir.fX = 0.0F;
                m_vMoveDir.fZ = 0.0F;
            }
            if(m_bRecalculateMove)
            {
                m_vMoveDir.Set(vMoveDir);
                bCouldMoveAfterColl = m_Vehicle.MoveByEllipsoid(m_vMoveDir);
                m_bRecalculateMove = false;
                vPos = new Vector(m_vVehiclePosition);
                vPos.Add(m_vMoveDir);
                if(!CanMoveToPosition(vPos))
                {
                    m_vMoveDir.fX = 0.0F;
                    m_vMoveDir.fZ = 0.0F;
                }
            }
            if(m_bNetPawnCollision)
            {
                m_vMoveDir.Set(vMoveDir);
                bCouldMoveAfterColl = true;
                m_bNetPawnCollision = false;
            }
            m_vVehiclePosition.Add(m_vMoveDir);
            float fOldRealSpeed = m_fRealSpeed;
            m_fRealSpeed = m_vMoveDir.Len() / m_fFrameTime;
            m_fRealAccel = (m_fRealSpeed - fOldRealSpeed) / m_fFrameTime;
            if(m_bCheckCollision)
                if(Math.abs(m_fCurrSpeed) > 0.0F && m_vMoveDir.Len2() == 0.0F)
                    HandleDetectedCollision(vMoveDir, bCouldMoveAfterColl);
                else
                if(m_vMoveDir.Len2() > 0.0F)
                {
                    vTemp1.Set(vMoveDir);
                    vTemp1.fY = 0.0F;
                    vTemp1.Normalize();
                    vTemp2.Set(m_vMoveDir);
                    vTemp2.fY = 0.0F;
                    vTemp2.Normalize();
                    if(Math.abs(m_fCurrSpeed) > 300F && vTemp1.Dot(vTemp2) < 0.7F)
                        HandleDetectedCollision(vMoveDir, bCouldMoveAfterColl);
                }
        } else
        {
            m_fRealSpeed = 0.0F;
            m_fRealAccel = 0.0F;
        }
        if(m_Vehicle.m_iStampSize > 0)
        {
            if(m_bPhysicsCalcOnly)
                return;
            if(m_vMoveDir.Len2() == 0.0F || m_fCurrSpeed == 0.0F)
            {
                if(!m_Vehicle.IsUpdatingPathMap())
                    m_Vehicle.UpdatePathMap(true, m_Vehicle.m_iStampSize, true);
            } else
            if(m_Vehicle.IsUpdatingPathMap())
                m_Vehicle.UpdatePathMap(false, m_Vehicle.m_iStampSize, true);
        }
    }

    void DecreaseVehicleVAngle()
    {
        if(m_fCurrVehicleVAngle >= 0.0F)
        {
            m_fCurrVehicleVAngle -= m_fFrameTime * m_Params._VERT_DEV_ACCEL;
            if(m_fCurrVehicleVAngle < 0.0F)
                m_fCurrVehicleVAngle = 0.0F;
        } else
        {
            m_fCurrVehicleVAngle += m_fFrameTime * m_Params._VERT_DEV_ACCEL;
            if(m_fCurrVehicleVAngle > 0.0F)
                m_fCurrVehicleVAngle = 0.0F;
        }
    }

    void DecreaseVehicleHAngle()
    {
        if(m_fCurrVehicleHAngle >= 0.0F)
        {
            m_fCurrVehicleHAngle -= m_fFrameTime * m_Params._HORIZ_DEV_ACCEL;
            if(m_fCurrVehicleHAngle < 0.0F)
                m_fCurrVehicleHAngle = 0.0F;
        } else
        {
            m_fCurrVehicleHAngle += m_fFrameTime * m_Params._HORIZ_DEV_ACCEL;
            if(m_fCurrVehicleHAngle > 0.0F)
                m_fCurrVehicleHAngle = 0.0F;
        }
    }

    Vector GetWheelFXPos(int nWheel)
    {
        Vector vPos = m_Wheels[nWheel] == -1 ? m_Vehicle.GetPosition() : m_Vehicle.GetElementPos(m_Wheels[nWheel]);
        vPos.fY += fWheelSmokeShiftY - _HALF_WHEEL_SIZE;
        return vPos;
    }

    void SetVehicle(Vehicle obj)
    {
        m_Vehicle = obj;
    }

    void PlaySoundAccel()
    {
        if(m_bPhysicsCalcOnly)
            return;
        if(m_fNowTime - m_fLastAccelSound > m_Params._TIME_BETWEEN_ACCEL_SOUNDS)
        {
            m_Vehicle.AccelSound();
            m_fBrakePressTime = m_fNowTime;
        }
    }

    void DecreaseTurning()
    {
        if(m_fTurnRight == 0.0F && m_fTurnLeft == 0.0F && m_fCurrDirAngle != 0.0F)
        {
            float fNewValue;
            if(m_fCurrDirAngle < 0.0F)
                fNewValue = m_fCurrDirAngle + m_Params._DECREASE_TURNING_SPEED * m_fFrameTime;
            else
                fNewValue = m_fCurrDirAngle - m_Params._DECREASE_TURNING_SPEED * m_fFrameTime;
            if(fNewValue * m_fCurrDirAngle < 0.0F)
                fNewValue = 0.0F;
            m_fCurrDirAngle = fNewValue;
        }
    }

    public void SGUpdate()
    {
        for(int i = 0; i < _MAX_WHEELS; i++)
            vWheelTmp[i] = new Vector(0.0F, 0.0F, 0.0F);

        AlignSpringsAndWheelsToTerrain();
    }

    void Simulate(byte iAccel, float fTurn, float fDeltaTime)
    {
        m_fFrameTime = fDeltaTime;
        m_fNowTime += m_fFrameTime;
        UpdateMovementParams(iAccel, fTurn);
        UpdateVehiclePhysics();
        if(bWheelSmokeFX && Math.abs(m_fCurrSpeed) > 10F)
            WheelSmokeFX();
    }

    void DecreaseSlide()
    {
        float fNewValue = m_vSlideVector.Len() - m_Params._SLIDE_TIME_COEF * m_fFrameTime;
        if(fNewValue < 0.0F)
            fNewValue = 0.0F;
        m_vSlideVector.Normalize();
        m_vSlideVector.Mul(fNewValue);
    }

    void SetBounceVector(Vector vNormal)
    {
        Vector vTemp = new Vector(Vector.Up);
        vTemp.Negate();
        vTemp.Add(vNormal);
        vTemp.Normalize();
        vTemp.Mul(m_Params._MAX_BOUNCE_RANGE);
        m_vSlideVector.Add(vTemp);
        m_vSlideVector.Normalize();
        m_vSlideVector.Mul(m_Params._MAX_BOUNCE_RANGE);
    }

    void SupressCollVector()
    {
        float fNewValue = m_vCollisionVector.Len() - m_Params._COLL_SUPRESS * m_fFrameTime;
        if(fNewValue < 0.0F)
            fNewValue = 0.0F;
        m_vCollisionVector.Normalize();
        m_vCollisionVector.Mul(fNewValue);
    }

    void EnableBackLater()
    {
        if(m_bPhysicsCalcOnly)
        {
            return;
        } else
        {
            m_bEnableBack = false;
            m_Vehicle.EnableBackLater(m_Params._TIME_TO_GOING_BACK);
            return;
        }
    }

    void UpdateVehicleWheels()
    {
        ShiftUpDownWheels();
        if(m_bNetSimulate)
            RotateTurnWheels(m_fCurrDirAngle);
        else
            RotateTurnWheels();
        RotateRevolutionWheels();
    }

    void RotateRevolutionWheels()
    {
        m_fWheelRotationSpeed -= m_fCurrSpeed * m_Params._WHEEL_MOVE_SPEED_COEF * m_fFrameTime;
        for(int i = 0; i < m_nWheelCnt; i++)
            if(m_Wheels[i] != -1)
                m_Vehicle.RotateElement(m_Wheels[i], m_vRotateRevolution, m_fWheelRotationSpeed);

    }

    void CalculateSprings()
    {
        Vector vSuspensionDir = new Vector(m_vVehicleTNormal);
        vSuspensionDir.Mul(2.0F * m_Params._SUSPENSION_HEIGHT);
        for(int i = 0; i < m_nWheelCnt; i++)
        {
            vWheelTmp[i].Set(GetWheelBasePos(i));
            vWheelTmp[i].Add(vSuspensionDir);
        }

        vSuspensionDir.Negate();
        vSuspensionDir.Mul(2.0F);
        Vector vEnd = null;
        Collision col = null;
        for(int i = 0; i < m_nWheelCnt; i++)
        {
            vEnd = new Vector(vSuspensionDir);
            vEnd.Add(vWheelTmp[i]);
            TestTrack(vWheelTmp[i], vEnd);
            vEnd.Set(m_collInfo.vEnd);
            if(m_collInfo.coll != null)
            {
                vEnd.Sub(vWheelTmp[i]);
                m_SpringsNew[i] = (2.0F * m_Params._SUSPENSION_HEIGHT + _HALF_WHEEL_SIZE) - vEnd.Len();
            } else
            {
                m_SpringsNew[i] = m_Params._SPRING_NORMAL;
            }
        }

    }

    public void InitWheelsElements()
    {
        m_Wheels[0] = m_Vehicle.GetElementID("kolo_PP");
        m_Wheels[1] = m_Vehicle.GetElementID("kolo_LP");
        m_Wheels[2] = m_Vehicle.GetElementID("kolo_LT");
        m_Wheels[3] = m_Vehicle.GetElementID("kolo_PT");
        m_WheelsBase[0] = m_Vehicle.GetElementID("kolobase_PP");
        m_WheelsBase[1] = m_Vehicle.GetElementID("kolobase_LP");
        m_WheelsBase[2] = m_Vehicle.GetElementID("kolobase_LT");
        m_WheelsBase[3] = m_Vehicle.GetElementID("kolobase_PT");
    }

    void SetVehiclePosAndOrientation()
    {
        m_vVehicleNormal.Normalize();
        m_vVehicleRight = m_vVehicleNormal.Cross(m_vVehicleForward);
        m_vVehicleRight.Normalize();
        m_vVehicleForward = m_vVehicleRight.Cross(m_vVehicleNormal);
        m_vVehicleForward.Normalize();
        m_vVehicleTForward.Set(m_vVehicleForward);
        m_vVehicleTNormal.Set(m_vVehicleNormal);
        m_vVehicleTForward = m_Vehicle.RotateVector(m_vVehicleTForward, m_fCurrVehicleVAngle, m_vVehicleRight);
        m_vVehicleTNormal = m_Vehicle.RotateVector(m_vVehicleTNormal, m_fCurrVehicleVAngle, m_vVehicleRight);
        if(m_bMotorLikeAlign)
            m_vVehicleTNormal = m_Vehicle.RotateVector(m_vVehicleTNormal, -m_fCurrVehicleHAngle, m_vVehicleTForward);
        else
            m_vVehicleTNormal = m_Vehicle.RotateVector(m_vVehicleTNormal, m_fCurrVehicleHAngle, m_vVehicleTForward);
        m_Vehicle.FromUpForwardPos(m_vVehicleTNormal, m_vVehicleTForward, m_vVehiclePosition);
        UpdateSpringsAndWheels();
    }

    void AccelerateSmokeFX()
    {
        if(m_bPhysicsCalcOnly)
            return;
        if(m_fNowTime - m_fLastAccelFXTime > m_Params._TIME_BTW_SMOKES)
            m_fLastAccelFXTime = m_fNowTime;
        else
            return;
        if(sWheelSmokeFX != null)
        {
            m_Vehicle.ExecuteFX(sWheelSmokeFX, GetWheelFXPos(2), m_vVehicleNormal);
            m_Vehicle.ExecuteFX(sWheelSmokeFX, GetWheelFXPos(3), m_vVehicleNormal);
        }
    }

    void TurnSlideSmokeFX()
    {
        if(m_bPhysicsCalcOnly)
            return;
        if(m_fNowTime - m_fLastSlideFXTime > m_Params._TIME_BTW_SMOKES_SLIDE)
            m_fLastSlideFXTime = m_fNowTime;
        else
            return;
        if(sWheelSmokeFX != null)
        {
            for(int i = 0; i < m_nWheelCnt; i++)
                m_Vehicle.ExecuteFX(sWheelSmokeFX, GetWheelFXPos(i), m_vVehicleNormal);

        }
    }

    void Init()
    {
        InitWheelsElements();
        if(m_Wheels[0] != -1)
        {
            Vector vTemp = m_Vehicle.GetElementPos(m_Wheels[0]);
            vTemp.Sub(m_Vehicle.GetPosition());
            _HALF_WHEEL_SIZE = vTemp.fY;
        }
        InitParamsFromVehicle();
        for(int i = 0; i < _MAX_WHEELS; i++)
            vWheelTmp[i] = new Vector(0.0F, 0.0F, 0.0F);

        m_Vehicle.SetMaxClimbAngle(90F);
    }

    void AlignSpringsAndWheelsToTerrain()
    {
        CalculateSprings();
        for(int i = 0; i < m_nWheelCnt; i++)
        {
            m_Springs[i] = m_SpringsNew[i];
            if(m_Springs[i] < m_Params._SPRING_MIN)
                m_Springs[i] = m_Params._SPRING_MIN;
            if(m_Springs[i] > m_Params._SPRING_MAX)
                m_Springs[i] = m_Params._SPRING_MAX;
        }

        ShiftUpDownWheels();
    }

    void PlaySoundHit()
    {
        if(m_bPhysicsCalcOnly)
        {
            return;
        } else
        {
            m_Vehicle.HitSound();
            m_fLastCollisionSound = m_fNowTime;
            return;
        }
    }

    void SetCurrMaxSpeed(float fValue)
    {
        m_Params._CURR_MAX_SPEED = fValue;
        if(m_Params.GetMaxSpeed() < fValue)
            m_Params.SetMaxSpeed(fValue);
    }

    void AlignToUp()
    {
        Vector vProduct = new Vector(Vector.Up);
        vProduct.Mul(m_Params._UP_FLY_ALIGN_INERTIA * m_fFrameTime);
        vProduct.Add(m_vVehicleNormal);
        vProduct.Normalize();
        m_vVehicleNormal.Set(vProduct);
    }

    void InitParamsFromVehicle()
    {
        m_vVehicleNormal = new Vector(m_Vehicle.GetUpVector());
        m_vVehicleForward = m_Vehicle.GetForwardVector();
        m_vVehicleRight = m_Vehicle.GetRightVector();
        m_vVehicleTForward = new Vector(m_vVehicleForward);
        m_vVehicleTNormal = new Vector(m_vVehicleNormal);
        m_vVehiclePosition = m_Vehicle.GetPosition();
        m_fLastYPos = m_vVehiclePosition.fY;
    }

    void TurnVehicle()
    {
        if(m_Vehicle.m_bIsPatrolling)
        {
            Vector vUp = new Vector(m_vVehicleRight);
            if(m_fCurrSpeed < 0.0F)
                vUp.Negate();
            vUp = m_vVehicleForward.Cross(vUp);
            m_vVehicleForward = m_Vehicle.RotateVector(m_vVehicleForward, -m_fCurrDirAngle * m_fFrameTime, vUp);
            m_fAngleSpeed = -m_fCurrDirAngle;
            if(m_fCurrSpeed < 0.0F)
                m_fAngleSpeed *= -1F;
        } else
        {
            float fSpeedCoef = GetSpeedToTurnCoeff(m_fCurrSpeed);
            Vector vUp = new Vector(m_vVehicleRight);
            if(m_fCurrSpeed < 0.0F)
                vUp.Negate();
            vUp = m_vVehicleForward.Cross(vUp);
            m_vVehicleForward = m_Vehicle.RotateVector(m_vVehicleForward, -m_fCurrDirAngle * m_fFrameTime * fSpeedCoef * m_Params._COEFF_TURN, vUp);
            m_fAngleSpeed = -m_fCurrDirAngle * fSpeedCoef * m_Params._COEFF_TURN;
            if(m_fCurrSpeed < 0.0F)
                m_fAngleSpeed *= -1F;
        }
    }

    float GetCurrMaxSpeed()
    {
        return m_Params._CURR_MAX_SPEED;
    }

    Vector GetWheelBasePos(int nWheel)
    {
        if(m_WheelsBase[nWheel] != -1)
            return m_Vehicle.GetElementPos(m_WheelsBase[nWheel]);
        else
            return m_Vehicle.GetPosition();
    }

    Vector GetWheelBaseLocalPos(int nWheel)
    {
        if(m_WheelsBase[nWheel] != -1)
            return m_Vehicle.GetElementLocalPos(m_WheelsBase[nWheel]);
        else
            return Vector.Zero;
    }

    void MovieSimulate(float fSpeed, float fAngleSpeed, float fDeltaTime)
    {
        float fSpeedDiff = fSpeed - m_fCurrSpeed;
        m_fCurrSpeed = fSpeed;
        m_fFrameTime = fDeltaTime;
        m_fNowTime += m_fFrameTime;
        boolean bSlide = false;
        boolean bAccel = false;
        boolean bBrake = false;
        boolean bFX = false;
        if(fSpeedDiff / fDeltaTime > 600F)
            bAccel = true;
        if(fSpeedDiff / fDeltaTime < -600F)
            bBrake = true;
        m_fCurrDirAngle = fAngleSpeed;
        if(m_fCurrDirAngle > m_Params._MAX_TURN_ANGLE)
            m_fCurrDirAngle = m_Params._MAX_TURN_ANGLE;
        if(m_fCurrDirAngle < -m_Params._MAX_TURN_ANGLE)
            m_fCurrDirAngle = -m_Params._MAX_TURN_ANGLE;
        if(m_fCurrDirAngle > 0.0F)
            m_fTurnRight = m_fCurrDirAngle / m_Params._MAX_TURN_ANGLE;
        else
            m_fTurnLeft = -m_fCurrDirAngle / m_Params._MAX_TURN_ANGLE;
        float fCoeff = Math.abs((m_Params._MAX_TURN_ANGLE - m_fCurrDirAngle) * fSpeed) / m_Params.GetMaxSpeed();
        if(fCoeff > 60F)
            bSlide = true;
        Vector vProduct = CalculateNewNormal();
        if(vProduct.Len2() != 0.0F)
        {
            vProduct.Mul(m_Params._GROUND_ALIGN_INERTIA * m_fFrameTime);
            m_vVehicleNormal.Mul(m_Params._NORMAL_INTERPOLATION_COEFF);
            vProduct.Add(m_vVehicleNormal);
            vProduct.Normalize();
            m_vVehicleNormal.Set(vProduct);
            m_vVehicleTNormal.Set(m_vVehicleNormal);
        }
        if(bSlide)
        {
            TurnSlideSmokeFX();
            PlaySoundSlide();
            bFX = true;
        }
        if(bAccel)
        {
            AccelerateSmokeFX();
            PlaySoundAccel();
            bFX = true;
        }
        if(bBrake)
        {
            BrakeSmokeFX();
            PlaySoundBrake();
            bFX = true;
        }
        if(!bFX && bWheelSmokeFX && Math.abs(m_fCurrSpeed) > 10F)
            WheelSmokeFX();
        UpdateSounds();
        m_fCurrDirAngle *= m_fMovieWheelsAngleMult;
        UpdateSpringsAndWheels();
    }

    void UpdateVehiclePhysics()
    {
        m_bIsFlyingOnFrame = false;
        if(m_fCurrDirAngle != 0.0F)
            DecreaseTurning();
        if(m_vTurningSlide.Len2() > 0.0F)
        {
            DecreaseTurnSlide();
            if(m_vTurningSlide.Len() > m_Params._SLIDE_SMOKE_COEF)
            {
                TurnSlideSmokeFX();
                PlaySoundSlide();
            }
        }
        if(m_fCurrDirAngle != 0.0F && m_fCurrSpeed != 0.0F && !m_bFlying)
            AddSlideFromTurning();
        if(m_fCurrDirAngle != 0.0F && m_fCurrSpeed != 0.0F && m_fFlyingTime < m_Params._REAL_FLY_TIME_CONTROL)
            TurnVehicle();
        else
            m_fAngleSpeed = 0.0F;
        if(m_vSlideVector.Len2() > 0.0F)
        {
            SlowDown();
            DecreaseSlide();
        }
        if(m_vCollisionVector.Len2() > 0.0F)
            SupressCollVector();
        MoveVehicle();
        if(m_fAccelerate > 0.0F && !m_bFlying && m_fCurrSpeed > 0.0F && m_fCurrSpeed < m_Params.GetMaxSpeed() / 20F)
            AccelerateSmokeFX();
        if(m_fAccelerate > 0.0F && !m_bFlying && m_fCurrSpeed < 0.0F)
            BrakeSmokeFX();
        if(m_fBrake > 0.0F && !m_bFlying && m_fCurrSpeed > 0.0F)
            BrakeSmokeFX();
        UpdateSounds();
        if(!m_bFlying && !m_bIsFlyingOnFrame)
        {
            if(m_fAccelerate > 0.0F)
                AccelVAngle(true);
            if(m_fBrake > 0.0F)
                AccelVAngle(false);
            if(m_fAccelerate == 0.0F && m_fBrake == 0.0F)
                DecreaseVehicleVAngle();
        }
        if(!m_bFlying)
        {
            if(m_fTurnLeft > 0.0F)
                TurnRightHAngle(false);
            else
            if(m_fTurnRight > 0.0F)
                TurnRightHAngle(true);
            else
                DecreaseVehicleHAngle();
        } else
        {
            DecreaseVehicleHAngle();
        }
        if(m_bFlying)
        {
            FallDown();
            DecreaseVehicleVAngle();
        } else
        if(!m_bIsFlyingOnFrame)
        {
            m_fFlyingTime = 0.0F;
            Vector vProduct = null;
            if(m_vMoveDir.Len() > 1.0F)
                vProduct = CalculateNewNormal();
            else
                vProduct = new Vector(m_vVehicleNormal);
            if(vProduct.Len2() == 0.0F)
            {
                SetVehiclePosAndOrientation();
                return;
            }
            vProduct.Mul(m_Params._GROUND_ALIGN_INERTIA * m_fFrameTime);
            m_vVehicleNormal.Mul(m_Params._NORMAL_INTERPOLATION_COEFF);
            vProduct.Add(m_vVehicleNormal);
            vProduct.Normalize();
            m_vVehicleNormal.Set(vProduct);
        } else
        {
            AlignToUp();
            m_fFlyingTime += m_fFrameTime;
            if(m_fFlyingTime > m_Params._REAL_FLY_TIME)
                m_bFlying = true;
        }
        SetVehiclePosAndOrientation();
    }

    void Clear()
    {
        m_fAccelerate = 0.0F;
        m_fBrake = 0.0F;
        m_fTurnRight = 0.0F;
        m_fTurnLeft = 0.0F;
        m_fFlyingTime = 0.0F;
        m_fCurrSpeed = 0.0F;
        m_fCurrDirAngle = 0.0F;
        m_fMoveSpeed = 0.0F;
        m_vTurningSlide.Set(Vector.Zero);
        RotateTurnWheels(0.0F);
        m_fFrameTime = 0.0F;
    }

    void TakeCollisionDamage(float fSpeed)
    {
        if(m_bPhysicsCalcOnly)
            return;
        float fDamageCoeff = m_Params._DAMAGE_COEFF_SAFE_COLLISION;
        if(fSpeed > m_Params._MAX_SPEED_TO_SAFE_COLLISION || fSpeed < -m_Params._MAX_SPEED_TO_SAFE_COLLISION)
            fDamageCoeff = m_Params._DAMAGE_COEFF_HARD_COLLISION;
        if(m_Vehicle.m_bLocalPlayerDriver && ((GameObject) (m_Vehicle)).Role < 4)
            m_Vehicle.MsgSendServerVehicleCollision(((Actor) (m_Vehicle)).fMaxHealth * fDamageCoeff);
        else
        if(m_Vehicle.m_bLocalPlayerDriver && ((GameObject) (m_Vehicle)).Role == 4)
            m_Vehicle.TakeDamage(((Actor) (m_Vehicle)).fMaxHealth * fDamageCoeff, EnumDamageType._BULLET);
    }

    void UpdateSpringsAndWheels()
    {
        if(m_bPhysicsCalcOnly)
        {
            return;
        } else
        {
            CalculateSprings();
            AlignSprings();
            UpdateVehicleWheels();
            return;
        }
    }

    void ShiftUpDownWheels()
    {
        Vector vPos = new Vector();
        for(int i = 0; i < m_nWheelCnt; i++)
        {
            vPos.Set(GetWheelBaseLocalPos(i));
            vPos.fZ -= m_Springs[i];
            if(m_Wheels[i] != -1)
                m_Vehicle.FromUpForwardPosElement(m_Wheels[i], m_vShiftUp, m_vShiftForward, vPos);
        }

    }

    void SlowDown()
    {
        float fValue = (m_Params._SLIDE_SPEED_COEF * m_vSlideVector.Len()) / m_Params._MAX_BOUNCE_RANGE;
        if(m_fCurrSpeed >= 0.0F)
        {
            m_fCurrSpeed -= m_fCurrSpeed * m_fFrameTime * fValue;
            if(m_fCurrSpeed < 0.0F)
                m_fCurrSpeed = 0.0F;
        } else
        {
            m_fCurrSpeed -= m_fCurrSpeed * m_fFrameTime * fValue;
            if(m_fCurrSpeed > 0.0F)
                m_fCurrSpeed = 0.0F;
        }
    }

    void FallDown()
    {
        Vector vStart = new Vector(m_vVehicleNormal);
        vStart.Mul(m_Params._SUSPENSION_HEIGHT);
        vStart.Add(m_vVehiclePosition);
        Vector vEnd = new Vector(m_vVehiclePosition);
        vEnd.Sub(vStart);
        vEnd.Mul(2.2F + _HEIGHT_OVER_GROUND);
        vEnd.Add(vStart);
        if(m_bLanding)
        {
            m_fLandingTime -= m_fFrameTime;
            if(m_fLandingTime <= 0.0F)
            {
                m_fLandingTime = 0.0F;
                m_fFlyingTime = 0.0F;
                m_bFlying = false;
                m_bLanding = false;
                return;
            }
        }
        TestTrack(vStart, vEnd);
        vEnd.Set(m_collInfo.vEnd);
        if(m_collInfo.coll != null)
        {
            vEnd.fY += _HEIGHT_OVER_GROUND;
            if(!m_bLanding)
            {
                m_bLanding = true;
                m_fLandingTime = m_Params._MAX_LANDING_TIME;
            }
            Vector vProduct = CalculateNewNormal();
            if(vProduct.Len2() == 0.0F)
            {
                AlignToUp();
                return;
            }
            vProduct.Mul(m_Params._GROUND_FLY_ALIGN_INERTIA * m_fFrameTime);
            vProduct.Add(m_vVehicleNormal);
            vProduct.Normalize();
            m_vVehicleNormal.Set(vProduct);
        } else
        {
            AlignToUp();
            vEnd.fY += _HEIGHT_OVER_GROUND;
        }
    }

    public void HandlePawnCollision(Pawn obj, Vector vNormal, Vector vMove, float fSpeed, Vector vPoint)
    {
        if(obj instanceof NewAIWalker)
        {
            HandleDetectedCollision(vMove, false);
            return;
        }
        if(m_bPhysicsCalcOnly)
            return;
        if(Math.abs(fSpeed) <= 500F)
            return;
        vMove.Normalize();
        Vector vToPlayerDir = new Vector(obj.GetPosition());
        vToPlayerDir.Sub(m_Vehicle.GetPosition());
        vToPlayerDir.fY = 0.0F;
        vToPlayerDir.Normalize();
        Vector vMoveDir = new Vector(vMove);
        vMoveDir.fY = 0.0F;
        vMoveDir.Normalize();
        if(vMoveDir.Dot(vToPlayerDir) <= 0.0F)
            return;
        vMove.Mul(fSpeed);
        m_vMoveDir.Set(vMove);
        m_vMoveDir.Mul(m_fFrameTime);
        float fDamage = ((Actor) (obj)).fMaxHealth;
        float fHitStrength = Math.abs(fSpeed) * m_Params._PAWN_HIT_COEF;
        if(fDamage < fHitStrength)
            fDamage = fHitStrength;
        obj.OnVehicleCollision(fDamage, m_Vehicle.GetFirstOccupant(0), null, vMove);
        if(obj instanceof Player)
            m_Vehicle.OnCollisionWithPlayer();
    }

    void PlaySoundBrake()
    {
        if(m_bPhysicsCalcOnly)
            return;
        if(m_fNowTime - m_fBrakePressTime > m_Params._TIME_BETWEEN_BRAKE_SOUNDS)
        {
            m_Vehicle.BrakeSound();
            m_fBrakePressTime = m_fNowTime;
        }
    }

    PhysicsVehicle()
    {
        _MAX_WHEELS = 8;
        _DEFAULT_WHEELS = 4;
        m_nWheelCnt = _DEFAULT_WHEELS;
        m_nWheelBaseCnt = _DEFAULT_WHEELS;
        m_fFrameTime = 0.0F;
        m_fNowTime = 2.0F;
        _HALF_WHEEL_SIZE = 0.0F;
        _HEIGHT_OVER_GROUND = 0.0F;
        m_Params = null;
        m_fFlyingTime = 0.0F;
        m_fLandingTime = 0.0F;
        m_bEnableBack = true;
        m_vSlideVector = new Vector(0.0F, 0.0F, 0.0F);
        m_fAccelerate = 0.0F;
        m_fBrake = 0.0F;
        m_fTurnLeft = 0.0F;
        m_fTurnRight = 0.0F;
        m_fCurrSpeed = 0.0F;
        m_fCurrGravity = 0.0F;
        m_fCurrDirAngle = 0.0F;
        m_bIsFlyingOnFrame = false;
        vWheelTmp = new Vector[_MAX_WHEELS];
        m_Springs = new float[8];
        m_SpringsNew = new float[8];
        m_fWheelRotationSpeed = 0.0F;
        m_bFlying = false;
        m_bLanding = false;
        m_vTurningSlide = new Vector(0.0F, 0.0F, 0.0F);
        m_fCurrVehicleHAngle = 0.0F;
        m_fCurrVehicleVAngle = 0.0F;
        m_vVehicleNormal = null;
        m_vVehicleForward = null;
        m_vVehicleRight = null;
        m_vVehicleTForward = null;
        m_vVehicleTNormal = null;
        m_vVehiclePosition = null;
        m_vCollisionVector = null;
        m_vMoveDir = null;
        m_bGotCollision = false;
        m_fLastAccelFXTimeStart = 0.0F;
        m_fLastAccelFXTime = 0.0F;
        m_fLastBrakeFXTime = 0.0F;
        m_fLastSlideFXTime = 0.0F;
        m_fLastWheelFXTime = 0.0F;
        m_Vehicle = null;
        m_fHitTurnAngle = 0.0F;
        m_fBrakePressTime = 0.0F;
        m_fLastCollisionSound = 0.0F;
        m_fLastSlideSound = 0.0F;
        m_fLastAccelSound = 0.0F;
        m_fMoveSpeed = 0.0F;
        m_fRealSpeed = 0.0F;
        m_fRealAccel = 0.0F;
        m_collInfo = new CollInfo();
        m_bCheckCollision = false;
        sWheelSmokeFX = "Smoke";
        bWheelSmokeFX = false;
        bWheelSmokeRearOnly = false;
        fWheelSmokeShiftY = 0.0F;
        m_fMinDirAngleSlide = 60F;
        m_bMotorLikeAlign = false;
        m_fTurnInPathMove = 0.0F;
        m_bRecalculateMove = false;
        m_fMovieWheelsAngleMult = 1.0F;
        m_bFlyOverWater = false;
        m_fLastYPos = 0.0F;
        m_bNetPawnCollision = false;
        m_fAngleSpeed = 0.0F;
        m_bNetSimulate = false;
        vMoveDir = new Vector();
        vTemp1 = new Vector();
        vTemp2 = new Vector();
        _TERRAIN_TEST_LEN = 100F;
        m_vShiftUp = new Vector(0.0F, 1.0F, 0.0F);
        m_vShiftForward = new Vector(0.0F, 0.0F, 1.0F);
        m_vRotateTurn = new Vector(0.0F, 0.0F, -1F);
        m_vRotateRevolution = new Vector(0.0F, -1F, 0.0F);
        m_PhysicsState = null;
        m_bPhysicsCalcOnly = false;
    }

    PhysicsVehicle(Vehicle vehicle)
    {
        _MAX_WHEELS = 8;
        _DEFAULT_WHEELS = 4;
        m_nWheelCnt = _DEFAULT_WHEELS;
        m_nWheelBaseCnt = _DEFAULT_WHEELS;
        m_fFrameTime = 0.0F;
        m_fNowTime = 2.0F;
        _HALF_WHEEL_SIZE = 0.0F;
        _HEIGHT_OVER_GROUND = 0.0F;
        m_Params = null;
        m_fFlyingTime = 0.0F;
        m_fLandingTime = 0.0F;
        m_bEnableBack = true;
        m_vSlideVector = new Vector(0.0F, 0.0F, 0.0F);
        m_fAccelerate = 0.0F;
        m_fBrake = 0.0F;
        m_fTurnLeft = 0.0F;
        m_fTurnRight = 0.0F;
        m_fCurrSpeed = 0.0F;
        m_fCurrGravity = 0.0F;
        m_fCurrDirAngle = 0.0F;
        m_bIsFlyingOnFrame = false;
        vWheelTmp = new Vector[_MAX_WHEELS];
        m_Springs = new float[8];
        m_SpringsNew = new float[8];
        m_fWheelRotationSpeed = 0.0F;
        m_bFlying = false;
        m_bLanding = false;
        m_vTurningSlide = new Vector(0.0F, 0.0F, 0.0F);
        m_fCurrVehicleHAngle = 0.0F;
        m_fCurrVehicleVAngle = 0.0F;
        m_vVehicleNormal = null;
        m_vVehicleForward = null;
        m_vVehicleRight = null;
        m_vVehicleTForward = null;
        m_vVehicleTNormal = null;
        m_vVehiclePosition = null;
        m_vCollisionVector = null;
        m_vMoveDir = null;
        m_bGotCollision = false;
        m_fLastAccelFXTimeStart = 0.0F;
        m_fLastAccelFXTime = 0.0F;
        m_fLastBrakeFXTime = 0.0F;
        m_fLastSlideFXTime = 0.0F;
        m_fLastWheelFXTime = 0.0F;
        m_Vehicle = null;
        m_fHitTurnAngle = 0.0F;
        m_fBrakePressTime = 0.0F;
        m_fLastCollisionSound = 0.0F;
        m_fLastSlideSound = 0.0F;
        m_fLastAccelSound = 0.0F;
        m_fMoveSpeed = 0.0F;
        m_fRealSpeed = 0.0F;
        m_fRealAccel = 0.0F;
        m_collInfo = new CollInfo();
        m_bCheckCollision = false;
        sWheelSmokeFX = "Smoke";
        bWheelSmokeFX = false;
        bWheelSmokeRearOnly = false;
        fWheelSmokeShiftY = 0.0F;
        m_fMinDirAngleSlide = 60F;
        m_bMotorLikeAlign = false;
        m_fTurnInPathMove = 0.0F;
        m_bRecalculateMove = false;
        m_fMovieWheelsAngleMult = 1.0F;
        m_bFlyOverWater = false;
        m_fLastYPos = 0.0F;
        m_bNetPawnCollision = false;
        m_fAngleSpeed = 0.0F;
        m_bNetSimulate = false;
        vMoveDir = new Vector();
        vTemp1 = new Vector();
        vTemp2 = new Vector();
        _TERRAIN_TEST_LEN = 100F;
        m_vShiftUp = new Vector(0.0F, 1.0F, 0.0F);
        m_vShiftForward = new Vector(0.0F, 0.0F, 1.0F);
        m_vRotateTurn = new Vector(0.0F, 0.0F, -1F);
        m_vRotateRevolution = new Vector(0.0F, -1F, 0.0F);
        m_PhysicsState = null;
        m_bPhysicsCalcOnly = false;
        m_Vehicle = vehicle;
        VehicleParams params = new VehicleParams();
        SetVehicleParams(params);
        m_fCurrGravity = 0.0F;
        m_vCollisionVector = new Vector(0.0F, 0.0F, 0.0F);
        m_vMoveDir = new Vector(m_Vehicle.GetForwardVector());
    }

    void WheelSmokeFX()
    {
        if(m_bPhysicsCalcOnly)
            return;
        if(m_fNowTime - m_fLastWheelFXTime > m_Params._TIME_BTW_SMOKES)
            m_fLastWheelFXTime = m_fNowTime;
        else
            return;
        if(sWheelSmokeFX != null)
            if(bWheelSmokeRearOnly)
            {
                m_Vehicle.ExecuteFX(sWheelSmokeFX, GetWheelFXPos(2), m_vVehicleNormal);
                m_Vehicle.ExecuteFX(sWheelSmokeFX, GetWheelFXPos(3), m_vVehicleNormal);
            } else
            {
                for(int i = 0; i < m_nWheelCnt; i++)
                    m_Vehicle.ExecuteFX(sWheelSmokeFX, GetWheelFXPos(i), m_vVehicleNormal);

            }
    }

    void EnableBack()
    {
        m_bEnableBack = true;
    }

    void TurnRightHAngle(boolean bRight)
    {
        if(m_fCurrSpeed == 0.0F)
        {
            DecreaseVehicleHAngle();
            return;
        }
        if(bRight)
        {
            m_fCurrVehicleHAngle -= (Math.abs(m_fCurrSpeed) / m_Params.GetMaxSpeed()) * m_fFrameTime * m_Params._HORIZ_DEV_ACCEL;
            if(m_fCurrVehicleHAngle < -m_Params._MAX_HORIZ_DEV)
                m_fCurrVehicleHAngle = -m_Params._MAX_HORIZ_DEV;
        } else
        {
            m_fCurrVehicleHAngle += (Math.abs(m_fCurrSpeed) / m_Params.GetMaxSpeed()) * m_fFrameTime * m_Params._HORIZ_DEV_ACCEL;
            if(m_fCurrVehicleHAngle > m_Params._MAX_HORIZ_DEV)
                m_fCurrVehicleHAngle = m_Params._MAX_HORIZ_DEV;
        }
    }

    void TestTrack(Vector vStart, Vector vEnd)
    {
        float fTerrainHeight = m_Vehicle.TerrainHeight(vStart.fX, vStart.fZ);
        if(vStart.fY <= fTerrainHeight)
        {
            GameObject.LogLine("Autko juz jest pod ziemia!!!! Wyciagamy!!! ");
            vStart.fY = fTerrainHeight + 20F;
        }
        TestTrackNoCheckTerrainHeight(vStart, vEnd);
    }

    void RestorePhysicsState()
    {
        m_bPhysicsCalcOnly = false;
        m_PhysicsState.RestorePhysicsState(this);
    }

    void AccelVAngle(boolean bAccel)
    {
        if(m_fCurrSpeed == 0.0F)
        {
            DecreaseVehicleVAngle();
            return;
        }
        float fCoef = m_fCurrSpeed;
        if(bAccel)
        {
            m_fCurrVehicleVAngle -= m_fFrameTime * m_Params._VERT_DEV_ACCEL;
            if(fCoef < 0.0F)
                fCoef = 0.0F;
            if(m_fCurrVehicleVAngle < -m_Params._MAX_VERT_DEV * (1.0F - fCoef / m_Params.GetMaxSpeed()))
                m_fCurrVehicleVAngle = -m_Params._MAX_VERT_DEV * (1.0F - fCoef / m_Params.GetMaxSpeed());
        } else
        {
            m_fCurrVehicleVAngle += m_fFrameTime * m_Params._VERT_DEV_ACCEL;
            if(fCoef > 0.0F)
                fCoef = 0.0F;
            if(m_fCurrVehicleVAngle > m_Params._MAX_VERT_DEV * (1.0F - fCoef / m_Params._MIN_SPEED))
                m_fCurrVehicleVAngle = m_Params._MAX_VERT_DEV * (1.0F - fCoef / m_Params._MIN_SPEED);
        }
    }

    int _MAX_WHEELS;
    int _DEFAULT_WHEELS;
    int m_nWheelCnt;
    int m_nWheelBaseCnt;
    float m_fFrameTime;
    float m_fNowTime;
    final float _FALL_DOWN_TEST_COEF = 0.2F;
    float _HALF_WHEEL_SIZE;
    static final float _CORRECTION = 0.01F;
    float _HEIGHT_OVER_GROUND;
    VehicleParams m_Params;
    float m_fFlyingTime;
    float m_fLandingTime;
    boolean m_bEnableBack;
    Vector m_vSlideVector;
    float m_fAccelerate;
    float m_fBrake;
    float m_fTurnLeft;
    float m_fTurnRight;
    float m_fCurrSpeed;
    float m_fCurrGravity;
    float m_fCurrDirAngle;
    boolean m_bIsFlyingOnFrame;
    int m_Wheels[] = {
        -1, -1, -1, -1, -1, -1, -1, -1
    };
    int m_WheelsBase[] = {
        -1, -1, -1, -1, -1, -1, -1, -1
    };
    Vector vWheelTmp[];
    float m_Springs[];
    float m_SpringsNew[];
    float m_fWheelRotationSpeed;
    boolean m_bFlying;
    boolean m_bLanding;
    Vector m_vTurningSlide;
    float m_fCurrVehicleHAngle;
    float m_fCurrVehicleVAngle;
    Vector m_vVehicleNormal;
    Vector m_vVehicleForward;
    Vector m_vVehicleRight;
    Vector m_vVehicleTForward;
    Vector m_vVehicleTNormal;
    Vector m_vVehiclePosition;
    Vector m_vCollisionVector;
    Vector m_vMoveDir;
    boolean m_bGotCollision;
    float m_fLastAccelFXTimeStart;
    float m_fLastAccelFXTime;
    float m_fLastBrakeFXTime;
    float m_fLastSlideFXTime;
    float m_fLastWheelFXTime;
    Vehicle m_Vehicle;
    float m_fHitTurnAngle;
    float m_fBrakePressTime;
    float m_fLastCollisionSound;
    float m_fLastSlideSound;
    float m_fLastAccelSound;
    float m_fMoveSpeed;
    float m_fRealSpeed;
    float m_fRealAccel;
    CollInfo m_collInfo;
    boolean m_bCheckCollision;
    String sWheelSmokeFX;
    boolean bWheelSmokeFX;
    boolean bWheelSmokeRearOnly;
    float fWheelSmokeShiftY;
    float m_fMinDirAngleSlide;
    boolean m_bMotorLikeAlign;
    float m_fTurnInPathMove;
    boolean m_bRecalculateMove;
    float m_fMovieWheelsAngleMult;
    boolean m_bFlyOverWater;
    float m_fLastYPos;
    boolean m_bNetPawnCollision;
    float m_fAngleSpeed;
    boolean m_bNetSimulate;
    Vector vMoveDir;
    Vector vTemp1;
    Vector vTemp2;
    float _TERRAIN_TEST_LEN;
    Vector m_vShiftUp;
    Vector m_vShiftForward;
    Vector m_vRotateTurn;
    Vector m_vRotateRevolution;
    VehiclePhysicsState m_PhysicsState;
    boolean m_bPhysicsCalcOnly;
}
