// Decompiled by Jad v1.5.8g. Copyright 2001 Pavel Kouznetsov.
// Jad home page: http://www.kpdus.com/jad.html
// Decompiler options: packimports(3) 
// Source File Name:   PlayerNetBaseDriver.java


public class PlayerNetBaseDriver extends PlayerNetBaseMover
{

    void ActionGetIn(int nSeatVehicleToGetIn, int nSeatIndex)
    {
        GameObject cObject = GetObjectByNetId(nSeatVehicleToGetIn);
        if(cObject == null)
        {
            NetLog.Error("ActionGetIn cObject == null");
            return;
        }
        if(!(cObject instanceof ISeatVehicle))
        {
            NetLog.Error("ActionGetIn " + GetDriverInfo() + " obj:" + cObject + " is not instanceof ISeatVehicle");
            return;
        }
        ISeatVehicle cSeatVehicle = (ISeatVehicle)cObject;
        SeatInfo aSeats[] = cSeatVehicle.GetSeats();
        SeatInfo cSeatInfo = aSeats == null || aSeats.length <= nSeatIndex ? null : aSeats[nSeatIndex];
        if(cSeatInfo == null)
        {
            NetLog.Error("ActionGetIn cSeatInfo == null");
            return;
        } else
        {
            ActionGetIn(cSeatInfo);
            return;
        }
    }

    void ActionGetIn(SeatInfo cSeat)
    {
        if(!(cSeat.GetOccupiedObject() instanceof ISeatVehicle))
        {
            NetLog.PlayerDriver("GET_IN canceled " + GetDriverInfo() + " because " + (cSeat.GetOccupiedObject() == null ? "cSeat.GetOccupiedObject()==null" : cSeat.GetOccupiedObject().GetNetInfo() + " is not ISeatVehicle"));
            return;
        }
        ISeatVehicle cSeatVehicle = (ISeatVehicle)cSeat.GetOccupiedObject();
        super.m_nSeatVehicleToGetInOut = cSeatVehicle.GetNetId();
        SeatInfo aSeats[] = cSeatVehicle.GetSeats();
        super.m_nSeatIndexToGetInOut = -1;
        if(aSeats != null)
        {
            for(int i = 0; i < aSeats.length; i++)
            {
                if(aSeats[i] != cSeat)
                    continue;
                super.m_nSeatIndexToGetInOut = i;
                break;
            }

        }
        if(super.Role == 4)
        {
            if(cSeatVehicle instanceof Vehicle)
            {
                Vehicle cVehicle = (Vehicle)cSeatVehicle;
                if(!cVehicle.DoesCanDrive())
                    return;
                if(cVehicle.m_bTeamExclusive)
                {
                    Pawn aOccupants[] = cVehicle.GetAllOccupants();
                    if(aOccupants != null)
                    {
                        Pawn cPawn = aOccupants[0];
                        if(cPawn instanceof PlayerNet)
                        {
                            PlayerNet cPlayer = (PlayerNet)cPawn;
                            if(GetPlayerInfo().GetTeamId() != cPlayer.GetPlayerInfo().GetTeamId())
                                return;
                        }
                    }
                }
            }
            if(super.bNetIsOwner)
            {
                super.m_cSeatToGetInOut = cSeat;
            } else
            {
                aSeats = cSeatVehicle.GetSeats();
                super.m_cSeatToGetInOut = aSeats == null || aSeats.length <= super.m_nSeatIndexToGetInOut ? null : aSeats[super.m_nSeatIndexToGetInOut];
                if(super.nFiringState != 0)
                {
                    NetLog.PlayerDriver("GET_IN canceled " + GetDriverInfo() + " because nFiringState == " + super.nFiringState);
                    return;
                }
            }
            NetLog.PlayerDriver("GET_IN " + GetDriverInfo() + "\n vehicle: " + GetNetInfo(cSeatVehicle) + "\n seat: " + super.m_cSeatToGetInOut.GetNetInfo());
            super.ActionGetInDo();
            if(super.m_cSeatToGetInOut.GetOccupant() == this)
            {
                NetLog.PlayerDriver("GET_IN success -> sendclient " + GetDriverInfo());
                MsgSendClientAction(5, super.m_nSeatVehicleToGetInOut, super.m_nSeatIndexToGetInOut, GetNextGlobalDriverCounter());
            } else
            {
                NetLog.PlayerDriver("GET_IN failed " + GetDriverInfo());
            }
        } else
        {
            NetLog.PlayerDriver("GET_IN sendrequest " + GetDriverInfo() + "\n vehicle " + GetNetInfo(cSeatVehicle) + "\n seat " + cSeat.GetNetInfo());
            MsgSendServerActionRequest(5, super.m_nSeatVehicleToGetInOut, super.m_nSeatIndexToGetInOut);
        }
    }

    void MsgSendServerVehicleCollision(GameObject Assassin)
    {
        MessageNew(25);
        MessagePackInt(Assassin.GetNetId());
        MessageSend();
    }

    void SetupAnimsAndCamerasToGetOut()
    {
        if(ModuleNet.IsGameGoing())
            super.SetupAnimsAndCamerasToGetOut();
    }

    void VehicleCrashed()
    {
        PlayerNet cAssassin = null;
        float fDamage = -1F;
        if(super.Role == 4 && sm_bDamageOnVehicleCrashed)
        {
            Vehicle cVehicle = null;
            if(super.cSeatInfo != null && (super.cSeatInfo.GetOccupiedObject() instanceof Vehicle))
            {
                cVehicle = (Vehicle)super.cSeatInfo.GetOccupiedObject();
                if(cVehicle != null)
                {
                    fDamage = super.fMaxHealth * cVehicle.GetOccupantsDamageMaxHealthMulOnCrash();
                    cAssassin = cVehicle.GetPlayerNetAssassin();
                }
            }
        }
        super.VehicleCrashed();
        if(super.Role == 4 && fDamage > 0.0F)
            TakeDamage(fDamage, fDamage, cAssassin, null, null, -1, EnumDamageType._BULLET);
    }

    public PlayerNetBaseDriver()
    {
        METHOD_ActionGetInDo = 0;
        m_cDriverCounter = new ChangeStateCounter(this);
        m_bGetInOutFromServer = false;
        m_fTryToCheckCollisionTimeOut = 0.0F;
        m_nTryToCheckCollisionSenderId = -1;
        m_cTryToCheckCollisionAssassin = null;
    }

    static void CleanGlobalDriverCounter()
    {
        sm_cGlobalDriverCounter.Clean();
    }

    int GetDriverCounter()
    {
        return m_cDriverCounter.Get();
    }

    void MsgSendClientVehicleCollisionAnswer(int nSenderId, boolean bPlayerDied)
    {
        MessageNew(26);
        MessagePackBoolean(bPlayerDied);
        MessageSendHost(nSenderId);
    }

    public void OnVehicleCollision(float fDamage, GameObject Assassin, Vector vHitLocation, Vector vSpeed)
    {
        if(super.Role < 4)
        {
            ClearFlag(32);
            MsgSendServerVehicleCollision(Assassin);
        }
        OnTakeDamage(fDamage, fDamage, Assassin, vHitLocation, vSpeed, -1, EnumDamageType._BLAST);
    }

    void MsgRecvServerVehicleCollision()
    {
        int nSenderId = MessageGetSenderId();
        int nAssasinId = MessageUnPackInt();
        MessageEnd();
        m_fTryToCheckCollisionTimeOut = GetTime() + 1.0F;
        m_nTryToCheckCollisionSenderId = nSenderId;
        m_cTryToCheckCollisionAssassin = GetObjectByNetId(nAssasinId);
        TryToCheckCollision();
    }

    void TryToCheckCollision()
    {
        if(super.fHealth <= 0.0F)
        {
            MsgSendClientVehicleCollisionAnswer(m_nTryToCheckCollisionSenderId, true);
            return;
        }
        if(GetTime() < m_fTryToCheckCollisionTimeOut)
            CallMethodIn("TryToCheckCollision", 0.1F);
        else
            MsgSendClientVehicleCollisionAnswer(m_nTryToCheckCollisionSenderId, false);
    }

    void ActionGetInDo()
    {
        DisableCallMethod(METHOD_ActionGetInDo);
        if(super.m_nSeatVehicleToGetInOut == -1)
        {
            NetLog.Error("ActionGetInDo " + GetDriverInfo() + " m_nSeatVehicleToGetInOut == -1");
            return;
        }
        GameObject cObject = GetObjectByNetId(super.m_nSeatVehicleToGetInOut);
        if(cObject == null)
        {
            CallMethodIn(METHOD_ActionGetInDo, 0.1F);
            return;
        }
        if(!(cObject instanceof ISeatVehicle))
        {
            NetLog.Error("ActionGetInDo " + GetDriverInfo() + " obj:" + cObject + " is not instanceof ISeatVehicle");
            return;
        }
        ISeatVehicle cSeatVehicle = (ISeatVehicle)cObject;
        SeatInfo aSeats[] = cSeatVehicle.GetSeats();
        super.m_cSeatToGetInOut = aSeats == null || aSeats.length <= super.m_nSeatIndexToGetInOut ? null : aSeats[super.m_nSeatIndexToGetInOut];
        if(super.m_cSeatToGetInOut == null)
        {
            NetLog.Error("ActionGetInDo " + GetDriverInfo() + " to " + GetNetInfo(cSeatVehicle) + " m_cSeatToGetInOut (" + super.m_nSeatIndexToGetInOut + ") == null");
            return;
        }
        if(m_bGetInOutFromServer && super.m_cSeatToGetInOut.IsOccupied() && (super.m_cSeatToGetInOut.GetOccupant() instanceof PlayerNet))
        {
            PlayerNet cPlayer = (PlayerNet)super.m_cSeatToGetInOut.GetOccupant();
            if(cPlayer.GetDriverCounter() < GetDriverCounter())
            {
                NetLog.PlayerDriver("GET_OUT force " + cPlayer.GetDriverInfo() + " because " + GetDriverInfo());
                cPlayer.ActionGetOutDo();
            } else
            {
                NetLog.PlayerDriver("GET_IN canceled " + GetDriverInfo() + " because " + cPlayer.GetDriverInfo());
                return;
            }
        }
        NetLog.PlayerDriver("GET_IN " + GetDriverInfo() + "\n vehicle: " + GetNetInfo(cSeatVehicle) + "\n seat: " + super.m_cSeatToGetInOut.GetNetInfo());
        super.ActionGetInDo();
        if(m_bGetInOutFromServer && super.m_cSeatToGetInOut.GetOccupant() != this)
            NetLog.Error("GET_IN failed " + GetDriverInfo() + "\n vehicle: " + GetNetInfo(cSeatVehicle) + "\n seat: " + super.m_cSeatToGetInOut.GetNetInfo());
    }

    void ActionGetOutDo()
    {
        if(super.m_nState != 2 || super.cSeatInfo == null)
        {
            if(super.m_nState == 2)
                NetLog.Error("ActionGetOutDo " + GetDriverInfo() + " cSeatInfo == null");
            else
            if(super.cSeatInfo != null)
                NetLog.Error("ActionGetOutDo " + GetDriverInfo() + " m_nState != _STATE_IN_VEHICLE");
            else
                NetLog.Error("ActionGetOutDo " + GetDriverInfo() + " not in vehicle");
            return;
        }
        SeatInfo cSeatInfoToGetOut = super.cSeatInfo;
        ISeatVehicle cSeatVehicleToGetOut = (ISeatVehicle)cSeatInfoToGetOut.GetOccupiedObject();
        NetLog.PlayerDriver("GET_OUT " + GetDriverInfo() + "\n vehicle: " + (cSeatVehicleToGetOut == null ? "null" : GetNetInfo(cSeatVehicleToGetOut)) + "\n seat: " + (cSeatInfoToGetOut == null ? "null" : cSeatInfoToGetOut.GetNetInfo()));
        super.ActionGetOutDo();
        if(m_bGetInOutFromServer && super.m_nState == 2)
            NetLog.Error("GET_OUT failed " + GetDriverInfo() + "\n vehicle: " + (cSeatVehicleToGetOut == null ? "null" : GetNetInfo(cSeatVehicleToGetOut)) + "\n seat: " + (cSeatInfoToGetOut == null ? "null" : cSeatInfoToGetOut.GetNetInfo()));
    }

    boolean GetOut()
    {
        Vector vCameraDir = null;
        if(super.bNetIsOwner && super.Camera != null && super.cSeatInfo != null && super.cSeatInfo.GetRole() == 2)
        {
            vCameraDir = super.Camera.GetForwardVector();
            vCameraDir.Negate();
            vCameraDir.fY = 0.0F;
            vCameraDir.Normalize();
        }
        SetPhysicsLastUpdateTime(RoundToPhysicsGranularity(GetPhysicsLastUpdateTime()));
        if(super.GetOut())
        {
            SetPhysicsLastUpdateTime(RoundToPhysicsGranularity(GetPhysicsLastUpdateTime()));
            super.m_nState = 1;
            CleanPlayerMotion();
            SetMotionMoveFromKeyState();
            if(vCameraDir != null)
                SetDir(vCameraDir);
            SetCorrectPosOnRender(true);
            UpdateMotion();
            return true;
        } else
        {
            return false;
        }
    }

    void PrepareHUDToGetOut()
    {
        super.PrepareHUDToGetOut();
        if(super.HUD != null && super.HUD.GetHUDCrossHair() != null)
            super.HUD.GetHUDCrossHair().Activate();
    }

    void ActionChangeSeat()
    {
        if(super.m_nState != 2 || super.cSeatInfo == null)
        {
            if(super.m_nState == 2)
                NetLog.Error("ActionChangeSeat " + GetDriverInfo() + " cSeatInfo == null");
            else
            if(super.cSeatInfo != null)
                NetLog.Error("ActionChangeSeat " + GetDriverInfo() + " m_nState != _STATE_IN_VEHICLE");
            else
                NetLog.Error("ActionChangeSeat " + GetDriverInfo() + " not in ISeatVehicle");
            return;
        }
        ISeatVehicle cSeatVehicle = (ISeatVehicle)super.cSeatInfo.GetOccupiedObject();
        SeatInfo aSeats[] = null;
        if(super.cSeatInfo.GetOccupant() == this)
        {
            aSeats = cSeatVehicle.GetSeats();
            if(aSeats == null || aSeats.length < 2)
                return;
        }
        if(super.Role == 4)
        {
            int nCurrentSeat = -1;
            if(aSeats != null)
            {
                for(int i = 0; i < aSeats.length; i++)
                {
                    if(aSeats[i] != super.cSeatInfo)
                        continue;
                    nCurrentSeat = i;
                    break;
                }

            }
            if(nCurrentSeat > -1)
            {
                int nCurrentRole = super.cSeatInfo.GetRole();
                SeatInfo cTargetSeat = null;
                int nTargetSeat = nCurrentSeat;
                do
                {
                    nTargetSeat = (nTargetSeat + 1) % aSeats.length;
                    if(aSeats[nTargetSeat] == null || aSeats[nTargetSeat].GetOccupant() != null || aSeats[nTargetSeat].GetRole() == nCurrentRole)
                        continue;
                    cTargetSeat = aSeats[nTargetSeat];
                    break;
                } while(nTargetSeat != nCurrentSeat);
                if(super.cSeatInfo.CanGetOut() && cTargetSeat != null)
                {
                    ActionGetOut();
                    ActionGetIn(cTargetSeat);
                }
            }
        } else
        if(super.cSeatInfo.GetOccupiedObject() instanceof ISeatVehicle)
        {
            cSeatVehicle = (ISeatVehicle)super.cSeatInfo.GetOccupiedObject();
            NetLog.PlayerDriver("CHANGE_SEAT sendrequest " + GetDriverInfo() + "\n vehicle " + GetNetInfo(cSeatVehicle) + "\n seat " + super.cSeatInfo.GetNetInfo());
            MsgSendServerActionRequest(7, cSeatVehicle.GetNetId());
        }
    }

    public void OnReceivedDataOnClient()
    {
        super.OnReceivedDataOnClient();
        if(super.m_nState == 2 && GetParent() == null)
        {
            String sLog = "!!! _STATE_IN_VEHICLE but no parent!!! " + GetDriverInfo();
            if(super.cSeatInfo != null && super.cSeatInfo.GetOccupant() == this)
            {
                super.cSeatInfo.AttachOccupant();
                SitDownToDrive();
                sLog = sLog + " force attach to " + super.cSeatInfo.GetNetInfo();
            }
        }
    }

    boolean SeatInfoCanGetOut()
    {
        boolean bRet = super.SeatInfoCanGetOut();
        if(!bRet && m_bGetInOutFromServer)
        {
            NetLog.PlayerDriver("!! GET_OUT SeatInfoCanGetOut() forced\n");
            bRet = true;
        }
        return bRet;
    }

    Vector GetCheckedPosToGetOut(ISeatVehicle cVehicle, SeatInfo cSeat)
    {
        Vector vRet = super.GetCheckedPosToGetOut(cVehicle, cSeat);
        if(vRet == null && m_bGetInOutFromServer)
        {
            NetLog.PlayerDriver("!! GET_OUT GetCheckedPosToGetOut() forced\n");
            vRet = GetPosition();
        }
        return vRet;
    }

    void GetIn(SeatInfo cSeat)
    {
        super.GetIn(cSeat);
        super.m_nState = 2;
        SetCorrectPosOnRender(false);
    }

    static int GetNextGlobalDriverCounter()
    {
        return sm_cGlobalDriverCounter.GetNext();
    }

    private String GetNetInfo(ISeatVehicle cSeatVehicle)
    {
        if(cSeatVehicle instanceof Vehicle)
            return ((Vehicle)cSeatVehicle).GetNetInfo();
        else
            return "" + cSeatVehicle;
    }

    void MsgRecvClientVehicleCollisionAnswer()
    {
        boolean bPlayerDied = MessageUnPackBoolean();
        MessageEnd();
        if(!bPlayerDied)
            SetFlag(32);
    }

    void PrepareHUDToGetIn(Vehicle vehicle)
    {
        super.PrepareHUDToGetIn(vehicle);
        if(super.cSeatInfo != null && (super.cSeatInfo.GetRole() == 0 && !(vehicle instanceof Walker) || super.cSeatInfo.GetRole() == 2) && super.HUD.GetHUDCrossHair() != null)
            super.HUD.GetHUDCrossHair().Deactivate();
    }

    boolean VerifyDriverCounter(int nCounter)
    {
        return m_cDriverCounter.Verify(nCounter);
    }

    void ActionGetOut()
    {
        if(super.m_nState != 2 || super.cSeatInfo == null)
        {
            if(super.m_nState == 2)
                NetLog.Error("ActionGetOut " + GetDriverInfo() + " cSeatInfo == null");
            else
            if(super.cSeatInfo != null)
                NetLog.Error("ActionGetOut " + GetDriverInfo() + " m_nState != _STATE_IN_VEHICLE");
            else
                NetLog.Error("ActionGetOut " + GetDriverInfo() + " not in ISeatVehicle");
            return;
        }
        if(super.Role == 4)
        {
            SeatInfo cSeat = super.cSeatInfo;
            ISeatVehicle cSeatVehicle = (ISeatVehicle)super.cSeatInfo.GetOccupiedObject();
            if(super.cSeatInfo.GetOccupant() == this && super.cSeatInfo.CanGetOut())
            {
                super.m_nSeatVehicleToGetInOut = cSeatVehicle.GetNetId();
                SeatInfo aSeats[] = cSeatVehicle.GetSeats();
                super.m_nSeatIndexToGetInOut = -1;
                if(aSeats != null)
                {
                    for(int i = 0; i < aSeats.length; i++)
                    {
                        if(aSeats[i] != cSeat)
                            continue;
                        super.m_nSeatIndexToGetInOut = i;
                        break;
                    }

                }
                ClearODE();
                ActionGetOutDo();
                SetPhysicsLastUpdateTime(RoundToPhysicsGranularity(GetPhysicsLastUpdateTime() - PlayerNetBase.sm_fPhysicsGranularity * 2.0F));
                if(cSeat.GetOccupant() == null)
                {
                    NetLog.PlayerDriver("GET_OUT success -> sendclient " + GetDriverInfo());
                    MsgSendClientAction(6, super.m_nSeatVehicleToGetInOut, super.m_nSeatIndexToGetInOut, GetNextGlobalDriverCounter(), EMsgSendMode.ALL, GetPhysicsLastUpdateTime());
                } else
                {
                    NetLog.Error("GET_OUT failed " + GetDriverInfo() + "\n vehicle " + GetNetInfo(cSeatVehicle) + "\n seat " + cSeat.GetNetInfo());
                }
            } else
            {
                NetLog.PlayerDriver("GET_OUT canceled " + GetDriverInfo() + "\n vehicle " + GetNetInfo(cSeatVehicle) + "\n seat " + cSeat.GetNetInfo() + "\n CanGetOut() " + CanGetOut());
            }
        } else
        if(super.cSeatInfo.GetOccupiedObject() instanceof ISeatVehicle)
        {
            ISeatVehicle cSeatVehicle = (ISeatVehicle)super.cSeatInfo.GetOccupiedObject();
            NetLog.PlayerDriver("GET_OUT sendrequest " + GetDriverInfo() + "\n vehicle " + GetNetInfo(cSeatVehicle) + "\n seat " + super.cSeatInfo.GetNetInfo());
            MsgSendServerActionRequest(6, cSeatVehicle.GetNetId());
        }
    }

    boolean UpdateMotionCanPlayAnim()
    {
        return super.m_nState != 2 && super.UpdateMotionCanPlayAnim();
    }

    String GetDriverInfo()
    {
        return GetDriverInfo(super.cSeatInfo);
    }

    String GetDriverInfo(SeatInfo cSeat)
    {
        return GetNetInfo() + " cnt:" + GetDriverCounter() + (cSeat == null ? "" : " seat:" + cSeat.GetNetInfo());
    }

    public void OnDestroy()
    {
        METHOD_ActionGetInDo = RegisterCallMethod("ActionGetInDo");
        super.OnDestroy();
        if(super.m_nState == 2)
            ActionGetOutDo();
    }

    static boolean sm_bDamageOnVehicleCrashed = true;
    int METHOD_ActionGetInDo;
    private static ChangeStateCounter sm_cGlobalDriverCounter = new ChangeStateCounter();
    private ChangeStateCounter m_cDriverCounter;
    boolean m_bGetInOutFromServer;
    float m_fTryToCheckCollisionTimeOut;
    int m_nTryToCheckCollisionSenderId;
    GameObject m_cTryToCheckCollisionAssassin;

}
