// Decompiled by Jad v1.5.8g. Copyright 2001 Pavel Kouznetsov.
// Jad home page: http://www.kpdus.com/jad.html
// Decompiler options: packimports(3) 
// Source File Name:   PlayerNetBaseIndicator.java


public class PlayerNetBaseIndicator extends PlayerNetBase
{

    void SetName(String sName)
    {
        super.SetName(sName);
        UpdateNickForIndicator();
    }

    void CleanPlayer()
    {
        super.CleanPlayer();
        ReadyForIndicator(false);
    }

    void IndicatorFX()
    {
        if(!bTestAllowIndicators)
        {
            return;
        } else
        {
            m_cIndicatorFXPositioner.ExecuteFX(m_cIndicatorFXPositioner, m_sIndicatorFX, m_vIndicatorPos);
            return;
        }
    }

    void JustSpoken()
    {
        super.JustSpoken();
        if(m_bIndicatorActive)
            SpokenFX();
        else
        if(super.cSeatInfo != null && (super.cSeatInfo.GetOccupiedObject() instanceof Vehicle))
        {
            Vehicle cVehicle = (Vehicle)super.cSeatInfo.GetOccupiedObject();
            if(cVehicle.IsIndicatorActive())
                cVehicle.SpokenFX();
        }
    }

    void PlayerDied(int nMode, int nParam)
    {
        ReadyForIndicator(false);
    }

    public PlayerNetBaseIndicator()
    {
        m_bTeamMode = false;
        m_sIndicatorFXBlue = "FXPlayerNetIndicatorBlue";
        m_sIndicatorFXRed = "FXPlayerNetIndicatorRed";
        m_cIndicatorFXPositioner = null;
        METHOD_IndicatorFX = 0;
        m_sNickForIndicator = " ";
        m_bReadyForIndicator = false;
        m_bIndicatorActive = false;
        m_sIndicatorFX = null;
        m_vIndicatorPos = new Vector(0.0F, 0.0F, 0.0F);
        bTestAllowIndicators = true;
    }

    void StartIndicator(int nTeamId)
    {
        String sFX = nTeamId != 1 ? m_sIndicatorFXRed : m_sIndicatorFXBlue;
        if(super.cSeatInfo != null && (super.cSeatInfo.GetOccupiedObject() instanceof Vehicle))
        {
            StopIndicatorFX();
            Vehicle cVehicle = (Vehicle)super.cSeatInfo.GetOccupiedObject();
            PlayerNet cMainPlayer = GetGameInfo() == null ? null : GetGameInfo().GetMyPlayerNet();
            if(cMainPlayer != null && ((Pawn) (cMainPlayer)).cSeatInfo != null && (((Pawn) (cMainPlayer)).cSeatInfo.GetOccupiedObject() instanceof Vehicle))
            {
                Vehicle cMainPlayerVehicle = (Vehicle)((Pawn) (cMainPlayer)).cSeatInfo.GetOccupiedObject();
                if(cMainPlayerVehicle == cVehicle)
                {
                    cVehicle.StopIndicatorFX();
                    return;
                }
            }
            if(!cVehicle.IsIndicatorActive())
                cVehicle.StartIndicatorFX(sFX);
        } else
        {
            StartIndicatorFX(sFX);
        }
    }

    void StopIndicator()
    {
        StopIndicatorFX();
        if(super.cSeatInfo != null && (super.cSeatInfo.GetOccupiedObject() instanceof Vehicle))
        {
            Vehicle cVehicle = (Vehicle)super.cSeatInfo.GetOccupiedObject();
            cVehicle.StopIndicatorFX();
        }
    }

    void SpokenFX()
    {
        ExecuteFX(m_cIndicatorFXPositioner, m_sIndicatorFX + "Spoken", new Vector(m_vIndicatorPos.fX, m_vIndicatorPos.fY + FXPlayerNetIndicator._SPOKEN_ADD_HEIGHT, m_vIndicatorPos.fZ));
    }

    boolean GetOut()
    {
        SeatInfo cSeat = super.cSeatInfo;
        boolean bRet = super.GetOut();
        if(bRet)
        {
            if(cSeat != null && (cSeat.GetOccupiedObject() instanceof Vehicle))
            {
                Vehicle cVehicle = (Vehicle)cSeat.GetOccupiedObject();
                if(cVehicle.GetAllOccupantsNum() <= 0)
                    cVehicle.StopIndicatorFX();
                else
                if(super.bNetIsOwner)
                {
                    Pawn aPawns[] = cVehicle.GetAllOccupants();
                    if(aPawns[0] instanceof PlayerNet)
                    {
                        PlayerNet cPlayer = (PlayerNet)aPawns[0];
                        cPlayer.CheckIndicatorState();
                    }
                }
            }
            CallOnFrameEnd("CheckIndicatorState");
        }
        return bRet;
    }

    void OnPostCreate()
    {
        super.OnPostCreate();
        UpdateNickForIndicator();
    }

    private void StartIndicatorFX(String sFX)
    {
        m_sIndicatorFX = sFX;
        m_bIndicatorActive = true;
        CallMethodEvery(METHOD_IndicatorFX, (float)((FXPlayerNetIndicator._DURATION - 10D) / 1000D));
    }

    String GetNickForIndicator()
    {
        return m_sNickForIndicator;
    }

    void ReadyForIndicator(boolean bReady)
    {
        m_bReadyForIndicator = bReady;
        CheckIndicatorState();
    }

    private void StopIndicatorFX()
    {
        m_bIndicatorActive = false;
        DisableCallMethod(METHOD_IndicatorFX);
    }

    void GetIn(SeatInfo cSeatInfo)
    {
        super.GetIn(cSeatInfo);
        if(super.bNetIsOwner)
            StopIndicator();
        else
            CallOnFrameEnd("CheckIndicatorState");
    }

    void UpdateIndicatorFXPositioner()
    {
        if(m_cIndicatorFXPositioner != null)
            m_cIndicatorFXPositioner.SetPosition(new Vector(0.0F, FXPlayerNetIndicator._HEIGHT, 0.0F));
    }

    void SetNetGameInfo(NetGameInfo cGameInfo)
    {
        super.SetNetGameInfo(cGameInfo);
        CheckIndicatorState();
    }

    public void Respawn()
    {
        super.Respawn();
        ReadyForIndicator(true);
    }

    public void OnCreate()
    {
        METHOD_IndicatorFX = RegisterCallMethod("IndicatorFX");
        super.OnCreate();
        m_cIndicatorFXPositioner = (NetSpritePositioner)CreateObject("NetSpritePositioner");
        m_cIndicatorFXPositioner.ActivateOnModule();
        AttachChild(m_cIndicatorFXPositioner);
        UpdateIndicatorFXPositioner();
    }

    void CheckIndicatorState()
    {
        if(super.bNetIsOwner)
            return;
        int nTeamId = GetGameInfo() == null ? 0 : GetGameInfo().GetTeamIndicator(GetPlayerInfo());
        if(m_bReadyForIndicator && nTeamId != 0)
            StartIndicator(nTeamId);
        else
            StopIndicator();
    }

    void UpdateNickForIndicator()
    {
        m_sNickForIndicator = GetName();
        if(m_cIndicatorFXPositioner != null)
            m_cIndicatorFXPositioner.SetText(m_sNickForIndicator);
        if(super.cSeatInfo != null && (super.cSeatInfo.GetOccupiedObject() instanceof Vehicle))
        {
            Vehicle cVehicle = (Vehicle)super.cSeatInfo.GetOccupiedObject();
            if(cVehicle != null)
                cVehicle.UpdateNickForIndicator();
        }
    }

    public void OnDestroy()
    {
        if(m_cIndicatorFXPositioner != null)
        {
            m_cIndicatorFXPositioner.DetachFromParent();
            m_cIndicatorFXPositioner.delete();
            m_cIndicatorFXPositioner = null;
        }
        super.OnDestroy();
    }

    private boolean m_bTeamMode;
    String m_sIndicatorFXBlue;
    String m_sIndicatorFXRed;
    NetSpritePositioner m_cIndicatorFXPositioner;
    int METHOD_IndicatorFX;
    private String m_sNickForIndicator;
    boolean m_bReadyForIndicator;
    boolean m_bIndicatorActive;
    String m_sIndicatorFX;
    Vector m_vIndicatorPos;
    boolean bTestAllowIndicators;
}
