// Decompiled by Jad v1.5.8g. Copyright 2001 Pavel Kouznetsov.
// Jad home page: http://www.kpdus.com/jad.html
// Decompiler options: packimports(3) 
// Source File Name:   PlayerNetStateList.java


public class PlayerNetStateList
{

    void Clean()
    {
        for(int i = 0; i < m_aStates.length; i++)
            if(m_aStates[i] != null)
                m_aStates[i].Destroy();
            else
                m_aStates[i] = new PlayerNetState();

        m_nLast = 0;
        m_bStored = false;
    }

    void StoreWithPortalSystemActiveFlag(float fTime)
    {
        Store(fTime);
        m_aStates[m_nLast].StorePortalSystemActiveFlag(m_cPlayer);
    }

    PlayerNetStateList(PlayerNetBaseMover cPlayer, int nMaxStates)
    {
        m_cPlayer = null;
        m_aStates = null;
        m_nLast = 0;
        m_bStored = false;
        m_cFoundStateInfo = new PlayerNetFoundStateInfo();
        m_cPlayer = cPlayer;
        m_aStates = new PlayerNetState[nMaxStates];
    }

    void Destroy()
    {
        if(m_aStates != null)
        {
            for(int i = 0; i < m_aStates.length; i++)
                if(m_aStates[i] != null)
                {
                    m_aStates[i].Destroy();
                    m_aStates[i] = null;
                }

            m_aStates = null;
        }
        m_cPlayer = null;
        m_bStored = false;
    }

    void Store(float fTimeStamp)
    {
        m_bStored = true;
        m_nLast++;
        if(m_nLast >= m_aStates.length)
            m_nLast = 0;
        m_aStates[m_nLast].Store(m_cPlayer, fTimeStamp);
    }

    void Store(PlayerNetState cState)
    {
        m_bStored = true;
        m_nLast++;
        if(m_nLast >= m_aStates.length)
            m_nLast = 0;
        if(m_aStates[m_nLast] != null)
            m_aStates[m_nLast].Destroy();
        m_aStates[m_nLast] = cState;
    }

    void ResimulateOnAdjust(PlayerNetAdjustState cAdjustState, float fLastUpdatePhysicsTime)
    {
        Vector vPrevPos = m_cPlayer.GetLocalPosition();
        ControlObject cParent = m_cPlayer.GetParent();
        m_cPlayer.m_bNetResimulate = true;
        PlayerNetFoundStateInfo cFoundStateInfo = GetStateInfo(((PlayerNetState) (cAdjustState)).fTimeStamp, ((PlayerNetState) (cAdjustState)).nODEDoneUpdatesCount);
        if(cFoundStateInfo == null || cFoundStateInfo.m_nIndex < 0)
            return;
        int nIndex = cFoundStateInfo.m_nIndex;
        int nElems = cFoundStateInfo.m_nElements;
        Vector vAdjustDiff = new Vector(((PlayerNetState) (cAdjustState)).vPosition);
        vAdjustDiff.Sub(m_aStates[nIndex].vPosition);
        NetLog.PlayerMover(" IN: Adjust - Diff: " + vAdjustDiff + " Time: " + ((PlayerNetState) (cAdjustState)).fTimeStamp + " ODEUpdates: " + ((PlayerNetState) (cAdjustState)).nODEDoneUpdatesCount + "\n");
        m_aStates[nIndex].StoreAdjust(cAdjustState);
        if(m_aStates[nIndex].cParent == ((PlayerNetState) (cAdjustState)).cParent);
        m_aStates[nIndex].Restore(m_cPlayer);
        m_aStates[nIndex].RestorePortalSystemActiveFlag(m_cPlayer);
        m_nLast = nIndex;
        for(; nElems > 0; nElems--)
        {
            m_aStates[m_nLast].RestoreMotionAndDirAndLocalSpeed(m_cPlayer);
            int nNextState = (m_nLast + 1) % m_aStates.length;
            float fDeltaTime = m_aStates[nNextState].fTimeStamp - m_aStates[m_nLast].fTimeStamp;
            m_cPlayer.UpdateMotion();
            m_cPlayer.UpdateState();
            float fLastPhysicsUpdate = m_aStates[m_nLast].fTimeStamp;
            if(m_aStates[m_nLast].nODEDoneUpdatesCount != 4)
                fLastPhysicsUpdate -= PlayerNetBase.sm_fPhysicsGranularity;
            m_cPlayer.SetPhysicsLastUpdateTime(fLastPhysicsUpdate);
            m_cPlayer.StepUpdatePhysicsWithODE(fDeltaTime, true, m_aStates[m_nLast].nODEDoneUpdatesCount);
            m_cPlayer.UpdateAnims(fDeltaTime);
            int nTmp = m_aStates[nNextState].nODEDoneUpdatesCount;
            m_aStates[nNextState].StorePhysics(m_cPlayer);
            m_aStates[nNextState].StorePos(m_cPlayer);
            m_aStates[nNextState].StorePortalSystemActiveFlag(m_cPlayer);
            m_aStates[nNextState].nODEDoneUpdatesCount = nTmp;
            m_nLast = nNextState;
        }

        m_aStates[m_nLast].RestoreMotionAndDirAndLocalSpeed(m_cPlayer);
        m_aStates[m_nLast].RestorePortalSystemActiveFlag(m_cPlayer);
        m_cPlayer.ApplyPortalSystemActiveFlag();
        float fRemainingDeltaTime = fLastUpdatePhysicsTime - m_aStates[m_nLast].fTimeStamp;
        m_cPlayer.UpdateMotion();
        m_cPlayer.UpdateState();
        float fLastPhysicsUpdate = m_aStates[m_nLast].fTimeStamp;
        if(m_aStates[m_nLast].nODEDoneUpdatesCount != 4)
            fLastPhysicsUpdate -= PlayerNetBase.sm_fPhysicsGranularity;
        m_cPlayer.SetPhysicsLastUpdateTime(fLastPhysicsUpdate);
        m_cPlayer.StepUpdatePhysicsWithODE(fRemainingDeltaTime, true, m_aStates[m_nLast].nODEDoneUpdatesCount);
        m_cPlayer.UpdateAnims(fRemainingDeltaTime);
        m_cPlayer.m_bNetResimulate = false;
        m_cPlayer.SwitchParentTo(cParent);
        if(m_cPlayer.m_bUpdateEllipsoidRequired)
            m_cPlayer.UpdateEllipsoidAndMaxClimbAngle();
        Vector vCorrect = m_cPlayer.GetLocalPosition();
        vCorrect.Sub(vPrevPos);
        if(vCorrect.Len2() > 0.01F)
            GameObject.LogD("IN: adjust: " + vAdjustDiff.toString() + " correct: " + vCorrect.toString() + ((PlayerNetState) (cAdjustState)).fTimeStamp + "\n");
    }

    PlayerNetState GetState(float fTimeStamp, int nODEDoneUpdatesCount)
    {
        PlayerNetFoundStateInfo cInfo = GetStateInfo(fTimeStamp, nODEDoneUpdatesCount);
        if(cInfo.m_nIndex < m_aStates.length && cInfo.m_nIndex >= 0)
            return m_aStates[cInfo.m_nIndex];
        else
            return null;
    }

    PlayerNetFoundStateInfo GetStateInfo(float fTimeStamp, int nODEDoneUpdatesCount)
    {
        int nElems = 0;
        int i;
        for(i = m_nLast; nElems <= m_aStates.length; i--)
        {
            if(i < 0)
                i = m_aStates.length - 1;
            if(m_aStates[i].fTimeStamp == fTimeStamp && m_aStates[i].nODEDoneUpdatesCount == nODEDoneUpdatesCount)
                break;
            nElems++;
        }

        m_cFoundStateInfo.m_nIndex = i;
        m_cFoundStateInfo.m_nElements = nElems;
        if(nElems > m_aStates.length)
        {
            m_cFoundStateInfo.m_nIndex = -1;
            m_cFoundStateInfo.m_nElements = -1;
        }
        return m_cFoundStateInfo;
    }

    void Start()
    {
        Clean();
    }

    static int sm_nMaxClientSentStates = 256;
    static int sm_nMaxServerSimulatedStates = 256;
    PlayerNetBaseMover m_cPlayer;
    PlayerNetState m_aStates[];
    int m_nLast;
    boolean m_bStored;
    PlayerNetFoundStateInfo m_cFoundStateInfo;
    static boolean sm_bCheckClimbingOnAdjust = true;

}
