// Decompiled by Jad v1.5.8g. Copyright 2001 Pavel Kouznetsov.
// Jad home page: http://www.kpdus.com/jad.html
// Decompiler options: packimports(3) 
// Source File Name:   RadioCommunicationSystem.java

import java.io.File;

class RadioCommunicationSystem extends GameObject
{

    public void InitMessages()
    {
        File fullPath = new File(_MESSAGES_SOUNDS_DIRECTORY);
        if(fullPath != null && fullPath.exists())
            m_sSoundsPathPrefix = fullPath.getPath() + "/";
        else
            m_sSoundsPathPrefix = "";
        if(m_aSoundsGroups != null)
        {
            for(int i = 0; i < m_aSoundsGroups.length; i++)
                if(m_aSoundsGroups[i] != null)
                    m_aSoundsGroups[i].Init(_MESSAGES_SOUNDS_DIRECTORY);

        }
        InitializeTimers();
    }

    public void OnAudioPreReinitialize()
    {
        if(m_nCurrentWaveID != 0 && IsPlayingWave(m_nCurrentWaveID))
            l_nWavePos = GetPlayingWavePos(m_nCurrentWaveID);
    }

    public void OnAudioReinitialize()
    {
        if(l_nWavePos != -1L)
            if(m_nCurrentVoiceNo == 1)
                m_nCurrentWaveID = PlayWaveFromPos(m_sVoiceWave_1, l_nWavePos);
            else
            if(m_nCurrentVoiceNo == 2)
                m_nCurrentWaveID = PlayWaveFromPos(m_sVoiceWave_2, l_nWavePos);
        l_nWavePos = -1L;
    }

    public boolean CheckIfMessageNeedsBuddy(int nMsgType)
    {
        return m_aSoundsGroups != null && m_aSoundsGroups[nMsgType] != null && m_aSoundsGroups[nMsgType].GetAnswerMsgType() != -1;
    }

    public void RadioWaveEnd()
    {
        DisableCallMethod("RadioWaveEnd");
        if(m_nCurrentVoiceNo == 1 && m_sVoiceWave_2 != null)
        {
            m_nCurrentVoiceNo = 2;
            m_nCurrentWaveID = PlayWave(m_sVoiceWave_2);
            CallMethodIn("RadioWaveEnd", m_fWaveDuration_2);
            return;
        } else
        {
            m_nCurrentVoiceNo = 0;
            m_nCurrentWaveID = 0;
            return;
        }
    }

    RadioCommunicationSystem()
    {
        m_fNextRadioMessageTime = 0.0F;
        m_aNextMessageOfTypeTime = new float[14];
        m_nCurrentWaveID = 0;
        m_Module = null;
        m_bCommunicatePlaying = false;
        l_nWavePos = -1L;
    }

    public float GetNextMessageTime(int nMsgType)
    {
        if(m_aSoundsGroups != null && m_aSoundsGroups[nMsgType] != null)
            return Math.max(m_aNextMessageOfTypeTime[nMsgType], m_fNextRadioMessageTime);
        else
            return -1F;
    }

    public boolean RadioMessage(int nMsgType, NewAI voiceOwner1, NewAI voiceOwner2)
    {
        float time = GetTime();
        if(time >= m_fNextRadioMessageTime && m_aSoundsGroups != null && m_aSoundsGroups[nMsgType] != null && time >= m_aNextMessageOfTypeTime[nMsgType])
        {
            m_nCurrentVoiceNo = 0;
            String fileName = m_aSoundsGroups[nMsgType].GetSoundName();
            if(fileName != null)
            {
                m_sVoiceWave_1 = m_sSoundsPathPrefix + fileName;
                m_sVoiceWave_2 = null;
                float duration2 = 0.0F;
                int answerMsgType = m_aSoundsGroups[nMsgType].GetAnswerMsgType();
                if(answerMsgType != -1)
                    if(voiceOwner2 != null && m_aSoundsGroups[answerMsgType] != null && (fileName = m_aSoundsGroups[answerMsgType].GetSoundName()) != null)
                    {
                        m_sVoiceWave_2 = m_sSoundsPathPrefix + fileName;
                        duration2 = GetWaveDuration(m_sVoiceWave_2);
                    } else
                    {
                        return false;
                    }
                m_VoiceOwner_1 = voiceOwner1;
                m_VoiceOwner_2 = voiceOwner2;
                m_nCurrentVoiceNo = 1;
                m_nCurrentWaveID = PlayWave(m_sVoiceWave_1);
                float duration1 = GameObject.GetWaveDuration(m_nCurrentWaveID);
                m_fNextRadioMessageTime = time + duration1 + duration2 + _MIN_TIME_BTW_MESSAGES;
                m_aNextMessageOfTypeTime[nMsgType] = m_fNextRadioMessageTime + m_aSoundsGroups[nMsgType].GetRandomDelay();
                voiceOwner1.SetNextScreamTime(time + duration1);
                if(m_sVoiceWave_2 != null)
                {
                    voiceOwner2.SetNextScreamTime(time + duration1 + duration2);
                    m_fWaveDuration_2 = duration2;
                    duration1 += m_aSoundsGroups[nMsgType].GetAnswerDelay();
                }
                DisableCallMethod("RadioWaveEnd");
                CallMethodIn("RadioWaveEnd", duration1);
                return true;
            }
        }
        return false;
    }

    public void BreakRadioMessage(NewAI voiceOwner)
    {
        if(voiceOwner == m_VoiceOwner_1 && m_nCurrentVoiceNo == 1 || voiceOwner == m_VoiceOwner_2 && m_nCurrentVoiceNo == 2)
        {
            StopWave(m_nCurrentWaveID);
            m_nCurrentWaveID = 0;
            DisableCallMethod("RadioWaveEnd");
            m_nCurrentVoiceNo = 0;
        }
    }

    public void PlayRadioCommunicate(FileName cFileName)
    {
        if(cFileName == null)
            return;
        if(cFileName.sName == null || cFileName.sName.length() == 0)
            return;
        if(!cFileName.Exists())
            return;
        if(!m_bCommunicatePlaying)
        {
            float fTime = GetWaveDuration(cFileName.sName);
            if(fTime <= 0.0F)
                return;
            m_Module.MainPlayer.AttachOneShotSound(cFileName.sName);
            m_bCommunicatePlaying = true;
            CallMethodIn("CommunicatePlayed", fTime);
        }
    }

    public void CommunicatePlayed()
    {
        DisableCallMethod("CommunicatePlayed");
        m_bCommunicatePlaying = false;
    }

    public void Reinitialize()
    {
        DisableCallMethod("RadioWaveEnd");
        if(m_nCurrentWaveID != 0)
            StopWave(m_nCurrentWaveID);
        m_nCurrentWaveID = 0;
        m_nCurrentVoiceNo = 0;
        InitializeTimers();
    }

    void InitializeTimers()
    {
        m_fNextRadioMessageTime = 0.0F;
        if(m_aNextMessageOfTypeTime != null)
        {
            for(int i = 0; i < m_aNextMessageOfTypeTime.length; i++)
                m_aNextMessageOfTypeTime[i] = 0.0F;

        }
    }

    void Init(ChromeModuleSingle module)
    {
        m_Module = module;
        InitMessages();
    }

    public static final int _RADIO_MSG_FIRE_IN_THE_HOLE = 0;
    public static final int _RADIO_MSG_GRENADE = 1;
    public static final int _RADIO_MSG_COVER_ME = 2;
    public static final int _RADIO_MSG_COVER_ME_ANSWER = 3;
    public static final int _RADIO_MSG_ENEMY_HIT = 4;
    public static final int _RADIO_MSG_WOUNDED = 5;
    public static final int _RADIO_MSG_CLEAR = 6;
    public static final int _RADIO_MSG_ENEMY_SPOTTED = 7;
    public static final int _RADIO_MSG_INTRUDER = 8;
    public static final int _RADIO_MSG_SUSPECT = 9;
    public static final int _RADIO_MSG_WATCHOUT = 10;
    public static final int _RADIO_MSG_SNIPER = 11;
    public static final int _RADIO_MSG_BACKUP_CALL = 12;
    public static final int _RADIO_MSG_ROGER = 13;
    public static final int _NOF_RADIO_MSG_TYPES = 14;
    public static float _MIN_TIME_BTW_MESSAGES = 2.0F;
    public static String _MESSAGES_SOUNDS_DIRECTORY = "Data/Sounds/AI/Radio";
    float m_fNextRadioMessageTime;
    String m_sSoundsPathPrefix;
    RadioSoundsGroup m_aSoundsGroups[] = {
        new RadioSoundsGroup("fire", 0.0F, 0.0F), new RadioSoundsGroup("grenade", 5F, 10F), new RadioSoundsGroup("coverme", 7F, 30F, 3, 0.5F), new RadioSoundsGroup("covered", 1.0F, 1.0F), new RadioSoundsGroup("enemyhit", 10F, 60F), new RadioSoundsGroup("wounded", 10F, 60F), new RadioSoundsGroup("clear", 10F, 60F), new RadioSoundsGroup("attack", 10F, 60F, 13, 0.2F), new RadioSoundsGroup("intruder", 10F, 60F, 13, 0.2F), new RadioSoundsGroup("suspect", 3F, 10F), 
        new RadioSoundsGroup("watchout", 10F, 60F), new RadioSoundsGroup("sniper", 1.0F, 40F), new RadioSoundsGroup("basereport", 10F, 60F), new RadioSoundsGroup("roger", 10F, 60F)
    };
    float m_aNextMessageOfTypeTime[];
    NewAI m_VoiceOwner_1;
    String m_sVoiceWave_1;
    NewAI m_VoiceOwner_2;
    String m_sVoiceWave_2;
    float m_fWaveDuration_2;
    int m_nCurrentWaveID;
    int m_nCurrentVoiceNo;
    ChromeModuleSingle m_Module;
    boolean m_bCommunicatePlaying;
    long l_nWavePos;

}
