// Decompiled by Jad v1.5.8g. Copyright 2001 Pavel Kouznetsov.
// Jad home page: http://www.kpdus.com/jad.html
// Decompiler options: packimports(3) 
// Source File Name:   Rocket.java


public class Rocket extends Bullet
{
    public class Flying extends Bullet.Flying
    {

        public void OnTakeDamage(float fDamage, float fPhSimDamage, GameObject Assassin, Vector vHitLocation, Vector vSpeed, int nMeshElementorBoneID, int nDamageType)
        {
            super.OnTakeDamage(fDamage, fPhSimDamage, Assassin, vHitLocation, vSpeed, nMeshElementorBoneID, nDamageType);
        }

        void SpeedUpdate()
        {
            CallMethodIn("SpeedUpdate", fSpeedUpdateTimer);
        }

        public void SGUpdate()
        {
            FileChunk.Log("[Rocket$Flying] : SGUpdate\n");
            DetachAllSounds();
            AttachSound(sSoundFlyName);
            super.SGUpdate();
        }

        public void OnCollisionFullInfo(ControlObject Col, Vector v1, Vector v2)
        {
            if(Col != null && (Col == Owner || Col == cWeaponOwner || (Col instanceof RocketCannon) || (Col instanceof WeaponHeavyRocketLauncher)))
            {
                return;
            } else
            {
                m_DirectVictim = Col;
                CallOnFrameEnd("Explode");
                return;
            }
        }

        public void SGLoad(FileChunk cParentFC)
        {
            FileChunk.Log("[Rocket$Flying] : SGLoad\n");
            FileChunk cFC = GameObject.LoadChunk(cParentFC);
            if(cFC.GetID() == 1638)
            {
                super.SGLoad(cFC);
                fLastFxTime = cFC.LoadFloat();
                vLastUpdatePos = cFC.LoadVector();
            }
            cFC.delete();
        }

        public void OnEnter()
        {
            fTimeToLive = fRange / fStartSpeed;
            super.OnEnter();
            CallMethodIn("FXUpdate", 0.0F);
            AttachSound(sSoundFlyName);
            vLastUpdatePos = GetPosition();
            EnableRendering(false);
        }

        void FXUpdate()
        {
            float fTime = GetTime();
            if(fLastFxTime == fTime)
                return;
            fLastFxTime = fTime;
            Vector vPos = GetPosition();
            Vector vDir = new Vector(vPos);
            vDir.Sub(vLastUpdatePos);
            float fLen = vDir.Len();
            vDir.Normalize();
            vDir.Mul(fFXUpdateDist);
            for(; fLen > fFXUpdateDist; fLen -= fFXUpdateDist)
            {
                EnableRendering(true);
                ExecuteFX(sFXSmokeName, vLastUpdatePos);
                vLastUpdatePos.Add(vDir);
            }

            if(!bExploded)
                CallMethodIn("FXUpdate", fFXUpdateTime);
        }

        public void SGSave(FileChunk cParentFC)
        {
            FileChunk.Log("[Rocket$Flying] : SGSave\n");
            FileChunk cFC = GameObject.NewChunk(1638, cParentFC);
            super.SGSave(cFC);
            cFC.SaveFloat(fLastFxTime);
            cFC.SaveVector(vLastUpdatePos);
            cFC.delete();
        }

        float fLastFxTime;

        public Flying()
        {
            fLastFxTime = 0.0F;
        }
    }


    Rocket()
    {
        fExplosionNoiseDistance = 3000F;
        fFXUpdateTime = 0.1F;
        fFXUpdateDist = 100F;
        vLastUpdatePos = new Vector();
        fRange = 10000F;
        fSpeedUpdateTimer = 0.1F;
        m_vStartPos = null;
        fMaxSpeed = 10000F;
        fAccelerate = 3400F;
        sFXSmokeName = "FXRocketSmoke";
        sSoundFlyName = "Data/Sounds/Weapon/RocketFlyFF.wav";
        super.MeshName = "Data/Meshes/Equipment/rakieta.3DA";
        super.fHealth = 1.0F;
        super.fStartSpeed = 7000F;
        super.fDamage = 100F;
        super.fPhysicsSimDamage = super.fDamage;
        super.fBlastDamage = 1250F;
        super.fDirectHitDamage = super.fBlastDamage;
        super.fPhysicsSimBlastDamage = super.fBlastDamage;
        super.fBlastRadius = 800F;
        super.sFXHitName = "FXBlowRocket";
        super.sSoundExplodeName = "data/sounds/weapon/GrenadeExplosion.wav";
    }

    void RemoveForMovie()
    {
        super.RemoveForMovie();
        DetachAllSounds();
    }

    public void SGUpdate()
    {
        FileChunk.Log("[Rocket.SGUpdate]\n");
        DetachAllSounds();
        super.SGUpdate();
    }

    void SetLightColor(float fR, float fG, float fB)
    {
        if(super.cDynLight != null)
            super.cDynLight.SetColor(fR, fG, fB);
    }

    void Explode()
    {
        if(!super.bExploded)
        {
            MakeNoise(fExplosionNoiseDistance, 3);
            DetachAllSounds();
            super.Explode();
        }
    }

    public void OnCreate()
    {
        super.OnCreate();
        SetPhysicsType(6);
        SetPosition(GetPosition());
        SetMass(0.0F);
    }

    public void delete()
    {
        if(super.bNoLight);
        super.delete();
    }

    public void SGSaveChunk(FileChunk cFCParent)
    {
        FileChunk.Log("[Rocket.SGSaveChunk]\n");
        FileChunk cFC = GameObject.NewChunk(1136, cFCParent);
        super.SGSaveChunk(cFC);
        cFC.SaveVector(m_vStartPos);
        cFC.delete();
    }

    public void SGLoadChunk(FileChunk cParentFC)
    {
        FileChunk.Log("[Rocket.SGLoadChunk]\n");
        FileChunk cFC = GameObject.LoadChunk(cParentFC);
        if(cFC.GetID() == 1136)
        {
            super.SGLoadChunk(cFC);
            m_vStartPos = cFC.LoadVector();
        }
        cFC.delete();
    }

    void Start(float fForce, Vector vPos, Vector vDir, float fTime)
    {
        super.bSG = true;
        SetStarted();
        SetOwner();
        if(super.m_bSetPositionWorld)
            SetPositionWorld(vPos);
        else
            SetPosition(vPos);
        SetDir(vDir);
        Vector vPlayerSpeed = new Vector();
        if(super.Owner != null)
            vPlayerSpeed = new Vector(super.Owner.GetAbsoluteSpeed());
        Vector vSpeed = new Vector(vDir);
        vSpeed.Normalize();
        vSpeed.Mul(super.fStartSpeed);
        SetDir(vSpeed);
        SetSpeed(vSpeed);
        SetDestSpeedValue(fMaxSpeed);
        SetPhysicsActive(fTime);
        ActivateOnModule();
        SetCorrectPosOnRender(true);
        SetState("Flying");
    }

    float fExplosionNoiseDistance;
    float fFXUpdateTime;
    float fFXUpdateDist;
    Vector vLastUpdatePos;
    float fRange;
    float fSpeedUpdateTimer;
    protected Vector m_vStartPos;
    public float fMaxSpeed;
    public float fAccelerate;
    public String sFXSmokeName;
    public String sSoundFlyName;
}
