// Decompiled by Jad v1.5.8g. Copyright 2001 Pavel Kouznetsov.
// Jad home page: http://www.kpdus.com/jad.html
// Decompiler options: packimports(3) 
// Source File Name:   Window.java

import java.util.Vector;

class Window extends Sprite
{

    void SetContextMenu(ContextMenu menu)
    {
        if(wndContextMenu != null)
            DestroyMenu();
        if(module == null)
        {
            GameObject.LogLine("Musisz ustawic modul, zanim zawolasz SetContextMenu dla " + this);
            return;
        }
        wndContextMenu = menu;
        if(menu != null)
        {
            AddChildWnd(menu, wndRoot);
            menu.SetModal();
            menu.MoveTop();
            Cursor cursor = module.GetCursor();
            if(cursor != null)
                cursor.MoveTop();
        }
    }

    boolean HitTest(Vector hitpoint)
    {
        Vector p = GetPos();
        Vector s = GetSize();
        if(p == null || s == null)
            return false;
        else
            return hitpoint.fX >= p.fX && hitpoint.fX < p.fX + s.fX && hitpoint.fY >= p.fY && hitpoint.fY < p.fY + s.fY;
    }

    boolean CanProcessMouseBtns()
    {
        if(wndCurrentModal == null)
            return true;
        return wndCurrentModal == wndRoot;
    }

    void SetToolTip(String sText)
    {
        if(sText == null)
            bToolTipEnabled = false;
        else
            bToolTipEnabled = sText.length() > 0;
        sToolTipText = sText;
        if(bToolTipVisible)
            DisplayToolTip();
    }

    Window SetModal()
    {
        Cursor cursor = null;
        DisableCallMethod("DisplayToolTip");
        if(module != null)
            cursor = module.GetCursor();
        if(cursor != null)
        {
            cursor.DisplayToolTip("");
            bToolTipVisible = false;
        }
        Window wndPrev = wndCurrentModal;
        SetRoot(this);
        wndCurrentModal = this;
        return wndPrev;
    }

    void RemoveChildWnd(Window wnd)
    {
        vChildWindows.removeElement(wnd);
    }

    void OnKeyReleased(int i, char c)
    {
    }

    void OnRBUp(float f, float f1)
    {
    }

    void SetSizeAndPos(float lw, float lh, float lx, float ly, boolean bpos)
    {
        m_lxpos = lx;
        m_lypos = ly;
        m_lwidth = lw;
        m_lheight = lh;
        m_blpos = bpos;
        int width;
        int height;
        if(wndParent == null)
        {
            width = GameObject.GetScreenWidth();
            height = GameObject.GetScreenHeight();
        } else
        {
            Vector v = wndParent.GetSize();
            width = (int)v.fX;
            height = (int)v.fY;
        }
        if(width <= 0 || height <= 0)
            return;
        int w = (int)(lw * (float)width);
        int h = (int)(lh * (float)height);
        int px;
        int py;
        if(bpos)
        {
            px = (int)(lx * (float)width) - w / 2;
            py = (int)(ly * (float)height) - h / 2;
        } else
        {
            px = (int)(lx * (float)width);
            py = (int)(ly * (float)height);
        }
        if(wndParent == null)
            SetPos(new Vector(px, py, 0.0F));
        else
            SetRelativePos(new Vector(px, py, 0.0F));
        SetSize(new Vector(w, h, 0.0F));
    }

    void RefreshSetSizeAndPos()
    {
        SetSizeAndPos(m_lwidth, m_lheight, m_lxpos, m_lypos, m_blpos);
        Window wnd = null;
        int cnt = vChildWindows.size();
        for(int i = 0; i < cnt; i++)
        {
            wnd = (Window)vChildWindows.elementAt(i);
            if(wnd != null)
                wnd.RefreshSetSizeAndPos();
        }

    }

    void OnButtonRB(Button btnSender)
    {
        if(btnSender == null)
            return;
        if(wndParent != null)
            wndParent.CallOnButtonRB(btnSender);
    }

    public void SetPos(Vector vPos)
    {
        super.SetPos(vPos);
        DisableCallMethod("DisplayToolTip");
        Cursor cursor = null;
        if(module != null)
            cursor = module.GetCursor();
        if(cursor != null && bToolTipVisible)
        {
            cursor.DisplayToolTip("");
            bToolTipVisible = false;
        }
    }

    void SetAlphaForAll(float _alpha)
    {
        SetAlpha(_alpha);
        Window wnd = null;
        int cnt = vChildWindows.size();
        for(int i = 0; i < cnt; i++)
        {
            wnd = (Window)vChildWindows.elementAt(i);
            if(wnd != null)
                wnd.SetAlphaForAll(_alpha);
        }

    }

    void OnButtonHighlight(Button btnSender)
    {
        if(btnSender == null)
            return;
        if(wndParent != null)
            wndParent.CallOnButtonHighlight(btnSender);
    }

    public void Hide()
    {
        DisableCallMethod("DisplayToolTip");
        Cursor cursor = null;
        if(module != null)
            cursor = module.GetCursor();
        if(cursor != null && bToolTipVisible)
        {
            cursor.DisplayToolTip("");
            bToolTipVisible = false;
        }
        super.ProcessMouse(false);
        super.ProcessKb(false);
        super.ProcessJoy(false);
        super.Hide();
    }

    public void ProcessKb(boolean bProcess)
    {
        super.ProcessKb(bProcess);
        bProcessingKb = bProcess;
    }

    public void RestoreTextures()
    {
    }

    void SetRoot(Window wndRt)
    {
        wndRoot = wndRt;
        int nChildCount = vChildWindows.size();
        for(int i = 0; i < nChildCount; i++)
        {
            Window child = (Window)vChildWindows.elementAt(i);
            if(child != null)
                child.SetRoot(wndRt);
        }

    }

    void OnButtonDoubleClick(Button btnSender)
    {
        if(btnSender == null)
            return;
        if(wndParent != null)
            wndParent.CallOnButtonDoubleClick(btnSender);
    }

    Vector GetLogicalPos(Vector hitpoint)
    {
        Vector p = GetPos();
        Vector s = GetSize();
        float x = hitpoint.fX - p.fX;
        if(s.fX != 0.0F)
            x /= s.fX;
        else
            x = 0.0F;
        float y = hitpoint.fY - p.fY;
        if(s.fY != 0.0F)
            y /= s.fY;
        else
            y = 0.0F;
        return new Vector(x, y, 0.0F);
    }

    ContextMenu CreateContextMenu(float fMouseX, float fMouseY)
    {
        return null;
    }

    void OnMouseMove(float fMouseX, float fMouseY, int iButtonsFlags)
    {
        if(bToolTipEnabled)
        {
            Cursor cursor = null;
            if(module != null)
                cursor = module.GetCursor();
            if(cursor != null && bToolTipVisible)
            {
                cursor.DisplayToolTip("");
                bToolTipVisible = false;
            }
            DisableCallMethod("DisplayToolTip");
            CallMethodIn("DisplayToolTip", fToolTipTime);
        }
    }

    public native void CallOnButtonHighlight(Button button);

    void OnButton(Button btnSender)
    {
        if(btnSender == null)
            return;
        if(wndParent != null)
            wndParent.CallOnButton(btnSender);
    }

    boolean IsCursorInWindow()
    {
        if(!CanProcessMouseMove())
            return false;
        Vector vPos = GetPos();
        Vector vSize = GetSize();
        Vector vMousePos = GetMousePos();
        return vMousePos.fX >= vPos.fX && vMousePos.fX <= vPos.fX + vSize.fX && vMousePos.fZ >= vPos.fY && vMousePos.fZ <= vPos.fY + vSize.fY;
    }

    void AddChildWnd(Window wndNew, Window wndRt)
    {
        if(wndNew.wndParent != null)
            wndNew.wndParent.RemoveChildWnd(wndNew);
        vChildWindows.addElement(wndNew);
        wndNew.SetRoot(wndRt);
        wndNew.wndParent = this;
    }

    public native void CallOnButtonRB(Button button);

    Window()
    {
        wndContextMenu = null;
        wndParent = null;
        wndRoot = null;
        module = null;
        vChildWindows = new Vector();
        bProcessingMouse = false;
        bProcessingKb = false;
        bProcessingJoy = false;
        sToolTipText = null;
        fToolTipTime = 0.5F;
        bToolTipEnabled = false;
        bToolTipVisible = false;
        fMouseMoveTime = 0.0F;
        m_lxpos = 0.0F;
        m_lypos = 0.0F;
        m_lwidth = 1.0F;
        m_lheight = 1.0F;
        m_blpos = false;
        m_cElementData = null;
    }

    void SetModule(Module windowMod)
    {
        module = windowMod;
    }

    void DestroyMenu()
    {
        if(wndContextMenu == null)
        {
            return;
        } else
        {
            wndContextMenu.Destroy();
            RemoveChildWnd(wndContextMenu);
            module.RemoveSprite(wndContextMenu);
            wndContextMenu.delete();
            wndContextMenu = null;
            ClearModal();
            return;
        }
    }

    void OnMouseLeave(float fMouseX, float fMouseY)
    {
        if(bToolTipEnabled)
        {
            DisableCallMethod("DisplayToolTip");
            Cursor cursor = null;
            if(module != null)
                cursor = module.GetCursor();
            if(cursor != null && bToolTipVisible)
            {
                cursor.DisplayToolTip("");
                bToolTipVisible = false;
            }
        }
    }

    void Destroy()
    {
        ReleaseTextures();
        for(Window wnd = null; vChildWindows.size() > 0; wnd = null)
        {
            wnd = (Window)vChildWindows.elementAt(0);
            vChildWindows.removeElementAt(0);
            wnd.Destroy();
            wnd.delete();
        }

        DeleteToolTip();
        if(module != null)
            module.RemoveSprite(this);
        else
            GetModule().RemoveSprite(this);
    }

    public void ProcessMouse(boolean bProcess)
    {
        super.ProcessMouse(bProcess);
        bProcessingMouse = bProcess;
    }

    public void DumpData(ScriptWriter cWriter)
    {
        Vector vSize = GetSize();
        cWriter.Write("LogicSize(" + vSize.fX / (float)GameObject.GetScreenWidth() + "," + vSize.fY / (float)GameObject.GetScreenHeight() + ")");
        Vector vPos = GetPos();
        cWriter.Write("LogicPos(" + vPos.fX / (float)GameObject.GetScreenWidth() + "," + vPos.fY / (float)GameObject.GetScreenHeight() + ")");
        cWriter.Write("Mouse(1)");
        cWriter.Write("Keyboard(1)");
        cWriter.Write("CanFocus(1)");
    }

    void ClearModal()
    {
        DisableCallMethod("DisplayToolTip");
        Cursor cursor = null;
        if(module != null)
            cursor = module.GetCursor();
        if(cursor != null)
        {
            cursor.DisplayToolTip("");
            bToolTipVisible = false;
        }
        wndCurrentModal = null;
    }

    void DisplayToolTip()
    {
        Cursor cursor = null;
        if(module != null)
            cursor = module.GetCursor();
        if(cursor != null)
            if(sToolTipText != null)
            {
                if(sToolTipText.length() > 0)
                {
                    if(IsVisible())
                    {
                        cursor.DisplayToolTip(sToolTipText);
                        bToolTipVisible = true;
                    } else
                    {
                        bToolTipVisible = false;
                    }
                } else
                {
                    bToolTipVisible = false;
                }
            } else
            {
                bToolTipVisible = false;
            }
    }

    void DeleteToolTip()
    {
        DisableCallMethod("DisplayToolTip");
        Cursor cursor = null;
        if(module != null)
            cursor = module.GetCursor();
        if(cursor != null && bToolTipVisible)
        {
            cursor.DisplayToolTip("");
            bToolTipVisible = false;
        }
    }

    Vector GetCenterPos()
    {
        Vector p = GetPos();
        Vector s = GetSize();
        return new Vector(p.fX + s.fX / 2.0F, p.fY + s.fY / 2.0F, p.fZ + s.fZ / 2.0F);
    }

    boolean CanProcessMouseMove()
    {
        if(wndCurrentModal == null)
            return true;
        return wndCurrentModal == wndRoot;
    }

    public void ProcessJoy(boolean bProcess)
    {
        super.ProcessJoy(bProcess);
        bProcessingJoy = bProcess;
    }

    public void Dump(ScriptWriter cWriter)
    {
        cWriter.NewLine();
        DumpHeader(cWriter);
        cWriter.Write("{");
        cWriter.IncIndent();
        DumpData(cWriter);
        for(int i = 0; i < vChildWindows.size(); i++)
            ((Window)vChildWindows.elementAt(i)).Dump(cWriter);

        cWriter.DecIndent();
        cWriter.Write("}");
    }

    public native void CallOnButtonDoubleClick(Button button);

    public void DumpHeader(ScriptWriter cWriter)
    {
        cWriter.Write("Window(\"UIWindow\", \"ID_\", \"Specific\")");
    }

    public void Show()
    {
        super.ProcessMouse(bProcessingMouse);
        super.ProcessKb(bProcessingKb);
        super.ProcessJoy(bProcessingJoy);
        super.Show();
    }

    public void ReleaseTextures()
    {
    }

    void OnCreate()
    {
        SetFont(Fonts.GetDefaultFont());
        wndRoot = this;
    }

    public native void CallOnButton(Button button);

    ContextMenu wndContextMenu;
    static Window wndCurrentModal = null;
    Window wndParent;
    Window wndRoot;
    Module module;
    Vector vChildWindows;
    boolean bProcessingMouse;
    boolean bProcessingKb;
    boolean bProcessingJoy;
    String sToolTipText;
    float fToolTipTime;
    boolean bToolTipEnabled;
    boolean bToolTipVisible;
    float fMouseMoveTime;
    float m_lxpos;
    float m_lypos;
    float m_lwidth;
    float m_lheight;
    boolean m_blpos;
    UIElement m_cElementData;

}
